
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)             Dateiname: DREI.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Mai 2001 Version: V 1.0                     |
  |-------------------------------------------------------------------------|
  | Thema:    Eingabe, Ausgabe  (Display-Modul)                             |
  |-------------------------------------------------------------------------|
  | Importe:  Das Modul Drei importiert die von POW! bereitgestellten       |
  |           Module Display und File. Damit werden Prozeduren fr Ein-     |
  |           und Ausgabeanweisungen und das Schreiben und Lesen von        |
  |           Dateien bereitgestellt.                                       |
  | Leistung: Einlesen von Zahlen, die vom Anwender mittels Tastatur einge- |
  |           gebenen werden. Verarbeitung (Addition) und Ausgabe des Er-   |
  |           gebnisses am Bildschirm. Einlesen und Anzeigen eines Textes.  |
  |           Ausgewhlte Daten werden in eine Datei auf einem externen     |
  |           Datentrger abgelegt und spter von dort wieder eingelesen.   |
  |           Nach dem Einlesen werden die Daten erneut verarbeitet (Sub-   |
  |           traktion) und am Bildschirm ausgegeben. Die Zeichenkette wird |
  |           ebenfalls ausgegeben.                                         |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |  
  *-------------------------------------------------------------------------*)

 MODULE Drei;
 
  IMPORT D:= Display,
         F:= File;            (* Import der Standardmodule Display und File *)


  TYPE   tStr25 = ARRAY 26 OF CHAR;  (* Typdeklaration eines Datentyps der  *)
                                     (* 25 druckbare Zeichen aufnehmen kann *)

  CONST  pfad = 'ZweiDrei.Dat';      (* Dateiname fr die Datei im aktuel-  *)
                                     (* len Dateiverzeichnis                *)


 (* ---------------------  U N T E R P R O G R A M M ---------------------- *)


  PROCEDURE Enter;
   (*-----------------------------------------------------------------------*
    | Leistung: Farbige positionierte Ausgabe einer Zeichenkette, Warten    |
    |           auf eine Tastenbettigung (Tastatur), Rcksetzen der Vor-   |
    |           dergrundfarbe auf Schwarz.                                  |
    *-----------------------------------------------------------------------*)

    BEGIN
      D.SetForeColor(0,160,160);
      D.WriteStrXY(65,24,'< ENTER >');
      REPEAT UNTIL D.KeyPressed();
      D.SetForeColor(0,0,0)
    END Enter;


  PROCEDURE Linie ( laenge, spalte, zeile : INTEGER; dotFlag : BOOLEAN );
   (*-----------------------------------------------------------------------*
    | bernahme: Lnge der Linie (Einheit: Zeichenbreite, 8 Pixel), Text-   |
    |            spalte und Textzeile. Der Bildschirm  besitzt im Display-  |
    |            modus 80 Spalten und 25 Zeilen. Der wert der booleschen    |
    |            Variable bestimmt die Art der Linie (Trennlinie o. Unter-  |
    |            streichung): dotFlag = TRUE,  gepunktete Linie             |
    |                         dotFlag = FALSE, durchgezogene Linie          |
    | Leistung:  In Abhngigkeit des Wertes der boolschen Variable wird     |
    |            eine gepunktete oder durchgezogene Linie, beginnen an dem  |
    |            durch die Werte der Variablen spalte und zeile festgeleg-  |
    |            ten Punkt, gezogen.                                        |
    *-----------------------------------------------------------------------*)

    VAR zeichen : CHAR;
        i       : INTEGER;

    BEGIN
      IF dotFlag THEN zeichen:= '' ELSE zeichen:= '' END;
            (* '' = <Alt> + <0><1><6><8> auf dem Nummernblock der Tastatur *)
            (* '' = <Alt> + <0><1><7><5> auf dem Nummernblock der Tastatur *)
      D.GotoXY(spalte,zeile);
      FOR i:= 1 TO laenge DO D.WriteChar(zeichen) END
    END Linie;


  PROCEDURE Erste ( VAR a, b : INTEGER );
   (*-----------------------------------------------------------------------*
    | Referenz: zwei ganze Zahlen, die vom Anwender mittels Tastatur einge- |
    |           geben wurden                                                |
    | Leistung: Anzeige einer unterstrichenen berschrift und einer Aufga-  |
    |           benstellung, Einlesen von zwei vorzeichenbehafteten ganzen  |
    |           Zahlen, errechnen der Summe und Ausgabe dieser, in Text ge- |
    |           kleidet, am Monitor.                                        |
    *-----------------------------------------------------------------------*)

    VAR resCode : CHAR;
        ergebn  : INTEGER;

    BEGIN
      D.WriteStrXY(4,2,'Ein- und Ausgaben im Display-Modul');
      Linie(36,3,3,TRUE);
      D.WriteStrXY(3,5,'Bitte zwei ganze Zahlen eingeben und jede Eingabe');
      D.WriteStrXY(3,6,'durch Bettigen der Enter-Taste abschlieen!');
      D.WriteStrXY(5,8,'1. ganze Zahl ( a ) = ');
      D.ReadInt(a,5,resCode);
      D.WriteStrXY(5,9,'2. ganze Zahl ( b ) = ');
      D.ReadInt(b,5,resCode);
      ergebn:= a + b;
      D.WriteStrXY(5,11,'Berechnen:    a + b = '); D.WriteInt(ergebn,1)
    END Erste;


  PROCEDURE Zweite ( VAR zeiKette : tStr25 );
   (*-----------------------------------------------------------------------*
    | Referenz: Zeichenkette, die maximal 25 Zeichen aufnehmen kann         |
    | Leistung: Anzeige einer Aufgabenstellung, Einlesen einer Zeichenkette,|
    |           die vom Anwender mittels Tastatur eingegeben wurde und far- |
    |           bige Kontrollausgabe der Zeichenkette. Die Kontrollausgabe  |
    |           wird zur Hervorhebung ober- und unterhalb von einer waage-  |
    |           rechten Linie eingefasst.                                   |
    *-----------------------------------------------------------------------*)

    VAR resCode      : CHAR;

    BEGIN
      D.WriteStrXY(3,13,'Bitte eine Zeichenkette eingeben und durch');
      D.WriteStrXY(3,14,'Bettigen der Enter-Taste abschlieen!');
      D.WriteStrXY(5,16,'Zeichenkette (max. 25 Zeichen): ');
      D.ReadStr(zeiKette,25,resCode);
      Linie(46,3,18,FALSE);
      D.SetForeColor(220,0,0);
      D.WriteStrXY(5,19,'Kontrollausgabe: ');
      D.SetForeColor(0,200,200);
      D.WriteStr(zeiKette);
      D.SetForeColor(0,0,0);
      Linie(46,3,21,FALSE)
    END Zweite;


  PROCEDURE DateiSchreiben ( a, b : INTEGER; zeiKette : tStr25 );
   (*-----------------------------------------------------------------------*
    | Leistung: Falls eine Datei gleichen Namens im aktuellen Pfad exis-    |
    |           tiert, wird sie gelscht. Die Datei wird geffnet, der Spei-|
    |           cherbedarf fr einen INTEGER-Wert ermittelt und zwei Blcke |
    |           (a, b) geschrieben. Nun wird der Speicherbedarf fr die Zei-|
    |           chenkette bestimmt und dieser Block geschrieben. Dann wird  |
    |           die Datei geschlossen und eine Zeichenkette am Monitor an-  |
    |           gezeigt, die das erfolgreiche Schreiben besttigt.          |
    *-----------------------------------------------------------------------*)

    VAR handle  : F.Handle;
        resCode : INTEGER;
        n       : LONGINT;

    BEGIN
      IF F.Exist(pfad) THEN F.Delete(pfad,resCode) END;
      F.Open(pfad,TRUE,F.DENYWRITE,F.WRITEONLY,handle,resCode);
      n:= SIZE(INTEGER);
                   (* bentigter Speicherplatz in System-Bytes, INTEGER = 2 *)
      F.WriteBlock(handle,a,n,resCode);
      F.WriteBlock(handle,b,n,resCode);
      n:= SIZE(tStr25);
                   (* bentigter Speicherplatz in System-Bytes, tStr25 = 27 *)
                   (* n:= SIZE(DATENTYP), Datentyp  n i c h t  Bezeichner   *)
      F.WriteBlock(handle,zeiKette,n,resCode);
      F.Close(handle);
      D.WriteStrXY(3,22,'Datei wurde erfolgreich geschrieben!');
      Enter
    END DateiSchreiben;


  PROCEDURE DatenLoeschen ( VAR a, b : INTEGER; VAR zeiKette : tStr25 );
   (*-----------------------------------------------------------------------*
    | Referenz: zwei INTEGER-Variablen und eine Zeichenketten-Variable      |
    | Leistung: Den Variablen werden die Werte o oder die leere Zeichenket- |
    |           te zugewiesen. Das ist notwendig, da der Computer vor der   |
    |           sich anschlieenden Kontrollausgabe die Daten nicht aus der |
    |           Datei liest, sondern die noch im Arbeitsspeicher befindli-  |
    |           chen nutzt.                                                 |
    *-----------------------------------------------------------------------*)

    BEGIN
      a:= 0; b:= 0; zeiKette:= ''
    END DatenLoeschen;


  PROCEDURE DateiLesen ( VAR a, b : INTEGER; VAR zeiKette : tStr25 );
   (*-----------------------------------------------------------------------*
    | Leistung: Falls die Datei im aktuellen Pfad existiert, wird sie ge-   |
    |           ffnet und die Daten blockweise gelesen. Die ersten beiden  |
    |           Blcke enthalten INTEGER-Zahlen, die Bestimmung der Block-  |
    |           gre ist vorausgegangen, der dritte Block enthlt die eine |
    |           Zeichenkette. Die Datei wird geschlossen und eine Zeichen-  |
    |           kette am Monitor angezeigt, die das erfolgreiche Lesen der  |
    |           Daten besttigt.                                            |
    *-----------------------------------------------------------------------*)

    VAR handle  : F.Handle;
        resCode : INTEGER;
        n, read : LONGINT;

    BEGIN
      IF F.Exist(pfad) THEN
        F.Open(pfad,FALSE,F.DENYREAD,F.READONLY,handle,resCode);
        n:= SIZE(INTEGER);
        F.ReadBlock(handle,a,n,read,resCode);
        F.ReadBlock(handle,b,n,read,resCode);
        n:= SIZE(tStr25);
        F.ReadBlock(handle,zeiKette,n,read,resCode);
        F.Close(handle);
        D.WriteStrXY(5,3,'Datei wurde erfolgreich gelesen!');
      ELSE
        HALT(100)
      END 
    END DateiLesen;


  PROCEDURE Kontrollausgabe ( a, b : INTEGER; zeiKette : tStr25 );
   (*-----------------------------------------------------------------------*
    | bernahme: zwei INTEGER-Werte und eine Zeichenkette (Kopien)          |
    | Leistung:  Kommentierte Ausgabe der bernommenen Werte der Variablen. |
    |            Lschen des Tastaurpuffers und Aufruf des Unterprogramms   |
    |            Enter.                                                     |
    *-----------------------------------------------------------------------*)

    VAR ergebn : INTEGER;

    BEGIN
      D.WriteStrXY(5,6,'KONTROLLAUSGABE:');
      Linie(16,5,7,FALSE);
      D.WriteStrXY(5,8,'Zahlen:    a = '); D.WriteInt(a,1);
      D.WriteStrXY(16,9,'b = '); D.WriteInt(b,1);
      D.WriteStrXY(5,11,'Zeichenkette = '); D.WriteStr(zeiKette);
      D.FlushKeyBuffer;
      Enter
    END Kontrollausgabe;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();

    VAR a, b         : INTEGER;
        zeichenkette : tStr25;

    BEGIN
      Erste(a,b);
      Zweite(zeichenkette);
      DateiSchreiben(a,b,zeichenkette);
      DatenLoeschen(a,b,zeichenkette);
      D.ClrScr;
      DateiLesen(a,b,zeichenkette);
      Kontrollausgabe(a,b,zeichenkette)
    END ProgMain;


 END Drei.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

