
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)             Dateiname: ZWEI.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Mai 2001 Version: V 1.0                     |
  |-------------------------------------------------------------------------|
  | Thema:    Eingabe, Ausgabe  (Display-Modul)                             |
  |-------------------------------------------------------------------------|
  | Importe:  Das Modul Zwei importiert das von POW! bereitgestellte Modul  |
  |           Display. Damit werden Prozeduren fr Ein- und Ausgabeanwei-   |
  |           sungen bereitgestellt.                                        |
  | Leistung: Einlesen von Zahlen, die vom Anwender mittels Tastatur einge- |
  |           gebenen werden. Verarbeitung (Addition) und Ausgabe des Er-   |
  |           gebnisses am Bildschirm. Einlesen und Anzeigen eines Textes.  |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)

 MODULE Zwei;
 
  IMPORT D:= Display;     (* Import des Standardmoduls Display,             *)
                          (* Zuweisen des Modulnamen auf den Bezeichner 'D' *)


 (* ---------------------  U N T E R P R O G R A M M ---------------------- *)


  PROCEDURE Linie ( laenge, spalte, zeile : INTEGER; dotFlag : BOOLEAN );
   (*-----------------------------------------------------------------------*
    | bernahme: Lnge der darzustellenden Linie, Textspalte und -zeile des |
    |            Anfangspunkts und den Wahrheitswert einer booleschen Vari- |
    |            able (dotFlag = TRUE, gepunktete Linie, sonst Volllinie)   |
    | Leistung:  Darstellen einer waagerechten gepunktete Linie oder einer  |
    |            waagerechten Volllinie.                                    |
    *-----------------------------------------------------------------------*)

    VAR zeichen : CHAR;
        i       : INTEGER;

    BEGIN
      IF dotFlag THEN zeichen:= '' ELSE zeichen:= '' END;
            (* '' = <Alt> + <0><1><6><8> auf dem Nummernblock der Tastatur *)
            (* '' = <Alt> + <0><1><7><5> auf dem Nummernblock der Tastatur *)
      D.GotoXY(spalte,zeile);
      FOR i:= 1 TO laenge DO D.WriteChar(zeichen) END
    END Linie;


  PROCEDURE Erste;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe einer Arbeitsanweisung, Einlesen von zwei ganzen    |
    |           Zahlen, die mittels Tastatur eingegeben wurden, Berechnen   |
    |           der Summe und Ausgabe dieser, in eine Zeichenkette geklei-  |
    |           det, am Monitor.                                            |
    *-----------------------------------------------------------------------*)

    VAR resCode : CHAR;
        a, b,
        ergebn  : INTEGER;

    BEGIN
      D.WriteStrXY(4,2,'Ein- und Ausgaben im Display-Modul');
      Linie(36,3,3,TRUE);
      D.WriteStrXY(3,5,'Bitte zwei ganze Zahlen eingeben und jede Eingabe');
      D.WriteStrXY(3,6,'durch Bettigen der Enter-Taste abschlieen!');
      D.WriteStrXY(5,8,'1. ganze Zahl ( a ) = ');
      D.ReadInt(a,5,resCode);
      D.WriteStrXY(5,9,'2. ganze Zahl ( b ) = ');
      D.ReadInt(b,5,resCode);
      ergebn:= a + b;
      D.WriteStrXY(5,11,'Berechnen:    a + b = ');
      D.WriteInt(ergebn,1)
    END Erste;


  PROCEDURE Zweite;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe einer Arbeitsanweisung, Einlesen einer maximal 25   |
    |           Zeichen umfassenden Zeichenkette, die mittels Tastatur ein- |
    |           gegeben wurden, Ausgabe dieser Zeichenkette am Monitor      |
    |           (Kontrollausgabe)                                           |
    *-----------------------------------------------------------------------*)

    VAR zeichenkette : ARRAY 26 OF CHAR;
                                     (* kann 25 druckbare Zeichen aufnehmen *)
        resCode      : CHAR;

    BEGIN
      D.WriteStrXY(3,13,'Bitte eine Zeichenkette eingeben und durch');
      D.WriteStrXY(3,14,'Bettigen der Enter-Taste abschlieen!');
      D.WriteStrXY(5,16,'Zeichenkette (max. 25 Zeichen): ');
      D.ReadStr(zeichenkette,25,resCode);
      Linie(46,3,18,FALSE);
      D.SetForeColor(220,0,0);
      D.WriteStrXY(5,19,'Kontrollausgabe: ');
      D.SetForeColor(0,200,200);
      D.WriteStr(zeichenkette);
      D.SetForeColor(0,0,0);
      Linie(46,3,21,FALSE)
    END Zweite;


  PROCEDURE Enter;
    BEGIN
      D.FlushKeyBuffer;
      D.WriteStrXY(65,23,'< ENTER >');
      REPEAT UNTIL D.KeyPressed()
    END Enter;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Erste;
      Zweite;
      Enter
    END ProgMain;


 END Zwei.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

