
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)         Dateiname: FORUEB02.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: August 2001 Version: V 2.1                  |
  |-------------------------------------------------------------------------|
  | Thema:    Wiederholungen: Die Zhlschleife (FOR-Anweisung)              |
  |-------------------------------------------------------------------------|
  | Anliegen: Das Programm verdeutlicht die Wirkungsweise der Zhlschleife  |
  |           (aufwrtszhlend und abwrtszhlend).                         |
  |           Es wird gezeigt, wie die Laufvariable der Schleife genutzt    |
  |           wird.                                                         |
  |           Lsung der Aufgabe aus FOR02.MOD                              |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Programm ist fr den Grafikmodus 800 x 600 Pixel         |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |           Das Beenden des Programms kann durch Bettigen der Enter-     |
  |           taste oder durch Mausklick auf das abschlieende < Enter >    |
  |           erfolgen.                                                     |
  |           Sollte der Mauszeiger nach der Anzeige '< Enter >' nicht auf  |
  |           dieses Wort zeigen, so mssen die Werte der Anweisung         |
  |           'Ch.MoveMouseRel(-78,-50);', in den Zeilen 72 und 105, ge-    |
  |           ringfgig gendert werden. '-78,50' ist der Wert fr die Gra- |
  |           fikkarte GLADIAC MX geforce2mx.                               |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)


 MODULE ForUeb02;

  IMPORT Ch:= ChSTools;

  CONST  dTime     = 25;

         message   = 'ITERATION  (Schleifen)';
         year      = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Schleife_aufsteigend ( ew : INTEGER; bkColor : Ch.tColor );
   (*-----------------------------------------------------------------------*
    | bernahme: Endwert fr die Zhlschleife,                              |
    |            Hintergrundfarbe (DT: Verbund aus den drei RGB-Farbwerten) |
    | Leistung:  Ausgabe einer Schar von kleiner werdenden Kreisen.         |
    *-----------------------------------------------------------------------*)

    CONST xM = 233;
          yM = 230;
          r  = 100;

    VAR   i  : INTEGER;

    BEGIN
      Ch.SetForeColorNb(Ch.LightMagenta);

     (* -----  Zhlschleife aufwrts  ----- *)

      FOR i:= 0 TO ew DO
        Ch.Circle(xM+2*i,yM+2*i,r-i);
        Ch.Delay_ms(dTime DIV 2)    
      END;

     (* ----------------------------------- *)

      Ch.Delay_ms(dTime);
      Ch.MoveMouseRel(-78,-50);
      Ch.Enter(660,45,Ch.Cyan,bkColor,FALSE,dTime);
      Ch.MoveMouseRel(800,600)
    END Schleife_aufsteigend;


  PROCEDURE Schleife_absteigend ( ew : INTEGER; bkColor : Ch.tColor );
   (*-----------------------------------------------------------------------*
    | bernahme: Endwert fr die Zhlschleife,                              |
    |            Hintergrundfarbe (DT: Verbund aus den drei RGB-Farbwerten) |
    | Leistung:  Ausgabe einer Schar von grer werdenden Kreisen.          |
    *-----------------------------------------------------------------------*)

    CONST xM = 548;
          yM = 230;
          r  = 100;

    VAR i : INTEGER;

    BEGIN
      Ch.SetForeColorNb(Ch.LightCyan);

     (* -----  Zhlschleife abwrts  ------ *)

       FOR i:= ew TO 0 BY -1 DO
         Ch.Circle(xM-2*i,yM+2*i,r-i);
         Ch.Delay_ms(dTime DIV 4)
       END;

     (* ----------------------------------- *)

      Ch.Delay_ms(dTime);
      Ch.MoveMouseRel(800,600);
      Ch.MoveMouseRel(-78,-50);
      Ch.Enter(660,45,Ch.Cyan,Ch.bkColor,FALSE,dTime)
    END Schleife_absteigend;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

 PROCEDURE ProgMain*;

   CONST endwert   = 57;

   BEGIN
     Ch.MoveMouseRel(800,600);
     Ch.Title(Ch.LightCyan,490,dTime,Ch.bkColor,
                     'Wiederholungen: Die Zhlschleife',FALSE);
     Schleife_aufsteigend(endwert,Ch.bkColor);
     Schleife_absteigend(endwert,Ch.bkColor);
     Ch.Close                                        (* Malkasten schlieen *)
   END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Ch.InitiateColorPlane(Ch.bkColor,0,0,32);   (* Malkasten ffnen und gro- *)
                                               (* es Fenster einstellen    *)
   Ch.HeadLine(message,year);                  (* Eintrag in die Bildleiste *)
   Ch.Delay_ms(500)
 END ForUeb02.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

