
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)         Dateiname: FORUEB03.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: August 2001 Version: V 2.1                  |
  |-------------------------------------------------------------------------|
  | Thema:    Wiederholungen: Die geschachtelte Zhlschleife                |
  |-------------------------------------------------------------------------|
  | Anliegen: Das Programm verdeutlicht die Wirkungsweise der Zhlschleife  |
  |           (aufwrtszhlend und abwrtszhlend).                         |
  |           Es wird gezeigt, wie die Laufvariable der Schleife genutzt    |
  |           wird.                                                         |
  |           Lsung der Aufgabe aus FOR02.MOD                              |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Programm ist fr den Grafikmodus 800 x 600 Pixel         |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |           Das Beenden des Programms kann durch Bettigen der Enter-     |
  |           taste oder durch Mausklick auf das abschlieende < Enter >    |
  |           erfolgen.                                                     |
  |           Sollte der Mauszeiger nach der Anzeige '< Enter >' nicht auf  |
  |           dieses Wort zeigen, so mssen die Werte der Anweisung         |
  |           'Ch.MoveMouseRel(-78,-50);', in den Zeilen 74 und 92, gering- |
  |           fgig gendert werden. '-78,50' ist der Wert fr die Grafik-  |
  |           karte GLADIAC MX geforce2mx.                                  |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)


 MODULE ForUeb03;

  IMPORT Ch:= ChSTools;

  CONST  dTime     = 100;

         message   = 'ITERATION  (Schleifen)';
         year      = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Schleife_geschachtelt ( ew : INTEGER; bkColor : Ch.tColor );
   (*-----------------------------------------------------------------------*
    | bernahme: Endwert fr die Zhlschleife,                              |
    |            Hintergrundfarbe (DT: Verbund aus den drei RGB-Farbwerten) |
    | Leistung:  Ausgabe eines Sternchenbaums am Bildschirm.                |
    *-----------------------------------------------------------------------*)

    CONST zeichen = '*';

    VAR   i, k    : INTEGER;

    BEGIN
      Ch.SetForeColorNb(Ch.LightGreen);

     (* -----  geschachtelte Zhlschleifen  ----- *)

      FOR i:= ew TO 0 BY -1 DO
        Ch.GotoXY(540+8*(i-ew),80+18*i);
        FOR k:= i*2 TO ew DO
          Ch.WriteChar(zeichen);
          Ch.Delay_ms(1)
        END;
        Ch.Delay_ms(dTime DIV 2)    
      END;

     (* ----------------------------------------- *)

      Ch.Delay_ms(dTime);
      Ch.MoveMouseRel(-78,-50);
      Ch.Enter(660,45,Ch.Cyan,bkColor,FALSE,dTime)
    END Schleife_geschachtelt;


  PROCEDURE Dreieck ( bkColor : Ch.tColor );
   (*-----------------------------------------------------------------------*
    | bernahme: Hintergrundfarbe (DT: Verbund aus den drei RGB-Farbwerten) |
    | Leistung:  Ausgabe eines Dreiecks, das den Sternchenbaum umschliet.  |
    *-----------------------------------------------------------------------*)

    BEGIN
      Ch.SetForeColorNb(Ch.Cyan);
      Ch.GotoXY(210,62);
      Ch.LineTo(384,448,Ch.DRAW);
      Ch.LineTo(558,62,Ch.DRAW);
      Ch.LineTo(210,62,Ch.DRAW);
      Ch.Delay_ms(dTime);
      Ch.MoveMouseRel(800,600);
      Ch.MoveMouseRel(-78,-50);
      Ch.Enter(660,45,Ch.Cyan,bkColor,FALSE,dTime)
    END Dreieck;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

 PROCEDURE ProgMain*;

   CONST endwert   = 40;

   BEGIN
     Ch.MoveMouseRel(800,600);
     Ch.Title(Ch.LightCyan,490,dTime DIV 25,Ch.bkColor,
                     'Wiederholungen: Die Zhlschleife',FALSE);
     Schleife_geschachtelt(endwert,Ch.bkColor);
     Dreieck(Ch.bkColor);
     Ch.Close                                        (* Malkasten schlieen *)
   END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Ch.InitiateColorPlane(Ch.bkColor,0,0,32);   (* Malkasten ffnen und gro- *)
                                               (* es Fenster einstellen    *)
   Ch.HeadLine(message,year);                  (* Eintrag in die Bildleiste *)
   Ch.Delay_ms(500)
 END ForUeb03.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

