
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)            Dateiname: FOR02.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: August 2001 Version: V 2.1                  |
  |-------------------------------------------------------------------------|
  | Thema:    Wiederholungen: Die Zhlschleife (FOR-Anweisung)              |
  |-------------------------------------------------------------------------|
  | Anliegen: Das Programm verdeutlicht die Wirkungsweise der Zhlschleife  |
  |           (aufwrtszhlend und abwrtszhlend).                         |
  |           Es wird gezeigt, wie die Laufvariable der Schleife genutzt    |
  |           wird.                                                         |
  |-------------------------------------------------------------------------|
  | Aufgabe:  Kopieren Sie sich das gesamte Programm unter dem Namen        |
  |           FORUEB02.MOD in das Ihnen zugewiesene Verzeichnis.            |
  |           Importieren Sie das Service-Modul 'ChSTools' (Ch:= ChSTools), |
  |           tauschen Sie in der  e r s t e n  Zhlschleife die            |
  |           Line-Anweisung gegen die folgende Zeile:                      |
  |             'Ch.Circle(xM+2*i,yM+2*i,r-i,3,0);'                         |
  |           und in der  z w e i t e n  Zhlschleife gegen die Zeile:      |
  |             'Ch.Circle(xM-2*i,yM+2*i,r-i,3,0);',                        |
  |           ergnzen Sie die fehlenden Konstanten (z.B. xM = 250;),       |
  |           entfernen Sie die Zahlen- und Textausgabe in den beiden Pro-  |
  |           zeduren 'Schleife_...' und whlen Sie die Koordinaten der     |
  |           Mittelpunkte der Kreise so, dass sich die beiden 'Rhren' an  |
  |           den Enden berhren. Speichern Sie den vernderten Quelltext.  |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Programm ist fr den Grafikmodus 800 x 600 Pixel         |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |           Das Fortsetzen und Beenden des Programms kann durch Bettigen |
  |           der Entertaste oder durch Mausklick auf das abschlieende     |
  |           < Enter > erfolgen.                                           |
  |           Sollte der Mauszeiger nach der Anzeige '< Enter >' nicht auf  |
  |           dieses Wort zeigen, so mssen die Werte der Anweisung         |
  |           'Ch.MoveMouseRel(-78,-50);', in den Zeilen 101 und 136, ge-   |
  |           ringfgig gendert werden. '-78,50' ist der Wert fr die Gra- |
  |           fikkarte GLADIAC MX geforce2mx.                               |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)


 MODULE For02;

  IMPORT Ch:= ChSTools;

  CONST  dTime     = 150;

         message   = 'ITERATION  (Schleifen)';
         year      = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Beschriften ( x, y, colNb : INTEGER; text : Ch.tStr75 );
   (*-----------------------------------------------------------------------*
    | bernahme: x- und y-Koordinate, Farbnummer der (Standard)-VGA-Farbe   |
    |            undauszugebender Text (Zeichenkette)                       |
    | Leistung:  Positionierte farbige Ausgabe einer Zeichenkette.          |
    *-----------------------------------------------------------------------*)

    BEGIN
      Ch.SetForeColorNb(colNb);
      Ch.WriteStrXY(x,y,text)
    END Beschriften;


  PROCEDURE Schleife_aufsteigend ( ew : INTEGER; bkColor : Ch.tColor );
   (*-----------------------------------------------------------------------*
    | bernahme: Endwert fr die Zhlschleife,                              |
    |            Hintergrundfarbe (DT: Verbund aus den drei RGB-Farbwerten) |
    | Leistung:  Ausgabe einer Linienschar mit gemeinsamen Endpunkt.        |
    |            Beschriften der kleinen Grafik mit dem Anfangs- und End-   |
    |            wert der Laufvariable.                                     |
    *-----------------------------------------------------------------------*)

    VAR i : INTEGER;

    BEGIN
      Beschriften(156,105,Ch.Brown,'0');
      Ch.Delay_ms(dTime);
      Ch.SetForeColorNb(Ch.LightMagenta);

     (* -----  Zhlschleife aufwrts  ----- *)

      FOR i:= 0 TO ew DO
        Ch.Line(170,100+6*i,600,100,Ch.DRAW);
        Ch.Delay_ms(dTime DIV 2)    
      END;

     (* ----------------------------------- *)

      Ch.Delay_ms(dTime);
      Beschriften(148,410,Ch.Brown,'50');
      Ch.Delay_ms(dTime);
      Beschriften(233,390,Ch.Magenta,'aufsteigend');
      Ch.MoveMouseRel(-78,-50);
      Ch.Enter(660,45,Ch.Cyan,bkColor,FALSE,dTime);
      Ch.MoveMouseRel(800,600)
    END Schleife_aufsteigend;


  PROCEDURE Schleife_absteigend ( ew : INTEGER; bkColor : Ch.tColor );
   (*-----------------------------------------------------------------------*
    | bernahme: Endwert fr die Zhlschleife,                              |
    |            Hintergrundfarbe (DT: Verbund aus den drei RGB-Farbwerten) |
    | Leistung:  Ausgabe einer Linienschar mit gemeinsamen Startpunkt.      |
    |            Beschriften der kleinen Grafik mit dem Anfangs- und End-   |
    |            wert der Laufvariable.                                     |
    *-----------------------------------------------------------------------*)

    VAR i : INTEGER;

    BEGIN
      Beschriften(605,410,Ch.Brown,'50');
      Ch.Delay_ms(dTime DIV 2);
      Ch.SetForeColorNb(Ch.LightCyan);

     (* -----  Zhlschleife abwrts  ------ *)

       FOR i:= ew TO 0 BY -1 DO
         Ch.Line(170,100,600,100+6*i,Ch.DRAW);
         Ch.Delay_ms(dTime DIV 4)
       END;

     (* ----------------------------------- *)

      Ch.Delay_ms(dTime);
      Beschriften(612,105,Ch.Brown,'0');
      Ch.Delay_ms(dTime);
      Beschriften(461,390,Ch.Cyan,'absteigend');
      Ch.MoveMouseRel(-78,-50);
      Ch.Enter(660,45,Ch.Cyan,Ch.bkColor,FALSE,dTime)
    END Schleife_absteigend;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

 PROCEDURE ProgMain*;

   CONST endwert   = 50;

   BEGIN
     Ch.MoveMouseRel(800,600);
     Ch.Title(Ch.LightCyan,490,dTime,Ch.bkColor,
                     'Wiederholungen: Die Zhlschleife',FALSE);
     Ch.Delay_ms(dTime*5);
     Schleife_aufsteigend(endwert,Ch.bkColor);
     Schleife_absteigend(endwert,Ch.bkColor);
     Ch.Close                                        (* Malkasten schlieen *)
   END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Ch.InitiateColorPlane(Ch.bkColor,0,0,32);   (* Malkasten ffnen und gro- *)
                                               (* es Fenster einstellen    *)
   Ch.HeadLine(message,year);                  (* Eintrag in die Bildleiste *)
   Ch.Delay_ms(500)
 END For02.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

