
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)            Dateiname: FOR03.MOD |
  |-------------------------------------------------------------------------|
  | Autor:     Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                  |
  |            Erstellungsdatum: August 2001 Version: V 2.1                 |
  |-------------------------------------------------------------------------|
  | Thema:     Wiederholungen: Die geschachtelte Zhlschleife               |
  |-------------------------------------------------------------------------|
  | Anliegen:  Das Programm enthlt zwei geschachtelte Zhlschleifen.       |
  |            Es wird gezeigt, wie die Laufvariablen der Schleifen         |
  |            (beide aufsteigend) genutzt werden.                          |
  |-------------------------------------------------------------------------|
  |  Aufgabe:  Schreiben Sie den Quelltext fr ein Programm, welches mit-   |
  |            tels zweier geschachtelter Schleifen einen 'Sternchenbaum'   |
  |     *      nebenstehenden Musters auf dem Bildschirm darstellt!         |
  |    ***     Der Textmodus ist ausreichend, falls es Ihnen unter Graphik  |
  |   *****    zu aufwendig erscheint.                                      |
  |  *******   Speichern Sie den Quelltext unter dem Namen FORUEB03.MOD in  |
  | *********  das fr Sie eingerichtete Verzeichnis!                       |
  |-------------------------------------------------------------------------|
  | Hinweise:  Das Programm ist fr den Grafikmodus 800 x 600 Pixel        |
  |            konzipiert (Ausnutzung der gesamten Bildschirmflche).       |
  |            Die Koordinaten des sichtbaren Grafikbildschirms sind:       |
  |            linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).    |
  |            Das Beenden des Programms kann durch Bettigen der Enter-    |
  |            taste oder durch Mausklick auf das abschlieende < Enter >   |
  |            erfolgen.                                                    |
  |            Sollte der Mauszeiger nach der Anzeige '< Enter >' nicht auf |
  |            dieses Wort zeigen, so mssen die Werte der Anweisung        |
  |            'Ch.MoveMouseRel(-78,-50);', Zeile 103, geringfgig gendert |
  |            werden. '-78,50' ist der Wert fr die Grafikkarte GLADIAC MX |
  |            geforce2mx.                                                  |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)

 MODULE For03;
 
  IMPORT Ch:= ChSTools, S:= Strings;

  CONST  dTime     = 100;

         message   = 'ITERATION  (Schleifen)';
         year      = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Beschriften ( x, y, colorNb : INTEGER; text : Ch.tStr75 );
   (*-----------------------------------------------------------------------*
    | bernahme: x- und y-Koordinate, Farbnummer der (Standard)-VGA-Farbe   |
    |            und auszugebender Text (Zeichenkette)                      |
    | Leistung:  Positionierte farbige Ausgabe einer Zeichenkette.          |
    *-----------------------------------------------------------------------*)

   BEGIN
     Ch.SetForeColorNb(colorNb);
     Ch.WriteStrXY(x,y,text)
   END Beschriften;


  PROCEDURE Schleifen_geschachtelt;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe je einer pinkfarbenen Linie (uere Schleife) und   |
    |           einer blauen Linienschar bestehend aus acht Linien (innere  |
    |           Schleife). Beschriften der Linien der ueren Schleife mit  |
    |           den aktuellen Werten der Laufvariable.                      |
    *-----------------------------------------------------------------------*)

   VAR text    : Ch.tStr75;
       i, k, n : INTEGER;
       
   BEGIN
     Ch.SetForeColorNb(Ch.LightMagenta);
     Ch.Line(215,100,255,100,Ch.DRAW);
     Beschriften(265,108,7,'uere Schleife');
     Ch.SetForeColorNb(9);
     Ch.Line(400,100,440,100,Ch.DRAW);
     Beschriften(450,108,7,'innere Schleife');
     Ch.Delay_ms(dTime*8);

     (* ---  Geschachtelte Zhlschleifen  --- *)
     
     FOR i:= 1 TO 8 DO
       S.Str(i,text);
       Ch.SetForeColorNb(7);
       Ch.WriteStrXY(232,112+36*i,text);
       Ch.SetForeColorNb(13);
       Ch.Line(245,105+36*i,545,105+36*i,Ch.DRAW);
       Ch.Delay_ms(dTime);
       Ch.SetForeColorNb(9);
       FOR k:= 1 TO 8 DO
         Ch.Line(255,110+36*i+3*k,535,110+36*i+3*k,Ch.DRAW);
         Ch.Delay_ms(dTime DIV 2)
       END; (* for k ... *)
       Ch.Delay_ms(dTime);
     END; (* for i ... *)
     
     (* ------------------------------------- *)
          
     Ch.MoveMouseRel(-78,-50);
     Ch.Enter(660,45,Ch.Cyan,Ch.bkColor,FALSE,dTime)
   END Schleifen_geschachtelt;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)
 
 PROCEDURE ProgMain*;
   BEGIN
     Ch.MoveMouseRel(800,600);
     Ch.Title(Ch.LightCyan,490,dTime,Ch.bkColor,
                     'Wiederholungen: Die geschachtelte Zhlschleife',FALSE);
     Ch.Delay_ms(dTime*8);
     Schleifen_geschachtelt;
     Ch.Close
   END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Ch.InitiateColorPlane(Ch.bkColor,0,0,32);   (* Malkasten ffnen und gro- *)
                                               (* es Fenster einstellen    *)
   Ch.HeadLine(message,year);                  (* Eintrag in die Bildleiste *)
   Ch.Delay_ms(500)
 END For03.

 (* ---------   1999/01  Manfred Kmmerer, Chamberlain-Soft JENA  ---------*)
