
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)         Dateiname: FORUEB01.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: August 2001 Version: V 2.1                  |
  |-------------------------------------------------------------------------|
  | Thema:    Wiederholungen: Zhlschleifen und VGA-Farbtabelle             |
  |           (Zusatzbung mit Graphik)                                     |
  |-------------------------------------------------------------------------|
  | Anliegen: In diesem Programm werden erneut Zhlschleifen zur Darstel-   |
  |           lung von Liniengarafiken eingesetzt.                          |
  |           Die im User-Modul 'VGAColors' kreierten 16 Standard-VGA-Far-  |
  |           ben werden dargestellt.                                       |
  |-------------------------------------------------------------------------|
  | Aufgabe:  Q u e l l t e x t a n a l y s e                               |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Programm ist fr den Grafikmodus 800 x 600 Pixel         |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |           Das Beenden des Programms kann durch Bettigen der Enter-     |
  |           taste oder durch Mausklick auf das abschlieende < Enter >    |
  |           erfolgen.                                                     |
  |           Sollte der Mauszeiger nach der Anzeige '< Enter >' nicht auf  |
  |           dieses Wort zeigen, so mssen die Werte der Anweisung         |
  |           'Ch.MoveMouseRel(-78,-50);', Zeile 128, geringfgig gendert  |
  |           werden. '-78,50' ist der Wert fr die Grafikkarte GLADIAC MX  |
  |           geforce2mx.                                                   |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)
  

 MODULE ForUeb01;
   
  IMPORT Ch:= ChSTools;

  CONST  dTime   = 100;

         message = 'ITERATION  (Schleifen)';
         year    = '2001';

   TYPE  tText   = Ch.tStr75;               (* 'Umtypisierung' ist mglich. *)
                                            (* Der Sinn ist fraglich!       *)


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)
 

  PROCEDURE Beschriften ( x, y : INTEGER; text : tText );
   (*-----------------------------------------------------------------------*
    | bernahme: Koordinaten und Zeichenkette fr die Zwischenberschriften |
    | Leistung:  Setzen der Vordergrundfarbe (Hellgrau) und positionierte   |
    |            Ausgabe einer Zeichenkette.                                |
    *-----------------------------------------------------------------------*)

    BEGIN
      Ch.SetForeColorNb(Ch.LightGray);
      Ch.WriteStrXY(x,y,text);
      Ch.Delay_ms(dTime)
    END Beschriften;
 
 
  PROCEDURE Segel;
   (*-----------------------------------------------------------------------*
    | Leistung: Anwendung einer Zhlschleife,                               |
    |           Setzen der RGB-Farbwerte und Zeichnen der farbigen Linien.  |
    *-----------------------------------------------------------------------*)
   
    VAR i : INTEGER;
   
    BEGIN
      FOR i:= 0 TO 20 DO
        Ch.SetForeColor(120,255-i*12,55+i*10);
        Ch.Line(100,100+i*20,500-i*20,100,Ch.DRAW);
        Ch.Delay_ms(dTime DIV 2)
      END;
      Ch.Delay_ms(dTime)
    END Segel;


  PROCEDURE Farbbalken;
   (*-----------------------------------------------------------------------*
    | Leistung: Anwendung einer geschachtelte Zhlschleife,                 |
    |           Setzen je einer VGA-Standardfarbe (uere Schleife) und     |
    |           Zeichnen der farbigen Balken (Linienschar, innere Schleife).|
    |           Zum Setzen der Farben wird eine Routine des User-Moduls     |
    |           VGAColor genutzt.                                           |
    *-----------------------------------------------------------------------*)

    VAR i, k : INTEGER;

    BEGIN
      FOR i:= 1 TO 15 DO
        Ch.SetForeColorNb(i);
        FOR k:= 0 TO 6 DO
          Ch.Line(560,385-k-i*16,660,385-k-i*16,Ch.DRAW)
        END;
        Ch.Delay_ms(dTime DIV 5)
      END;
      Ch.Delay_ms(dTime)
    END Farbbalken;


  PROCEDURE Darstellen;
   (*-----------------------------------------------------------------------*
    | Leistung: Ablaufsteuerung fr die beiden Grafiken und deren Teilber- |
    |           schriften.                                                  |
    *-----------------------------------------------------------------------*)
   
    BEGIN   
      Beschriften(180,420,'EINE LINIENGRAFIK');
      Segel;
      Beschriften(530,420,'DIE VGA-FARBTABELLE');
      Farbbalken
    END Darstellen;
   
   
 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)
     
 PROCEDURE ProgMain*(); 
   BEGIN
     Ch.MoveMouseRel(800,600);
     Ch.Title(Ch.LightCyan,490,dTime,Ch.bkColor,
                     'Zwei grafische Anwendungsbeispiele',FALSE);
     Darstellen;
     Ch.MoveMouseRel(-78,-50);
     Ch.Enter(660,45,Ch.Cyan,Ch.bkColor,FALSE,dTime);
     Ch.Close
   END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Ch.InitiateColorPlane(Ch.bkColor,0,0,32);   (* Malkasten ffnen und gro- *)
                                               (* es Fenster einstellen    *)
   Ch.HeadLine(message,year);                  (* Eintrag in die Bildleiste *)
   Ch.Delay_ms(500)
   
 END ForUeb01.

 (* -----------   2001 Manfred Kmmerer, Chamberlain-Soft JENA  -----------*)
