
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)         Dateiname: REPEAT01.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: August 2001 Version: V 2.1                  |
  |-------------------------------------------------------------------------|
  | Thema:    Wiederholungen: Schleife mit Austrittsbedingung               |
  |                           (Schleife mit nachgestelltem Test,            |
  |                           die REPEAT-Anweisung)                         |
  |-------------------------------------------------------------------------|
  | Anliegen: Das Programm demonstriert in der Wiederholungsababfrage die   |
  |           Anwendung der REPEAT-Anweisung.                               |
  |           Die REPEAT-Anweisung wird in diesem Modul in zwei Prozeduren  |
  |           und in der ProgMain genutzt.                                  |
  |-------------------------------------------------------------------------|
  | Aufgabe:  Schreiben Sie ein Oberon-2-Programm, welches im 'Hauptpro-    |
  |           gramm (ProgMain) eine REPEAT-Anweisung zum Anhalten eines     |
  |           rotierenden 'Zeigers' enthlt, der in einer Prozedur oder     |
  |           in einem USER-MODUL programmiert ist.                         |
  |           Die Farben des entstandenen 'Rades' sollen sich jeweils nach  |
  |           einem Dreivierteldurchlauf ndern. Nutzen Sie konsequent das  |
  |           prozedurale Konzept (lokale Variablen).                       |
  |           Der Anwender muss versuchen, den Zeiger beim Farbbergang     |
  |           von Wei nach Blau durch Tastendruck zu stopppen. Das ent-    |
  |           spricht im Zhlerfenster der Zahl 315 o. 316.                 |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Programm ist fr den Grafikmodus 800 x 600 Pixel         |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |           Das Beenden des Programms kann durch Bettigen der Enter-     |
  |           taste oder durch Mausklick auf das abschlieende < Enter >    |
  |           erfolgen.                                                     |
  |           Sollte der Mauszeiger nach der Anzeige '< Enter >' nicht auf  |
  |           dieses Wort zeigen, so mssen die Werte der Anweisung         |
  |           'Ch.MoveMouseRel(-78,-50);', Zeile 208, geringfgig gendert  |
  |           werden. '-78,50' ist der Wert fr die Grafikkarte GLADIAC MX  |
  |           geforce2mx.                                                   |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)

 MODULE Repeat01;
 
  IMPORT Ch:= ChSTools, S:= Strings;
 
  CONST  dTime     = 100;

         message   = 'ITERATION  (Schleifen)';
         year      = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE ReadVal ( VAR wert : INTEGER );
   (*-----------------------------------------------------------------------*
    | Rckgabe: Mittels Tastatur eingegebener Wert                          |
    | Leistung: Positionierte Ausgabe von zwei Zeichenketten, Einlesen      |
    |           einer mittels Tastatur eingegebenen Zeichenfolge.           |
    |           Auswertung: Nach dem Bettigen der Enter- oder Esc-Taste    |
    |           wird die Variable aChar (Zeichenfolge) mit '55' belegt.     |
    |           Werden Ziffernfolgen eingegeben, die einer Austrittsbedin-  |
    |           gungen der Schleife gengt, folgt die Konvertierung der     |
    |           Zeichenfolge in einen INTEGER-Wert.                         |
    *-----------------------------------------------------------------------*)

   VAR aChar   : Ch.tStr75;
       resCode : CHAR;
       
   BEGIN
     Ch.SetBackColorRec(Ch.bkColor);
     Ch.SetForeColorNb(Ch.Yellow); Ch.GotoXY(190,70);
     Ch.WriteStr('Bitte eine Zahl zwischen 40 und 65 eingeben!');
     Ch.GotoXY(555,70); Ch.WriteStr('Zahl =');
     
     (* ---  Schleife mit Austrittsbedingung  --- *)

     REPEAT
       Ch.Bar(618,70,630,56,Ch.ERASE);
       Ch.GotoXY(616,70);
       Ch.ReadStr(aChar,3,resCode);
       IF (aChar = '') & (resCode = Ch.ENTER) OR (resCode = Ch.ESC) THEN 
         aChar:= '55';
         Ch.WriteStr('55');
         Ch.Delay_ms(dTime * 5)
       END
     UNTIL (aChar >= '40') & (aChar <= '65');

     (* ----------------------------------------- *)

     wert:= SHORT(S.Val(aChar));
     Ch.Bar(188,56,632,70,Ch.ERASE)
   END ReadVal;
 

  PROCEDURE Segel ( Wert : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Per Tastatur eingegebener Wert (Wertparameter)             |
    | Leistung:  Zeichnen eines geschlossenen zweifarbigen Linienzugs.      |
    *-----------------------------------------------------------------------*)

   VAR i, x, x1, x2, y, y1, y2 : INTEGER;

   BEGIN
     Ch.SetForeColorNb(Ch.Green);
     x:= 450; y:= 74;
     Ch.GotoXY(x,y);                         (* Zeichnen eines geschlossenen *)
     FOR i:= 0 TO 49 DO                     (* Linienzuges, Ch.LineTo(...)  *)
       x1:= 150+8*i; y1:= 74+3*i;        
       IF ODD(i) THEN Ch.LineTo(x1,y1,Ch.DRAW) 
         ELSE x1:= 450+5*i; y1:= 74+8*i; 
         Ch.LineTo(x1,y1,Ch.DRAW)
       END;
       IF (i > Wert DIV 2) THEN Ch.SetForeColorNb(Ch.LightBlue) END;
       Ch.Delay_ms(dTime DIV 8)
     END;
     Ch.Delay_ms(dTime)
   END Segel;

 
  PROCEDURE Kasten ( Wert : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Per Tastatur eingegebener Wert (Wertparameter)             |
    | Leistung: Zeichnen einer zweifarbigen Folge von Rechtecken.           |
    *-----------------------------------------------------------------------*)

    VAR i : INTEGER;

    BEGIN
      FOR i:= 1 TO Wert DIV 2 DO
        IF (i MOD 6 = 0) THEN Ch.SetForeColorNb(Ch.LightBlue)
          ELSE Ch.SetForeColorNb(Ch.Yellow) END;
        Ch.Box(350-6*i,250-4*i,400-2*i,300+4*i,Ch.DRAW);
        Ch.Delay_ms(dTime DIV 10)
      END
    END Kasten;


  PROCEDURE Wiederholung () : CHAR;
   (*-----------------------------------------------------------------------*
    | Referenz: Funktionswert, ein Zeichen (DT: CHAR)                       |
    | Leistung: Positionierte farbige Ausgabe einer Zeichenkette, Lschen   |
    |           des Tastaturpuffers, Zeichen einer kurzen Linie als Grafik- |
    |           cursor, eine bestimmte Zeit warten, Linie mit Hintergrund-  |
    |           farbe bermalen und wieder eine bestimmte Zeit warten.      |
    |           Dieser Vorgang wird wiederholt, bis eine Taste auf der Tas- |
    |           tatur bettigt wird. Danach wird die Zeichenkette gelscht  |
    |           und das eingegebene Zeichen, falls es sich um einen Klein-  |
    |           buchstaben handelt, als Grobuchstabe an das rufende Pro-   |
    |           gramm 'zurgkgegeben' (Funktionswert als Referenzparameter).|
    |           Wurde eine beliebige Taste, die ein druckbares Zeichen re-  |
    |           prsentiert, auf der Tastatur bettigt, soll das vom aus-   |
    |           wertenden Programmteil als 'J' (Ja) interpretiert werden.   |
    |-----------------------------------------------------------------------|
    | Hinweis:  Diese Prozedur ist im User-Modul ChSTools implementiert,    |
    |           wurde aber wegen der REPEAT-Anweisung in dieses Modul auf-  |
    |           genommen.                                                   |
    *-----------------------------------------------------------------------*)

   VAR key : CHAR;
   
   BEGIN
     Ch.MoveMouseRel(800,600);
     Ch.SetBackColorRec(Ch.bkColor);
     Ch.SetForeColorNb(Ch.LightGreen);
     Ch.GotoXY(240,50); Ch.WriteStr('Wird eine Wiederholung gewnscht (J/N) J');
     Ch.FlushKeyBuffer();

     (* ---  Schleife mit Austrittsbedingung  --- *)
     (*      blinkender Cursor im Grafikmodus     *)

     REPEAT 
       Ch.SetForeColorNb(Ch.White); Ch.Line(551,36,560,36,Ch.DRAW);
       Ch.Delay_ms(dTime*3);
       Ch.SetForeColorNb(Ch.Black); Ch.Line(551,36,560,36,Ch.DRAW);
       Ch.Delay_ms(dTime*2)
     UNTIL Ch.KeyPressed();

     (* ----------------------------------------- *)

     key:= Ch.ReadKey();
     Ch.Bar(100,466,690,36,Ch.ERASE);
     RETURN CAP(key)                     (* CAP(x) wandelt einen Kleinbuch- *)
                                         (* staben in einen Grobuchstaben  *)
   END Wiederholung;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)
 
 PROCEDURE ProgMain*;

   VAR n : INTEGER;

   BEGIN
     Ch.MoveMouseRel(800,600);
     Ch.Title(Ch.LightCyan,486,dTime,Ch.bkColor,
                     'Wiederholungen: Die REPEAT-Anweisung',FALSE);

     (* ---  Schleife mit Austrittsbedingung  --- *)

     REPEAT
       ReadVal(n);
       Segel(n);
       Kasten(n);
       Ch.MoveMouseRel(800,600);
       Ch.MoveMouseRel(-78,-50);
       Ch.Enter(660,45,Ch.Cyan,Ch.bkColor,FALSE,dTime)
     UNTIL Wiederholung() = 'N';
     (* O D E R :                                                  *)
     (* UNTIL Wiederholung() Ch.Repetition(10,240,50,dTime) = 'N'; *)

     (* ----------------------------------------- *)

     Ch.Close                                         (* Malkasten schlieen *)
   END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Ch.InitiateColorPlane(Ch.bkColor,0,0,32);   (* Malkasten ffnen und gro- *)
                                               (* es Fenster einstellen    *)
   Ch.HeadLine(message,year);                  (* Eintrag in die Bildleiste *)
   Ch.Delay_ms(500)
 END Repeat01.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

