
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)          Dateiname: WINDOWS.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Mrz 2001 Version: V 1.1                    |
  |-------------------------------------------------------------------------|
  | Thema:    DEFINITION statt MODULE unter Pow 32-Bit                      |
  |-------------------------------------------------------------------------|
  | Anliegen: Fr die Nutzung bestimmter WINDOWS-Funktionen werden Dekla-   |
  |           rationen aus den Definitionsdateien von Oberon-2 POW! 32-Bit  |
  |           WINBASE.MOD, WINUSER.MOD bzw. ihrer Symboldateien ( *.SYM)    |
  |           bentigt, die sehr viel Speicher im jeweiligen Pfad belegen.  |
  |           Da kann eine DEFINITION Marke Eigenbau sehr gute Dienste      |
  |           leisten. Es werden aus den oben genannten *.MOD-Dateien nur   |
  |           die fr unsere Anwendungen bentigten Definitionen entnommen. |
  |           Die Anpassung der Datentypen ist etwas kompliziert. Aber mit  |
  |           Geduld, entsprechendem Literaturstudium und Einsichtnahme in  |
  |           WINDOWS-Hilfedateiene werden die Hrden berwunden. Nur Mut!  |
  |-------------------------------------------------------------------------|
  | Leistung: Import wichtiger und/oder ntzlicher Deklarationen fr das    |
  |           Einbinden von WINDOWS-API-Funktionen.                         |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)

 DEFINITION Windows;           (*  !!  N U R  fr POW!-32-Bit anwendbar !!  *)


  PROCEDURE [_APICALL] ShowWindow ( hWnd     : LONGINT;
                                    nCmdShow : LONGINT) : LONGINT;

  PROCEDURE [_APICALL] GetActiveWindow () : LONGINT;
  
  PROCEDURE [_APICALL] MessageBoxA ( hWnd      : LONGINT; 
                                     lpText    : LONGINT; (* !! SYSTEM.ADR('TEEEXXXT'); !! *)
                                     lpCaption : LONGINT; (* !! dito                    !! *)
                                     uType     : LONGINT ) : LONGINT;

  PROCEDURE [_APICALL] SetWindowTextA ( hWnd     : LONGINT;
                                        lpString : LONGINT ): BOOLEAN;

  PROCEDURE [_APICALL] CreateFontA ( nHeight            : LONGINT; 
                                     nWidth             : LONGINT; 
                                     nEscapment         : LONGINT; 
                                     nOrientation       : LONGINT; 
                                     fnWidth            : LONGINT; 
                                     fdwItalic          : LONGINT; 
                                     fdwUnderLine       : LONGINT; 
                                     fdwStrikeOut       : LONGINT; 
                                     fdwCharSet         : LONGINT; 
                                     fdwOutputPrecision : LONGINT; 
                                     fdwClipPrecision   : LONGINT; 
                                     fdwQuality         : LONGINT; 
                                     fdwPitchAndFamily  : LONGINT; 
                                     lpszFace           : LONGINT ) : LONGINT;

  PROCEDURE [_APICALL] GetTickCount() : LONGINT;


  PROCEDURE [_APICALL] TextOutA ( hdc      : LONGINT; 
                                  nXStart  : LONGINT; 
                                  nYStart  : LONGINT; 
                                  lpString : LONGINT; 
                                  cbString : LONGINT ) : LONGINT;        

  PROCEDURE [_APICALL] mouse_event ( dwFlags     : LONGINT;
                                     dx          : LONGINT;
                                     dy          : LONGINT;
                                     cButtons    : LONGINT;
                                     dwExtraInfo : LONGINT );

 (* PROCEDURE [_APICALL] GetDC ( hWnd : LONGINT ) : LONGINT; *)

  PROCEDURE [_APICALL] Sleep ( dwMilliseconds : LONGINT);
 
 END Windows.

 (* ----------------------------------------------------------------------- *)

  (*                             *)
  (*  * MOUSEKEYS dwFlags field  *)
  (*                             *)
  
    MKF_MOUSEKEYSON = 1H;
    MKF_AVAILABLE = 2H;
    MKF_HOTKEYACTIVE = 4H;
    MKF_CONFIRMHOTKEY = 8H;
    MKF_HOTKEYSOUND = 10H;
    MKF_INDICATOR = 20H;
    MKF_MODIFIERS = 40H;
    MKF_REPLACENUMBERS = 80H;

    SM_CMOUSEBUTTONS = 43;

