
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)         Dateiname: LOGOGRAF.MOD |
  |-------------------------------------------------------------------------|
  | Autor:   Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                    |
  |          Erstellungsdatum: Januar 2001 Version: V 1.1                   |
  |-------------------------------------------------------------------------|
  |                                                                         |
  | Thema:   Fortgeschrittene - Programmierung in OBERON-2 POW!             |
  |          Erstellen eines von anderen Modulen importierbaren MODULs.     |
  |                                                                         |
  |-------------------------------------------------------------------------|
  |                                                                         |
  |            PROCEDURE ...                                                |
  |                                                                         |
  |              Backward* ( lenght : INTEGER );                           |
  |                                                                         |
  |                 Unter Bercksichtigung der aktuellen Grafikcursor-      |
  |                 position und der Zeichenrichtung wird ein Strich der    |
  |                 gewnschten Lnge lenght (Einheit: Pixel) gezeichnet.   |
  |                 Die Zeichenfarbe (Stiftfarbe) wird beibehalten.         |
  |                                                                         |
  |              ClearScreen* ( bc_red, bc_green, bc_blue : INTEGER );     |
  |                                                                         |
  |                 Die RGB-Werte fr die Hintergrundfarbe (DT: INTEGER)    |
  |                 werden bernommen (Wertebereich: 0..255).               |
  |                 Das groe Bildschirmfensters (Zeichen- bzw. Malflche)  |
  |                 wird mit Hintergrundfarbe gefllt (gelscht).           |
  |                 Das linke Rahmenelement bleibt erhalten.                |
  |                                                                         |
  |              Close*;                                                   |
  |                                                                         |
  |                 Turtle-Malkasten schlieen.                             |
  |                                                                         |
  |              Delay_ms* ( msec : LONGINT );                             |
  |                                                                         |
  |                 Eine definierte Zeit warten.                            |
  |                                                                         |
  |              Enter* ( dTime : INTEGER );                               |
  |                                                                         |
  |                 bernahme der Wartezeit, Einrichten der Textfarbe       |
  |                 (Cyan), Ausgabe der Zeichenkette '< ENTER>' am Punkt    |
  |                 P(650|45) des Bildschirms und Warten auf eine Tasten-   |
  |                 bettigung auf der Tastatur.                            |
  |                                                                         |
  |              Forward* ( lenght : INTEGER );                            |
  |                                                                         |
  |                 Unter Bercksichtigung der aktuellen Grafikcursor-      |
  |                 position und der Zeichenrichtung wird ein Strich der    |
  |                 gewnschten Lnge lenght (Einheit: Pixel) gezeichnet.   |
  |                 Die Zeichenfarbe (Stiftfarbe) wird beibehalten.         |
  |                                                                         |
  |              Init* ( xStart, yStart : INTEGER );                       |
  |                                                                         |
  |                 Die Turtle wird an den Punkt P(xStart|yStart) oder,     |
  |                 falls beide Werte kleiner 0 sind, in der Mitte der      |
  |                 sichtbaren Zeichenflche plaziert. Bei SVGA-Auflsung,  |
  |                 800 x 600 Pixel, ist das der Punkt P(392|277).         |
  |                 Im Klartext: Der Grafikcursor wird auf den Startpunkt   |
  |                 und der Zeichnenmodus (mode = C.DRAW) auf Zeichnen ge-  |
  |                 setzt. Die Ausgangsrichtung (direction) ist 0, d. h.   |
  |                 die Turtle zeigt nach oben.                             |
  |                                                                         |
  |              InitiateTurtleGraphic* ( VAR screenCol : tColor;          |
  |                                               r, g, b : INTEGER );      |
  |                                                                         |
  |                 Der 'Malkasten' wird geffnet (Initialisieren der Gra-  |
  |                 fik) und die Zeichenflche mit der bergebenen Hinter-  |
  |                 grundfarbe (RGB-Werte) gefrbt. Die Turtel wird in der  |
  |                 Mitte der Zeichenflche plaziert. Weitere Einstellungen |
  |                 siehe Init*(...).                                       |
  |                                                                         |
  |              LineTo* ( x, y, mode : INTEGER );                         |
  |                                                                         |
  |                 bernahme der Koordinaten des Punktes P(x|y) zu dem     |
  |                 die Linie gezeichnet (gelscht) werden soll.            |
  |                 Modi: mode = C.DRAW,  C.draw  oder 1 (Zeichnen)         |
  |                       mode = C.ERASE, C.erase oder 0 (Lschen)          |
  |                 Die aktuelle Grafikcursorposition wird ermittelt und    |
  |                 eine Linie zum bergebenen Punkt P(x|y) gezeichnet.     |
  |                 Die Grafikcursorposition wird aktualisiert.             |
  |                                                                         |
  |              Polygon* ( laenge, n : INTEGER );                         |
  |                                                                         |
  |                 bernahme der Lnge einer Teilstrecke des Polygonum-    |
  |                 fangs (laenge) und Anzahl der Ecken (n).                |
  |                 In n Schritten wird aus kleinen Teilstrecken ein n-Eck  |
  |                 (n > 2, Polygon) oder ein Kreis zusammengesetzt.        |
  |                 Fr groe Kreise sollte n 72 betragen, bei kleineren    |
  |                 Kreisen 36 oder weniger.                                |
  |                                                                         |
  |              SetPenColor* ( r, g, b : INTEGER );                       |
  |                                                                         |
  |                 bernahme der RGB-Farbwerte, Setzen der Stiftfarbe.     |
  |                                                                         |
  |              SetScreenColor* ( r, g, b : INTEGER );                    |
  |                                                                         |
  |                 bernahme der RGB-Farbwerte, Setzen der Stiftfarbe.     |
  |                                                                         |
  |              SetScreenColorRec* ( screenCol : tColor );                |
  |                                                                         |
  |                 bernahme des RGB-Farbwerteverbundes, Setzen der        |
  |                 Hindergrundfarbe des Bildschirms.                       |
  |                                                                         |
  |              SetScreenUpdate ( flag : BOOLEAN );                       |
  |                                                                         |
  |                 flag = FALSE: aktiven Bildschirm unsichtbar schalten.   |
  |                 flag = TRUE:  aktiven Bildschirm sichtbar schalten.     |
  |                                                                         |
  |              TurnLeft* ( angle : REAL );                               |
  |                                                                         |
  |                 Die auf der internen globalen Variable direction ge-    |
  |                 speicherte Zeichenrichtung wird um den bergebenen      |
  |                 Winkel im Uhrzeigersinn gedreht.                        |
  |                 (Winkelangaben in Grad)                                 |
  |                                                                         |
  |              TurnRight* ( angle : REAL );                              |
  |                                                                         |
  |                 Die auf der internen globalen Variable direction ge-    |
  |                 speicherte Zeichenrichtung wird um den bergebenen      |
  |                 Winkel gegen den Uhrzeigersinn gedreht.                 |
  |                 (Winkelangaben in Grad)                                 |
  |                                                                         |
  |              WriteStrXY* ( x, y : INTEGER; text : B.tStr75 );          |
  |                                                                         |
  |                 Ausgabe einer Zeichenkette (text), die maximal          |
  |                 75 Zeichen enthalten darf. x und y halten die           |
  |                 Koordinaten fr das erste Zeichen.                      |
  |                                                                         |
  |-------------------------------------------------------------------------|
  | Hinweise: Dieses Programm ist fr den Grafikmodus 800 x 600 Pixel      |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |           Die Turtle wird nach dem Initialisieren der Turtlegrafik      |
  |           auf den Punkt P(392|277) gesetzt.                             |
  |           Die Zeichenfarbe ist Schwarz und die Ausrichtung 90 (Aus-    |
  |           gangsrichtung nach oben).                                     |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)

  MODULE LogoGraf;

   IMPORT C:= ColorPlane, F:= Float, S:= Strings, SYSTEM, W:= Windows;

   TYPE   tColor*    = RECORD
                         R*, G*, B* : INTEGER
                       END;

          tStr75*    = ARRAY 76 OF CHAR;
          tYearStr   = ARRAY  5 OF CHAR;

    VAR   mode       : INTEGER;
          dummy      : LONGINT;
          direction,
          x, y       : REAL;
          screenCol* : tColor;


 (* -------------------  W E I T E R L E I T U N G E N  ------------------- *)


  PROCEDURE Close*;
    BEGIN
      C.Close
    END Close;

  PROCEDURE SetPenColor* ( r, g, b : INTEGER );
    BEGIN
      C.SetForeColor(r,g,b)
    END SetPenColor;

  PROCEDURE SetScreenColor* ( r, g, b : INTEGER );
    BEGIN
      C.SetBackColor(r,g,b)
    END SetScreenColor;

  PROCEDURE SetScreenColorRec* ( screenCol : tColor );
    BEGIN
      C.SetBackColor(screenCol.R,screenCol.G,screenCol.B)
    END SetScreenColorRec;

  PROCEDURE SetScreenUpdate* ( flag : BOOLEAN );
    BEGIN
      C.SetScreenUpdate(flag)
    END SetScreenUpdate;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE WriteStrXY* ( x, y : INTEGER; text : tStr75 );
   (*-----------------------------------------------------------------------*
    | bernahme: x- und y-Koordinaten fr die Position der Zeichenkette     |
    |            und Inhalt der Zeichenkette                                |
    | Leistung:  Positionierte Ausgabe einer langen Zeichenkette am Bild-   |
    |            schirm.                                                    |
    *-----------------------------------------------------------------------*)

    BEGIN
      C.GotoXY(x,y);
      C.WriteStr(text)
    END WriteStrXY;


  PROCEDURE RoundReal ( x : REAL ) : INTEGER;
   (*-----------------------------------------------------------------------*
    | bernahme: reelle Zahl (DT: REAL) als Wertparameter                   |
    | Referenz:  Funktionswert, positive oder negative ganze Zahl           |
    |            ((DT: INTEGER)                                             |
    | Leistung:  mathematisch exaktes Runden                                |
    *-----------------------------------------------------------------------*)

    BEGIN
      RETURN SYSTEM.VAL(INTEGER,x+0.5)
    END RoundReal;


  PROCEDURE ClearScreen* ( bc_red, bc_green, bc_blue : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: RGB-Werte fr die Hintergrundfarbe (DT: INTEGER)           |
    |            (Wertebereich: 0..255).                                    |
    | Leistung:  Das groe Bildschirmfensters (Zeichen- bzw. Malflche)     |
    |            wird mit Hintergrundfarbe gefllt (gelscht). Das linke    |
    |            Rahmenelement bleibt erhalten.                             |
    *-----------------------------------------------------------------------*)
  
    BEGIN
      C.SetBackColor(bc_red,bc_green,bc_blue);
      C.Bar(5,0,1024,778,C.ERASE)
    END ClearScreen;


  PROCEDURE Delay_ms* ( msec : LONGINT );
   (*-----------------------------------------------------------------------*
    | Leistung: Eine definierte Zeit warten.                                |
    *-----------------------------------------------------------------------*)

    VAR startzeit, zielzeit : LONGINT;

    BEGIN
      startzeit:= W.GetTickCount(); 
      REPEAT
        zielzeit:= W.GetTickCount()
      UNTIL zielzeit > startzeit + msec 
    END Delay_ms;


  PROCEDURE FlushKeyBuffer*;
   (*-----------------------------------------------------------------------*
    | Leistung: Lschen des Tastaturpuffers.                                |
    *-----------------------------------------------------------------------*)

    VAR dummy : CHAR;

    BEGIN
      WHILE C.KeyPressed() DO
        dummy:= C.ReadKey()
      END
    END FlushKeyBuffer;


  PROCEDURE Enter* ( dTime : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Wartezeit bis die Zeichenkette ausgegeben wird             |
    |            (sorgt fr ruhigen Programmablauf)                         |
    | Leistung:  Ausgabe einer Zeichenkette, Lschen des Tastaturpuffers,   |
    |            Warten auf eine Tastatureingabe.                           |
    *-----------------------------------------------------------------------*)

    VAR dummy : CHAR;

    BEGIN
      C.SetForeColor(0,169,169);
      C.GotoXY(650,45); C.WriteStr('< ENTER >');
      Delay_ms(dTime*10);
      FlushKeyBuffer;
      dummy:= C.ReadKey()
    END Enter;


  PROCEDURE TurnLeft* ( angle : REAL );
   (*-----------------------------------------------------------------------*
    | bernahme: Drehwinkel der Turtle                                      |
    | Leistung:  Die auf der internen globalen Variable direction gespei-   |
    |            cherte Zeichenrichtung wird um den bergebenen Winkel      |
    |            im Uhrzeigersinn gedreht. (Winkelangaben in Grad)          |
    *-----------------------------------------------------------------------*)

    BEGIN
      direction:= direction + angle;
      IF direction > 360 THEN
        direction:= direction -360
      END
    END TurnLeft;


  PROCEDURE TurnRight* ( angle : REAL );
   (*-----------------------------------------------------------------------*
    | bernahme: Drehwinkel der Turtle                                      |
    | Leistung:  Die auf der internen globalen Variable direction gespei-   |
    |            cherte Zeichenrichtung wird um den bergebenen Winkel      |
    |            gegen den Uhrzeigersinn gedreht. (Winkelangaben in Grad)   |
    *-----------------------------------------------------------------------*)

    BEGIN
      direction:= direction - angle;
      IF direction < 0 THEN
        direction:= direction + 360
      END
    END TurnRight;


  PROCEDURE LineTo* ( x, y, mode : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: x- und y-Koordinate fr den Grafikcursor (Startpunkt) und  |
    |            Zeichenmodus (Zeichnen, Lschen)                           |
    | Leistung:  bernahme der Koordinaten des Punktes P(x|y) zu dem die    |
    |            Linie gezeichnet (gelscht) werden soll.                   |
    |            Modi: mode = C.DRAW,  C.draw  oder 1 (Zeichnen)            |
    |                  mode = C.ERASE, C.erase oder 0 (Lschen)             |
    |            Die aktuelle Grafikcursorposition wird ermittelt und eine  |
    |            Linie zum bergebenen Punkt P(x|y) gezeichnet.             |
    |            Die Grafikcursorposition wird aktualisiert.                |
    *-----------------------------------------------------------------------*)

    VAR x_akt, y_akt : INTEGER;

    BEGIN
      x_akt:= C.WhereX(); y_akt:= C.WhereY();
      C.Line(x_akt,y_akt,x,y,mode);
      C.GotoXY(x,y);
    END LineTo;


  PROCEDURE Forward* ( lenght : REAL );
   (*-----------------------------------------------------------------------*
    | bernahme: Lnge der zu zeichnenden Linie                             |
    | Leistung:  Unter Bercksichtigung der aktuellen Grafikcursorposition  |
    |            und der Zeichenrichtung wird ein Strich der gewnschten    |
    |            Lnge lenght (Einheit: Pixel) gezeichnet.                  |
    |            Die Zeichenfarbe (Stiftfarbe) wird beibehalten.            |
    *-----------------------------------------------------------------------*)

    BEGIN
      x:= x - lenght * F.Sin(direction/180 * SHORT(F.Pi));
      y:= y + lenght * F.Cos(direction/180 * SHORT(F.Pi));
      LineTo(RoundReal(x),RoundReal(y),mode)
    END Forward;


  PROCEDURE Backward* ( lenght : REAL );
   (*-----------------------------------------------------------------------*
    | bernahme: Lnge der zu zeichnenden Linie                             |
    | Leistung:  Unter Bercksichtigung der aktuellen Grafikcursorposition  |
    |            und der Zeichenrichtung wird ein Strich der gewnschten    |
    |            Lnge lenght (Einheit: Pixel) gezeichnet.                  |
    |            Die Zeichenfarbe (Stiftfarbe) wird beibehalten.            |
    *-----------------------------------------------------------------------*)

    BEGIN
      x:= x + lenght * F.Sin(direction/180 * SHORT(F.Pi));
      y:= y - lenght * F.Cos(direction/180 * SHORT(F.Pi));
      LineTo(RoundReal(x),RoundReal(y),mode)
    END Backward;


  PROCEDURE Polygon* ( laenge, n : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Lnge einer Teilstrecke des Polygonumfangs (laenge) und    |
    |            Anzahl der Ecken (n).                                      |
    | Leistung:  In n Schritten wird aus kleinen Teilstrecken ein n-Eck     |
    |            (n > 2, Polygon) oder ein Kreis zusammengesetzt.           |
    |            Fr groe Kreise sollte n 72 betragen, bei kleineren Krei- |
    |            sen 36 oder weniger.                                       |
    *-----------------------------------------------------------------------*)

    VAR i, pixel : INTEGER;

    BEGIN
      pixel:= RoundReal(360/n);
      FOR i:= 1 TO n DO
        Forward(2*3.1415926*laenge/n);
        TurnRight(pixel)
      END;
    END Polygon;


  PROCEDURE Init* ( xStart, yStart : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: x- und y-Koordinate fr den Grafikcursor (Startpunkt)      |
    | Leistung:  Die Turtle (der Startpunkt) wird in der Mitte der sicht-   |
    |            baren Zeichenflche plaziert, falls xStart oder yStart     |
    |            bzw. beide einen negativen Wert besitzen.                  |
    |            Bei SVGA-Auflsung, 800 x 600 Pixel, ist das der Punkt    |
    |            P(399|299). Im Klartext: Der Grafikcursor wird auf den     |
    |            Startpunkt und der Zeichnenmodus (mode = C.DRAW) auf       |
    |            Zeichnen gesetzt. Die Ausgangsrichtung (direction) ist     |
    |            0, d. h. die Turtle zeigt nach oben.                      |
    *-----------------------------------------------------------------------*)

    BEGIN
      IF (xStart < 0) & (yStart < 0) THEN 
        x:= 399;                        (* Startpunkt in der Mitte fr      *)
        y:= 299                         (* SVGA-Auflsung: 800 x 600 Pixel *)
      ELSE                              (* Pixel, engl. picture elements    *)
        x:= xStart;
        y:= yStart
      END;
      C.GotoXY(xStart,yStart);          (* Grafikcursor auf Startpunkt      *)
      direction:= 0;                    (* Ausgangsrichtung nach oben       *)
      mode:= C.DRAW;                    (* Modus auf Zeichnen setzen        *)
    END Init;


  PROCEDURE HeadLine* ( message : tStr75 ; year : tYearStr );
   (*-----------------------------------------------------------------------*
    | bernahme: Variabler Teil des in der Kopfzeile des Grafikbildschirms  |
    |            anzuzeigenden Textes und Jahreszahl fr das Copyright ()  |
    | Leistung:  Ausgabe der gewnschten Mitteilung in der blauen Kopfzeile |
    |            des Grafikbildschirms. Zum Beispiel: Aussage zum bearbei-  |
    |            teten Thema, Copyrightzeichen, Jahreszahl und Name oder    |
    |            Alias des Programmierers.                                  |
    *-----------------------------------------------------------------------*)

    VAR dummy       : BOOLEAN;
        messageHdLn : tStr75;

    BEGIN
      messageHdLn:= '        Chamberlain-Soft';
      S.Insert(year,messageHdLn,9);
      S.Insert(message,messageHdLn,4);
      dummy:= W.SetWindowTextA(W.GetActiveWindow(),SYSTEM.ADR(messageHdLn))
    END HeadLine;


  PROCEDURE InitiateTurtleGraphic* ( VAR screenCol : tColor;
                                                      r, g, b : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: RGB-Werte fr die Hintergrundfarbe (DT: INTEGER)           |
    |            (Wertebereich: 0..255).                                    |
    | Referenz:  Hintergrundfarbe, die RGB-Werte sind in einer Verbund-     |
    |            Variable abgelegt                                          |
    | Leistung:  Der Malkasten wird 'geffnet' (Initialisieren der Grafik), |
    |            das Grafikfenster mit Hintergrundfarbe bermalt und am     |
    |            linken Rand ein Rahmenelement gezeichnet, damit der Bild-  |
    |            schirm nicht an einer Seite 'offen' ist.                   |
    |            Die Turtle (der Startpunkt) wird in der Mitte der sicht-   |
    |            baren Zeichenflche plaziert.                              |
    |            Weitere Erluterungen siehe Prozedur Init.                 |
    *-----------------------------------------------------------------------*)

    BEGIN
      C.Open;
      dummy:= W.ShowWindow(W.GetActiveWindow(),3);
      screenCol.R:= r; screenCol.G:= g; screenCol.B:= b;
      SetScreenColorRec(screenCol);
      ClearScreen(r,g,b);
      C.SetForeColor(200,200,200);
      C.Bar(1,0,3,650,C.DRAW);
      C.SetForeColor(0,0,0);
      C.Line(4,0,4,650,C.DRAW);
      Init(392,277)
    END InitiateTurtleGraphic;

 END LogoGraf.

 (* --------   2000/01 Manfred Kmmerer, Chamberlain-Soft JENA  ---------- *)

