
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)         Dateiname: POLYGONE.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Februar 2001 Version: V 1.0                 |
  |-------------------------------------------------------------------------|
  | Thema:    Fortgeschrittene - Programmierung in OBERON-2 POW!            |
  |           Anwenden des User-Moduls LogoGraf zum Erstellen einfacher     |
  |           Grafiken unter Anwendung rekursiver Algorithmen.              |
  |-------------------------------------------------------------------------|
  | Leistung: Darstellen einer Schar immer kleiner werdender regelmiger   |
  |           Fnfecke. Durch geringfgige nderungen im Quelltext, knnen  |
  |           auch andere Polygone (n-Ecke, Kreise) dargestellt werden.     |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Programm ist fr den Grafikmodus 800 x 600 Pixel         |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)

 MODULE Polygone;

  IMPORT L:= Logograf;

  CONST  dTime   = 25;

         message = 'REKURSION';
         year    = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Figur ( laenge : INTEGER );

    CONST xOffset = 130;  yOffset = 110;

    BEGIN
      IF laenge > -1 THEN
        L.Init(laenge+xOffset,laenge+yOffset);
        L.TurnRight(24);
        L.Polygon(laenge,5);
        L.Delay_ms(dTime);
        Figur(laenge-3)
      END;
    END Figur;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      L.ClearScreen(255,255,232);        (* BS-Lschen, aktuelle Parameter: *)
                                         (* RGB-Werte der Hintergrundfarbe  *)
      L.Delay_ms(dTime*15);              (* 375 ms warten                   *)
      Figur(160);                        (* Liniengrafik darstellen         *)
      L.Enter(dTime);                    (* Eingabeaufforderung ausgeben    *)
                                         (* und Tastenbettigung auf der    *)
                                         (* Tastatur abwarten               *)
      L.Close                            (* Turtle-Malkasten schlieen      *)
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   L.InitiateTurtleGraphic(L.screenCol,255,255,232);
                                         (* Malkasten ffnen und groes     *)
                                         (* Fenster einstellen              *)
   L.HeadLine(message,year);             (* Eintrag in die Bildleiste       *)
 END Polygone.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

