
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)         Dateiname: IFUEBG01.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Februar 2001 Version: V 2.0                 |
  |-------------------------------------------------------------------------|
  | Thema:    Fallunterscheidung: Einfache Auswahl, die IF-Anweisung        |
  |-------------------------------------------------------------------------|
  | Anliegen: Dieses Programms zeigt die Lsung der Aufgabe dess Moduls     |
  |           If01.MOD.                                                     |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Programm ist fr den Grafikmodus 800 x 600 Pixel         |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |           Das Beenden des Programms kann durch Bettigen der Entertaste |
  |           oder durch Mausklick auf das abschlieende < Enter > erfolgen.|
  |           Sollte der Mauszeiger nach der Anzeige '< Enter >' nicht auf  |
  |           dieses Wort zeigen, so mssen die Werte der Anweisung         |
  |           'Ch.MoveMouseRel(-78,-50);', Zeile 123, geringfgig gendert  |
  |           werden. '-78,50' ist der Wert fr die Grafikkarte GLADIAC MX  |
  |           geforce2mx.                                                   |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)
  
 MODULE IfUebg01;
 
  IMPORT Ch:= ChSTools, S:= Strings;

  CONST  dTime     = 10;

         message   = 'SELEKTION  (Auswahl)';
         year      = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Beschriften ( grenze : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Positionierte Ausgabe einer Textzeile (Zeichenkette).       |
    *-----------------------------------------------------------------------*)

    VAR grenzeStr : Ch.tShortStr;

    BEGIN
      Ch.Delay_ms(dTime*3);
      Ch.SetForeColorNb(Ch.LightGray);
      Ch.GotoXY(90,80);
      Ch.WriteStr('Wenn die Laufvariable den Wert ');
      S.Str(grenze,grenzeStr);
      Ch.WriteShortStr(grenzeStr);
      Ch.WriteStr(' erreicht, ');
      Ch.WriteStr('wechseln die Hhe und die Farbe.');
      Ch.Delay_ms(dTime*8)
    END Beschriften;


  PROCEDURE Hervorhebung ( grenze : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Positionierte farbige Ausgabe einer Zahl (grenze).          |
    *-----------------------------------------------------------------------*)

    VAR grenzeStr : Ch.tShortStr;

    BEGIN
      Ch.SetForeColorNb(Ch.Yellow);
      S.Str(grenze,grenzeStr);
      Ch.WriteShortStrXY(338,80,grenzeStr)
    END Hervorhebung;


  PROCEDURE ZeichneZaun ( grenze : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Hintergrundfarbe (Wertparameter, der DT Ch.tFarbe wird aus |
    |            dem MODUL ChSTools importiert)                             |
    | Leistung:  Ausgabe von 40 pinkfarbener Rechtecke am Bildschirm, deren |
    |            Kantenlnge sich nach einer bestimmten Vorschrift vergr-  |
    |            ert. Bevor das 21. Rechteck gezeichnet wird, wechselt die |
    |            Zeichenfarbe ihre Helligkeit. Zur Fallunterscheidung wird  |
    |            die Laufvariable der Zhlschleife genutzt.                 |
    *-----------------------------------------------------------------------*)

   CONST faktor1 =   5;
         faktor2 =   2;
         x       = 130;

   VAR   i, summand,
         xOffset, yOffset : INTEGER;

   BEGIN
     Ch.SetForeColorNb(Ch.Brown);
     FOR i:= 1 TO 100 DO

      (* ---------------  einfache Auswahl  ---------------- *)

       IF i = grenze THEN
         Hervorhebung(grenze);
         Ch.SetForeColorNb(Ch.Yellow);
         Ch.Delay_ms(dTime*5)
       END;

      (* --------------------------------------------------- *)

       xOffset:= faktor1  * i;
       yOffset:= faktor2  * i;
       summand:= (grenze) * 4-faktor2 - yOffset;

      (* ---------------  zweifache Auswahl  --------------- *)

       IF i < grenze THEN
         Ch.Line(x+xOffset,175,x+xOffset,275+yOffset,Ch.DRAW)
       ELSE
         Ch.Line(x+xOffset,175,x+xOffset,275+summand,Ch.DRAW)
       END;

      (* --------------------------------------------------- *)

       Ch.Delay_ms(dTime)
     END; (* For *)
     Ch.MoveMouseRel(-78,-50);
     Ch.Enter(660,45,Ch.Cyan,Ch.bkColor,FALSE,dTime)
   END ZeichneZaun;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

 PROCEDURE ProgMain*;

   VAR grenze : INTEGER;

   BEGIN
     Ch.MoveMouseRel(800,600);
     Ch.Title(Ch.LightCyan,490,dTime,Ch.bkColor,
                     'Fallunterscheidung: Die ein- und zweifache Auswahl',FALSE);

     grenze:= 61;                                     (* 10 < grenze < 90    *)
     
     Beschriften(grenze);
     ZeichneZaun(grenze);
     Ch.Close                                         (* Malkasten schlieen *)
   END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Ch.InitiateColorPlane(Ch.bkColor,0,0,32);   (* Malkasten ffnen und gro- *)
                                               (* es Fenster einstellen    *)
   Ch.HeadLine(message,year);                  (* Eintrag in die Bildleiste *)
   Ch.Delay_ms(500)
 END IfUebg01.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

