
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)           Dateiname: CASE01.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Februar 2001 Version: V 2.0                 |
  |-------------------------------------------------------------------------|
  | Thema:    Fallunterscheidung: Mehrfache Auswahl, die CASE-Anweisung     |
  |-------------------------------------------------------------------------|
  | Anliegen: Dieses Programm demonstriert die Anwendung der mehrfachen     |
  |           Auswahl (FALLWEISE selektor ...).                             |
  |           Statt Anweisungsblcken stehen Prozeduraufrufe in den Anwei-  |
  |           sungsteilen hinter den Marken (labels).                       |
  |-------------------------------------------------------------------------|
  | Aufgabe:  Probieren Sie beide Wahlmglichkeiten.                        |
  |           Schreiben Sie ein Oberon-2-Programm, welches es dem Nutzer    |
  |           ermglicht, sich drei verschiedene Figuren am Bildschirm      |
  |           ausgeben zu lassen.                                           |
  |           Nutzen Sie dazu den Quelltext FIGUREN.MOD!                    |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Programm ist fr den Grafikmodus 800 x 600 Pixel         |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)

 MODULE Case01;
 
  IMPORT Ch:= ChSTools, S:= Strings;
 
  CONST  dTime   = 100;

         message = 'SELEKTION  (Auswahl)';
         year    = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Key() : INTEGER;
   (*-----------------------------------------------------------------------*
    | Referenz: Funktionswert, mittels Tastatur eingegebener Wert           |
    | Leistung: Positionierte Ausgabe einer Zeichenkette, Einlesen eines    |
    |           mittels Tastatur eingegebenen Zeichens.                     |
    |           Auswertung: Wird die Enter- oder die Esc-Taste bettigt,    |
    |           wird die Variable aChar (Zeichenfolge) mit '1' belegt.      |
    |           Wird eine Ziffer eingegeben, die der Austrittsbedingung der |
    |           Schleife gengen, folgt die Konvertierung des Zeichens in   |
    |           einen INTEGER-Wert.                                         |
    *-----------------------------------------------------------------------*)

    VAR aChar    : Ch.tStr75;
        resCode  : CHAR;
        kennzahl : INTEGER;
       
    BEGIN
      Ch.SetForeColorNb(Ch.Yellow);
      Ch.GotoXY(183,70);
      Ch.WriteStr('Bitte eine Kennziffer (1 oder 2) eingeben! Ziffer = ');
     
     (* ---  Schleife mit Austrittsbedingung  --- *)

      REPEAT
        Ch.Bar(601,70,609,56,Ch.ERASE);
        Ch.GotoXY(601,70);
        Ch.ReadStr(aChar,1,resCode);
        IF (aChar = '') & (resCode = Ch.ENTER) OR (resCode = Ch.ESC) THEN 
          aChar:= '1';
          Ch.WriteStr('1');
          Ch.Delay_ms(dTime)
        END;
        IF (aChar > '0') & (aChar < '3') THEN
          kennzahl:= SHORT(S.Val(aChar))
        END
      UNTIL (kennzahl > 0) & (kennzahl < 3);

     (* ----------------------------------------- *)

      RETURN kennzahl
    END Key;
 
 
  PROCEDURE Kennzahl () : INTEGER;
   (*-----------------------------------------------------------------------*
    | Referenz: Funktionswert, mittels Tastatur eingegebener Wert           |
    | Leistung: Positionierte Ausgabe einer Zeichenkette, die in Abhngig-  |
    |           keit der mittels Tastatur eingegebenen Ziffer (kennziffer)  |
    |           komplettiert und ausgegeben wird.                           |
    *-----------------------------------------------------------------------*)

    VAR zeichenkette : ARRAY 30 OF CHAR;
        ziffer       : ARRAY  3 OF CHAR;
        kennzahl     : INTEGER;

    BEGIN
      zeichenkette:= 'Sie haben das Bild   gewhlt.';
      ziffer[1]:= '1';
      ziffer[2]:= '2';
      kennzahl:= Key();
      Ch.Bar(183,56,609,70,Ch.ERASE);
      S.Delete(zeichenkette,20,1);
      IF kennzahl = 1 THEN S.InsertChar(ziffer[1],zeichenkette,20)
        ELSE S.InsertChar(ziffer[2],zeichenkette,20)
      END;
      RETURN kennzahl
    END Kennzahl;


  PROCEDURE Rosette;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe einer farbigen Rosette, die aus einem zusammenhn-  |
    |           genden Linienzug besteht.                                   |
    *-----------------------------------------------------------------------*)

    CONST xM = 390;  yM = 280;

    VAR alpha, i, r, w : INTEGER;
        VAR p          : Ch.tPoint;


    BEGIN
      w:= 0;
      r:= 160;
      Ch.Delay_ms(dTime);
      Ch.SetForeColorNb(Ch.LightMagenta);
      Ch.GotoXY(416,285);
      FOR i:= 1 TO 80 DO
        Ch.CalculatePoint(p,xM,yM,r,w);
        Ch.LineTo(p.x,p.y,Ch.DRAW);
                                (* Zeichnen eines geschlossenen Linienzuges *)
        Ch.Delay_ms(dTime DIV 8);
        w:= w + Ch.RoundLongReal(Ch.Pi*61);
        DEC(r)
      END
    END Rosette;


  PROCEDURE Polygonschar;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe von 36 farbigen Polygonen (Neunecken), deren Farbe  |
    |           zwischen Wei und hellem Rot alterniert.                    |
    *-----------------------------------------------------------------------*)

    CONST time = 25;
    VAR   i    : INTEGER;

    BEGIN
      Ch.Delay_ms(dTime);
      FOR i:= 1 TO 36 DO
        IF ODD(i) THEN Ch.SetForeColorNb(Ch.White)
          ELSE Ch.SetForeColorNb(Ch.LightRed);
        END;
        Ch.Polygone(Ch.DRAW,9,220+6*i,135+4*i,5+4*i);
        Ch.Delay_ms(dTime DIV 3)
      END
    END Polygonschar;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

 PROCEDURE ProgMain*;
   
   VAR kennzahl  : INTEGER;

   BEGIN
     Ch.MoveMouseRel(800,600);
     Ch.Title(Ch.LightCyan,490,dTime,Ch.bkColor,
              'Fallunterscheidung: Die mehrfache Auswahl',
              FALSE);
     REPEAT
       kennzahl:= Kennzahl();
  
     (* ------  mehrfache Auswahl mit ANSONSTEN-Zweig -------- *)
  
       CASE kennzahl OF
         1: Rosette
       | 2: Polygonschar
       END;
  
     (* ------------------------------------------------------ *)
  
     UNTIL Ch.Repetition(10,240,50,dTime*5) = 'N';
     Ch.Close
   END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Ch.InitiateColorPlane(Ch.bkColor,0,0,32);   (* Malkasten ffnen und gro- *)
                                               (* es Fenster einstellen    *)
   Ch.HeadLine(message,year);                  (* Eintrag in die Bildleiste *)
   Ch.Delay_ms(500)
 END Case01.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

