
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon (POW!-16)                   Dateiname: ZWEI.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Ostern 2001 Version: V 1.0                  |
  |-------------------------------------------------------------------------|
  | Thema:    A b s t r a k t e r   D a t e n t y p   L i s t e             |
  |-------------------------------------------------------------------------|
  | Leistung: Das Modul importiert u. a. das Service-Modul ADTLISTE.        |
  |           Erzeugen eines Stapels (Keller, stack), Textausgabe;          |
  |           einen INTEGER-Wert stapeln und wieder abholen, Textausgabe;   |
  |           Mitteilung, dass der Stapel leer ist, Textausgabe.            |
  |-------------------------------------------------------------------------|
  | Hinweise: Eine Version fr den Farbgrafik-Modus befindet sich unter:    |
  |            ...\adt\demo\colorplane\zwei.mod                             |
  |-------------------------------------------------------------------------|
  |             2001  Manfred Kmmerer, Chamberlain-Soft JENA              |
  *-------------------------------------------------------------------------*)

 MODULE zwei;

  IMPORT ADTL:= adtliste, D:= Display, S:= Strings, Sy:= SYSTEM, W:= Windows;

  CONST  ersteSpalte = 26;

  VAR    eins, zwei : ADTL.Liste; (* zwei Stapel (Listen) aus dem ADTL-Modul*)
         dummy      : LONGINT;    (* Hilfsvariable, siehe Initialisierung   *)

 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE LoescheBereich ( zeile, anzahlZeilen : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Nummer der Zeile, bei der der Lschvorgang beginnt und An- |
    |            zahl der zu lschenden Zeilen                              |
    | Leistung:  Lschen eines Bildschirmbereichs von 60 Zeichen Breite.    |
    *-----------------------------------------------------------------------*)

    VAR i, spalte : INTEGER;

    BEGIN
      spalte:= ersteSpalte - 8;
      DEC(zeile);
      FOR i:= 1 TO anzahlZeilen DO
        D.WriteSpacesXY(spalte,zeile+i,60) 
      END;
    END LoescheBereich;


  PROCEDURE Wiederholung () : BOOLEAN;
   (*-----------------------------------------------------------------------*
    | Referenz: Funktionswert vom Datentyp BOOLEAN (TRUE fr Wiederholung,  |
    |           FALSE fr ohne Wiederholung)                                |
    | Leistung: Ausgabe der Frage mit unterstrichenem 'J' als Hinweis, dass |
    |           eine beliebige Tastenbettigung fr 'JA' (Wiederholung ge-  |
    |           wnscht) und < N > (n-Taste) fr 'NEIN' (Wiederholung nicht |
    |           gewnscht) steht.                                           |
    *-----------------------------------------------------------------------*)

    VAR schluessel : CHAR;

    BEGIN
      D.SetForeColor(127,160,160);
      D.WriteStrXY(31,24,'Wiederholung (J/N) J'); D.GotoXY(50,24);
      D.ReadChar(schluessel);
      D.SetForeColor(96,220,220);
      D.WriteSpacesXY(31,24,20);
      IF CAP(schluessel) = 'N' THEN  (* CAP(char) = wandelt einen Klein- in *)
        RETURN FALSE                 (*             einen Grobuchstaben    *)
      ELSE
        RETURN TRUE
      END
    END Wiederholung;


  PROCEDURE Enter;
   (*-----------------------------------------------------------------------|
    | Leistung:  Ausgabe einer Zeichenkette, Lschen des Tastaturpuffers,   |
    |            Warten auf eine Tastatureingabe (beliebige-Taste) und      |
    |            Lschen der Zeichenkette.                                  |
    |-----------------------------------------------------------------------*)

    VAR dummy : CHAR;

    BEGIN
      D.SetForeColor(96,200,200);
      D.WriteStrXY(68,24,'< ENTER >');
      D.FlushKeyBuffer;
      dummy:= D.ReadKey();
      D.FlushKeyBuffer;
      D.SetForeColor(96,220,220);
      D.WriteSpacesXY(68,24,9)
    END Enter;


  PROCEDURE AusgebenStapelnummer ( nr : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Nummer des Stapels                                         |
    | Leistung:  Ausgabe der in einen Erluterungstext eingefgte Nummer    |
    |            des erzeugten Stapels.                                     |
    *-----------------------------------------------------------------------*)

    BEGIN
      D.SetForeColor(0,228,200);
      D.WriteStrXY(ersteSpalte,11,'Es wurde ein leerer Stapel erzeugt.');
      D.WriteStrXY(ersteSpalte,13,'Der Stapel besitzt die Nummer');
      D.WriteInt(nr,2); D.WriteStr('.')
    END AusgebenStapelnummer;


  PROCEDURE AusgebenElement ( daten, nr : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Inhalt (daten) des Stapelelements und Nummer (nr) des Sta- |
    |            pels von dem das Element geholt ('entstapelt') wurde       |
    | Leistung:  Ausgabe einer zusammengesetzten (Zahlen und Text) Zeichen- |
    |            kette am Bildschirm                                        |
    *-----------------------------------------------------------------------*)

    BEGIN
      D.SetForeColor(0,228,200);
      D.WriteStrXY(ersteSpalte,11,'Vom Stapel'); D.WriteInt(nr,2);
      D.WriteStr(' geholte Zahl ='); D.WriteInt(daten,6)
    END AusgebenElement;


  PROCEDURE AusgebenStapelzustand ( flag : BOOLEAN; nr : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Flag (boolesche Variable flag) und Stapelnummer (nr)       |
    | Leistung:  Ausgabe einer Zeichenkette, deren Inhalt in Abhngigkeit   |
    |            des Werts der booleschen Variable zusammengestellt wird.   |
    *-----------------------------------------------------------------------*)

    BEGIN
      D.SetForeColor(0,228,200);
      D.WriteStrXY(ersteSpalte,11,'Der Stapel'); D.WriteInt(nr,2);
      IF flag THEN D.WriteStr(' ist nicht leer!')
        ELSE D.WriteStr(' ist leer!')
      END
   END AusgebenStapelzustand;


  PROCEDURE AusgebenStapelExistiertNicht;                 (* ohne Kommentar *)
    BEGIN
      D.SetForeColor(255,96,0);
      D.WriteStrXY(ersteSpalte,11,'Der Stapel existiert nicht!')
    END AusgebenStapelExistiertNicht;


  PROCEDURE EinlesenStapelnummer ( VAR nr : INTEGER; zeile : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Position der Textausgabe (zeile)                           |
    | Referenz:  Stapelnummer (nr)                                          |
    | Leistung:  Lschen eines begrenzten Bildschirmbereichs und sicheres   |
    |            Einlesen einer gltigen Stapelnummer.                      |
    *-----------------------------------------------------------------------*)
    VAR resCode : CHAR;

    BEGIN
      REPEAT
        LoescheBereich(11,3);
        D.SetForeColor(96,220,220);
        D.WriteSpacesXY(ersteSpalte,zeile,1); D.GotoXY(ersteSpalte,zeile+20);
        D.WriteStrXY(ersteSpalte,zeile,'Stapel (1 oder 2) = ');
        D.ReadInt(nr,1,resCode)
      UNTIL (nr = 1) OR (nr = 2)
    END EinlesenStapelnummer;


  PROCEDURE ErzeugenStapel ( VAR st1, st2 : BOOLEAN );
   (*-----------------------------------------------------------------------*
    | bernahme: Wahrheitswerte: TRUE fr Stapel existiert bereits          |
    | Referenz:  Wahrheitswert TRUE, falls ein Stapel erzeugt (angelegt)    |
    |            wurde (st1 oder st2, DT: BOOLEAN)                          |
    | Leistung:  Einlesen der vom Anwender gewnschten Stapelnummer,        |
    |            existiert dieser Stapel bereits, Ausgabe einer Meldung,    |
    |            sonst Erzeugen des Stapels (der Liste, Modul adtliste),    |
    |            Darstellen des Stapelbodens im Stapelanzeigefenster und    |
    |            Ausgabe der Erfolgsmeldung am Bildschirm.                  |
    |            Wurde bisher nur ein Stapel erzeugt, wird die Frage nach   |
    |            Wiederholung des Vorgangs gestellt. Wurden bereits beide   |
    |            Stapel erzeugt, wird < ENTER > am Bildschirm ausgegeben    |
    |            auf eine Tastenbettigung gewartet.                        |
    *-----------------------------------------------------------------------*)

    VAR  nr : INTEGER;

    BEGIN
      D.SetForeColor(96,255,236);
      D.WriteStrXY(ersteSpalte-2,7,'STAPEL ERZEUGEN:');
      REPEAT
        EinlesenStapelnummer(nr,9);
        IF (nr = 1) & st1 OR (nr = 2) & st2 THEN
          D.SetForeColor(255,96,0);
          D.WriteStrXY(ersteSpalte,11,'Dieser Stapel existiert bereits!')
        ELSE
          IF nr = 1 THEN
            ADTL.Erzeugen(eins);
             st1:= TRUE
          ELSE
            ADTL.Erzeugen(zwei);
            st2:= TRUE
          END;
          AusgebenStapelnummer(nr)
        END;
        IF st1 & st2 THEN Enter END
      UNTIL st1 & st2 OR ~Wiederholung();
      LoescheBereich(7,7)
    END ErzeugenStapel;


  PROCEDURE StapelnElement ( VAR st1, st2 : BOOLEAN );
   (*-----------------------------------------------------------------------*
    | bernahme: Wahrheitswerte: TRUE fr Stapel existiert bereits          |
    | Referenz:  Wahrheitswert TRUE, falls ein Stapel erzeugt (angelegt)    |
    | Leistung:  Abgesichertes Einlesen eines Stapelelements (berwachung   |
    |            des Gltigkeitsbereichs der Eingabe hinsichtlich Datentyp).|
    |            Einlesen der Stapelnummer. Sollte der Stapel noch nicht    |
    |            existieren, wird er angelegt und eine entsprechende Mel-   |
    |            dung ausgegeben. Das Element wird gestapelt (in die Liste  |
    |            eingetragen), die Elementnummer des entsprechenden Stapels |
    |            inkrementiert. Das Element wird symbolisch im Stapelanzei- |
    |            gefenster auf dem Stapelboden bzw. auf dem bereits exis-   |
    |            tierenden noch aufnahmefhigen Stapel abgelegt und der Vor-|
    |            gang mit einer Erfolgsmeldung abgeschlossen.               |
    |            Wurde nach einer Eingabe die Wiederholungsanfrage mit      |
    |            'NEIN' (N-Taste) beantwortet, kehrt das System zum Men    |
    |            zurck.                                                    |
    *-----------------------------------------------------------------------*)

    VAR resCode  : CHAR;
        daten,nr : INTEGER;

    BEGIN
      D.SetForeColor(96,255,236);
      D.WriteStrXY(ersteSpalte-2,7,'ELEMENT STAPELN:');
      D.SetForeColor(96,220,220);
      D.WriteStrXY(ersteSpalte,9,'Eintrag (DT: INTEGER) =');
      REPEAT
        LoescheBereich(11,5);
        REPEAT
          D.WriteSpacesXY(ersteSpalte+24,9,5); D.GotoXY(ersteSpalte+24,9);
          D.SetForeColor(96,220,220);
          D.ReadInt(daten,5,resCode);
        UNTIL ORD(resCode) = 13;          (* Zahl ist im Gltigkeitsbereich *)
        EinlesenStapelnummer(nr,11);
        IF (nr = 1) & ~st1 THEN
          ADTL.Erzeugen(eins);
          st1:= TRUE;
          AusgebenStapelnummer(nr)
        ELSIF (nr = 2) & ~st2 THEN
          ADTL.Erzeugen(zwei);
          st2:= TRUE;
          AusgebenStapelnummer(nr)
        END;
        CASE nr OF
           1: ADTL.EinfuegenElement(eins,daten)
         | 2: ADTL.EinfuegenElement(zwei,daten)
        END;
        D.WriteStrXY(ersteSpalte,15,'Es wurde ein Element gestapelt.')
      UNTIL ~Wiederholung();
      LoescheBereich(7,9)
    END StapelnElement;


  PROCEDURE EntstapelnElement ( VAR st1, st2 : BOOLEAN );
   (*-----------------------------------------------------------------------*
    | bernahme: Wahrheitswerte: TRUE fr Stapel existiert bereits          |
    | Referenz:  Wahrheitswert TRUE, falls ein Stapel erzeugt (angelegt)    |
    | Leistung:  Einlesen der Stapelnummer (nr) des Stapels, von dem das    |
    |            oberste Element entnommen werden soll. Falls der Stapel    |
    |            leer ist, wird eine entsprechende Mitteilung ausgegeben,   |
    |            sonst wird der Inhalt des Elements in einen Satz eingefgt |
    |            und zur Kontrolle am Bildschirm angezeigt. Das Element     |
    |            wird aus der Liste (Modul adtliste) entfernt und im Stapel-|
    |            ausgabefenster symbolisch vom Stapel 'weggenommen'.        |
    |            Die Elementnummer des entsprechenden Stapels wird dekre-   |
    |            mentiert und die Frage nach Wiederholung des Vorgangs ge-  |
    |            stellt.                                                    |
    *-----------------------------------------------------------------------*)
    VAR daten, nr : INTEGER;

    BEGIN
      D.SetForeColor(96,255,236);
      D.WriteStrXY(ersteSpalte-2,7,'ELEMENT VOM STAPEL HOLEN:');
      REPEAT
        EinlesenStapelnummer(nr,9);
        CASE nr OF
          1: IF ADTL.ListeLeer(eins) & st1 THEN
               AusgebenStapelzustand(FALSE,nr)
             ELSIF st1 THEN
               ADTL.HoleEintrag(eins,daten);
               AusgebenElement(daten,nr);
               ADTL.LoeschenElement(eins)
             ELSE
               AusgebenStapelExistiertNicht
             END
        | 2: IF ADTL.ListeLeer(zwei) & st2 THEN
               AusgebenStapelzustand(FALSE,nr)
             ELSIF st2 THEN
               ADTL.HoleEintrag(zwei,daten);
               AusgebenElement(daten,nr);
               ADTL.LoeschenElement(zwei)
             ELSE
               AusgebenStapelExistiertNicht
             END
        END;
      UNTIL ~Wiederholung();
      LoescheBereich(7,9)
    END EntstapelnElement;


  PROCEDURE StapelInspizieren ( st1, st2 : BOOLEAN );
   (*-----------------------------------------------------------------------*
    | bernahme: Wahrheitswerte: TRUE fr Stapel existiert bereits          |
    | Referenz:  Wahrheitswert TRUE, falls ein Stapel erzeugt (angelegt)    |
    | Leistung:  Einlesen der Stapelnummer (nr) des Stapels, der inspiziert |
    |            werden soll. Ist der Stapel leer, enthlt er mindestens    |
    |            ein Element oder existiert dieser Stapel nicht, wird eine  |
    |            entsprechende Meldung ausgegeben. Danach wird die Frage    |
    |            nach Wiederholung des Vorgangs gestellt.                   |
    *-----------------------------------------------------------------------*)
    VAR leer : BOOLEAN;
        nr   : INTEGER; 

    BEGIN
      REPEAT
        D.SetForeColor(96,255,236);
        D.WriteStrXY(ersteSpalte-2,7,'STAPEL INSPIZIEREN:');
        EinlesenStapelnummer(nr,9);
        CASE nr OF
           1: IF ADTL.ListeLeer(eins) & st1 THEN
                AusgebenStapelzustand(FALSE,nr)
              ELSIF st1 THEN
                AusgebenStapelzustand(TRUE,nr)
              ELSE
                AusgebenStapelExistiertNicht
              END
         | 2: IF ADTL.ListeLeer(zwei) & st2 THEN
                AusgebenStapelzustand(FALSE,nr)
              ELSIF st2 THEN
                AusgebenStapelzustand(TRUE,nr)
              ELSE
                AusgebenStapelExistiertNicht
              END
        END (* case *)
      UNTIL ~Wiederholung();
      LoescheBereich(7,9)
    END StapelInspizieren;


  PROCEDURE Ueberschrift;

    VAR i : INTEGER;

    BEGIN
      D.SetForeColor(96,255,255);
      D.WriteStrXY(19,3,'V E R W A L T E N   Z W E I E R   S T A P E L');
      D.GotoXY(18,4);
      D.SetForeColor(96,220,220);
      FOR i:= 1 TO 47 DO D.WriteChar('') END
    END Ueberschrift;


  PROCEDURE Menue ( VAR kennzahl : INTEGER );
   (*-----------------------------------------------------------------------*
    | Referenz: gltiger Wert der Variablen kennzahl                        |
    | Leistung: Ausgabe der in Klammern gesetzten Kennziffern und der Wahl- |
    |           punkte des Mens. Einlesen der vom Anwender mittels Tasta-  |
    |           tur eingegebenen Kennziffer. Abweisen der Kennziffer, falls |
    |           sie nicht zum Kennziffernvorrat gehrt und Auffordern zur   |
    |           Wiederholung der Eingabe (blinkender Cursor).               |
    *-----------------------------------------------------------------------*)

    CONST spalte  = 28;

    VAR   resCode : CHAR;

    BEGIN
      D.SetForeColor(96,255,220);
      D.WriteStrXY(spalte,6,'(1) Leeren Stapel erzeugen');
      D.WriteStrXY(spalte,7,'(2) Element stapeln');
      D.WriteStrXY(spalte,8,'(3) Elelement entnehmen');
      D.WriteStrXY(spalte,9,'(4) Stapel inspizieren');
      D.WriteStrXY(spalte,11,'(0) Programm beenden');
      REPEAT
        D.SetForeColor(96,220,220);
        D.WriteStrXY(spalte+4,14,'Kennzahl =');
        D.WriteSpacesXY(spalte+15,14,1); D.GotoXY(spalte+15,14);
        D.ReadInt(kennzahl,1,resCode);
        IF ORD(resCode) = 0 THEN kennzahl:= 5 END
      UNTIL kennzahl IN {0..4}
    END Menue;


  PROCEDURE Information;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe einer Information nach Abschluss des Programms.     |
    *-----------------------------------------------------------------------*)

    CONST m1 = 'Besuchen Sie die POW-Seiten des CZ-Gymnasiums!';
          m2 = ' http://www.cz.j.th.schule.de/informatik';
          m3 = '     2001 Chamberlain-Soft';

    VAR   m : ARRAY 91 OF CHAR;

    BEGIN
      D.ClrScr;
      m:= m1; S.Append(m,m2);
      dummy:= W.MessageBoxA(W.GetActiveWindow(),Sy.ADR(m),Sy.ADR(m3),40H)
    END Information;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)


  PROCEDURE ProgMain*();

    VAR ProgEnde,
        st1, st2 : BOOLEAN;
        kennzahl,
        nummer   : INTEGER;

    BEGIN
      ProgEnde:= FALSE;
      st1:= FALSE;
      st2:= FALSE;
      Ueberschrift;
      REPEAT
        Menue(kennzahl);
        LoescheBereich(6,9);
        CASE kennzahl OF
          1: ErzeugenStapel(st1,st2)
        | 2: StapelnElement(st1,st2)
        | 3: EntstapelnElement(st1,st2)
        | 4: StapelInspizieren(st1,st2)
        ELSE
          ProgEnde:= TRUE
        END (* case *)
      UNTIL ProgEnde;
      Information
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   D.SetBackColor(32,8,64);
   D.SetForeColor(96,220,220);
   (* Da die Vordergrundfarbe Schwarz automatisch eingestellt ist,  m u s s *)
   (* die Textfarbe bereits hier initialisiert werden. Sonst sieht man die  *)
   (* Eingabe bei der Anweisung 'D.ReadChar()' nicht!                       *)
   D.SetWindowTitle('Arbeit mit dem ADT Liste');
   (* Ausgabe einer berschrift (DT: string) in der Titelzeile des aktiven  *)
   (* Bildschirmfensters statt des Dateinamens.                     *)
   dummy:= W.ShowWindow(W.GetActiveWindow(),3);
   (* Damit das aktive Bildschirmfenster nicht bei jedem Aufruf 'wandert',  *)
   (* sondern sich nach dem Programmstart stets in der linken oberen Ecke   *)
   (* befindet.                                                             *)
   D.ClrScr
 END zwei.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

