
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon (POW!-32)                   Dateiname: ZWEI.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    A b s t r a k t e r   D a t e n t y p   L i s t e             |
  |-------------------------------------------------------------------------|
  | Leistung: Das Modul importiert u. a. das Service-Modul ADTLISTE.        |
  |           Erzeugen eines Stapels (Keller, stack), Textausgabe;          |
  |           einen INTEGER-Wert stapeln und wieder abholen, Textausgabe;   |
  |           Mitteilung, dass der Stapel leer ist, Textausgabe.            |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul als lauffhiges Grundgerst finden Sie unter:       |
  |            ...\adt\good\zwei.mod                                        |
  *-------------------------------------------------------------------------*)

 MODULE zwei;

  IMPORT In, Out, ADTL:= adtliste;

  VAR    eins, zwei : ADTL.Liste;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE AusgebenStapelnummer ( nr : INTEGER );
    BEGIN
      Out.Ln;
      Out.String('    Es wurde ein leerer Stapel erzeugt.'); Out.Ln;
      Out.String('    Der Stapel besitzt die Nummer'); Out.Int(nr,2);
      Out.String('.'); Out.Ln
    END AusgebenStapelnummer;


  PROCEDURE AusgebenElement ( daten, nr : INTEGER );
    BEGIN
      Out.Ln;
      Out.String('    Vom Stapel'); Out.Int(nr,2);
      Out.String(' geholte Zahl = '); Out.Int(daten,6); Out.Ln
    END AusgebenElement;


  PROCEDURE AusgebenStapelzustand ( flag : BOOLEAN; nr : INTEGER );
    BEGIN
      Out.Ln;
      Out.String('    Der Stapel'); Out.Int(nr,2);
      IF flag THEN Out.String(' ist nicht leer!')
        ELSE Out.String(' ist leer!')
      END;
      Out.Ln
   END AusgebenStapelzustand;


  PROCEDURE AusgebenStapelExistiertNicht;
    BEGIN
      Out.Ln;
      Out.String('    Der Stapel existiert nicht!'); Out.Ln
    END AusgebenStapelExistiertNicht;


  PROCEDURE EinlesenStapelnummer ( VAR nr : INTEGER );
    BEGIN
      REPEAT
        In.Prompt('Stapel (1 oder 2)');
        In.Int(nr)
      UNTIL (nr = 1) OR (nr = 2)
    END EinlesenStapelnummer;


  PROCEDURE ErzeugenStapel ( VAR st1, st2 : BOOLEAN );
   (*-----------------------------------------------------------------------*
    | Referenz: Wahrheitswerte zur Existenz der beiden Stapel (st1, st2)    |
    | Leistung: Ausgabe einer berschrift, Einlesen der gewnschten Stapel- |
    |           nummer, berprfen, ob dieser Stapel bereits existiert.      |
    |           Wenn das der Fall ist, wird eine diesbezgliche Meldung     |
    |           ausgegeben, sonst wird der Stapel (die Liste) erzeugt.      |
    |           Diese Operation wird durch die Prozedur Erzeugen() des      |
    |           Servicemoduls ADTListe bernommen.                          |
    *-----------------------------------------------------------------------*)

    VAR nummer : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('  STAPEL ERZEUGEN:'); Out.Ln;
      EinlesenStapelnummer(nummer);
      IF (nummer = 1) & st1 OR (nummer = 2) & st2 THEN
        Out.Ln; Out.String('    Dieser Stapel existiert bereits!'); Out.Ln
      ELSE
        CASE nummer OF
           1: ADTL.Erzeugen(eins); st1:= TRUE
         | 2: ADTL.Erzeugen(zwei); st2:= TRUE
        END;
        AusgebenStapelnummer(nummer)
      END
    END ErzeugenStapel;


  PROCEDURE StapelnElement ( VAR st1, st2 : BOOLEAN );
   (*-----------------------------------------------------------------------*
    | Referenz: Wahrheitswerte zur Existenz der beiden Stapel (st1, st2)    |
    | Leistung: Ausgabe einer berschrift und eines Eingabehinweises. Ein-  |
    |           lesen der Daten und der gewnschten Stapelnummer. berpr-  |
    |           fen, ob der Stapel bereits existiert. Wenn das der Fall     |
    |           ist, wird der Wert des eingelesenen Elements auf dem ge-    |
    |           wnschten Stapel abgelegt. Existiert der Stapel noch nicht, |
    |           wird er erzeugt, die Stapelnummer angezeigt und der Wert    |
    |           des eingelesenen Elements gestapelt.                        |
    |           Die Operationen Erzeugen() und EinfuegenElement() gehren,  |
    |           wie am 'Qualifizierer' zu erkennen ist, zum Servicemoduls   |
    |           ADTListe.                                                   |
    *-----------------------------------------------------------------------*)

    VAR nummer : INTEGER;

    VAR daten : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('  ELEMENT STAPELN:'); Out.Ln;
      In.Prompt('Eintrag (DT: INT)');
      In.Int(daten);
      EinlesenStapelnummer(nummer);
      IF (nummer = 1) & ~st1 THEN
        ADTL.Erzeugen(eins);
        st1:= TRUE;
        AusgebenStapelnummer(nummer)
      ELSIF (nummer = 2) & ~st2 THEN
        ADTL.Erzeugen(zwei);
        st2:= TRUE;
        AusgebenStapelnummer(nummer)
      END;
      CASE nummer OF
         1: ADTL.EinfuegenElement(eins,daten)
       | 2: ADTL.EinfuegenElement(zwei,daten)
      END;
      Out.Ln;
      Out.String('    Es wurde ein Element gestapelt.'); Out.Ln
    END StapelnElement;


  PROCEDURE EntstapelnElement ( VAR st1, st2 : BOOLEAN );
   (*-----------------------------------------------------------------------*
    | Referenz: Wahrheitswerte zur Existenz der beiden Stapel (st1, st2)    |
    | Leistung: Ausgabe einer berschrift und eines Eingabehinweises.       |
    |           Einlesen einer Stapelnummer. Das Programm verzweigt in Ab-  |
    |           hngigkeit der Stapelnummer. Existiert der Stapel, ist je-  |
    |           doch leer, ADTL.ListeLeer(), wird das angezeigt. Ist der    |
    |           Stapel nicht leer, wird der Wert des obersten Elements 'ab- |
    |           geholt', ADTL.HoleEintrag(), der Inhalt angezeigt und das   |
    |           Element vom Stapel entfernt, ADTL.LoeschenElement().        |
    |           Existiert der Stapel nicht, wird entsprechende Meldung aus- |
    |           gegeben.
    *-----------------------------------------------------------------------*)

    VAR daten, nummer : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('  ELEMENT VOM STAPEL HOLEN:'); Out.Ln;
      EinlesenStapelnummer(nummer);
      CASE nummer OF
         1: IF st1 & ADTL.ListeLeer(eins) THEN
              AusgebenStapelzustand(FALSE,nummer)
            ELSIF st1 THEN
              ADTL.HoleEintrag(eins,daten);
              AusgebenElement(daten,nummer);
              ADTL.LoeschenElement(eins)
            ELSE
              AusgebenStapelExistiertNicht
            END
       | 2: IF st2 & ADTL.ListeLeer(zwei) THEN
              AusgebenStapelzustand(FALSE,nummer)
            ELSIF st2 THEN
              ADTL.HoleEintrag(zwei,daten);
              AusgebenElement(daten,nummer);
              ADTL.LoeschenElement(zwei)
            ELSE
              AusgebenStapelExistiertNicht
            END
      END;
      Out.Ln
    END EntstapelnElement;


  PROCEDURE StapelInspizieren ( st1, st2 : BOOLEAN );
   (*-----------------------------------------------------------------------*
    | bernahme: Wahrheitswerte zur Existenz der beiden Stapel (st1, st2)   |
    | Leistung:  Ausgabe einer berschrift, Einlesen einer Stapelnummer und |
    |            Ermitteln, ob der Stapel leer ist. Der Zustand des Stapels |
    |            wird geprft und am Bildschirm eine entsprechende Meldung  |
    |            ausgegeben. Existiert der Stapel nicht, wird das ebenfalls |
    |            gemeldet.                                                  |
    *-----------------------------------------------------------------------*)

    VAR leer   : BOOLEAN;
        nummer : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('  STAPEL INSPIZIEREN:'); Out.Ln;
      EinlesenStapelnummer(nummer);
      CASE nummer OF 
         1: leer:= st1 & ADTL.ListeLeer(eins)
       | 2: leer:= st2 & ADTL.ListeLeer(zwei)
      END;
      IF leer THEN
        AusgebenStapelzustand(FALSE,nummer);
      ELSIF ~leer & st1 THEN
        AusgebenStapelzustand(TRUE,nummer)
      ELSIF ~leer & st2 THEN
        AusgebenStapelzustand(TRUE,nummer)
      ELSE
        AusgebenStapelExistiertNicht
      END
    END StapelInspizieren;


  PROCEDURE Wiederholung () : BOOLEAN;

    VAR schluessel : CHAR;

    BEGIN
      In.Prompt('Wiederholung (j/n)');
      In.Char(schluessel);
      IF CAP(schluessel) = 'N' THEN  (* CAP(char) = wandelt einen Klein- in *)
        RETURN FALSE                 (*             einen Grobuchstaben    *)
      ELSE
        RETURN TRUE
      END
    END Wiederholung;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();

    VAR st1, st2 : BOOLEAN;

    BEGIN
      st1:= FALSE;
      st2:= FALSE;
      REPEAT
        ErzeugenStapel(st1,st2)
      UNTIL st1 & st2 OR ~Wiederholung();
      REPEAT
        StapelnElement(st1,st2)
      UNTIL ~Wiederholung();
      REPEAT
        EntstapelnElement(st1,st2)
      UNTIL ~Wiederholung();
      REPEAT
        StapelInspizieren(st1,st2)
      UNTIL ~Wiederholung()
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;
   Out.Open
 END zwei.

 (* ----------------------------------------------------------------------- *)

