
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon (POW!-32)                   Dateiname: ZWEI.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    A b s t r a k t e r   D a t e n t y p   L i s t e             |
  |-------------------------------------------------------------------------|
  | Leistung: Das Modul importiert u. a. das Service-Modul ADTLISTE.        |
  |           Es wird ein Stapel (Keller, stack) erzeugt, ein INTEGER-Wert  |
  |           gestapelt und wieder abgeholt, es folgt eine Textausgabe      |
  |           (Mitteilung, dass der Stapel leer ist).                       |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur das Grundgerst dar. |
  |           Es sollten Nutzerhinweise eingefgt werden.                   |
  |           Siehe: ...\adt\fine\zwei.mod                                  |
  *-------------------------------------------------------------------------*)

 MODULE zwei;

  IMPORT In, Out, adtliste;

  VAR eins, zwei : adtliste.Liste;


  PROCEDURE ErzeugenStapel;

    VAR nummer, daten : INTEGER;

    BEGIN
      In.Open;
      In.Int(nummer);
      In.Int(daten);                       (* mute hier eingefgt werden! *)
      CASE nummer OF
         1: adtliste.Erzeugen(eins)
       | 2: adtliste.Erzeugen(zwei)
      END;
      Out.Ln;
      Out.String(' Es wurde ein leerer Stapel erzeugt.');
      Out.Ln
    END ErzeugenStapel;


  PROCEDURE StapelnElement;

    VAR nummer, daten : INTEGER;

    BEGIN
      In.Open;
      In.Int(nummer);
      In.Int(daten);
      CASE nummer OF
         1: adtliste.EinfuegenElement(eins,daten)
       | 2: adtliste.EinfuegenElement(zwei,daten)
      END;
      Out.Ln;
      Out.String(' Es wurde ein Element gestapelt.');
      Out.Ln; Out.Ln
    END StapelnElement;


  PROCEDURE EntstapelnElement;

    VAR nummer, daten : INTEGER;

    BEGIN
      In.Open;
      In.Int(nummer);
      CASE nummer OF
         1: IF adtliste.ListeLeer(eins) THEN
              Out.String(' Der Stapel ist leer!'); Out.Ln;
              Out.Ln
            ELSE
              adtliste.HoleEintrag(eins,daten);
              Out.String(' Vom Stapel geholte Zahl: ');
              Out.Int(daten,6); Out.Ln;
              Out.Ln;
              adtliste.LoeschenElement(eins)
            END
       | 2: IF adtliste.ListeLeer(zwei) THEN
              Out.String(' Der Stapel ist leer!'); Out.Ln;
              Out.Ln
            ELSE
              adtliste.HoleEintrag(zwei,daten);
              Out.String(' Vom Stapel geholte Zahl: ');
              Out.Int(daten,6); Out.Ln;
              Out.Ln;
              adtliste.LoeschenElement(zwei)
            END
      END
    END EntstapelnElement;


  PROCEDURE StapelLeer;

    VAR nummer : INTEGER;
        leer   : BOOLEAN;

    BEGIN
      In.Open;
      In.Int(nummer);
      CASE nummer OF 
         1: leer:= adtliste.ListeLeer(eins)
       | 2: leer:= adtliste.ListeLeer(zwei)
      END;
      IF leer THEN
        Out.String(' Der Stapel ist leer.'); Out.Ln;
        Out.Ln
      ELSE
        Out.String(' Der Stapel ist nicht leer.'); Out.Ln;
        Out.Ln
      END
    END StapelLeer;


  PROCEDURE ProgMain*();
    BEGIN
      ErzeugenStapel;
      StapelnElement;
      EntstapelnElement;
      StapelLeer
    END ProgMain;


 BEGIN
   Out.Open
 END zwei.

