
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)       Dateiname: SCHALTJAHR.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    D a t u m  (Schaltjahr)                                       |
  |-------------------------------------------------------------------------|
  | Leistung: Ermitteln, ob ein eingelesenes Jahr ein Schaltjahr ist.       |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst, das 'Anweisungslcken  |
  |           im Quelltext enthlt, befindet sich in:                       |
  |            ...\datum1\good\schaltja.mod                                 |
  |-------------------------------------------------------------------------|
  | Aufgabenstellung: ...\datum1\txt\datum.txt und                          |
  |                   ...\datum1\doc\datum.doc                              |
  | Erluterungstext: ...\datum1\txt\schaltja.txt und                       |
  |                   ...\datum1\doc\schaltja.doc                           |
  *-------------------------------------------------------------------------*)

 MODULE Schaltjahr;

  IMPORT In, Out;


 (* --------------------  U N T E R P R O G R A M M E --------------------- *)


  PROCEDURE Ueberschrift;

    VAR i : INTEGER;

    BEGIN
      Out.Ln; Out.Ln;
      Out.String('   S C H A L T J A H R'); Out.Ln;
      Out.String('  '); FOR i:= 1 TO 21 DO Out.Char('') END;
      Out.Ln
    END Ueberschrift;


  PROCEDURE Beispieldaten;
    BEGIN
      Out.Ln;
      Out.String('   Beispieldaten:  ');
      Out.String('1600 1900 1996 1997 2000 2003 2004 2008 2100  2400');
      Out.Ln
    END Beispieldaten;


  PROCEDURE Wiederholung () : BOOLEAN;                 (* Funktionsprozedur *)

    VAR schluessel : CHAR;

    BEGIN
      In.Prompt('Wiederholung (j/n)');
      In.Char(schluessel);
      IF CAP(schluessel) = 'N' THEN  (* CAP(char) = wandelt einen Klein- in *)
        RETURN FALSE                 (*             einen Grobuchstaben    *)
      ELSE
        RETURN TRUE
      END
    END Wiederholung;


  PROCEDURE Gueltig ( jahreszahl : INTEGER ) : BOOLEAN;
   (*-----------------------------------------------------------------------*
    | bernahme: Jahreszahl des zu testenden Jahres (jahreszahl)            |
    | Referenz:  Wahrheitswert als Rckgabewert Funktionswert)              |
    |            TRUE = korrekt, FALSE = nicht korrekt (siehe Hinweis)      |
    | Leistung:  Ermitteln, ob es sich bei dem zu testenden Jahr um ein     |
    |            nach dem gregorianischen Kalender gltiges Jahr handelt.   |
    | Hinweis:   Ist eine Jahreszahl des gregorianischen Kalenders durch    |
    |            4 oder (einschlieend) 400 teilbar, so handelt es sich bei |
    |            diesem Jahr um ein Schaltjahr, der 29.02. existiert.       |
    *-----------------------------------------------------------------------*)

    BEGIN
      IF (jahreszahl < 1583) OR (jahreszahl > 3000) THEN
        Out.Ln;
        Out.String('   Nur Jahreszahlen von 1583 bis 3000 eingeben!'); Out.Ln;
        Out.String('           (gregorianischer Kalender)'); Out.Ln;
        RETURN FALSE
      ELSE
        RETURN TRUE
      END;
    END Gueltig;


  PROCEDURE Schaltjahr;
   (*-----------------------------------------------------------------------*
    | Leistung:  Ermitteln, ob es sich bei dem zu testenden Jahr um ein     |
    |            Schaltjahr handelt. Ausgabe der Antwort als Zeichenkette.  |
    *-----------------------------------------------------------------------*)

    VAR jahreszahl : INTEGER;
        schaltjahr : BOOLEAN;

    VAR c, j : INTEGER;

    BEGIN
      REPEAT
        In.Prompt('Jahreszahl  ( jjjj )');
        In.Int(jahreszahl);
      UNTIL Gueltig(jahreszahl);
      
      c:= jahreszahl DIV 100; 
      j:= jahreszahl MOD 100;
      
      IF j = 0 THEN 
        schaltjahr:= c MOD 4 = 0
      ELSE
        schaltjahr:= j MOD 4 = 0 
      END;

      Out.Ln;
      Out.String('   Das Jahr');  Out.Int(jahreszahl,5);
      IF schaltjahr THEN
        Out.String(' ist ein Schaltjahr.')
      ELSE
        Out.String(' ist kein Schaltjahr.')
      END
    END Schaltjahr;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)


  PROCEDURE ProgMain*();
    BEGIN
      Ueberschrift;
      Beispieldaten;
      REPEAT
        Schaltjahr
      UNTIL ~Wiederholung()
    END ProgMain;


 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;
   Out.Open
 END Schaltjahr.

 (* ----------------------------------------------------------------------- *)

