
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)        Dateiname: ZWEIDATEN.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    D a t u m   (Import des Servicemoduls DatumOperationen)       |
  |-------------------------------------------------------------------------|
  | Leistung: Abstand zwischen zwei Kalenderdaten in Tagen.                 |
  |           Ermitteln eines zuknftigen oder vergangenen Kalenderdatums,  |
  |           aus einem eingegebenen Datum und dem Abstand in Tagen.        |
  |           Ordnung  zwischen zwei Kalenderdaten (liegt vor/nach dem ers- |
  |           ten Datum).                                                   |
  |           Alle Daten mssen zwischen 1583 und 3000 (gregorianisher Ka-  |
  |           lender) liegen.                                               |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst, befindet sich in:      |
  |            ...\datum2\good\zweidate.mod                                 |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\datum2\txt\datumtool.txt und                      |
  |                   ...\datum2\doc\datumtool.doc                          |
  *-------------------------------------------------------------------------*)

 MODULE ZweiDaten;

  IMPORT In, Out, Op:= DatumOperationen, S:= Strings, W:= Windows;

  VAR dummy : LONGINT;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Ueberschrift ( fall : INTEGER );

    VAR  i : INTEGER;

    BEGIN
      Out.Ln; Out.String('   ');
      IF fall = 1 THEN
        Out.String('A N Z A H L  Tage zwischen zwei Kalenderdaten'); Out.Ln;
        Out.String('  ');
        FOR i:= 1 TO 47 DO Out.Char('') END
            (* '' = <Alt> + <0><1><6><8> auf dem Nummernblock der Tastatur *)
      ELSIF fall = 2 THEN
        Out.String('A B S T A N D  zwischen zwei Kalenderdaten'); Out.Ln
      ELSE 
        Out.String('O R D N U N G  zwischen zwei Kalenderdaten'); Out.Ln
      END;
      IF (fall = 2) OR (fall = 3) THEN
        Out.String('  ');
        FOR i:= 1 TO 44 DO Out.Char('') END
      END;
      Out.Ln
    END Ueberschrift;


  PROCEDURE Beispieldaten ( art : INTEGER );
    BEGIN
      Out.String('   Beispieldaten: ');
      CASE art OF
        1: Out.String('2001 12 25  und  2003 12 25')
      | 2: Out.String('2004 7 12  Abstand: 40000')
      ELSE Out.String('2000 12 31  und  2001 1 1')
      END;
      Out.Ln
    END Beispieldaten;


  PROCEDURE Weiter;

    VAR ch : CHAR;

    BEGIN
      In.Prompt('< - > + < ENTER > ');
      In.Char(ch)
    END Weiter;


  PROCEDURE Ausgeben ( datum : Op.tDatum );
   (*-----------------------------------------------------------------------*
    | bernahme: Jahreszahl, Monats- und Tagesnummer des auszugebenden Ka-  |
    |            lenderdatums (Verbund datum, DT: tDatum)                   |
    | Leistung:  Anzeige eines Kalenderdatums am Bildschirm                 |
    *-----------------------------------------------------------------------*)

    BEGIN
      Out.Int(datum.jahr,6); Out.Int(datum.monat,3); Out.Int(datum.tag, 3);
      Out.Ln
    END Ausgeben;


  PROCEDURE AnzeigeSchaltjahr ( datum : Op.tDatum );
   (*-----------------------------------------------------------------------*
    | bernahme: Jahreszahl, Monats- und Tagesnummer des eingelesenen und   |
    |            geprften Kalenderdatums (Verbund datum, DT: tDatum)       |
    | Leistung:  Ausgabe der Information, ob es sich beim bernommenen Ka-  |
    |            lenderjahr um ein Schaltjahr handelt oder nicht.           |
    |            Der Wahrheitswert der Schaltjahrinformation, der als boole-|
    |            scher Ausdruck der zweiseitigen Auswahl dient, wird durch  |
    |            den Aufruf der Funktionsprozedur Schaltjahr() aus dem Ser- |
    |            vicemoduls DatumOperationen geliefert.                     |
    *-----------------------------------------------------------------------*)

    BEGIN
      IF Op.Schaltjahr(datum.jahr) THEN
        Out.String(' (Schaltjahr)')
      ELSE
        Out.String(' (kein Schaltjahr)')
      END;
      Out.Ln
    END AnzeigeSchaltjahr;


  PROCEDURE AusgabeKorrektesDatum ( flag : BOOLEAN; datum : Op.tDatum );
   (*-----------------------------------------------------------------------*
    | bernahme: Wahrheitswert der booleschen Variablen flag, Jahreszahl,   |
    |            Monats- und Tagesnummer des eingelesenen und geprften Ka- |
    |            lenderdatums (Verbund datum, DT: tDatum)                   |
    | Leistung:  In Abhngigkeit des Wahrheitswerts der Variablen flag und  |
    |            des Werts der Verbundvariablen datum.jahr wird entweder    |
    |            eine Besttigung oder ein Hinweis zur Programmbedienung am |
    |            Bildschirm ausgegeben.                                     |
    *-----------------------------------------------------------------------*)

    BEGIN
      Out.Ln;
      IF flag THEN
        Out.String('   Der Tag existiert. ')
      ELSE
        Out.String('   Der Tag existiert in diesem Kalender nicht.'); Out.Ln;
        IF (datum.jahr < 1583) OR (datum.jahr > 3000) THEN
          Out.Ln;
          Out.String('   Nur Jahreszahlen zwischen 1583 und 3000!'); Out.Ln
        END
      END
    END AusgabeKorrektesDatum;


  PROCEDURE Korrekt ( datum : Op.tDatum ) : BOOLEAN;
   (*-----------------------------------------------------------------------*
    | bernahme: Jahreszahl, Monats- und Tagesnummer des eingelesenen und   |
    |            geprften Kalenderdatums (Verbund datum, DT: tDatum)       |
    | Referenz:  Wahrheitswert (Rckgabe-, Funktionswert)                   |
    | Leistung:  berprfen, ob ein bernommenes Kalenderdatum im gregoria- |
    |            nischen Kalender existiert. Dafr wird die Funktionsproze- |
    |            dur Existenz() aus dem Servicemoduls DatumOperationen an-  |
    |            gewendet.                                                  |
    *-----------------------------------------------------------------------*)

    BEGIN
      IF Op.Existenz(datum) THEN
        RETURN TRUE
      ELSE
        RETURN FALSE
      END
    END Korrekt;


  PROCEDURE Einlesen ( VAR datum : Op.tDatum; fall : INTEGER );
   (*-----------------------------------------------------------------------*
    | Referenz: Jahreszahl, Monats- und Tagesnummer des eingelesenen Kalen- |
    |           derdatums (Verbund datum, DT: tDatum) und eine Zahl {0..2}, |
    |           um den Inhalt einer Mitteilung anzupassen                   |
    | Leistung: Ausgabe von Eingabehilfen (Prompt), Einlesen eines komplet- |
    |           ten Datums von der Tastatur und Kontrollausgabe am Monitor. |
    *-----------------------------------------------------------------------*)

    VAR mitteilung : ARRAY 40 OF CHAR;

    BEGIN
      In.Prompt('Jahrszahl');
      In.Int(datum.jahr);
      In.Prompt('Monatsnummer');
      In.Int(datum.monat);
      In.Prompt('Tagesnummer');
      In.Int(datum.tag);
      mitteilung:= '   Das eingegebene Datum lautet:';
      CASE fall OF
        1: S.Insert(' erste',mitteilung,6)
      | 2: S.Insert(' zweite',mitteilung,6)
      ELSE END;
      Out.Ln; Out.String(mitteilung);
      Ausgeben(datum)
    END Einlesen;


  PROCEDURE Zwischen;

   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe von Eingabehilfen (Prompt), Einlesen eines komplet- |
    |           ten Kalenderdatums von der Tastatur, Existenzprfung und    |
    |           Kontrollausgabe samt Schaltjahrsinformation am Bildschirm.  |
    |           Wiederholung des gesamten Geschehens fr ein zweites Datum. |
    |           Sind beide Daten korrekt, wird die Differenz ermittelt und  |
    |           der Variable anzahl zugewiesen. Zum Ermitteln der 'Entfer-  |
    |           nung' der beiden Kalenderdaten wird die Funktionsprozedur   |
    |           Abstand() aus dem Servicemoduls DatumOperationen angewandet.|
    |           Das Ergebnis, Wert der Variablen anzahl wird in einen Satz  |
    |           gekleidet am Bildschirm ausgegeben, auch wenn beide Kalen-  |
    |           daten identisch sein sollten. Falls ein Datum oder beide    |
    |           Daten nicht im gregorianischen Kalender existieren, wird    |
    |           das durch entsprechende Meldungen angezeigt.                |
    *-----------------------------------------------------------------------*)

    CONST aussage1 = '   Zwischen beiden Daten liegen ';
          aussage2 = '   Es ist das gleiche Datum.';

    VAR   OKdat1, OKdat2 : BOOLEAN;
          anzahl,
          jrTag, jsTag   : LONGINT;
          datum1, datum2 : Op.tDatum;

    BEGIN
      Einlesen(datum1,1);
      OKdat1:= Korrekt(datum1);
      IF OKdat1 THEN  
        AusgabeKorrektesDatum(OKdat1,datum1);
        AnzeigeSchaltjahr(datum1);
        Einlesen(datum2,2);
        OKdat2:= Korrekt(datum2);
        IF OKdat2 THEN
          AusgabeKorrektesDatum(OKdat2,datum2);
          AnzeigeSchaltjahr(datum2);
          Out.Ln;
          IF OKdat1 & OKdat2 THEN
            anzahl:= Op.Abstand(datum1,datum2);
            IF anzahl > 0 THEN
              Out.String(aussage1);
              Out.Int(anzahl,1);
              IF anzahl = 1 THEN
                Out.String(' Tag.')
              ELSE
                Out.String(' Tage.')
              END
            ELSE
              Out.String(aussage2)
            END;
            Out.Ln
          END
        ELSE
          AusgabeKorrektesDatum(OKdat2,datum2)
        END
      ELSE
        AusgabeKorrektesDatum(OKdat1,datum1)
      END;

   (*-----------------------------------------------------------------------*
    |                   Anwendung des 'julianischen Tages'                  |
    *-----------------------------------------------------------------------*
    | Erluterungen, siehe Servicemodul:                                    |
    |                                ...\datum2\fine\DatumOperationen.mod   |
    *-----------------------------------------------------------------------*)

      IF OKdat1 & OKdat2 THEN
        IF Op.LiegtVor(datum2,datum1) THEN
          Op.TauschenDaten(datum1,datum2)
        END;
        jrTag:= Op.JulianischeTagesnummer(datum1);
        jsTag:= Op.JulianischeTagesnummer(datum2);
        anzahl:= jsTag - jrTag;
        Out.Ln;
        IF anzahl > 0 THEN
          Out.String("   Unter Nutzung des 'julianischen Tages': "); Out.Ln;
          Out.Ln;
          Out.String(aussage1);
          Out.Int(anzahl,1);
          IF anzahl = 1 THEN
            Out.String(' Tag.')
          ELSE
            Out.String(' Tage.')
          END
        ELSE
          Out.String(aussage2)
        END;
        Out.Ln; Out.Ln
      END;
   (*-----------------------------------------------------------------------*)
      Weiter
    END Zwischen;


  PROCEDURE DanachDavor;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe von Eingabehilfen (Prompt), Einlesen eines komplet- |
    |           ten Kalenderdatums und des gewnschten Abstands in Tagen,   |
    |           der auf seine Gre geprft wird, von der Tastatur, Exis-   |
    |           tenzprfung und Kontrollausgabe samt Schaltjahrsinformation |
    |           am Bildschirm.                                              |
    |           Errechnen des gewollten Datums unter Einsatz der Prozedur   |
    |           DavorDanach() des Servicemoduls DatumOperationen, Ausgabe   |
    |           des Datums, das in einen korrekten Satz gekleidet ausgege-  |
    |           ben wird. Sollte das Datum nicht im Gltigkeitsbereich des  |
    |           gregorianischen Kalenders liegen, wird eine entsprechende   |
    |           Mitteilung gegeben.                                         |
    *-----------------------------------------------------------------------*)

    CONST aussage1 = ' Tage spter lautet das Datum:';
          aussage2 = ' Tage frher lautet das Datum:';

    VAR   OKdat1, OKdat2 : BOOLEAN;
          abstand, jTag  : LONGINT;
          datum1, datum2 : Op.tDatum;
        

    BEGIN
      Einlesen(datum1,0);
      OKdat1:= Korrekt(datum1);
      IF OKdat1 THEN  
        AusgabeKorrektesDatum(OKdat1,datum1);
        AnzeigeSchaltjahr(datum1);
        REPEAT
          In.Prompt('Abstand in Tagen');
          In.LongInt(abstand);
        UNTIL (abstand # 0) & (ABS(abstand) < 517914);
                    (* zwischen 1583 1 1 und 3000 12 31 liegen 517.913 Tage *)
        Op.DavorDanach(datum1,abstand,datum2);
        Out.Ln; Out.String('   ');
        Out.Int(ABS(abstand),1);
        IF abstand > 0 THEN
          Out.String(aussage1)
        ELSIF abstand < 0 THEN
          Out.String(aussage2)
        END;
        Ausgeben(datum2);
        OKdat2:= Korrekt(datum2);
        IF OKdat2 THEN
          AusgabeKorrektesDatum(OKdat2,datum2);
          AnzeigeSchaltjahr(datum2);
        ELSE  
          AusgabeKorrektesDatum(OKdat2,datum2)
        END;
        Out.Ln
      ELSE
        AusgabeKorrektesDatum(OKdat1,datum1)
      END;

   (*-----------------------------------------------------------------------*
    |                   Anwendung des 'julianischen Tages'                  |
    *-----------------------------------------------------------------------*
    | Erluterungen, siehe Servicemodul:                                    |
    |                                ...\datum2\fine\DatumOperationen.mod   |
    *-----------------------------------------------------------------------*)

      IF OKdat1 THEN
        jTag:= Op.JulianischeTagesnummer(datum1);
        jTag:= jTag + abstand;
        Op.GibDatum(jTag,datum2);
        Out.String("   Unter Nutzung des 'julianischen Tages': "); Out.Ln;
        Out.Ln;
        Out.Ln; Out.String('   '); Out.Int(ABS(abstand),1);
        IF abstand > 0 THEN
          Out.String(aussage1)
        ELSIF abstand < 0 THEN
          Out.String(aussage2)
        END;
        Ausgeben(datum2);
        OKdat2:= Korrekt(datum2);
        IF OKdat2 THEN
          AusgabeKorrektesDatum(OKdat2,datum2);
          AnzeigeSchaltjahr(datum2);
        ELSE  
          AusgabeKorrektesDatum(OKdat2,datum2)
        END
      END;
      Out.Ln; Out.Ln;
   (*-----------------------------------------------------------------------*)
      Weiter
    END DanachDavor;

  
  PROCEDURE Ordnung;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe von Eingabehilfen (Prompt), Einlesen eines komplet- |
    |           ten Kalenderdatums von der Tastatur, Existenzprfung und    |
    |           Kontrollausgabe samt Schaltjahrsinformation am Bildschirm.  |
    |           Wiederholung des gesamten Geschehens fr ein zweites Datum. |
    |           Sind beide Daten korrekt, wird zuerst auf Gleichheit und,   |
    |           falls das nicht zutrifft, auf 'Datum 1 liegt vor Datum2'    |
    |           geprft. Beide Entscheidungen werden unter Anwendung der    |
    |           Rckgabewerte von Funktionsprozeduren des Servicemoduls     |
    |           DatumOperationen (IstGleich() und LiegtVor())getroffen.     |
    |           Ausgabe der Ordnung als Satz.                               |
    *-----------------------------------------------------------------------*)

    CONST aussage1 = '   Es ist das gleiche Datum.';
          aussage2 = '   Das erste Datum liegt vor dem zweiten Datum.';
          aussage3 = '   Das zweite Datum liegt vor dem ersten Datum.';

    VAR OKdat1, OKdat2 : BOOLEAN;
        abstand,
        jrTag, jsTag   : LONGINT;
        datum1, datum2 : Op.tDatum;

    BEGIN
      Einlesen(datum1,1);
      OKdat1:= Korrekt(datum1);
      IF OKdat1 THEN
        AusgabeKorrektesDatum(OKdat1,datum1);
        AnzeigeSchaltjahr(datum1);
        Einlesen(datum2,2);
        OKdat2:= Korrekt(datum2);
        IF OKdat2 THEN
          AusgabeKorrektesDatum(OKdat2,datum2);
          AnzeigeSchaltjahr(datum2);
          Out.Ln;
          IF Op.IstGleich(datum1,datum2) THEN
            Out.String(aussage1)
          ELSIF Op.LiegtVor(datum1,datum2) THEN 
            Out.String(aussage2)
          ELSE Out.String(aussage3)
          END;
          Out.Ln
        ELSE  
          AusgabeKorrektesDatum(OKdat2,datum2)
        END
      ELSE
        AusgabeKorrektesDatum(OKdat1,datum1)
      END;

   (*-----------------------------------------------------------------------*
    |                   Anwendung des 'julianischen Tages'                  |
    *-----------------------------------------------------------------------*
    | Erluterungen, siehe Servicemodul:                                    |
    |                                ...\datum2\fine\DatumOperationen.mod   |
    *-----------------------------------------------------------------------*)

      IF OKdat1 & OKdat2 THEN
        jrTag:= Op.JulianischeTagesnummer(datum1);
        jsTag:= Op.JulianischeTagesnummer(datum2);
        abstand:= jsTag - jrTag;
        Out.Ln;
        Out.String("   Unter Nutzung des 'julianischen Tages': "); Out.Ln;
        Out.Ln;
        IF abstand = 0 THEN
          Out.String(aussage1);
        ELSIF abstand > 0 THEN
          Out.String(aussage2)
        ELSE
          Out.String(aussage3)
        END;
        Out.Ln
      END
   (*-----------------------------------------------------------------------*)
    END Ordnung;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
     Ueberschrift(1);
     Beispieldaten(1);
     Zwischen;
     Ueberschrift(2);
     Beispieldaten(2);
     DanachDavor;
     Ueberschrift(3);
     Beispieldaten(3);
     Ordnung
    END ProgMain;


 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   dummy:= W.ShowWindow(W.GetActiveWindow(),3);
   In.Open;
   Out.Open
 END ZweiDaten.

 (* ----------------------------------------------------------------------- *)

