
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)         Dateiname: EINDATUM.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    D a t u m   (Import des Servicemoduls DatumOperationen)       |
  |-------------------------------------------------------------------------|
  | Leistung: Demonstrieren einiger Operationen des Moduls DatumOperationen |
  |           unter Anwendung des aus diesem Modul importierten Datentyps   |
  |           tDatum.                                                       |
  |           Alle Daten mssen zwischen 1583 und 3000 (gregorianisher Ka-  |
  |           lender) liegen.                                               |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst, befindet sich in:      |
  |            ...\datum2\good\eindatum.mod                                 |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\datum2\txt\datumtool.txt und                      |
  |                   ...\datum2\doc\datumtool.doc                          |
  *-------------------------------------------------------------------------*)

 MODULE EinDatum;

  IMPORT In, Out, Op:= DatumOperationen;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Ueberschrift;

    VAR i : INTEGER;

    BEGIN
      Out.Ln; Out.Ln;
      Out.String('   Vorgnger und Nachfolger eines Kalenderdatums');
      Out.Ln; Out.String('  ');
      FOR i:= 1 TO 47 DO Out.Char('') END;
            (* '' = <Alt> + <0><1><6><8> auf dem Nummernblock der Tastatur *)
      Out.Ln; Out.Ln
    END Ueberschrift;


  PROCEDURE Beispieldatum;
    BEGIN
      Out.String('   Beispieldatum:  2000 2 29');
      Out.Ln
    END Beispieldatum;


  PROCEDURE Ausgeben ( datum : Op.tDatum );
   (*-----------------------------------------------------------------------*
    | bernahme: Jahreszahl, Monats- und Tagesnummer des auszugebenden Ka-  |
    |            lenderdatums (Verbund datum, DT: tDatum)                   |
    | Leistung:  Anzeige eines Kalenderdatums am Bildschirm                 |
    *-----------------------------------------------------------------------*)

    BEGIN
      Out.Int(datum.jahr,5); Out.Int(datum.monat,3); Out.Int(datum.tag, 3);
      Out.Ln; Out.Ln
    END Ausgeben;


  PROCEDURE Einlesen ( VAR datum : Op.tDatum; VAR korrekt : BOOLEAN );
   (*-----------------------------------------------------------------------*
    | Referenz: Jahreszahl, Monats- und Tagesnummer des eingelesenen Kalen- |
    |           derdatums (Verbund datum, DT: tDatum)                       |
    | Leistung: Ausgabe von Eingabehinweisen (Prompt), Einlesen eines Ka-   |
    |           lenderdatums, Prfen der Gltigkeit (gregorianisher Kalen-  |
    |           der) und formatierte Kontrollausgabe des Datums oder Aus-   |
    |           gabe einer Fehlermeldung am Bildschirm.                     |
    |           Falls das eingegebene Datum die Monatsnummer 2 enthlt,     |
    |           wird die Funktionsprozedur Schaltjahr() aus dem Servicemo-  |
    |           dul DatumOperationen einbezogen und ggf. eine entsprechende |
    |           Mitteilung am Bildschirm ausgegeben.                        |
    *-----------------------------------------------------------------------*)

    BEGIN
      In.Prompt('Jahreszahl)');
      In.Int(datum.jahr);
      In.Prompt('Monatsnummer');
      In.Int(datum.monat);
      In.Prompt('Tagesnummer');
      In.Int(datum.tag);
      korrekt:= Op.Existenz(datum);
      Out.Ln;
      Out.String('   Das eingegebene Datum lautet:');
      IF korrekt THEN
        Out.String('              '); Ausgeben(datum);
        IF (datum.monat = 2) & Op.Schaltjahr(datum.jahr) THEN
          Out.String('   Das Jahr '); Out.Int(datum.jahr,1);
          Out.String(' ist ein Schaltjahr.'); Out.Ln; Out.Ln
        END;
        Out.String('   Der Tag existiert, ');
      ELSE
        Ausgeben(datum);
        Out.String('   Der Tag existiert nicht.'); Out.Ln; Out.Ln;
        Out.String('   Die Kalenderdaten mssen zwischen 1583 1 1 und');
        Out.Ln; Out.Ln;
        Out.String('   3000 12 31 (gregorianisher Kalender) liegen.');
        Out.Ln
      END
    END Einlesen;


  PROCEDURE Wochentag ( datum : Op.tDatum );
   (*-----------------------------------------------------------------------*
    | bernahme: Jahreszahl, Monats- und Tagesnummer des eingelesenen Ka-   |
    |            lenderdatums (Verbund datum, DT: tDatum)                   |
    | Leistung:  Ermitteln und Ausgeben des Wochentagsnamens, der zum ber- |
    |            nommenen Kalenderdatum gehrt.                             |
    *-----------------------------------------------------------------------*)

    VAR wochentagsname : Op.tName;

    BEGIN
      Out.String('es ist ein ');    
      Op.Wochentagsname(Op.Wochentagsnummer(datum),wochentagsname);
      Out.String(wochentagsname); Out.Char('.'); Out.Ln;
      Out.Ln
    END Wochentag;


  PROCEDURE Vorgaenger ( datum : Op.tDatum );
    
   (*-----------------------------------------------------------------------*
    | bernahme: Jahreszahl, Monats- und Tagesnummer des eingelesenen Ka-   |
    |            lenderdatums (Verbund datum, DT: tDatum)                   |
    | Leistung:  Ermitteln des Kalenderdatums des vorangegangenen Tages und |
    |            formatierte Ausgabe dieses Datums am Bildschirm.           |
    *-----------------------------------------------------------------------*)

    BEGIN
      Op.Vorgaenger(datum);
      Out.String('   Das Datum des vorangegangenen Tages lautet:');
      Ausgeben(datum)
    END Vorgaenger;


  PROCEDURE Nachfolger ( datum : Op.tDatum );

   (*-----------------------------------------------------------------------*
    | bernahme: Jahreszahl, Monats- und Tagesnummer des eingelesenen Ka-   |
    |            lenderdatums (Verbund datum, DT: tDatum)                   |
    | Leistung:  Ermitteln des Kalenderdatums des nachfolgenden Tages und   |
    |            formatierte Ausgabe dieses Datums am Bildschirm.           |
    *-----------------------------------------------------------------------*)
    
    BEGIN
      Op.Nachfolger(datum);
      Out.String('   Das Datum des nachfolgenden Tages lautet:  ');
      Ausgeben(datum)
    END Nachfolger;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)


  PROCEDURE ProgMain*();

    VAR korrekt : BOOLEAN;
        datum   : Op.tDatum;

    BEGIN
      Ueberschrift;
      Beispieldatum;
      Einlesen(datum,korrekt);
      IF korrekt THEN
        Wochentag(datum);
        Vorgaenger(datum);
        Nachfolger(datum)
      END
    END ProgMain;


 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

  BEGIN
    In.Open;
    Out.Open
  END EinDatum.

 (* ----------------------------------------------------------------------- *)

