
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)            Dateiname: JAHRE.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    D a t u m   (Import des Servicemoduls DatumOperationen)       |
  |-------------------------------------------------------------------------|
  | Leistung: Es wird das Datum des Ostersonntags eines eingegebenen Jahres |
  |           ermittelt (gregorianischer Kalender). Zustzlich wird ange-   |
  |           zeigt, ob es sich um ein Schaltjahr handelt.                  |
  |           Alle Daten mssen zwischen 1583 und 3000 (gregorianisher Ka-  |
  |           lender) liegen.                                               |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst, befindet sich in:      |
  |            ...\datum2\good\jahre.mod                                    |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\datum2\txt\datumtool.txt und                      |
  |                   ...\datum2\doc\datumtool.doc                          |
  *-------------------------------------------------------------------------*)

 MODULE Jahre;

  IMPORT In, Out, Op:= DatumOperationen;


 (* ---------------------  U N T E R P R O G R A M M  --------------------- *)


  PROCEDURE Ueberschrift;

    VAR i : INTEGER;

    BEGIN
      Out.Ln; Out.Ln;
      Out.String('   O S T E R D A T U M');
      Out.Ln; Out.String('  ');
      FOR i:= 1 TO 21 DO Out.Char('') END;
            (* '' = <Alt> + <0><1><6><8> auf dem Nummernblock der Tastatur *)
      Out.Ln
    END Ueberschrift;


  PROCEDURE Einlesen ( VAR datum : Op.tDatum );
   (*-----------------------------------------------------------------------*
    | Referenz: Jahreszahl, Monats- und Tagesnummer des eingelesenen Kalen- |
    |           derdatums (Verbund datum, DT: tDatum)                       |
    | Leistung: Ausgabe von Eingabehinweisen (Prompt), Einlesen eines Ka-   |
    |           lenderdatums, Prfen der Gltigkeit (gregorianisher Kalen-  |
    |           der) und formatierte Kontrollausgabe des Datums oder Aus-   |
    |           gabe einer Fehlermeldung am Bildschirm.                     |
    |           Falls das eingegebene Datum die Monatsnummer 2 enthlt,     |
    |           wird die Funktionsprozedur Schaltjahr() aus dem Servicemo-  |
    |           dul DatumOperationen einbezogen und ggf. eine entsprechende |
    |           Mitteilung am Bildschirm ausgegeben.                        |
    *-----------------------------------------------------------------------*)

    VAR fehler, korrektesDatum : BOOLEAN;

    BEGIN
      fehler:= FALSE;
      REPEAT
        In.Prompt('Jahreszahl');
        In.Int(datum.jahr);
        datum.monat:= 1; datum.tag:= 1;
        IF Op.Existenz(datum) THEN
          korrektesDatum:= TRUE
        ELSIF ~fehler THEN
          fehler:= TRUE;
          Out.Ln;
          Out.String('   Das Jahr existiert nicht.'); Out.Ln; Out.Ln;
          Out.String('   Die Kalenderjahre mssen zwischen'); Out.Ln;
          Out.Ln;
          Out.String('   1583 und 3000 liegen (gregorianisher Kalender).');
          Out.Ln;
          Out.String('        ');
          Out.Ln
        END;
      UNTIL korrektesDatum
    END Einlesen;


  PROCEDURE Angaben ( datum : Op.tDatum );

   (*-----------------------------------------------------------------------*
    | bernahme: Jahreszahl, Monats- und Tagesnummer des eingelesenen und   |
    |            geprften Kalenderdatums (Verbund datum, DT: tDatum)       |
    | Leistung:  Berechnen des Osterdatums fr das bernommene Kalenderjahr |
    |            durch Aufruf der Prozedur Ostersonntag() aus dem Service-  |
    |            modul DatumOperationen. Ausgabe des kompletten Datums fr  |
    |            den Ostersonntag und der ergnzenden Information, ob das   |
    |            Jahr ein Schaltjahr ist oder nicht. Der Wahrheitswert der  |
    |            Schaltjahrinformation, der als boolescher Ausdruck der     |
    |            zweiseitigen Auswahl dient, wird durch den Aufruf der      |
    |            Funktionsprozedur Schaltjahr() des gleichen Servicemoduls  |
    |            geliefert.                                                 |
    *-----------------------------------------------------------------------*)

    VAR ostern : Op.tDatum;

    BEGIN
      Op.Ostersonntag(datum.jahr,ostern);
      Out.Ln; Out.String('   Datum des Ostersonntags: ');
      Out.Int(ostern.jahr,5);
      Out.Int(ostern.monat,3);
      Out.Int(ostern.tag, 3);
      Out.Ln; Out.Ln;
      IF Op.Schaltjahr(datum.jahr) THEN
        Out.String('   Das Jahr ist ein Schaltjahr.')
      ELSE
        Out.String('   Das Jahr ist kein Schaltjahr.')
      END;
      Out.Ln
    END Angaben;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();

    VAR korrekt : BOOLEAN;
        datum   : Op.tDatum;

    BEGIN
      Ueberschrift;
      Einlesen(datum);
      Angaben(datum)
    END ProgMain;


 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;
   Out.Open
 END Jahre.

 (* ----------------------------------------------------------------------- *)

