
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)        Dateiname: ZWEIDATEN.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    D a t u m   (Import des Servicemoduls DatumOperationen)       |
  |-------------------------------------------------------------------------|
  | Leistung: Abstand zwischen zwei Kalenderdaten in Tagen.                 |
  |           Ermitteln eines zuknftigen oder vergangenen Kalenderdatums,  |
  |           aus einem eingegebenen Datum und dem Abstand in Tagen.        |
  |           Ordnung  zwischen zwei Kalenderdaten (liegt vor/nach dem ers- |
  |           ten Datum).                                                   |
  |           Alle Daten mssen zwischen 1583 und 3000 (gregorianisher Ka-  |
  |           lender) liegen.                                               |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Kommentare eingefgt werden.                       |
  |           Siehe ...\datum2\fine\zweidate.mod                            |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\datum2\txt\datumtool.txt und                      |
  |                   ...\datum2\doc\datumtool.doc                          |
  *-------------------------------------------------------------------------*)

 MODULE ZweiDaten;

  IMPORT In, Out, Op:= DatumOperationen;


  PROCEDURE Ausgeben ( datum : Op.tDatum );
    BEGIN
      Out.Int(datum.jahr,7); Out.Int(datum.monat,3); Out.Int(datum.tag,3);
      Out.Ln
    END Ausgeben;


  PROCEDURE Einlesen ( VAR r : Op.tDatum );
    BEGIN
      In.Prompt('Jahreszahl)');
      In.Int(r.jahr);
      In.Prompt('Monatsnummer');
      In.Int(r.monat);
      In.Prompt('Tagesnummer');
      In.Int(r.tag);
      Ausgeben(r)
    END Einlesen;


  PROCEDURE Korrekt ( r, s : Op.tDatum ) : BOOLEAN;
    BEGIN
      IF Op.Existenz(r) & Op.Existenz(s) THEN
        Out.String('   Die Tage existieren.'); Out.Ln;
        RETURN TRUE
      ELSIF ~Op.Existenz(r) THEN
        Out.String('   Der erste Tag existiert nicht.'); Out.Ln;
        RETURN FALSE
      ELSE
        Out.String('   Der zweite Tag existiert nicht.'); Out.Ln;
        RETURN FALSE
      END
    END Korrekt;


  PROCEDURE Zwischen ( r, s : Op.tDatum );
    BEGIN
      Out.String('   Zwischen dem ersten und dem zweiten Tag liegen ');
      Out.Int(Op.Abstand(r,s),1);
      Out.String(' Tage.'); Out.Ln
    END Zwischen;


  PROCEDURE Danach ( r : Op.tDatum );

    VAR abstand : LONGINT;
        s       : Op.tDatum;

    BEGIN
      Out.Ln;
      Out.String('   Abstand zum eingegebenen Datum in Tagen = ');
      In.Prompt('Anzahl Tage');
      In.LongInt(abstand);
      Out.Int(abstand,1); Out.Ln;
      Op.Summe(r,abstand,s);
      Out.String('   ');
      Out.Int(ABS(abstand),1);
      IF Op.LiegtVor(r,s) THEN 
        Out.String(' Tage spter: ')
      ELSE
        Out.String(' Tage frher: ')
      END;
      Ausgeben(s)
    END Danach;
  
  
  PROCEDURE Ordnung ( r, s : Op.tDatum );
    BEGIN
      IF Op.IstGleich(r,s) THEN
        Out.String(' Es sind die gleichen Tage.')
      ELSIF Op.LiegtVor(r,s) THEN 
        Out.String('   Der erste Tag liegt vor dem zweiten Tag.')
      ELSE
        Out.String('   Der zweite Tag liegt vor dem ersten Tag.')
      END;
      Out.Ln
    END Ordnung;


  PROCEDURE Abstand;

    VAR r, s : Op.tDatum;

    BEGIN
      Out.Ln;
      Out.String('  Abstand zwischen zwei Kalenderdaten:'); Out.Ln;
      Einlesen(r);
      Einlesen(s);
      IF Korrekt(r,s) THEN
       Zwischen(r,s)
      END
    END Abstand;


  PROCEDURE DatumTageDanach;

    VAR r : Op.tDatum;

    BEGIN
      Out.Ln;
      Out.String('  Datum, Tage nach (vor) dem Eingabedatum:'); Out.Ln;
      Einlesen(r);
      IF Op.Existenz(r) THEN
        Out.String('   Der Tage existiert.'); Out.Ln;
        Danach(r)
      END
    END DatumTageDanach;


  PROCEDURE Reihenfolge;

    VAR r, s : Op.tDatum;

    BEGIN
      Out.Ln;
      Out.String('  Reihenfolge von zwei Kalenderdaten:'); Out.Ln;
      Einlesen(r);
      Einlesen(s);
      IF Korrekt(r,s) THEN  
        Ordnung(r,s)
      END
    END Reihenfolge;


  PROCEDURE ProgMain*();
    BEGIN
      Abstand;
      DatumTageDanach;
      Reihenfolge
    END ProgMain;


 BEGIN
   In.Open;
   Out.Open
 END ZweiDaten.

