
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)        Dateiname: TETRAEDER.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Einstieg in die Programmierung mit OBERON                     |
  |-------------------------------------------------------------------------|
  | Leistung: Nach dem Einlesen einer reellen Zahl (Kantenlnge) werden die |
  |           Oberflche und das Volumens eines Tetraeders berechnet und    |
  |           die Ergebnisse am Bildschirm zugeordnet ausgegeben.           |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst befindet sich in:       |
  |            ...\eistieg\good\tetraeder.mod                               |
  *-------------------------------------------------------------------------*)

 MODULE Tetraeder;

  IMPORT In, Out, F:= Float;

  VAR a, Ao, V : REAL; 
      zahlStrg : ARRAY 12 OF CHAR;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Ueberschrift;
    BEGIN
      Out.Ln; Out.Ln;
      Out.String('    D a s  T e t r a e d e r'); Out.Ln;
      Out.String('   '); Out.Ln;
            (* '' = <Alt> + <0><1><6><8> auf dem Nummernblock der Tastatur *)
    END Ueberschrift;


  PROCEDURE ZahlWandeln ( zahl : REAL );

   (*-----------------------------------------------------------------------*
    | Leistung: Wandeln einer reellen Zahl in eine Zeichenkette, dabei wird |
    |           Anzahl der Vorkomma- und Nachkommastellen vereinbart, das   |
    |           mathematisch korrekte Runden erfolgt bei Bedarf automatisch |
    *-----------------------------------------------------------------------*)

    BEGIN
      F.StrF(zahl,6,2,zahlStrg)
    END ZahlWandeln;


  PROCEDURE Einlesen;
    BEGIN
      Out.Ln;
      Out.String('     Kantenlnge =');
      In.Real(a);
      ZahlWandeln(a);
      Out.String(zahlStrg); Out.String(' cm');
      Out.Ln
    END Einlesen;


  PROCEDURE Berechnen;
    BEGIN
      Ao := 1.7320508 * a * a;
      V := 0.11785113 * a * a * a;
      Out.Ln; Out.Ln; Out.Ln;
      Out.String('   Berechnungsergebnisse:'); Out.Ln; Out.Ln
    END Berechnen;


  PROCEDURE Ausgeben;
    BEGIN
      Out.Ln;
      Out.String('     Oberflche  =');
      ZahlWandeln(Ao);
      Out.String(zahlStrg); Out.String(' cm');
      Out.Ln;  Out.Ln;
      Out.String('     Volumen     =');
      ZahlWandeln(V);
      Out.String(zahlStrg); Out.String(' cm');
      Out.Ln
    END Ausgeben;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Ueberschrift;
      Einlesen;
      Berechnen;
      Ausgeben
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

  BEGIN
    In.Open;
    Out.Open
  END Tetraeder.

 (*-------------------------------------------------------------------------*
  | Hinweis: Das Zeichen '' (ASCII 0168) wird mittels folgender Tastenbe-  |
  |          ttigungen eingegeben:  < Alt >+< 0 >< 1 >< 6 >< 8 >.          |
  |          Fr die '0168' die Zifferntasten des Nummernblocks benutzen!   |
  *-------------------------------------------------------------------------*)

