
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)          Dateiname: HAMMING.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Thringer Abiturprfung Grundfach Informatik 1999,            |
  |           Aufgabe 1.3 (Zentralabitur)                                   |
  |-------------------------------------------------------------------------|
  | Leistung: Berechnen des Hamming-Abstands.                               |
  |           Fr einen Code wird der kleinste auftretende Abstand seiner   |
  |           Codewrter ermittelt. Diese Zahl heit Hamming-Abstand.       |
  |           Beispiel:  Die Codewrter  00110                              |
  |                      und             10111                              |
  |                      besitzen den Abstand 2.                            |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst befindet sich in:       |
  |            ...\hamming\good\hamming.mod                                 |
  |-------------------------------------------------------------------------|
  | Aufgabenstellung: ...\hammining\txt\hamminga.txt                        |
  |                   ...\hammining\doc\hamminga.doc                        |
  | Lsungsentwurf:   ...\hammining\txt\hammingb.txt                        |
  |                   ...\hammining\doc\hammingb.doc                        |
  | Eingabehinweise:  ...\hammining\doc\hammtool.txt                        |
  |                   ...\hammining\doc\hammtool.doc                        |
  *-------------------------------------------------------------------------*)

 MODULE Hamming;

  IMPORT In, Out, S:= Strings;

  TYPE tCodewort = ARRAY  21 OF CHAR;  (* maximale Lnge der Codewrter: 20 *)
       tCodes    = ARRAY 100 OF tCodewort;  (* max. Anzahl Codewrtern: 100 *)


 (* --------------------  U N T E R P R O G R A M M E --------------------- *)


  PROCEDURE Erlaeuterungen;

    VAR i : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('  Bitte Anzahl der auszuwertenden Codewrter und deren');
      Out.String(' Lnge eingeben!'); Out.Ln;
      Out.Ln;
      Out.String('    O D E R :'); Out.Ln;
      Out.String('   '); Out.Ln;
      Out.Ln;
      Out.String('    Men:   Pane                     (Mausklick)'); Out.Ln;
      Out.String('    Option: read input from file...  (Mausklick)'); Out.Ln;
      Out.String('    Pfad:   ...\hamming\fine         (Doppelklick)'); Out.Ln;
      Out.String('    Datei:  hamming.txt ffnen       (Doppelklick)'); Out.Ln;
      Out.Ln; Out.Char(' ');
      FOR i:= 1 TO 56 DO Out.Char('') END;
      Out.Ln
    END Erlaeuterungen;


  PROCEDURE AnzahlEinlesen ( VAR anzahl : INTEGER );
    BEGIN
      Out.Ln;
      Out.String('   Anzahl der auszuwertenden Codewrter =');
      In.Prompt('Anzahl ( max. 100 )');
      In.Int(anzahl);
      Out.Int(anzahl,4); Out.Ln
    END AnzahlEinlesen;


  PROCEDURE LaengeEinlesen ( VAR laenge : INTEGER );
    BEGIN
      Out.Ln;
      Out.String('   Lnge der auszuwertenden Codewrter =');
      In.Prompt('Lnge ( max. 20 )');
      In.Int(laenge);
      Out.Int(laenge,5); Out.Ln
    END LaengeEinlesen;


  PROCEDURE CodeEinlesen ( VAR codes : tCodes; anzahl : INTEGER );

    CONST codewort = '. Codewort';

    VAR   k        : INTEGER;
          message  : ARRAY 14 OF CHAR;

    BEGIN
      Out.Ln;
      Out.String('   Codewrter:');
      FOR k:= 0 TO anzahl-1 DO
        S.Str(k+1,message); S.Append(message,codewort);
        In.Prompt(message);
        In.String(codes[k]);
        Out.String('   '); Out.String(codes[k]);
        IF (k+1) MOD 5 = 0 THEN
          Out.Ln; Out.String('              ');
        END
      END;
      IF (k+1) MOD 5 # 0 THEN Out.Ln END;
      Out.Ln; Out.Ln;
      Out.String('   Anzahl eingelesener Codewrter ='); Out.Int(k,10);
      Out.Ln
    END CodeEinlesen;


  PROCEDURE Abstand ( r, s : tCodewort; laenge : INTEGER ) : INTEGER;

    VAR abstand, i: INTEGER;

    BEGIN
      abstand:= 0;
      FOR i:= 0 TO laenge-1 DO
        IF r[i] # s[i] THEN INC(abstand) END
      END;
      RETURN abstand
    END Abstand;


  PROCEDURE HammingAbstand ( codes : tCodes;
                                        anzahl, laenge : INTEGER ) : INTEGER;

    VAR m, n, a, minimum : INTEGER;

    BEGIN
      minimum:= laenge;
      FOR m:= 0 TO anzahl-2 DO
        FOR n:= m+1 TO anzahl-1 DO
          a:= Abstand(codes[m],codes[n],laenge);
          IF a < minimum THEN minimum:= a END
        END
      END;
      RETURN minimum
    END HammingAbstand;


  PROCEDURE AbstandBerechnen ( codes : tCodes; anzahl, laenge : INTEGER );
    BEGIN
      Out.Ln;
      Out.String('   Hamming-Abstand =                      ');
      Out.Int(HammingAbstand(codes,anzahl,laenge),3);
      Out.Ln
    END AbstandBerechnen;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)


  PROCEDURE ProgMain*();

    VAR codes    : tCodes;
        anzahl, 
        laenge   : INTEGER;

    BEGIN
      Erlaeuterungen;
      AnzahlEinlesen(anzahl);
      LaengeEinlesen(laenge);
      CodeEinlesen(codes,anzahl);
      AbstandBerechnen(codes,anzahl,laenge)
    END ProgMain;


 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;
   Out.Open
 END Hamming.

 (* ----------------------------------------------------------------------- *)

