
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)           Dateiname: TURTLE.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S E R V I C E - M O D U L  (Turtle-Grafik)                    |
  |-------------------------------------------------------------------------|
  | Leistung: Bereitstellen der Grundfunktionen einer Turtle-Grafik.        |
  |           (Erluterungen, siehe grne Texte (remarks) der Prozeduren)   |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst befindet sich in:       |
  |           ...\hilbert\good\turtle.mod                                   |
  *-------------------------------------------------------------------------*)

 MODULE Turtle;

  IMPORT C:= ColorPlane, F:= Float, W:= Windows;

  VAR    x, y, winkel : REAL;


 (* --------------------  U N T E R P R O G R A M M E --------------------- *)


  PROCEDURE BildNeu* ( x0, y0 : INTEGER );

   (*-----------------------------------------------------------------------*
    | bernahme: x- und y-Koordinate des Startpunkts (Turtle)               |
    | Leistung:  Lschen des Grafikfensters, Initialisieren der Startpunkt- |
    |            koordinaten (x und y) und der Variable winkel den Wert 0.0 |
    |            zuweisen                                                   |
    *-----------------------------------------------------------------------*)

    BEGIN
      C.Clear;
      x:= x0;
      y:= y0;
      winkel:= 0.0
    END BildNeu;


  PROCEDURE Strecke ( x1, y1, x2, y2 : INTEGER );

   (*-----------------------------------------------------------------------*
    | bernahme: Koordinaten des Anfangs- und Endpunkts der zu zeichnenden  |
    |            Strecke                                                    |
    | Leistung:  Darstellen einer Strecke am Bildschirm.                    |
    *-----------------------------------------------------------------------*)

    BEGIN
      C.Line(x1,y1,x2,y2,C.DRAW)
    END Strecke; 


  PROCEDURE Vorwaerts* ( l : INTEGER );

   (*-----------------------------------------------------------------------*
    | bernahme: Lnge der Strecke (Einheit: Pixel)                         |
    | Leistung:  Runden und Konvertieren (Wandeln) der Werte der x- und y-  |
    |            Koordinate in Werte vom Datentyp INTEGER.                  |
    |            Berechnen der Koordinaten des Zielpunkts und Aufruf der    |
    |            Prozedur Strecke.                                          |
    *-----------------------------------------------------------------------*)

    VAR x1, y1 : INTEGER;

    PROCEDURE Runden ( r : REAL ) : INTEGER;
      BEGIN
        RETURN SHORT(ENTIER(r + 0.5))
      END Runden;

    BEGIN  (* Vorwaerts *)
      x1:= Runden(x);
      y1:= Runden(y);; 
      x:= x + l * F.Cos(winkel * SHORT(F.Pi)/180);
      y:= y + l * F.Sin(winkel * SHORT(F.Pi)/180);
      Strecke(x1,y1,Runden(x),Runden(y))
    END Vorwaerts;


  PROCEDURE Aufkurs* ( w : INTEGER );

   (*-----------------------------------------------------------------------*
    | bernahme: Winkel (ganzzahlig, Einheit Grad)                          |
    | Leistung:  Korrektur des Wertes der Variablen winkel, falls er nicht  |
    |            im Bereich 0 bis 360 liegt.                              |
    *-----------------------------------------------------------------------*)

    BEGIN
      winkel:=  w;
      WHILE winkel > 360 DO winkel:= winkel - 360 END;
      WHILE winkel < 0 DO winkel:= winkel + 360 END
    END Aufkurs;


  PROCEDURE Rechts* ( w : INTEGER );

   (*-----------------------------------------------------------------------*
    | bernahme: Wert des Winkels (ganzzahlig, Einheit Grad) fr die        |
    |            Rechtsdrehung                                              |
    | Leistung:  Berechnen und Zuweisen des neuen Werts der Variablen       |
    |            winkel nach der geforderten Rechtsdrehung um den Betrag w. |
    |            Korrektur des Wertes der Variablen winkel, falls er nicht  |
    |            im Bereich 0 bis 360 liegt.                              |
    *-----------------------------------------------------------------------*)

    BEGIN
      winkel:= winkel - w;
      WHILE winkel > 360 DO winkel := winkel - 360 END;
      WHILE winkel < 0 DO winkel := winkel + 360 END
    END Rechts;


 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   C.Open
 END Turtle.

 (* ----------------------------------------------------------------------- *)

