
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)           Dateiname: TURTLE.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S E R V I C E - M O D U L  (Turtle-Grafik)                    |
  |-------------------------------------------------------------------------|
  | Leistung: Bereitstellen der Grundfunktionen einer Turtle-Grafik.        |
  |           (Erluterungen, siehe grne Texte (remarks) der Prozeduren)   |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Siehe ...\hilbert\fine\turtle.mod                             |
  *-------------------------------------------------------------------------*)

 MODULE Turtle;

  IMPORT XYplane, Float, W:= Windows;

  VAR    dummy  : LONGINT;
         x, y,
         winkel : REAL;


  PROCEDURE BildNeu* ( x0, y0 : INTEGER );
    BEGIN
      XYplane.Clear;
      x:= x0;
      y:= y0;
      winkel:= 0.0
    END BildNeu;


  PROCEDURE Strecke ( x1, y1, x2, y2 : INTEGER );

   (* Zeichnet eine Strecke durch Setzen von einzelnen Bildpunkten (Pixeln) *)
   (* vom Punkt mit den Koordinaten (x1, y1) zum Punkt mit den Koordinaten  *)
   (* (x2, y2). Da das Modul XYplane Linien darstellen kann, sollten die    *)
   (* Prozedur XYplane.Line(x1,y1,x2,y2,XYplane.DRAW) fr das Zeichnen und  *)
   (* die Prozedur XYplane.Line(x1,y1,x2,y2,XYplane.ERASE) fr das Lschen  *)
   (* einer Linie eingesetzt werden (siehe ...\hilbert\fine\turtle.mod).    *)

    VAR xi, yi : INTEGER;
        m, n   : REAL;

    BEGIN
      IF ABS(x2 - x1) < ABS(y2 - y1) THEN
        m:= (x2 - x1) / (y2 - y1);
        n:= x1 - m * y1;
        IF y1 < y2 THEN
           FOR yi:= y1 TO y2 DO
             XYplane.Dot(SHORT(ENTIER(m * yi + n + 0.5)),yi,1)
           END
        ELSE 
           FOR yi:= y1 TO y2 BY -1 DO
             XYplane.Dot(SHORT(ENTIER(m * yi + n + 0.5)),yi,1)
           END
        END
      ELSE
        m:= (y2 - y1) / (x2 - x1);
        n:= y1 - m * x1;
        IF x1 < x2 THEN
          FOR xi:= x1 TO x2 DO
            XYplane.Dot(xi,SHORT(ENTIER(m * xi + n + 0.5)),1)
          END
        ELSE
          FOR xi := x1 TO x2 BY -1 DO
            XYplane.Dot(xi,SHORT(ENTIER(m * xi + n + 0.5)),1)
          END
        END
      END
    END Strecke; 


  PROCEDURE Vorwaerts* ( l : INTEGER );

    VAR x1, y1: INTEGER;

    BEGIN
      x1:= SHORT(ENTIER(x + 0.5));
      y1:= SHORT(ENTIER(y + 0.5)); 
      x:= x + l * Float.Cos(winkel * SHORT(Float.Pi) / 180);
      y:= y + l * Float.Sin(winkel * SHORT(Float.Pi) / 180);
      Strecke(x1,y1,SHORT(ENTIER(x + 0.5)),SHORT(ENTIER(y + 0.5)))
    END Vorwaerts;


  PROCEDURE Aufkurs* ( w : INTEGER );
    BEGIN
      winkel:=  w;
      WHILE winkel > 360 DO winkel:= winkel - 360 END;
      WHILE winkel < 0 DO winkel:= winkel + 360 END
    END Aufkurs;


  PROCEDURE Rechts* ( w : INTEGER );
    BEGIN
      winkel := winkel - w;
      WHILE winkel > 360 DO winkel := winkel - 360 END;
      WHILE winkel < 0 DO winkel := winkel + 360 END
    END Rechts;


 BEGIN
   XYplane.Open;
   dummy:= W.ShowWindow(W.GetActiveWindow(),3)   (* Fenster maximaler Gre *)
 END Turtle.

