
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)        Datei-Name: LABYDEMO.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: 28.-29.3.2001 Version: V 1.1                |
  |-------------------------------------------------------------------------|
  | Thema:    S u c h e   i m   L a b y r i n t h   (Backtracking)          |
  |-------------------------------------------------------------------------|
  | Leistung: Das Programm liest nach dem Start die Textdatei bild01.txt    |
  |           automatisch ein, zeigt das Labyrinth am Bildschirm an und     |
  |           sucht alle mglichen Wege durch dieses Labyrinth.             |
  |           Die geforderten Eingaben, < ENTER> oder die Wahl der Farbe    |
  |           der Mauern des Labyrinths, knnen mit einem Mausklick (linke  |
  |           Maustaste) oder einer fast beliebigen Tastenbettigung der    |
  |           Tastatur bewirkt werden.                                      |
  |-------------------------------------------------------------------------|
  | Quelle:   ThILLM-Materialien 38, SERVICE-CD, Dr. Michael Fothe u. a.    |
  |           GRAFIKQ.MOD (Oberon-2 V4)                                     |
  |-------------------------------------------------------------------------|
  | Hinweise: Grafikmodus 800 x 600 Pixel, Farbauflsung mindestens 15 Bit |
  |           siehe: ...\GRUNDLAGEN\ALLGEMEIN\DOC\GRAFIK.DOC  oder          |
  |                  ...\GRUNDLAGEN\ALLGEMEIN\TXT\GRAFIK.TXT                |
  |           Das Modul als lauffhiges Grundgerst befindet sich in:       |
  |            ...\laby\good\labyrinth.mod                                  |
  |-------------------------------------------------------------------------|
  | Erluterungstext:  ...\laby\txt\labyrinth.txt                           |
  |                    ...\laby\doc\labyrinth.doc                           |
  |-------------------------------------------------------------------------|
  |             2001  Manfred Kmmerer, Chamberlain-Soft JENA              |
  *-------------------------------------------------------------------------*)

 MODULE LabyDemo;

  IMPORT C:= ColorPlane, F:= File, S:= Strings, Sy:= SYSTEM, W:= Windows;

  CONST dTime     =  25;            (* 25 ist ein gut geeigneter Mittelwert *)
        faktor    =   9;
        RGBmax    = 255;
        xOffset   =  30;
        xText     = 450;
        yOffset   =  20;

        TxtDat1   = 'abi95.txt';
        TxtDat2   = 'bildkorr.txt';

  TYPE  tBild     = ARRAY 80, 80 OF CHAR;
        tKoordStr = ARRAY  3 OF CHAR;
        tZeile    = ARRAY 76 OF CHAR;
        tZielChar = ARRAY 3 OF tZeile;

  VAR   bc_Red,
        bc_Green,
        bc_Blue,                           (* HG-Farben des groen Fenster  *)
        xMax, yMax,
        xStart, yStart,
        xZiel, yZiel  : INTEGER;
        laby          : tBild; 


 (* --------------------  U N T E R P R O G R A M M E --------------------- *)


  PROCEDURE WriteStrXY ( pixelSpalte,pixelZeile : INTEGER; 
                                                     mitteilung : tZeile );
    BEGIN
      C.GotoXY(pixelSpalte,pixelZeile);
      C.WriteStr(mitteilung)
    END WriteStrXY;


  PROCEDURE Delay_ms ( msec : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Eine bestimmte Zeit warten.                                 |
    *-----------------------------------------------------------------------*)

    VAR startzeit, zielzeit : LONGINT;

    BEGIN
      startzeit:= W.GetTickCount(); 
      REPEAT
        zielzeit:= W.GetTickCount()
      UNTIL zielzeit > startzeit + msec 
    END Delay_ms;


  PROCEDURE FlushKeyBuffer;
   (*-----------------------------------------------------------------------*
    | Leistung: Lschen des Tastaturpuffers                                 |
    *-----------------------------------------------------------------------*)

    VAR Dummy : CHAR;

    BEGIN
      WHILE C.KeyPressed() DO Dummy:= C.ReadKey() END
    END FlushKeyBuffer;


  PROCEDURE FlushMouseBuffer;
   (*-----------------------------------------------------------------------*
    | Leistung: Lschen des Mauspuffers                                     |
    *-----------------------------------------------------------------------*)

    VAR i, xMouse, yMouse : INTEGER;
        buttons           : SET;

    BEGIN
      FOR i:= 1 TO 100 DO
        C.GetMouse(buttons,xMouse,yMouse);
      END;
    END FlushMouseBuffer;


  PROCEDURE ButtonUp ( x1, y1, x2, y2 : INTEGER );
    BEGIN
      C.SetBackColor(180,180,190);
      C.Bar(x1+2,y1,x2,y2,C.ERASE);
      C.SetForeColor(180,180,190);
      C.Line(x1,y1+1,x1,y2-2,C.DRAW); C.Line(x1,y1+2,x2+1,y1+2,C.DRAW);
      C.SetForeColor(RGBmax,RGBmax,RGBmax);
      C.Line(x1+1,y1,x1+1,y2-1,C.DRAW); C.Line(x1+1,y1+1,x2,y1+1,C.DRAW);
      C.SetForeColor(155,155,150);
      C.Line(x1+2,y2-1,x2+1,y2-1,C.DRAW); C.Line(x2+1,y1+1,x2+1,y2,C.DRAW);
      C.SetForeColor(115,115,125);
      C.Line(x1+1,y2-2,x2+2,y2-2,C.DRAW); C.Line(x2+2,y1+2,x2+2,y2-1,C.DRAW);
      C.SetForeColor(0,0,0)
    END ButtonUp;


  PROCEDURE ButtonDown ( dTime, x1, y1, x2, y2 : INTEGER; buchstabe : CHAR );

    VAR zeichen : ARRAY 2 OF CHAR;

    BEGIN
      C.SetForeColor(115,115,125);
      C.Line(x1,y1+1,x1,y2-2,C.DRAW); C.Line(x1,y1+2,x2+2,y1+2,C.DRAW);
      C.SetForeColor(155,155,160);
      C.Line(x1+1,y1,x1+1,y2-2,C.DRAW); C.Line(x1+1,y1+1,x2+1,y1+1,C.DRAW);
      C.SetForeColor(180,180,190);
      C.Line(x1+2,y2-1,x2+1,y2-1,C.DRAW); C.Line(x2+1,y1,x2+1,y2,C.DRAW);
      C.SetForeColor(RGBmax,RGBmax,RGBmax);
      C.Line(x1+1,y2-2,x2+2,y2-2,C.DRAW); C.Line(x2+2,y1+1,x2+2,y2-1,C.DRAW);
      C.SetForeColor(128,128,128);
      C.GotoXY(x1+7,y1-6); C.WriteStr(' ');
      zeichen:= ' ';
      zeichen[0]:= buchstabe;
      C.GotoXY(x1+5,y1-6); C.WriteStr(zeichen);
      Delay_ms(dTime);
      C.SetForeColor(0,0,0)
    END ButtonDown;


  PROCEDURE EnterEvaluation ( x, y : INTEGER ) : BOOLEAN;
   (*-----------------------------------------------------------------------*
    | Referenz: Rckgabewert (Funktionswert) TRUE, falls das Wort < Enter > |
    |           mit der linken Maustaste angeklickt wurde                   |
    | Leistung: Mauspuffer lschen, solange Maus und Tastatur abfragen, bis |
    |           entweder eine Tastatur- oder Maustastenbettigung regis-    |
    |           triert wurde. Auswerten der Mauszeigerkoordinaten (Klick)   |
    |           und der Nummer der bettigten Maustaste, ggf. Wiederholung  |
    |           des Vorgangs bis zum erfolgreichen Abschlu. Wert der Maus- |
    |           tastenvariable berschreiben und Tastaturpuffer lschen.    |                                          
    *-----------------------------------------------------------------------*)

    VAR Ok      : BOOLEAN;
        x1, y1,
        xMouse,
        yMouse  : INTEGER;
        buttons : SET;

    BEGIN
      Ok:= FALSE;
      x1:= x + 83; y1:= y - 21;
      FlushMouseBuffer;
      REPEAT 
        C.GetMouse(buttons,xMouse,yMouse);
        IF C.KeyPressed() THEN Ok:= TRUE END
      UNTIL Ok OR (xMouse > x-3) & (xMouse < x1+4) &
                  (yMouse < y+2) & (yMouse > y1-4) &
                  (buttons = {0});
      buttons:= {1};
      FlushKeyBuffer;
      RETURN TRUE
    END EnterEvaluation;


  PROCEDURE Enter ( dT, x, y : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung:  Ausgabe einer Zeichenkette, Lschen des Tastaturpuffers,   |
    |            Warten auf eine Tastatureingabe (Enter- oder Escape-Taste) |
    |            und Lschen der Zeichenkette.                              |
    *-----------------------------------------------------------------------*)

    BEGIN
      Delay_ms(dT);
      C.SetBackColor(bc_Red,bc_Green,bc_Blue);
      C.SetForeColor(0,127,127);
      WriteStrXY(x,y,'< ENTER >');
      FlushKeyBuffer;
      REPEAT UNTIL EnterEvaluation(x,y);
      C.Bar(x,y,x+72,y-18,C.ERASE);
      C.SetForeColor(0,0,0);
    END Enter;


  PROCEDURE Fehlermeldung ( flag : BOOLEAN );
    BEGIN
      C.SetForeColor(207,48,0);
      IF flag THEN  
        WriteStrXY(134,350,'Die Textdatei konnte nicht geffnet ');
        C.WriteStr('werden!')
      ELSE
        WriteStrXY(70,350,'Die Bilddatei des Labyrinths konnte nicht ');
        C.WriteStr('geffnet werden!')
      END;
      WriteStrXY(120,325,'Wahrscheinlich ist der Datei-Pfad nicht korrekt.');
      HALT(1)
    END Fehlermeldung;


  PROCEDURE BereichLoeschen ( gross : BOOLEAN );
   (*-----------------------------------------------------------------------*
    | Leistung: Einen Bildschirmbereich lschen, dessen Gre vom Wert der  |
    |           booleschen Variable abhngt.                                |
    *-----------------------------------------------------------------------*)

    BEGIN
      C.SetBackColor(bc_Red,bc_Green,bc_Blue);
      IF gross THEN
        C.Bar(0,0,C.RESOLUTIONX-1,C.RESOLUTIONY-1,C.ERASE)
      ELSE
        C.Bar(xText,260,586,150,C.ERASE)
      END
    END BereichLoeschen;


  PROCEDURE Bildlagekorrektur;
   (*-----------------------------------------------------------------------*
    | Leistung: Prfen, ob die Textdatei existiert, wenn ja, ffnen, sonst  |
    |           Fehlermeldung anzeigen. Textdatei ffnen, zeilenweise ein-  |
    |           lesen und den Inhalt am Bildschirm ausgeben. Aufruf der     |
    |           Prozedur Enter und Textdatei schlieen.                     |
    *-----------------------------------------------------------------------*)

    VAR textZeile   : tZeile;
        fHandle     : F.Handle;
        resCode,
        z, pZeile   : INTEGER;

    BEGIN
      BereichLoeschen(TRUE);
      IF F.Exist(TxtDat2) THEN
        F.Open(TxtDat2,FALSE,F.DENYNONE,F.READONLY,fHandle,resCode);
      ELSE
        Fehlermeldung(TRUE)
      END;
      z:= 1;
      pZeile:= 350;
      C.SetForeColor(0,103,127);
      WHILE ~F.AtEnd(fHandle) DO
        F.ReadLn(fHandle,textZeile,resCode);
        IF z = 7 THEN C.SetForeColor(127,127,15)
          ELSIF z = 9 THEN C.SetForeColor(0,175,127)
        END;
        WriteStrXY(150,pZeile,textZeile);
        INC(z); DEC(pZeile,18)
      END;
      Enter(dTime*25,500,35);
      BereichLoeschen(TRUE);
      C.SetForeColor(0,0,0)
    END Bildlagekorrektur;


  PROCEDURE StartZielSetzen ( x, y : INTEGER; flag : BOOLEAN);
   (*-----------------------------------------------------------------------*
    | bernahme: x- und y-Koordinate des auszugebenden Symbols sowie das    |
    |            Start/Zielflag fr das Darstellen des entsprechenden Sym-  |
    |            bols (TRUE fr Startsymbol, FALSE fr Zielsymbol)          |
    | Leistung:  Anzeigen der Symbole fr den Start- und den Zielpunkt.     |
    *-----------------------------------------------------------------------*)

    BEGIN
      IF flag THEN
        C.SetForeColor(207,79,0)
      ELSE
        C.SetForeColor(79,207,0)
      END;
      C.Bar(faktor*x+2+xOffset,faktor*y+2+yOffset,
              faktor*x+6+xOffset,faktor*y+6+yOffset,C.DRAW);
      C.SetForeColor(0,0,0);
      C.Box(faktor*x+1+xOffset,faktor*y+1+yOffset,
              faktor*x+7+xOffset,faktor*y+7+yOffset,C.DRAW)
    END StartZielSetzen;


  PROCEDURE Legende;
    BEGIN
      C.SetBackColor(bc_Red,bc_Green,bc_Blue);
      C.Bar(444,330,580,yOffset,C.ERASE);
      StartZielSetzen(47,31,TRUE);
      StartZielSetzen(47,29,FALSE);
      WriteStrXY(470,311,'= Start');
      WriteStrXY(470,293,'= Ziel')
    END Legende;


  PROCEDURE WahlEvaluation ( zielBuchstaben : tZielChar ) : INTEGER;
   (*-----------------------------------------------------------------------*
    | bernahme: x- und y-Koordinaten der unteren linken Ecke und der obe-  |
    |            ren recgten Ecke des Gesamtbereichs der Tastenflchen und  |
    |            Inhalt der Reihung, die die erlaubten Buchstaben enthlt   |
    | Leistung:  Auswerten eines Mausklicks, der im Bereich der Taster      |
    |            stattfand oder einer Tastenbettigung, ggf. Ermitteln des  |
    |            Buchstaben aus den Koordinaten, die durch die Mausbetti-  |
    |            gung geliefert wurden und Rckgabe der um 64 verninderten  |
    |            ASCII-Nummer des Buchstabens als Funktionswert.            |
    *-----------------------------------------------------------------------*)

    CONST x1 = 462;  x2 = 482;     x3 = 260;  x4 = 270;
          y1 = 210;  y2 = y1 - 24; y3 = 130;  y4 = y3 - 24;

          yM1o = 281; yM1u = 263;
          yM2o = 256; yM2u = 238;
          yM3o = 231; yM3u = 213;

    VAR   zeichen : ARRAY 2 OF CHAR;
          Ok      : BOOLEAN;
          n,
          x, y,
          xMouse,
          yMouse  : INTEGER;
          buttons : SET;

    BEGIN
      x:= x1 + 50; y:= y1 - 16;
      C.SetForeColor(0,0,0);
      REPEAT 
        FlushMouseBuffer;
        C.GetMouse(buttons,xMouse,yMouse);
        IF C.KeyPressed() THEN
          REPEAT
            zeichen:= ' ';
            zeichen[0]:= C.ReadKey();
            S.UpCase(zeichen);                (* Wandeln in Grobuchstaben  *)
            IF (zeichen > '@') & (zeichen < 'D') THEN
              n:= ORD(zeichen[0]) - 64;       (* ... damit statt 'A'...'C', *)
                                              (*     1..3 geliefert wird    *)
            ELSIF zeichen = '' THEN 
              n:= 1
            END
          UNTIL (n > 0) & (n < 4);
          Ok:= TRUE;
       (* ELSIF (buttons = {0}) & (xMouse > x)
          & (xMouse < x) & (yMouse < y) & (yMouse > yM3u) THEN
          Ok:= TRUE
        ELSIF (yMouse < yM1o) & (yMouse > yM1u) THEN
          n:= 1;
          ButtonDown(dTime,x1,y1,x2,y2,'A');
          
          ELSIF (yMouse < yM2o) & (yMouse > yM2u) THEN
            n:= 2;
            ButtonDown(dTime,x1,y1,x2,y2,'B');
            ELSIF (yMouse < yM3o) & (yMouse > yM3u) THEN
              n:= 3;
              ButtonDown(dTime,x1,y1,x2,y2,'C');
              ELSE Ok:= FALSE *)
        END
      UNTIL Ok;
      buttons:= {1};
      FlushKeyBuffer;
      RETURN n
    END WahlEvaluation;


  PROCEDURE WahlStartZiel();
   (*-----------------------------------------------------------------------*
    | Leistung: Anzeige der Wahlbuchstaben fr Start- und Zielpunkt einer   |
    |           Wegsuche im Labyrinth. Wurde ein Startpunkt gewhlt, werden |
    |           nur noch die Buchstaben fr zwei mgliche Zielpunkte ange-  |
    |           zeigt. Nach der Auswahl eines Buchstaben per Maus oder Tas- |
    |           tataur werden die entsprechenden Indizees fr die Eintra-   |
    |           gung der Kennung in die zweidimensionale Reihung (laby) er- |
    |           rechnet, jeweils einer Komponente der Reihung die Kennung,  |
    |           3 = Start oder 4 = Ziel, zugewiesen und die Symbole im La-  |
    |           byrinth angezeigt.
    *-----------------------------------------------------------------------*)

    CONST x1 = 462;  x2 = 482;     x3 = 260;  x4 = 270;
          y1 = 210;  y2 = y1 - 24; y3 = 130;  y4 = y3 - 24;

    VAR   farbKennzahl,
          i, maxLen, n   : INTEGER;
          wahlBuchstabe  : tZeile;
          zielBuchstaben : tZielChar;

    BEGIN
      C.SetBackColor(bc_Red,bc_Green,bc_Blue);
      C.SetForeColor(0,128,128);
      WriteStrXY(xText,320,'Bitte Start- und');
      WriteStrXY(xText,302,' Zielbuchstaben');
      WriteStrXY(xText,284,'    whlen!');
      C.SetForeColor(0,0,0);
      WriteStrXY(xText+16,240,'START:');
      C.Line(xText+10,224,xText+68,224,C.DRAW);
      FOR i := 0 TO 2 DO
        ButtonUp(x1+i*30,y1,x2+i*30,y2);
        wahlBuchstabe:= ' '; wahlBuchstabe[0]:= CHR(65+i);
        WriteStrXY(x1+8+i*30,y1-6,wahlBuchstabe);
        zielBuchstaben[i]:= '';
        zielBuchstaben[i,0]:= CHR(i+65)
      END;
      n:= WahlEvaluation(zielBuchstaben);
      CASE n OF
         1: zielBuchstaben[1]:= 'B'; zielBuchstaben[2]:= 'C';
            laby[16,34]:= '3'; xStart:= 16; yStart:= 34; 
       | 2: zielBuchstaben[1]:= 'A'; zielBuchstaben[2]:= 'C';
            laby[16,3]:= '3'; xStart:= 16; yStart:= 3;
       | 3: zielBuchstaben[1]:= 'A'; zielBuchstaben[2]:= 'B';
            laby[2,15]:= '3'; xStart:= 2; yStart:= 15;
      END;
      C.SetBackColor(bc_Red,bc_Green,bc_Blue);
      WriteStrXY(xText+16,160,'ZIEL:');
      C.Line(xText+10,144,xText+58,144,C.DRAW);
      FOR i := 0 TO 1 DO
        ButtonUp(x1+i*30,y3,x2+i*30,y4);
        wahlBuchstabe:= ' '; wahlBuchstabe[0]:= zielBuchstaben[i+1,0];
        WriteStrXY(x1+8+i*30,y3-6,wahlBuchstabe)
      END;
      n:= WahlEvaluation(zielBuchstaben);
      CASE n OF
         1: laby[16,34]:= '4'; xZiel:= 16 ;yZiel:= 34;
       | 2: laby[16,3]:= '4'; xZiel:= 16 ;yZiel:= 3;
       | 3: laby[2,15]:= '4'; xZiel:= 2 ;yZiel:= 15
      END;
      C.SetBackColor(bc_Red,bc_Green,bc_Blue);
      StartZielSetzen(xStart,yStart,TRUE);
      StartZielSetzen(xZiel,yZiel,FALSE)
    END WahlStartZiel;


  PROCEDURE WegsucheText ( i : INTEGER );
    BEGIN
      C.SetBackColor(bc_Red,bc_Green,bc_Blue);
      C.SetForeColor(0,119,119);
      WriteStrXY(xText,260,'Suche nach der');
      IF i = 0 THEN
        WriteStrXY(xText,242,'ersten Lsung')
      ELSE
        WriteStrXY(xText+88,260,'einer');
        WriteStrXY(xText,242,'weiteren Lsung')
      END
    END WegsucheText;


  PROCEDURE AusgabeLoesungsnummer ( VAR i : INTEGER );

    VAR zahlStr : ARRAY 3 OF CHAR;

    BEGIN
      BereichLoeschen(FALSE);
      INC(i);
      S.Str(i,zahlStr);
      C.GotoXY(xText,260); C.WriteStr(zahlStr); C.WriteStr('. Lsung');
      Enter(dTime*25,500,35);
      WegsucheText(i);
      C.SetForeColor(0,119,119);
      C.GotoXY(xText,210);
      IF i = 1 THEN
        C.WriteStr('Bisher wurde eine');
        WriteStrXY(xText,192,'Lsung gefunden.');
      ELSE
        C.WriteStr('Bisher wurden');
        C.GotoXY(xText,192); C.WriteStr(zahlStr); C.WriteStr(' Lsungen');
        WriteStrXY(xText,174,'gefunden.')
      END;
      C.SetBackColor(RGBmax,RGBmax,RGBmax)
    END AusgabeLoesungsnummer;


  PROCEDURE Einlesen;
   (*-----------------------------------------------------------------------*
    | Leistung: Prfen, ob die Textdatei existiert, wenn ja, ffnen, sonst  |
    |           Fehlermeldung anzeigen. Textdatei ffnen, die ersten beiden |
    |           Blcke lesen, die eingelesenen Informationen (KoordStr) in  |
    |           INTEGER-Werte wandeln, Rest der Datei zeilenweise einlesen, |
    |           wobei Zeilenendezeichen ignoriert werden, und den Inhalt    |
    |           den Elementen einer zweidimensionalen Reihung zuweisen.     |
    |           Textdatei schlieen.                                        |
    *-----------------------------------------------------------------------*)

    VAR KoordStr : tKoordStr;
        CR       : BOOLEAN;
        zeichen  : CHAR;
        fHandle  : F.Handle;
        anzahl,
        dummy,
        resCode,
        x, y     : INTEGER;
        read     : LONGINT;

    BEGIN
      IF F.Exist(TxtDat1) THEN
        F.Open(TxtDat1,FALSE,F.DENYNONE,F.READONLY,fHandle,resCode);
      ELSE
        Fehlermeldung(FALSE)
      END;
      F.ReadBlock(fHandle,KoordStr,SIZE(tKoordStr),read,resCode);
      xMax:= SHORT(S.Val(KoordStr));        (* xMax = Breite des Labyrinths *)
      F.ReadBlock(fHandle,KoordStr,SIZE(tKoordStr),read,resCode);
      yMax:= SHORT(S.Val(KoordStr));        (* yMax = Hhe des Labyrinths   *)
      F.ReadBlock(fHandle,dummy,SIZE(tKoordStr),read,resCode);
      FOR y:= yMax TO 0 BY -1 DO
        FOR x:= 0 TO xMax DO
          F.ReadChar(fHandle,zeichen,resCode);
          laby[x,y]:= zeichen
        END;
        F.ReadChar(fHandle,zeichen,resCode) (* berlesen des Zeilenwechsels *)
      END;
      F.Close(fHandle)
    END Einlesen;


  PROCEDURE BauenUndBeschriften;
   (*-----------------------------------------------------------------------*
    | Leistung: Vorbereitungen zum Bau des Labyrinths treffen und die Mau-  |
    |           ern in der gewnschten Farbe darstellen.                    |
    *-----------------------------------------------------------------------*)

    VAR zeichen    : CHAR;
        zeichenStr : tZeile;
        farbKennz,
        ordZeichen,
        x, y       : INTEGER;

    PROCEDURE MauerSetzen ( x, y : INTEGER );
      BEGIN
        C.Bar(faktor*x+xOffset,faktor*y+yOffset,
                faktor*x+8+xOffset,faktor*y+8+yOffset,C.DRAW)
      END MauerSetzen;

    BEGIN  (* BauenUndBeschriften *)
      BereichLoeschen(TRUE);
      C.SetBackColor(RGBmax,RGBmax,RGBmax);
      C.SetForeColor(0,0,0);
      C.Bar(xOffset-12,yOffset+2*faktor-24,
              xMax*faktor+xOffset+16,yMax*faktor+yOffset+34,C.ERASE);
      FOR y:= 1 TO yMax DO
        FOR x:= 0 TO xMax-1 DO
          zeichen:= laby[x,y];
          ordZeichen:= ORD(zeichen);
          IF (zeichen = '1') OR (zeichen = '2') THEN MauerSetzen(x,y)
          ELSIF (ordZeichen > 64) & (ordZeichen < 74) THEN
            zeichenStr:= ' ';
            zeichenStr[0]:= CHR(ordZeichen);
            C.SetForeColor(200,96,0);
            IF (ordZeichen = 65) THEN
              WriteStrXY(faktor*x+xOffset,faktor*y+yOffset+20,zeichenStr)
            ELSIF (ordZeichen = 67) THEN
              WriteStrXY(faktor*x+xOffset,faktor*y+yOffset+11,zeichenStr)  
            ELSE
              WriteStrXY(faktor*x+xOffset,faktor*y+yOffset,zeichenStr)
            END;
            C.SetForeColor(0,0,0)
          END;
          IF zeichen = '3' THEN xStart:= x; yStart:= y END;
          IF zeichen = '4' THEN xZiel:= x;  yZiel:= y END
        END
      END
    END BauenUndBeschriften;


  PROCEDURE Suchen ( VAR i : INTEGER );
   (*-----------------------------------------------------------------------*
    | Referenz: Anzahl gefundener Wege durch das Labyrinth                  |
    | Leistung: Schritt fr Schritt (Rekursion) wird ein Weg durch das La-  |
    |           byrinth gesucht. Dabei wird die 'Linke-Hufregel', deren     |
    |           Entwickler Minotaurus gewesen sein soll, dauerhaft angewen- |
    |           det. Der bereits zurckgelegte Weg einer Wegsuche wird mit  |
    |           kleinen Farbflchen gekennzeichnet, Prozedur SteinSetzen(). |
    |           Von Wegen die rckwrts beschritten werden mssen, Irrwege, |
    |           werden die Farbflchen wieder entfernt, Prozedur SteinEnt-  |
    |           nen().                                                      |
    *-----------------------------------------------------------------------*)

    PROCEDURE SteinSetzen ( x, y : INTEGER );
      BEGIN
        Delay_ms(dTime);
        C.SetForeColor(0,79,207);
        C.Bar(faktor*x+2+xOffset,faktor*y+2+yOffset,
              faktor*x+6+xOffset,faktor*y+6+yOffset,C.DRAW);
      END SteinSetzen;
      
    PROCEDURE SteinEntfernen ( x, y : INTEGER );
      BEGIN
        Delay_ms(dTime DIV 2);
        C.SetBackColor(RGBmax,RGBmax,RGBmax);
        C.Bar(faktor*x+2+xOffset,faktor*y+2+yOffset,
              faktor*x+6+xOffset,faktor*y+6+yOffset,C.ERASE);
      END SteinEntfernen;
      
    PROCEDURE Schritt ( xAlt, yAlt : INTEGER );

      VAR richtung, xNeu, yNeu : INTEGER;

      BEGIN
        FOR richtung:= 1 TO 4 DO
          CASE richtung OF
              1: xNeu:= xAlt + 1; yNeu:= yAlt
            | 2: xNeu:= xAlt;     yNeu:= yAlt + 1
            | 3: xNeu:= xAlt - 1; yNeu:= yAlt
            | 4: xNeu:= xAlt;     yNeu:= yAlt - 1
           END;
           IF laby[xNeu,yNeu] = '4' THEN AusgabeLoesungsnummer(i) END;
           IF laby[xNeu,yNeu] = '0' THEN
             SteinSetzen(xNeu,yNeu);  
             laby[xNeu,yNeu]:= '5';  
             Schritt(xNeu,yNeu);                       (* rekursiver Aufruf *)
             laby[xNeu,yNeu]:= '0';  
             SteinEntfernen(xNeu,yNeu)
           END
        END
      END Schritt;
      
    BEGIN  (* Suchen *)
      WegsucheText(i);
      Schritt(xStart,yStart)                           (* erster Aufruf     *)
    END Suchen;


  PROCEDURE AnzahlLoesungen ( i : INTEGER );

    VAR zahlStr : ARRAY 3 OF CHAR;

    BEGIN
      BereichLoeschen(FALSE);
      S.Str(i,zahlStr);
      C.SetForeColor(207,79,0);
      IF i > 1 THEN
        WriteStrXY(xText,240,'Es existieren ');
      ELSE
        WriteStrXY(xText,240,'Es existiert ')
      END;
      C.GotoXY(xText,222); C.WriteStr(zahlStr); C.WriteStr(' Lsungen.');
      Enter(dTime*25,500,35)
    END AnzahlLoesungen;


  PROCEDURE Information;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe einer Information nach Abschluss des Programms.     |
    *-----------------------------------------------------------------------*)

    CONST m1 = 'Besuchen Sie die POW-Seiten des CZ-Gymnasiums!';
          m2 = ' http://www.cz.j.th.schule.de/informatik';
          m3 = '     2001 Chamberlain-Soft';

    VAR   m     : ARRAY 91 OF CHAR;
          dummy : LONGINT;

    BEGIN
      dummy:= W.ShowWindow(W.GetActiveWindow(),3); (* Groes Fenster ffnen *)
     (* C.SetBackColor(24,16,48); *)
      C.Bar(5,10,850,600,C.ERASE);
      m:= m1; S.Append(m,m2);
      dummy:= W.MessageBoxA(W.GetActiveWindow(),Sy.ADR(m),Sy.ADR(m3),40H);
      Delay_ms(dTime)
    END Information;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)


  PROCEDURE ProgMain*();

    VAR i : INTEGER;

    BEGIN
      Bildlagekorrektur;
      Einlesen;
      BauenUndBeschriften;
      WahlStartZiel();
      Legende;
      Enter(dTime,500,35);
      i:= 0;
      Suchen(i);
      AnzahlLoesungen(i);
      Information
    END ProgMain;


 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   C.Open;
   bc_Red:= 240; bc_Green:= 240; bc_Blue:= 220
 END LabyDemo.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

