
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)       Datei-Name: LABYRINTH.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S u c h e   i m   L a b y r i n t h   (Backtracking)          |
  |-------------------------------------------------------------------------|
  | Leistung: Das Programm liest nach dem Start die Textdatei bild.txt      |
  |           automatisch ein, zeigt das Labyrinth am Bildschirm an und     |
  |           sucht alle mglichen Wege durch dieses Labyrinth.             |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise eingefgt werden.                   |
  |           Siehe ...\laby\fine\labyrinth.mod                             |
  |-------------------------------------------------------------------------|
  | Erluterungstext:  ...\laby\txt\labyrinth.txt                           |
  |                    ...\laby\doc\labyrinth.doc                           |
  *-------------------------------------------------------------------------*)

 MODULE Labyrinth;

  IMPORT In, Out, S:= Strings, W:= Windows, XYpl:= XYplane;

  TYPE Bild = ARRAY 80, 80 OF CHAR;

  CONST dTime = 25;

  VAR laby            : Bild; 
      xMax, yMax,
      xStart, yStart,
      xZiel, yZiel    : INTEGER;
      dummy           : LONGINT;


  PROCEDURE Anleitung1;
    BEGIN
      Out.String('   - Ziehen Sie im Fenster XYPLANE den Button im ');
      Out.String('vertikalen Rollbalken'); Out.Ln;
      Out.String('     mit der Maus an den   u n t e r e n   Anschlag!');
      Out.Ln;
      Out.String("   - Aktivieren Sie das Men 'Pane',"); Out.Ln;
      Out.String("   - Klicken Sie die Option 'read input from file...' an,");
      Out.Ln;
      Out.String("   - whlen Sie den Dateipfad '...\laby\good' und"); Out.Ln;
      Out.String("   - klicken Sie doppelt auf den Dateinamen 'bild.txt'!");
      Out.Ln
    END Anleitung1;


  PROCEDURE Anleitung2 ( xMax, yMax : INTEGER );
    BEGIN
      Out.Ln;
      Out.String('   max. x-Ausdehnung ='); Out.Int(xMax,3); Out.Ln;
      Out.String('   max. y-Ausdehnung ='); Out.Int(yMax,3); Out.Ln;
      Out.Ln
    END Anleitung2;


  PROCEDURE Anleitung3;
    BEGIN
      Out.Ln;
      Out.String('   Gltige Codeziffern:'); Out.Ln;
      Out.String('      Umrandungsmauer = 2'); Out.Ln;
      Out.String('      Labyrinthmauer  = 1'); Out.Ln;
      Out.String('      Labyrinthweg    = 0'); Out.Ln;
      Out.String('      Startpunkt      = 3'); Out.Ln;
      Out.String('      Zielpunkt       = 4'); Out.Ln;
    END Anleitung3;


  PROCEDURE Einlesen;

    VAR mitteilung     : ARRAY 10 OF CHAR;
        zZahlStr       : ARRAY  3 OF CHAR;
        CR             : BOOLEAN;
        zeichen        : CHAR;
        anzahl, kZahl,
        zZahl, x, y    : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('  Labyrinth einlesen'); Out.Ln; Out.Ln;
      Out.String("    (1) aus der Datei 'bild.txt'");  Out.Ln;
      Out.String('    (2) zeilenweise mittels Tastatur');  Out.Ln;  Out.Ln;
      In.Prompt('Kennzahl'); In.Int(kZahl);
      IF kZahl = 1 THEN
        In.Prompt('Keine Eingabe!');
        Anleitung1;
        In.Int(xMax);
        In.Int(yMax);
        Anleitung2(xMax,yMax);
        FOR y:= yMax TO 0 BY -1 DO
          FOR x:= 0 TO xMax DO
            In.Char(zeichen);
            laby[x,y]:= zeichen;
            IF zeichen = '3' THEN xStart:= x; yStart:= y END;
            IF zeichen = '4' THEN xZiel:= x;  yZiel:= y END;
          END;
          In.Char(zeichen)                    (* berlesen des Zeilenwechsels *)
        END
      ELSE
        In.Prompt('x-Ausdehnung');
        In.Int(xMax);
        In.Prompt('y-Ausdehnung');
        In.Int(yMax);
        Anleitung2(xMax,yMax);
        Anleitung3;
        FOR y:= yMax TO 0 BY -1 DO
          FOR x:= 0 TO xMax DO
            REPEAT
              In.Prompt('Codierung');
              In.Char(zeichen);
              IF zeichen = '3' THEN xStart:= x; yStart:= y END;
              IF zeichen = '4' THEN xZiel:= x;  yZiel:= y END
            UNTIL (zeichen >= '0') & (zeichen < '5');
            laby[x,y]:= zeichen
          END
        END
      END;
      Out.String('   Labyrinthdaten wurden eingelesen.'); Out.Ln;
      Out.Ln
    END Einlesen;


  PROCEDURE Bauen;

    VAR zeichen : CHAR;
        x, y    : INTEGER;

    PROCEDURE MauerSetzen ( x, y : INTEGER );

      VAR i, k : INTEGER;

      BEGIN
        FOR i:= 9 * x TO 9 * x + 8 DO
          FOR k:= 9 * y TO 9 * y + 8 DO
            XYpl.Dot(i,k,1)
          END
        END
      END MauerSetzen;

    PROCEDURE StartSetzen ( x, y : INTEGER);

      VAR i, k : INTEGER;

      BEGIN
        FOR i:= 9 * x + 2 TO 9 * x + 6 DO
          FOR k := 9 * y + 2 TO 9 * y + 6 DO
            XYpl.Dot(i,k,1)
          END
        END;
        XYpl.Dot(9 * x + 3, 9 * y + 4, 0);
        XYpl.Dot(9 * x + 4, 9 * y + 4, 0);
        XYpl.Dot(9 * x + 5, 9 * y + 4, 0)
      END StartSetzen;

    PROCEDURE ZielSetzen ( x, y : INTEGER );

      VAR i, k : INTEGER;

      BEGIN
        FOR i:= 9 * x + 2 TO 9 * x + 6 DO
          FOR k:= 9 * y + 2 TO 9 * y + 6 DO
            XYpl.Dot(i,k,1)
          END
        END;
        XYpl.Dot(9 * x + 3, 9 * y + 4, 0);
        XYpl.Dot(9 * x + 4, 9 * y + 4, 0);
        XYpl.Dot(9 * x + 5, 9 * y + 4, 0);
        XYpl.Dot(9 * x + 4, 9 * y + 3, 0);
        XYpl.Dot(9 * x + 4, 9 * y + 5, 0)
      END ZielSetzen;

    BEGIN
      FOR y:= 0 TO yMax DO
        FOR x:= 0 TO xMax DO
          zeichen:= laby[x,y];
          IF (zeichen = '1') OR (zeichen = '2') THEN MauerSetzen(x,y) END
        END
      END;
      StartSetzen(xStart,yStart);
      ZielSetzen(xZiel,yZiel)
    END Bauen;


  PROCEDURE Suchen;

    PROCEDURE Delay ( msec : INTEGER );
  
      VAR startzeit, zielzeit : LONGINT;
  
      BEGIN
        startzeit:= W.GetTickCount(); 
        REPEAT
          zielzeit:= W.GetTickCount()
        UNTIL zielzeit > startzeit + msec 
      END Delay;

    PROCEDURE SteinSetzen ( x, y : INTEGER );

      VAR i, k : INTEGER;

      BEGIN
        FOR i:= 9 * x + 2 TO 9 * x + 6 DO
           FOR k:= 9 * y + 2 TO 9 * y + 6 DO
              XYpl.Dot(i,k,1)
           END
        END;
        Delay(dTime)
      END SteinSetzen;
      
    PROCEDURE SteinEntfernen ( x, y : INTEGER );

      VAR i, k : INTEGER;

      BEGIN
        FOR i:= 9 * x + 2 TO 9 * x + 6 DO
           FOR k:= 9 * y + 2 TO 9 * y + 6 DO
              XYpl.Dot(i,k,0)
           END
        END;
        Delay(dTime)
      END SteinEntfernen;
      
      PROCEDURE Schritt ( xAlt, yAlt : INTEGER );

      VAR richtung, xNeu, yNeu : INTEGER;

      BEGIN
        FOR richtung:= 1 TO 4 DO
          CASE richtung OF
              1: xNeu:= xAlt + 1; yNeu:= yAlt
            | 2: xNeu:= xAlt;     yNeu:= yAlt + 1
            | 3: xNeu:= xAlt - 1; yNeu:= yAlt
            | 4: xNeu:= xAlt;     yNeu:= yAlt - 1
           END;
           IF laby[xNeu,yNeu] = '4' THEN Delay(dTime*150) END;
           IF laby[xNeu,yNeu] = '0' THEN
             SteinSetzen(xNeu, yNeu);  
             laby[xNeu,yNeu]:= '5';  
             Schritt(xNeu,yNeu);                       (* rekursiver Aufruf *)
             laby[xNeu,yNeu]:= '0';  
             SteinEntfernen(xNeu,yNeu)
           END
        END
      END Schritt;
      
    BEGIN
      Out.String('   Die Suche im Labyrinth wird gestartet.'); Out.Ln;
      Schritt(xStart, yStart)                          (* erster Aufruf     *)
    END Suchen;


  PROCEDURE ProgMain*();
    BEGIN
      Einlesen;
      Bauen;
      Suchen
    END ProgMain;


 BEGIN
   dummy:= W.ShowWindow(W.GetActiveWindow(),3);  
                                           (* grtmgliches Fenster ffnen *)
   In.Open;
   XYpl.Open
 END Labyrinth.
