
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)           Dateiname: OSTERN.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Thringer Abiturprfung Grundfach Informatik 2000,            |
  |           Aufgabe 1.5 (Zentralabitur)                                   |
  |-------------------------------------------------------------------------|
  | Aufgabe:  Entwerfen und implementieren Sie ein (Turbo Pascal) Programm, |
  |           das fr den Zeitraum von 2000 bis 2200 das Jahr ermittelt,    |
  |           in dem der Aschermittwoch auf den 29. Februar fllt!          |
  |-------------------------------------------------------------------------|
  | Leistung: Lsung der Aufgabenstellung                                   |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul als lauffhiges Grundgerst befindet sich in:       |
  |            ...\ostern\good\ostern.mod                                   |
  |-------------------------------------------------------------------------|
  | Aufgabenstellung: ...\ostern\txt\osterna.txt                            |
  |                   ...\ostern\doc\osterna.doc                            |
  | Lsungsentwurf:   ...\ostern\txt\osternb.txt                            |
  |                   ...\ostern\doc\osternb.doc                            |
  *-------------------------------------------------------------------------*)

 MODULE Ostern;

  IMPORT In, Out;


 (* --------------------  U N T E R P R O G R A M M E --------------------- *)


  PROCEDURE Ueberschrift;

    VAR i : INTEGER;

    BEGIN
      Out.Ln; Out.Ln;
      Out.String('   Thringer Abiturprfung Grundfach Informatik 2000');
      Out.Ln; Out.String('  ');
      FOR i:= 1 TO 51 DO Out.Char('') END;
      Out.Ln; Out.Ln;
      Out.String('   Berechnungen zum Osterdatum und zum Aschermittwoch:');
      Out.Ln
    END Ueberschrift;


  PROCEDURE Test ( jahr : INTEGER ) : BOOLEAN;
   (*-----------------------------------------------------------------------*
    | Leistung: Diese Funktionsprozedur prft, ob das bergebene Jahr ein   |
    |           Schaltjahr ist und liefert einen Funktionswert vom Datentyp |
    |           Boolean.                                                    |
    |           Falls die Jahreszahl des bergebenen Jahres ohne Rest durch |
    |           400 teilbar ist oder die Jahreszahl ohne Rest durch 4 und   |
    |           nicht durch 100 teilbar ist, handelt es sich um ein Schalt- |
    |           jahr und der Funktionswert ist TRUE, sonst FALSE.           |
    *-----------------------------------------------------------------------*)

    VAR schaltjahr : BOOLEAN;

    BEGIN 
      IF (jahr MOD 400 = 0) OR (jahr MOD 4 = 0) & (jahr MOD 100 # 0) THEN
        RETURN TRUE
      ELSE
        RETURN FALSE
      END
    END Test;



  PROCEDURE Algorithmus ( x : INTEGER ) : INTEGER;
   (*-----------------------------------------------------------------------*
    | bernahme: Jahreszahl                                                 |
    | Leistung:  Berechnung des Wertes os zur Ermittlung des Datums des be- |
    |            weglichen Feiertags Ostersonntag. Der hierfr benutzte Al- |
    |            gorithmus wurde von dem Mathematiker Carl Friedrich GAUSS, |
    |            der von 1777-1855 lebte, entwickelte.                      | 
    *-----------------------------------------------------------------------*)

    VAR k, m, s, a, d, r, og, sz, oe, os : INTEGER;

    BEGIN
      k:= x DIV 100;
      m:= 15 + (3 * k + 3) DIV 4 - (8 * k + 13) DIV 25;
      s:= 2 - (3 * k + 3) DIV 4;
      a:= x MOD 19;
      d:= (19 * a + m) MOD 30;
      r:= d DIV 29 + (d DIV 28 - d DIV 29) * (a DIV 11);
      og:= 21 + d - r;
      sz:= 7 - (x + x DIV 4 + s) MOD 7;
      oe:= 7 - (og - sz) MOD 7;
      os:= og + oe;
      RETURN os
    END Algorithmus;


  PROCEDURE Start;
   (*-----------------------------------------------------------------------*
    | Leistung: Test des Algorithmus fr die Jahre 1997 und 2000 und Suche  |
    |           nach der Lsung (den Lsungen) fr die Jahre 2000 bis 2200. |
    *-----------------------------------------------------------------------*)

    VAR jz: INTEGER;

    BEGIN
      Out.Ln;
      Out.String('     os fr 1997:'); Out.Int(Algorithmus(1997),4); Out.Ln;
      Out.String('     os fr 2000:'); Out.Int(Algorithmus(2000),4); Out.Ln;
      Out.Ln; Out.Ln;
      Out.String('   Zwischen den Jahren 2000 und 2200 fllt der Aschermittwoch');
      Out.Ln;
      Out.String('   nur im Jahr');
      FOR jz:= 2000 TO 2200 DO
        IF (Test(jz) = TRUE) & (Algorithmus(jz) = 46) THEN
          Out.Int(jz,5) 
        END
      END;
      Out.String(' auf den 29. Februar.')
    END Start;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Ueberschrift;
      Start
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Out.Open
 END Ostern.

 (* ----------------------------------------------------------------------- *)

