
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)           Dateiname: OSTERN.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Thringer Abiturprfung Grundfach Informatik 2000,            |
  |           Aufgabe 1.5 (Zentralabitur)                                   |
  |-------------------------------------------------------------------------|
  | Leistung: Ermitteln des Osterdatums                                     |
  |-------------------------------------------------------------------------|
  | Aufgabe:  Entwerfen und implementieren Sie ein (Turbo Pascal) Programm, |
  |           das fr den Zeitraum von 2000 bis 2200 das Jahr ermittelt,    |
  |           in dem der Aschermittwoch auf den 29. Februar fllt!          |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise eingefgt werden.                   |
  |           Siehe ...\ostern\fine\ostern.mod                              |
  |-------------------------------------------------------------------------|
  | Aufgabenstellung: ...\ostern\txt\osterna.txt                            |
  |                   ...\ostern\doc\osterna.doc                            |
  | Lsungsentwurf:   ...\ostern\txt\osternb.txt                            |
  |                   ...\ostern\doc\osternb.doc                            |
  *-------------------------------------------------------------------------*)

 MODULE Ostern;

  IMPORT In, Out;


  PROCEDURE Test ( jahr : INTEGER ) : BOOLEAN;

    VAR schaltjahr : BOOLEAN;

    BEGIN 
      IF (jahr MOD 400 = 0) OR (jahr MOD 4 = 0) & (jahr MOD 100 # 0) THEN
        schaltjahr:= TRUE
      ELSE
        schaltjahr:= FALSE
      END;
      RETURN schaltjahr
    END Test;


  PROCEDURE Algorithmus ( x : INTEGER ) : INTEGER;

    VAR k, m, s, a, d, r, og, sz, oe, os : INTEGER;

    BEGIN
      k:= x DIV 100;
      m:= 15 + (3 * k + 3) DIV 4 - (8 * k + 13) DIV 25;
      s:= 2 - (3 * k + 3) DIV 4;
      a:= x MOD 19;
      d:= (19 * a + m) MOD 30;
      r:= d DIV 29 + (d DIV 28 - d DIV 29) * (a DIV 11);
      og:= 21 + d - r;
      sz:= 7 - (x + x DIV 4 + s) MOD 7;
      oe:= 7 - (og - sz) MOD 7;
      os:= og + oe;
      RETURN os
    END Algorithmus;


  PROCEDURE Start;

    VAR jz: INTEGER;

    BEGIN
      Out.Ln;
      (* Test des Algorithmus fr die Jahre 1997 und 2000: *)
      Out.String('  os fr 1997:'); Out.Int(Algorithmus(1997),5); Out.Ln;
      Out.String('  os fr 2000:'); Out.Int(Algorithmus(2000),5); Out.Ln;
    
      (* Suche nach der Lsung: *) 
      Out.Ln;
      FOR jz:= 2000 TO 2200 DO
        IF (Test(jz) = TRUE) & (Algorithmus(jz) = 46) THEN
          Out.String('  Lsung:'); Out.Int(jz,5); Out.Ln 
        END
      END
    END Start;


  PROCEDURE ProgMain*();
    BEGIN
      Start
    END ProgMain;
  

 BEGIN
   Out.Open
 END Ostern.
