
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)    Dateiname: PERMUTATIONEN.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    P e r m u t a t i o n                                         |
  |-------------------------------------------------------------------------|
  | Leistung: Permutation von vier Zeichen (DT: CHAR)                       |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise eingefgt werden.                   |
  |           Siehe ...\perm\fine\perm.mod                                  |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\perm\txt\permutat.txt und                         |
  |                   ...\perm\doc\permutat.doc                             |
  *-------------------------------------------------------------------------*)

 MODULE Permutationen;

  IMPORT In, Out;

  VAR    a      : ARRAY 10 OF CHAR;
         nMax   : INTEGER;
         anzahl : LONGINT;


  PROCEDURE LoesungAusgeben;

    VAR i: INTEGER;

    BEGIN 
      INC(anzahl);
      Out.String('    ');
      FOR i:= 0 TO nMax DO
        Out.Char(' '); Out.Char(a[i])
      END;
      Out.Ln
    END LoesungAusgeben;


  PROCEDURE Tausch ( VAR x, y : CHAR );

    VAR h: CHAR;

    BEGIN
      h:= x;
      x:= y;
      y:= h
    END Tausch;


  PROCEDURE Perm ( n : INTEGER );

    VAR k : INTEGER;

    BEGIN 
      IF n = 0 THEN
        LoesungAusgeben
      ELSE
        FOR k:= n TO 0 BY -1 DO
          Tausch(a[k],a[n]);
          Perm(n-1);                                   (* rekursiver Aufruf *)
          Tausch(a[k], a[n])
        END
      END
    END Perm;


  PROCEDURE Einlesen;

    VAR i       : INTEGER;
        zeichen : CHAR;

    BEGIN
      In.Prompt('vier Buchstaben:');
      i:= 0;
      REPEAT
        In.Char(zeichen);
        WHILE zeichen = ' ' DO
          In.Char(zeichen)
        END;
        a[i]:= zeichen;
        INC(i)
      UNTIL i = 4;
      nMax:= i-1;
      Out.Ln; Out.String('    eingelesen');
      Out.Ln; Out.Ln
    END Einlesen;


  PROCEDURE Loesen;
    BEGIN
      anzahl:= 0;
      Perm(nMax);                                          (* erster Aufruf *)
      Out.Ln; Out.Int(anzahl,4);
      Out.String(' Permutationen');
      Out.Ln
    END Loesen;


  PROCEDURE ProgMain*();
    BEGIN
      Einlesen;
      Loesen
    END ProgMain;


 BEGIN
   In.Open;
   Out.Open
 END Permutationen.

