
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)             Dateiname: POLY.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Polyalpabetische Verschlsselung                              |
  |-------------------------------------------------------------------------|
  | Leistung: Verschlsseln und Entschlsseln eines Textes mittels          |
  |           polyalphabetischer Substitution.                              |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Siehe ...\mono\fine\mono.mod                                  |
  |-------------------------------------------------------------------------|
  | Erluterungstexte: ...\poly\txt\poly.txt                                |
  |                    ...\poly\txt\polytool.txt                            |
  |                    ...\poly\doc\poly.doc                                |
  |                    ...\poly\doc\polytool.doc                            |
  *-------------------------------------------------------------------------*)

 MODULE Poly;

  IMPORT In, Out;

  VAR schluessel       : ARRAY 20 OF CHAR;
      schluessellaenge : INTEGER;


 (* --------------------  U N T E R P R O G R A M M E --------------------- *)


  PROCEDURE Erlaeuterung;

    VAR i : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('  H I N W E I S E :'); Out.Ln; Out.Ln;
      Out.String('   Jede eingegebene Zeichenkette ist mit der Tilde ( ~ ),');
      Out.Ln; Out.Ln;
      Out.String('   Tastenkombination < Alt Gr > + < + > und < Enter > ab-');
      Out.Ln; Out.Ln;
      Out.String('   zuschlieen!'); Out.Ln;
      Out.Ln; Out.Ln;
      Out.String('   Fr den Schlssel und den Klartext sind nur Kleinbuch-');
      Out.Ln; Out.Ln;
      Out.String('   staben zugelassen.');
      Out.Ln; Out.Ln;
      Out.String('  ');
      FOR i:= 1 TO 55 DO Out.Char('') END;
      Out.Ln
    END Erlaeuterung;


  PROCEDURE Schluesseleingabe;

    VAR i       : INTEGER; 
        zeichen : CHAR;

    BEGIN
      i:= 0;
      In.Prompt('Schlssel:');
      REPEAT
        In.Char(zeichen);
        WHILE zeichen = ' ' DO
          In.Char(zeichen)
        END;
        IF zeichen # '~' THEN
          schluessel[i]:= zeichen;
          INC(i)
        END
      UNTIL zeichen = '~';
      schluessellaenge:= i - 1;
      Out.Ln;
      Out.String("   Schlssel eingelesen"); Out.Ln
    END Schluesseleingabe;


  PROCEDURE Verschluesseln;

    VAR differenz, nummer, i : INTEGER;
        klarbuchstabe,
        schluesselbuchstabe, 
        geheimbuchstabe      : CHAR;

    BEGIN
      Out.Ln;
      In.Prompt('Klartext:');
      Out.String('   Geheimtext: ');
      i:= 0;
      REPEAT
        In.Char(klarbuchstabe);
        WHILE klarbuchstabe = ' ' DO
          In.Char(klarbuchstabe)
        END;
        schluesselbuchstabe:= schluessel[i];
        INC(i);
        IF i > schluessellaenge THEN
          i:= 0
        END;
        IF klarbuchstabe # '~' THEN
          differenz:= ORD(schluesselbuchstabe) - 97;
          nummer:= ORD(klarbuchstabe) + differenz;
          IF nummer > 122 THEN
            nummer:= nummer - 26
          END;
          geheimbuchstabe:= CHR(nummer-32);
          Out.Char(geheimbuchstabe)
        END
      UNTIL klarbuchstabe = '~';
      Out.Ln
    END Verschluesseln;


  PROCEDURE Entschluesseln;

    VAR differenz, nummer, i : INTEGER;
        klarbuchstabe,
        schluesselbuchstabe, 
        geheimbuchstabe      : CHAR;

    BEGIN
      Out.Ln;
      Out.String('   Klartext:   ');
      i:= 0;
      REPEAT
        In.Prompt('Geheimbuchstabe:');
        In.Char(geheimbuchstabe);
        schluesselbuchstabe:= schluessel[i];
        INC(i);
        IF i > schluessellaenge THEN
          i:= 0
        END;
        nummer:=    ORD(geheimbuchstabe) + 32;
        differenz:= ORD(schluesselbuchstabe) - 97;
        nummer:=    nummer - differenz;
        IF nummer < 97 THEN
          nummer:= nummer + 26
        END;
        klarbuchstabe:= CHR(nummer);
        IF ORD(klarbuchstabe) < 123 THEN
          Out.Char(klarbuchstabe)
        END
      UNTIL geheimbuchstabe = '~'
    END Entschluesseln;


  PROCEDURE ProgMain*();
    BEGIN
      Erlaeuterung;
      Schluesseleingabe;
      Verschluesseln;
      Entschluesseln
    END ProgMain;


 BEGIN
   In.Open;
   Out.Open
 END Poly.

