
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)         Dateiname: PROZEDUR.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Prozeduren mit Parametern                                     |
  |             (Wertparameter und Referenzparameter (Variablenparameter))  |
  |-------------------------------------------------------------------------|
  | Aufgabe:  Es wird eine Prozedur gesucht, die die Summe zweier Werte     |
  |           berechnet und den berechneten Wert zurckgibt (referenziert). |
  |           Die Prozedur soll Parameter besitzen.                         |
  |-------------------------------------------------------------------------|
  | Leistung: Einfaches OBERON-Programm, das die Arbeit mit Parametern      |
  |           illustriert.                                                  |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst befindet sich in:       |
  |            ...\proz\good\prozedur.mod                                   |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\proz\txt\prozedur.txt und                         |
  |                   ...\proz\doc\prozedur.doc                             |
  |-------------------------------------------------------------------------|
  | Aufgabe:  Fertigen Sie einen Schreibtischtest (Trockentest) der erwar-  |
  |           teten Leistung des Programms an. Schreiben Sie dafr  a l l e |
  |           vom Programm gettigten Bildschirmausgaben auf!               |
  *-------------------------------------------------------------------------*)

 MODULE Prozedur;

  IMPORT Out;

  CONST  n = 7;          (* Formatierung (max. 7 Zeichen) fr Out.Int(xxx,n *)

 (* --------------------  U N T E R P R O G R A M M E --------------------- *)


  PROCEDURE Eins ( a, b, summe : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Drei formale Parameter (Wertparameter a, b, summe, alle    |
    |            vom DT: INTEGER)                                           |
    | Referenz:  keine                                                      |
    | Leistung:  Anfertigen von Kopien der Werte der Variablen a, b und     |
    |            summe. Addition der Werte der Variablen a und b.           |
    |            Die Variable summe bekommt das Ergebnis zugewiesen.        |
    |            'Vernichten' der drei kopierten Variablen und Rckkehr zur |
    |            rufenden Prozedur Start.                                   |
    | Hinweis:   Da im Prozedurkopf kein Referenzparameter steht, wird kein |
    |            Wert an die rufende Prozedur Start 'zurckgegeben'.        |
    *-----------------------------------------------------------------------*)

    BEGIN
      summe:= a + b
    END Eins;


  PROCEDURE Zwei ( VAR a, b, summe : INTEGER );
   (*-----------------------------------------------------------------------*
    | Referenz:  Drei formale Parameter (Referenzparameter a, b, summe)     |
    | Leistung:  Addition der Werte der Variablen a und b.                  |
    |            Die Variable summe bekommt das Ergebnis zugewiesen.        |
    | Hinweis:   Da im Prozedurkopf als formale Parameter nur Referenzpara- |
    |            meter stehen, bleiben der rufenden Prozedur Start alle     |
    |            drei Parameter bekannt. Die nderung des Wertes der Varia- |
    |            blen summe bleibt nach der Rckkehr zur Prozedur Start als |
    |            Wert des aktuellen Parameters s gltig.                    |
    |            Begrndung: Die Variable s, aktueller Parameter der rufen- |
    |            den Prozedur Start, und die Variable summe, Referenzpara-  |
    |            meter der gerufenen Prozedur Zwei, besitzen den gleichen   |
    |            Speicherplatz (gleiche Adresse eines Speicherplatzes) im   |
    |            Arbeitsspeicher des Computers.                             |
    |            Es muss demzufolge  k e i n e  Kopie angefertigt werden.   |
    *-----------------------------------------------------------------------*)

    BEGIN
      summe:= a + b
    END Zwei;


  PROCEDURE Drei ( a, b : INTEGER; VAR summe : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Zwei formale Parameter (Wertparameter a und b)             |
    | Referenz:  Ein formaler Parameter (summe, DT: INTEGER)                |
    | Leistung:  Addition der Werte der Variablen a und b.                  |
    |            Die Variable summe bekommt das Ergebnis zugewiesen.        |
    | Hinweis:   Da im Prozedurkopf ein Referenzparameter steht, bleibt der |
    |            rufenden Prozedur Start der Parameter s bekannt. Die nde- |
    |            rung des Wertes der Variablen summe bleibt nach der Rck-  |
    |            kehr zur Prozedur Start als Wert des aktuellen Parameters  |
    |            s gltig.                                                  |
    |            Begrndung: Siehe Erluterungen zur Prozedur Zwei.         |
    *-----------------------------------------------------------------------*)

    BEGIN
      summe:= a + b
    END Drei;


  PROCEDURE Vier ( VAR a, b, summe : INTEGER );
   (*-----------------------------------------------------------------------*
    | Referenz:  Drei formale Parameter (Referenzparameter a, b, summe)     |
    | Leistung:  Addition der Werte der Variablen a und b.                  |
    |            Die Variable summe bekommt das Ergebnis zugewiesen.        |
    |            Die Werte der Variablen a und b werden um eins erhht (in- |
    |            krementiert, a:= a + 1).                                   |
    | Hinweis:   Da im Prozedurkopf nur Referenzparameter stehen, bleiben   |
    |            der rufenden Prozedur Start alle drei Parameter bekannt.   |
    |            Die nderung des Wertes der Variablen summe und die inkre- |
    |            mentierten Werte der Variablen a und b bleiben nach der    |
    |            Rckkehr zur Prozedur Start als Werte der aktuellen Para-  |
    |            meter e, f, s gltig.                                      |
    |            Begrndung: Siehe Erluterungen zur Prozedur Zwei.         |
    | ACHTUNG!   Die Werte der Variablen a und b haben sich gendert, die   |
    |            Werte der aktuellen Parameter e und f der Prozedur Start   |
    |            wurden somit ebenfalls gendert (Referenz). Da steckt mg- |
    |            licherweise eine Falle. (Seiteneffekt, Nebenwirkung)       |
    *-----------------------------------------------------------------------*)

    BEGIN
      summe:= a + b;
      INC(a);
      INC(b)
    END Vier;


  PROCEDURE Fuenf ( a, b : INTEGER) : INTEGER;
   (*-----------------------------------------------------------------------*
    | bernahme: Zwei formale Parameter (Wertparameter a, und b)            |
    | Referenz:  Fuenf (Bezeichner der Funktionsprozedur)                   |
    | Leistung:  Anfertigen von Kopien der Werte der Variablen a, b.        |
    |            Addition der Werte der Variablen a und b.                  |
    |            Der Bezeichner der Funktionsprozedur bekommt das Ergebnis, |
    |            RETURN a + b, ohne Zuweisungszeichen zugewiesen.           |
    |            'Vernichten' der drei kopierten Variablen und Rckkehr zur |
    |            rufenden Prozedur Start.                                   |
    *-----------------------------------------------------------------------*)

    BEGIN
      RETURN a + b
    END Fuenf;


  PROCEDURE Start;
   (*-----------------------------------------------------------------------*
    | Leistung: Wertzuweisungen an Variablen, Aufruf der Prozeduren Eins    |
    |           bis Fuenf. Die Prozeduraufrufe besitzen Parameterlisten,    |
    |           die die aktuellen Parameter als Konstanten, Variablen oder  |
    |           Ausdrcke enthalten. Ausgabe der aktuellen Werte einiger    |
    |           aktueller Parameter nach der Rckkehr aus dem aufgerufenen  |
    |           Unterprogramm.                                              |
    *-----------------------------------------------------------------------*)

    VAR e, f, s, g : INTEGER;

    BEGIN
      s:= 0;
      Out.Ln;
      Out.String('   Prozedur Eins'); Out.Ln;
      e:=  7;
      f:= 23;
      Eins(e,f,s);
      Out.Int(s,n); Out.Ln;
      Out.Ln;

      Out.String('   Prozedur Zwei'); Out.Ln;
      e:= 7;
      f:= 23;
      Zwei(e,f,s);
      Out.Int(s,n); Out.Ln;
      Out.Ln;

      Out.String('   Prozedur Drei'); Out.Ln;
      Drei(7,23,s);
      Out.Int(s,n); Out.Ln;

      Drei(5+2,15+2*4,s);
      Out.Int(s,n); Out.Ln;

      e:= 7;
      f:= 23;
      Drei(e,f,s);
      Out.Int(s,n); Out.Ln;
      Out.Ln;

      Out.String('   Prozedur Vier'); Out.Ln;
      e:= 7;
      f:= 23;
      Vier(e,f,s);
      Out.Int(s,n); Out.Ln;
      Vier(e,f,s);
      Out.Int(s,n); Out.Ln;
      Out.Ln;

      Out.String('   Funktionsprozedur Fuenf'); Out.Ln;
      e:= 7;
      f:= 23;
      Out.Int(Fuenf(e,f),n); Out.Ln;
      Out.Int(Fuenf(7,23),n); Out.Ln;
      g:= 3 * Fuenf(7, 23) - 1;
      Out.Int(g,n); Out.Ln;
      Out.Ln;

    END Start;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Start
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Out.Open
 END Prozedur.

 (* ----------------------------------------------------------------------- *)
