
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)         Dateiname: PROZEDUR.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Prozeduren mit Parametern                                     |
  |             (Wertparameter und Referenzparameter (Variablenparameter))  |
  |-------------------------------------------------------------------------|
  | Aufgabe:  Es wird eine Prozedur gesucht, die die Summe zweier Werte     |
  |           berechnet und den berechneten Wert zurckgibt (referenziert). |
  |           Die Prozedur soll Parameter besitzen.                         |
  |-------------------------------------------------------------------------|
  | Leistung: Einfaches OBERON-Programm, das die Arbeit mit Parametern      |
  |           illustriert.                                                  |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise und Zwischenberschriften eingefgt |
  |           werden. Siehe: ...\proz\fine\prozedure.mod                    |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\proz\txt\prozedur.txt und                         |
  |                   ...\proz\doc\prozedur.doc                             |
  *-------------------------------------------------------------------------*)

 MODULE Prozedur;

  IMPORT Out;


  PROCEDURE Eins ( a, b, summe : INTEGER );
    BEGIN
      summe:= a + b
    END Eins;


  PROCEDURE Zwei ( VAR a, b, summe : INTEGER );
    BEGIN
      summe:= a + b
    END Zwei;


  PROCEDURE Drei ( a, b : INTEGER; VAR summe : INTEGER );
    BEGIN
      summe:= a + b
    END Drei;


  PROCEDURE Vier ( VAR a, b, summe : INTEGER );
    BEGIN
      summe:= a + b;
      INC(a);
      INC(b)
    END Vier;


  PROCEDURE Fuenf ( a, b : INTEGER) : INTEGER;
    BEGIN
      RETURN a + b
    END Fuenf;


  PROCEDURE Start;

    VAR e, f, s, g : INTEGER;

    BEGIN
      Out.Ln;
      e:= 7;
      f:= 23;
      Eins(e,f,s);
      Out.Int(s,6); Out.Ln;
      Out.Ln;

      e:= 7;
      f:= 23;
      Zwei(e,f,s);
      Out.Int(s,6); Out.Ln;
      Out.Ln;

      Drei(7,23,s);
      Out.Int(s,6); Out.Ln;

      Drei(5+2,15+2*4,s);
      Out.Int(s,6); Out.Ln;

      e:= 7;
      f:= 23;
      Drei(e,f,s);
      Out.Int(s,6); Out.Ln;
      Out.Ln;

      e:= 7;
      f:= 23;
      Vier(e,f,s);
      Out.Int(s,6); Out.Ln;
      Vier(e,f,s);
      Out.Int(s,6); Out.Ln;
      Out.Ln;

      e:= 7;
      f:= 23;
      Out.Int(Fuenf(e,f),6); Out.Ln;
      Out.Int(Fuenf(7,23),6); Out.Ln;
      g:= 3 * Fuenf(7, 23) - 1;
      Out.Int(g,6); Out.Ln;
      Out.Ln;

    END Start;


  PROCEDURE ProgMain*();
    BEGIN
      Start
    END ProgMain;

 BEGIN
   Out.Open
 END Prozedur.
