
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)         Dateiname: AUSWAEHO.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   durch Auswhlen - 6. Variante             |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren von n Zahlen durch Auswhlen.                       |
  |           Zum Ermitteln des Zeitverhaltens des Algorithmus bei wachsen- |
  |           der Anzahl n werden entweder die Anzahl der Vergleiche oder   |
  |           die der Bewegungen ermittelt.                                 |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul als lauffhiges Grundgerst finden Sie unter:       |
  |            ...\sort1\good\auswaeh0.mod                                  |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort1\txt\auswaeh6.txt und                        |
  |                   ...\sort1\doc\auswaeh6.doc                            |
  *-------------------------------------------------------------------------*)

 MODULE AuswaehO;

  IMPORT In, Out, S:= Strings, W:= Windows;

  CONST  max = 1000;

  VAR    a   : ARRAY max+1 OF INTEGER;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Ueberschrift;
    BEGIN
      Out.Ln;
      Out.String('   S O R T I E R E N   durch Auswhlen'); Out.Ln;
      Out.String('  '); Out.Ln
             (* '' = <Alt> + < 0 1 6 8 > auf dem Nummernblock der Tastatur *)
    END Ueberschrift;


  PROCEDURE Art ( VAR art : INTEGER );
    BEGIN
      Out.Ln;
      Out.String('  Arten:'); Out.Ln;
      Out.String('    (1) Vergleiche'); Out.Ln;
      Out.String('    (2) Bewegungen'); Out.Ln;
      Out.String('  anzeigen'); Out.Ln; Out.Ln;
      Out.String('  Eingabe mit < Enter > abschlieen.');
      REPEAT
        In.Prompt('Art   ( 1 oder 2 )');
        In.Int(art)
      UNTIL (art = 1) OR (art = 2)                    (* ODER art IN {1..2} *)
    END Art;


  PROCEDURE Anleitung;

    VAR zeichen : CHAR;
        spalte,
        zeile   : INTEGER;

    BEGIN
      In.Prompt('Ohne Eingabe!');
      Out.Ln;  Out.Ln;
      Out.String('  A N L E I T U N G :'); Out.Ln;
      Out.String('  '); Out.Ln;
             (* '' = <Alt> + < 0 1 7 5 > auf dem Nummernblock der tastatur *)
      Out.String("  - Aktivieren Sie das Men 'Pane',"); Out.Ln;
      Out.String("  - klicken Sie auf die Option 'read input from file...',");
      Out.Ln;
      Out.String("  - whlen Sie den Dateipfad '...\SORT1\FINE' und"); Out.Ln;
      Out.String("  - klicken Sie doppelt auf den Dateinamen 'TESTxxxx.TXT'!");
      Out.Ln; Out.Ln;
      Out.String("  Es bedeuten:"); Out.Ln; Out.Ln; 
      Out.String("  - 'TEST10up.TXT', die Datei enthlt 10 Zahlen, aufwrts ");
      Out.String(" sortiert"); Out.Ln;
      Out.String("  - 'TEST10rd.txt', die Datei enthlt 10 Zahlen, zufllig ");
      Out.String("verteilt"); Out.Ln;   
      Out.String("  - 'TEST10dw.txt', die Datei enthlt 10 Zahlen, die abwrts ");
      Out.String("sortiert")
    END Anleitung;


  PROCEDURE Einlesen ( VAR n : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Einlesen der berschrift und ab der zweiten Dateizeile der  |
    |           INTEGER-Werte aus einer Textdatei mittels der Option        |
    |           'read input from file...' aus dem Men 'Pane'.              |
    *-----------------------------------------------------------------------*)

    VAR string : ARRAY 50 OF CHAR;
        zahl   : INTEGER;
        dummy  : LONGINT;
        
    BEGIN
      In.String(string);
         (* Erste Zeile der Textdatei (DT: Zeichenkette), berschrift, ein- *)
         (* lesen (die Textdatei stellt hier den Eingabestream dar) ...     *)
      Out.Ln; Out.Ln; Out.String('  ');     
      Out.String(string); Out.Ln;   (*      ... und am Bildschirm ausgeben. *)
      Out.Ln; Out.String('   ');
      n:= 0;
      In.Int(zahl);                 (* Ersten Eintrag (DT: INTEGER) aus der *)
                                    (* Textdatei (Eingabestream) lesen.     *)
      WHILE In.Done DO              (* Solange das Dateiende nicht erreicht *)
        INC(n);                     (* wurde, n inkrementieren, a[n] den    *)
        a[n]:= zahl;                (* Wert der Variable zahl zuweisen,     *)
        IF n = 26 THEN              (* wenn n den Wert 26 besitzt, Zeilen-  *)
          Out.Ln; Out.String('   ');(* umbruch und fhrende Leerzeichen     *)
        END;                        (* ausgeben,                            *)
        Out.Int(a[n],3);            (* Wert der Komponente der Reihung ta-  *)
                                    (* bellarisch formatiert am BS ausgeben *)
        In.Int(zahl)                (* und nchsten Eintrag aus der Text-   *)
      END;                          (* datei (Eingabestream) einlesen.      *)
      Out.Ln;
      IF n > 10 THEN                (* Falls die Anzahl der eingelesenen    *)
                                    (* Werte zehn berschreitet, das groe  *)
        dummy:= W.ShowWindow(W.GetActiveWindow(),3)
                                    (* Bildschirmfenster 'aufziehen'.       *)
      END;
    END Einlesen;


  PROCEDURE Sortieren ( art, n : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Sortieren durch Auswhlen.                                  |
    |           Die ausfhrliche Beschreibung des Algorithmus' findet man   |
    |           unter  ...\sort1\doc\auswaeh1.doc (WORD-Version)            |
    |           oder   ...\sort1\txt\auswaeh1.txt (Text-Version)            |
    *-----------------------------------------------------------------------*)

    VAR r, s, t, x : INTEGER;      
        vergleiche,
        bewegungen : LONGINT;

    BEGIN
      Out.Ln;
      IF art = 1 THEN
        Out.String('  Ausgabe der Vergleiche'); Out.Ln;
        vergleiche:= 0
      ELSE
        Out.String('  Ausgabe der Bewegungen'); Out.Ln;
        bewegungen:= 0
      END;
      Out.Ln;
      Out.String('    ');
      FOR r:= 1 TO n-1 DO
        t:= r;
        x:= a[r];  
        IF art = 2 THEN
          Out.Char('*');
          INC(bewegungen)
        END;
        FOR s:= r+1 TO n DO
          IF art = 1 THEN
            Out.Char('*');
            INC(vergleiche)
          END;
          IF a[s] < x THEN
            t:= s;
            x:= a[s];  
            IF art = 2 THEN
              Out.Char('*');
              INC(bewegungen)
            END
          END
        END;
        a[t]:= a[r];
        a[r]:= x;  
        IF art = 2 THEN
          Out.String('**');
          INC(bewegungen,2)
        END;
        Out.Ln; Out.String('    ');                        (* Zeilenwechsel! *)
      END;
      Out.Ln;
      Out.String('    ');
      IF art = 1 THEN
        Out.Int(vergleiche,1); Out.String(' Vergleiche')
      ELSE
        Out.Int(bewegungen,1); Out.String(' Bewegungen')
      END;
      Out.Ln; Out.Ln
    END Sortieren;


  PROCEDURE Ausgeben ( n : INTEGER );

    VAR k: INTEGER;

    BEGIN
      Out.String('  Elemente in sortierter Reihenfolge:'); Out.Ln; Out.Ln;
      Out.String('   ');
      FOR k:= 1 TO n DO
        IF k = 26 THEN
          Out.Ln; Out.String('   ');
        END;
        Out.Int(a[k],3)
      END;
      Out.Ln; Out.Ln
    END Ausgeben;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();

    VAR art, n : INTEGER;

    BEGIN
      Ueberschrift;
      Art(art);
      Anleitung;
      Einlesen(n);
      Sortieren(art,n);
      Ausgeben(n)
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;
   Out.Open
 END AuswaehO.

 (* ----------------------------------------------------------------------- *)
