
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (32 Bit)         Dateiname: AUSWAEHD.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   durch Auswhlen - 2. Variante             |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren von Kalenderdaten, die in einer Textdatei abgelegt  |
  |           sind.                                                         |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul als lauffhiges Grundgerst finden Sie unter:       |
  |            ...\sort1\good\auswaehd.mod                                  |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort1\txt\auswaeh2.txt und                        |
  |                   ...\sort1\doc\auswaeh2.doc                            |
  *-------------------------------------------------------------------------*)

 MODULE AuswaehD;

  IMPORT In, Out, D:= DatumOperationen;

  CONST  max = 5 ;

  TYPE   tString    = ARRAY 26 OF CHAR;

         tDatensatz = RECORD
                        dat : D.tDatum;
                        txt : tString
                      END;

  VAR    a : ARRAY max+1 OF tDatensatz; 


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Ueberschrift;
    BEGIN
      Out.Ln;
      Out.String('   Sortieren von Kalenderdaten'); Out.Ln;
      Out.String('  '); Out.Ln
             (* '' = <Alt> + < 0 1 6 8 > auf dem Nummernblock der Tastatur *)
    END Ueberschrift;


  PROCEDURE Anleitung;

    VAR zeichen : CHAR;
        spalte,
        zeile   : INTEGER;

    BEGIN
      In.Prompt('Ohne Eingabe!');
      Out.String('   A N L E I T U N G :'); Out.Ln; Out.Ln;
      Out.String("   - Aktivieren Sie das Men 'Pane',"); Out.Ln;
      Out.String("   - klicken Sie auf die Option 'read input from file...',");
      Out.Ln;
      Out.String("   - whlen Sie den Dateipfad '...\SORT1\FINE und"); Out.Ln;
      Out.String("   - klicken Sie doppelt auf den Dateinamen 'DATEN.TXT'!");
      Out.Ln; Out.Ln
    END Anleitung;


  PROCEDURE EinlesenDatum ( VAR datum : D.tDatum );
   (*-----------------------------------------------------------------------*
    | Leistung: Einlesen des Datums (nach der neuen Norm):                  |
    |           Jahr (vierstellig), Leerzeichen, Monat (ein- oder zweistel- |
    |           lig), Leerzeichen, Tag (ein- oder zweistellig).             |
    *-----------------------------------------------------------------------*)

    BEGIN
      In.Int(datum.jahr);  
      In.Int(datum.monat); 
      In.Int(datum.tag)
    END EinlesenDatum;


  PROCEDURE EinlesenText ( VAR text : tString );
   (*-----------------------------------------------------------------------*
    | Leistung: Einlesen eines maximal 25 Zeichen langen Textes.            |
    *-----------------------------------------------------------------------*)

    BEGIN
      In.Prompt('String[25]:');                         (* Text bis 25 Char *)
      In.String(text)
    END EinlesenText;


  PROCEDURE Einlesen;
   (*-----------------------------------------------------------------------*
    | Leistung: Alle Daten und Texte einlesen, ....                         |
    *-----------------------------------------------------------------------*)

    VAR index : INTEGER;
        datum : D.tDatum;
        text  : tString;

    BEGIN
      FOR index:= 1 TO max DO
        EinlesenDatum(datum);
        EinlesenText(text);
        a[index].dat:= datum;
        a[index].txt:= text
      END;
      Out.String('  Zu sortierende Elemente: a[1] bis a['); Out.Int(max,1);
     Out.Char(']'); Out.Ln; Out.Ln
    END Einlesen;


  PROCEDURE Sortieren;
   (*-----------------------------------------------------------------------*
    | Leistung: Sortieren durch Auswhlen.                                  |
    |           Die ausfhrliche Beschreibung des Algorithmus' findet man   |
    |           unter  ...\sort1\doc\auswaeh1.doc (WORD-Version)            |
    |           oder   ...\sort1\txt\auswaeh1.txt (Text-Version)            |
    *-----------------------------------------------------------------------*)

    VAR r, s, t : INTEGER;
        x       : tDatensatz;

    BEGIN
      Out.String('    Das Sortieren beginnt.'); Out.Ln;
      FOR r:= 1 TO max-1 DO
         t:= r;
         x:= a[r];
         FOR s:= r+1 TO max DO
            IF D.LiegtVor(a[s].dat,x.dat) THEN
               t:= s;
               x:= a[s]
            END
         END;
         a[t]:= a[r];
         a[r]:= x
      END;
      Out.String('    Das Sortieren ist beendet.'); Out.Ln; Out.Ln
    END Sortieren;


  PROCEDURE AusgebenDatum ( datum : D.tDatum );
    BEGIN
      Out.String('   ');
      Out.Int(datum.jahr,5);  
      Out.Int(datum.monat,3); 
      Out.Int(datum.tag,3)
    END AusgebenDatum;


  PROCEDURE AusgebenEreignis ( txt : tString );
    BEGIN
      Out.String('  '); Out.String(txt)    
    END AusgebenEreignis;


  PROCEDURE Ausgeben;

    VAR k : INTEGER;

    BEGIN
      Out.String('  Elemente in sortierter Reihenfolge:'); Out.Ln;
      Out.Ln;
      FOR k := 1 TO max DO
        AusgebenDatum(a[k].dat);
        AusgebenEreignis(a[k].txt); Out.Ln
      END
    END Ausgeben;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Ueberschrift;
      Anleitung;
      Einlesen;
      Sortieren;
      Ausgeben
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;
   Out.Open
 END AuswaehD.

 (*-------------------------------------------------------------------------*)

