
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)             Dateiname: EINS.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Mai 2001 Version: V 1.0                     |
  |-------------------------------------------------------------------------|
  | Thema:    Eingabe, Ausgabe  (In- und Out-Modul)                         |
  |-------------------------------------------------------------------------|
  | Importe:  Das Modul Eins importiert die von POW! bereitgestellten       |
  |           Module In und Out (Oakwood Guidelines). Damit werden Proze-   |
  |           duren fr Ein- und Ausgabeanweisungen bereitgestellt.         |
  | Leistung: Einlesen von Zahlen, die vom Anwender mittels Tastatur einge- |
  |           gebenen werden. Verarbeitung (Addition) und Ausgabe des Er-   |
  |           gebnisses am Bildschirm. Einlesen und Anzeigen eines Textes.  |
  |           Speichern der Eingaben (inputstream) in einer Textdatei.      |
  |           Einlesen der gespeicherten Daten, erneute Verarbeitung (Sub-  |
  |           traktion) und Ausgabe des Ergebnisses am Bildschirm. Die Zei- |
  |           chenkette wird ebenfalls ausgegeben.                          |
  |-------------------------------------------------------------------------|
  | Hinweise: Der krzeste Weg zur Einsichtnahme in die Leistungsmerkmale   |
  |           der Module In und Out:                                        |
  |           Klick mit der  r e c h t e n  Maustaste auf eines der beiden  |
  |           Wrter in der IMPORT-Zeile. Es ffnet sich die kontextsensi-  |
  |           tive Hilfe, die alle Erluterungen der im Modul verfgbaren   |
  |           Anweisungen enthlt.                                          |
  |                                                                         |
  | POW!:     Pow! = Programmers Open Workbench!                            |
  |                                                                         |
  | Hilfe:    < F1 >:          ffnen des POW!-Hilfe-Index                  |
  |           < Alt >+< F1 >:  Oberon Hilfeindex                            |
  |           < Strg >+< F1 >: Suchen nach Themen oder Schlsselwrtern:    |
  |           schneller:       Cursor auf ein Schlsselwort setzen,         |
  |                            < rechte Maustaste > drcken: automatisches  |
  |                            ffnen der kontextsensitive Hilfe oder des   |
  |                            Oberon Hilfeindex', falls das Schlsselwort  |
  |                            nicht korrekt geschrieben ist                |
  |-------------------------------------------------------------------------|
  |             2001  Manfred Kmmerer, Chamberlain-Soft JENA              |
  *-------------------------------------------------------------------------*)

 MODULE Eins;
 
  IMPORT In, Out;                    (* Imort der Standardmodule In und Out *)


 (* ---------------------  U N T E R P R O G R A M M ---------------------- *)


  PROCEDURE Erste;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe einer Arbeitsanweisung, Einlesen von zwei ganzen    |
    |           Zahlen, die mittels Tastatur eingegeben wurden, Berechnen   |
    |           der Summe und Ausgabe dieser, in eine Zeichenkette geklei-  |
    |           det, am Monitor.                                            |
    *-----------------------------------------------------------------------*)

    VAR a, b, ergebn : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('  Bitte zwei ganze Zahlen eingeben und jede Eingabe');
      Out.Ln;
      Out.String('  durch Bettigen der Enter-Taste abschlieen!'); Out.Ln;
      In.Prompt('1. ganze Zahl ( a )'); (* Beschriftung, die links neben    *)
                                        (* dem Eingabefenster erscheint     *)
      In.Int(a);
      In.Prompt('2. ganze Zahl ( b )');
      In.Int(b);
      ergebn:= a + b;
      Out.Ln;
      Out.String('    Berechnen:    a + b = '); Out.Int(ergebn,1); Out.Ln
    END Erste;


  PROCEDURE Zweite;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe einer Arbeitsanweisung, Einlesen einer maximal 25   |
    |           Zeichen umfassenden Zeichenkette, die mittels Tastatur ein- |
    |           gegeben wurden, Ausgabe dieser Zeichenkette am Monitor      |
    |           (Kontrollausgabe)                                           |
    *-----------------------------------------------------------------------*)

    VAR zeichenkette : ARRAY 26 OF CHAR;
                                     (* kann 25 druckbare Zeichen aufnehmen *)
    BEGIN
      Out.Ln;
      Out.String('  Bitte eine Zeichenkette eingeben und durch'); Out.Ln;
      Out.String('  Bettigen der Enter-Taste abschlieen!'); Out.Ln; Out.Ln;
      In.Prompt('max. 25 Zeichen');  (* Beschriftung, die links neben dem   *)
                                     (* Eingabefenster erscheint            *)
      In.String(zeichenkette);
      Out.String('    Zeichenkette: '); Out.String(zeichenkette); Out.Ln
    END Zweite;


  PROCEDURE Linie;
   (*-----------------------------------------------------------------------*
    | Leistung: Darstellen einer waagerechten Volllinie. Das Darstellen     |
    |           einer gepunktete Linie ist vorbereitet.                     |
    *-----------------------------------------------------------------------*)

    VAR i : INTEGER;

    BEGIN
      Out.Ln; Out.Char(' ');
      FOR i:= 1 TO 56 DO Out.Char('') END;
            (* '' = <Alt> + <0><1><7><5> auf dem Nummernblock der Tastatur *)
            (* '' = <Alt> + <0><1><6><8> auf dem Nummernblock der Tastatur *)
      Out.Ln
    END Linie;


  PROCEDURE Speichern;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe einer Arbeitsanleitung, Warten auf die geforderte   |
    |           Eingabe mittels Tastatur, Aufruf des Unterprogramms Linie   |
    |           und Anzeige einer Besttigungsmeldung am Monitor.           |
    *-----------------------------------------------------------------------*)

    VAR dummy : CHAR;
    
    BEGIN
      Linie;
      Out.String('  Arbeitsanleitung zum Speichern des Eingabestroms:');
      Out.Ln;  Out.Ln;
      Out.String('    Men:   Pane                     (Mausklick)'); Out.Ln;
      Out.String('    Option: save input to file...    (Mausklick)'); Out.Ln;
      Out.String("    Datei:  'eins.txt'               ( <Enter> )"); Out.Ln;
      Out.Ln;
      Out.String('  Nach dem Speichern bitte ein Leerzeichen eingeben ');
      Out.Ln;
      Out.String('  und die Enter-Taste bettigen!'); Out.Ln;
      In.Prompt('Ohne Eingabe!');
      In.Char(dummy);
      Linie;
      Out.String('  Die Textdatei wurde angelegt und die Daten geschrieben.');
      Out.Ln
    END Speichern;


  PROCEDURE Dritte;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe einer Frage am Monitor, Einlesen einer alternativen |
    |           Antwort, die mittels Tastatur eingegeben wurde, ggf. Wand-  |
    |           lung des eingelesenen Buchstaben in einen Grobuchstaben.   |
    |           Falls das eingelesene Zeichen nach der Konvertierung der    |
    |           Grobuchstabe J ist, wird das Unterprogramm Laden aufgeru-  |
    |           fen, die Differenz der beiden aus der Textdatei eingelese-  |
    |           nen ganzen Zahlen gebildet, diese, in eine Zeichenkette ge- |
    |           setzt und ausgegeben. Anschlieend wird noch die ebenfalls  |
    |           aus der Textdatei eingelesene Zeichenkette am Monitor ange- |
    |           zeigt.                                                      |
    *-----------------------------------------------------------------------*)

    VAR zeichenkette : ARRAY 26 OF CHAR;
        zeichen      : CHAR;
        a, b, ergebn : INTEGER;

    PROCEDURE Laden;
     (**
      | Leistung: Aufruf des Unterprogramms Linie, Ausgabe einer Arbeitsan- |
      |           leitung, Einlesen von zwei INTEGER-Werten aus der Textda- |
      |           tei, Einlesen einer Zeichenkette, die maximal 25 Zeichen  |
      |           enthlt ebenfalls aus dieser Textdatei, erneuter Aufruf   |
      |           des UP Linie und Anzeige einer Besttigungsmeldung am Mo- |
      |           nitor.                                                    |
      **)

      BEGIN
        Linie;
        In.Prompt('Ohne Eingabe!');
        Out.String('  Arbeitsamleitung zum Lesen der Daten aus einer Datei:');
        Out.Ln;  Out.Ln;
        Out.String('    Men:   Pane                     (Mausklick)');
        Out.Ln;
        Out.String('    Option: read input from file...  (Mausklick)');
        Out.Ln;
        Out.String('    Pfad:   ...\quelltext            (Doppelklick)');
        Out.Ln;
        Out.String('    Datei:  eins.txt ffnen          (Doppelklick)');
        Out.Ln;
        In.Int(a);
        In.Int(b);
        In.String(zeichenkette);
        Linie;
        Out.String('  Der Inhalt der Textdatei wurde gelesen und den');
        Out.Ln;
        Out.String('  Variablen a, b und zeichenkette zugewiesen.'); Out.Ln;
      END Laden;

    BEGIN  (* Dritte *)
      Out.String('  Sollen die Daten wieder eingelesen werden?'); Out.Ln;
      In.Prompt('Daten lesen (J/N)');
      In.Char(zeichen);
      zeichen:= CAP(zeichen);  (* Kleinbuchstaben in Grobuchstaben wandeln *)
      IF zeichen # 'N' THEN    (* # = relationale Ungleichheit              *)
        Laden;
        ergebn:= a - b;
        Out.Ln;
        Out.String('    Berechnen:     a - b = '); Out.Int(ergebn,1); Out.Ln;
        Out.Ln;
        Out.String('    Zeichenkette: '); Out.String(zeichenkette); Out.Ln;
        Out.Ln
      END
    END Dritte;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Erste;
      Zweite;
      Speichern;
      Dritte
    END ProgMain;


 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;                   (* Die Initialisierung des In- und Out-Moduls *)
   Out.Open                   (* kann weggelassen werden!                   *)
 END Eins.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

