
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)            Dateiname: FOR01.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Januar 2001 Version: V 2.0                  |
  |-------------------------------------------------------------------------|
  | Thema:    Wiederholungen: Die Zhlschleife (FOR-Anweisung)              |
  |-------------------------------------------------------------------------|
  | Anliegen: Schwarz-Wei-Grafik als Einfhrungsbeispiel                   |
  |           Verdeutlichen der Wirkungsweise der Zhlschleife (aufwrts-   |
  |           zhlend und abwrtszhlend). Es wird gezeigt, wie die Lauf-   |
  |           variable der Schleife genutzt wird.                           |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Programm ist fr den Grafikmodus 800 x 600 Pixel         |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)

 MODULE For01;
 
  IMPORT C:= ColorPlane, W:= Window;
 
  CONST  dTime = 150;

  VAR    dummy : BOOLEAN; 


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Delay_ms ( msec : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Eine bestimmte Zeit warten.                                 |
    *-----------------------------------------------------------------------*)

    VAR startzeit, zielzeit : LONGINT;

    BEGIN
      startzeit:= W.GetTickCount(); 
      REPEAT
        zielzeit:= W.GetTickCount()
      UNTIL zielzeit > startzeit + msec 
    END Delay_ms;


  PROCEDURE Enter;
    BEGIN
      Delay_ms(dTime*5);
      C.GotoXY(660,45); C.WriteStr('<ENTER >')
    END Enter;

     
  PROCEDURE Beschriften ( x, y : INTEGER; Text : ARRAY 35 OF CHAR );
   (*-----------------------------------------------------------------------*
    | bernahme: x- und y-Koordinate und auszugebender Text (Zeichenkette)  |
    | Leistung:  Positionierte Ausgabe einer Zeichenkette.                  |
    *-----------------------------------------------------------------------*)

    BEGIN
      Delay_ms(dTime);
      C.GotoXY(x,y); C.WriteStr(Text);
      Delay_ms(dTime*2)
    END Beschriften;
 
 
  PROCEDURE Schleife_aufsteigend ( Ew : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Endwert fr die Zhlschleife                               |
    | Leistung:  Ausgabe einer Linienschar mit gemeinsamen Endpunkt.        |
    |            Beschriften der kleinen Grafik mit dem Anfangs- und End-   |
    |            wert der Laufvariable.                                     |
    *-----------------------------------------------------------------------*)

    VAR i : INTEGER;
 
    BEGIN
      Beschriften(156,105,'0');
 
      (* -----  Zhlschleife aufwrts  ----- *)
 
      FOR i:= 0 TO Ew DO
        C.Line(170,100+6*i,600,100,C.DRAW);
        Delay_ms(dTime DIV 4)   
      END;
 
      (* ----------------------------------- *)
     
      Delay_ms(dTime);
      Beschriften(148,410,'50');
      Delay_ms(dTime);
      Beschriften(233,390,'aufsteigend');
      (* Ch.Enter(660,45,V.Cyan,BkColor,FALSE,dTime) *)
    END Schleife_aufsteigend;
 
 
  PROCEDURE Schleife_absteigend ( Ew : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Endwert fr die Zhlschleife                               |
    | Leistung:  Ausgabe einer Linienschar mit gemeinsamen Startpunkt.      |
    |            Beschriften der kleinen Grafik (Wert der Laufvariable).    |
    *-----------------------------------------------------------------------*)

    VAR i : INTEGER;
 
    BEGIN
      Beschriften(605,410,'50');
      Delay_ms(dTime DIV 4);
     
      (* -----  Zhlschleife abwrts  ------ *)
     
      FOR i:= Ew TO 0 BY -1 DO
        C.Line(170,100,600,100+6*i,C.DRAW);
        Delay_ms(dTime DIV 8)
      END;
     
      (* ----------------------------------- *)
     
      Delay_ms(dTime);
      Beschriften(612,105,'0');
      Delay_ms(dTime);
      Beschriften(461,390,'absteigend');
      Enter
    END Schleife_absteigend;
 

 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

 PROCEDURE ProgMain*;
   
   CONST Endwert = 50;
     
   BEGIN
     Beschriften(260,480,'Wiederholungen: Die Zhlschleife');
     Schleife_aufsteigend(Endwert);
     Schleife_absteigend(Endwert);
     REPEAT UNTIL C.KeyPressed();
     C.Close                                         (* Malkasten schlieen *)
   END ProgMain;


 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   C.Open;                                           (* Malkasten ffnen    *)
   dummy:= W.ShowWindow(W.GetActiveWindow(),3);      (* groes Fenster      *)
 END For01.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

