
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 (16 Bit)                File-Name: LINIEN.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: 23.-30.12.1998 Version: V 1.0               |
  |           Letzte nderung:  August 2001 Version: V 2.1                  |
  |-------------------------------------------------------------------------|
  | Thema:    Ausgabe mehrerer Liniengrafiken in Farbe,                     |
  |           Programmieren eines komplexeren Programms unter Nutzung       |
  |           von Anweisungen (Prozeduren) eines Service-Moduls,            |
  |           Anwenden der Datentypen REIHUNG und VERBUND                   |
  |-------------------------------------------------------------------------|
  | Anliegen: I d e e n b  r s e  fr Liniengrafiken                       |
  |-------------------------------------------------------------------------|
  | Aufgabe:  Quelltextanalyse ( ... oder: lassen Sie die Seele baumeln!)   |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Programm ist fr den Grafikmodus 800 x 600 Pixel         |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |           Das Beenden des Programms kann durch Bettigen der Enter-     |
  |           taste oder durch Mausklick auf das abschlieende < Enter >    |
  |           erfolgen.                                                     |
  |-------------------------------------------------------------------------|
  |            1998/01  Manfred Kmmerer, Chamberlain-Soft JENA            |
  *-------------------------------------------------------------------------*)

 MODULE Linien;
   
  IMPORT Ch:= ChSTools;

  CONST  dTime   = 75;

         message = 'Datentypen: REIHUNG und VERBUND';
         year    = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)
   

  PROCEDURE Loeschen ( Flag : BOOLEAN; bkColor : Ch.tColor );
    BEGIN
      IF Flag THEN 
        Ch.Delay_ms(dTime);
        Ch.Enter(660,45,Ch.Cyan,bkColor,FALSE,dTime)
      END;
      Ch.SetBackColor(41,44,46);
      Ch.Bar(190,68,594,448,Ch.ERASE);
      Ch.SetForeColorNb(8);
      Ch.Box(195,73,589,443,Ch.DRAW)
    END Loeschen;


  PROCEDURE Berechne_und_zeichne ( Offs, r : REAL );

    CONST xM = 392;  yM = 265;

    VAR   i, k,
          x, y, x1,
          x2, y1, y2 : INTEGER;
          alpha      : REAL;
          p          : Ch.tPoint;

    BEGIN
      alpha:= Offs;
      FOR k:= 1 TO 14 DO
        Ch.SetForeColor(k*18,40,k*4+90);
        Ch.CalculatePoint(p,xM,yM,r,alpha);
        x1:= p.x; y1:= p.y;
        FOR i:= 1 TO 3 DO
          alpha:= alpha + SHORT(Ch.Pi)/1.5;
                      (*SHORT: Argumenttyp LONGINT, Ergebnistyp INTEGER*)           
          p.x:= x1; p.y:= y1;
          Ch.CalculatePoint(p,xM,yM,r,alpha);
          x2:= p.x; y2:= p.y;
          Ch.Line(x1,y1,x2,y2,Ch.DRAW);
          x1:= x2; y1:= y2
        END;
        alpha:= alpha + 0.033 * SHORT(Ch.Pi)/1.5;   (* + 0.02 .. 0.072  *)
      END 
    END Berechne_und_zeichne;
 

  PROCEDURE Polygone;

    TYPE  tPolygonDaten = RECORD
                            max    : INTEGER;
                            teiler : REAL;
                            subtr  : REAL;
                            flag   : BOOLEAN
                          END;


    CONST xM      = 392;
          yM      = 265;

          offset  = SHORT(Ch.Pi + 0.19);
                    (* Pi+0.1875 oder Pi+0.7999 diese Summanden verndert *)
                    (*                   den Startpunkt fr die Garphiken *)

    VAR   p       : ARRAY 13 OF tPolygonDaten;
          bild, i : INTEGER;
          x1, x2  : INTEGER;
          y1, y2  : INTEGER;
          alpha,
          radius  : REAL;
          point   : Ch.tPoint;

    BEGIN
      p[1].max :=  110;  p[1].teiler :=  2.012;  p[1].subtr := 1.5 ;  p[1].flag := FALSE;
      p[2].max :=  125;  p[2].teiler :=  1.66 ;  p[2].subtr := 1.25;  p[2].flag := TRUE;
      p[3].max :=  110;  p[3].teiler :=  2.025;  p[3].subtr := 1.5 ;  p[3].flag := FALSE;
      p[4].max :=  192;  p[4].teiler :=  2.48 ;  p[4].subtr := 0.85;  p[4].flag := TRUE;
      p[5].max :=  125;  p[5].teiler :=  1.48 ;  p[5].subtr := 1   ;  p[5].flag := FALSE;
      p[6].max :=  165;  p[6].teiler :=  2.025;  p[6].subtr := 1   ;  p[6].flag := TRUE;
      p[7].max :=  156;  p[7].teiler :=  1.6  ;  p[7].subtr := 1   ;  p[7].flag := FALSE;
      p[8].max := 1560;  p[8].teiler :=  10.1 ;  p[8].subtr := 0.1 ;  p[8].flag := TRUE;
      p[9].max :=  125;  p[9].teiler :=  1.66 ;  p[9].subtr := 1.25;  p[9].flag := FALSE;
      p[10].max:=  315;  p[10].teiler:=  2.48 ;  p[10].subtr:= 0.5 ;  p[10].flag:= TRUE;
      p[11].max:=  125;  p[11].teiler:=  2.48 ;  p[11].subtr:= 1   ;  p[11].flag:= FALSE;
      p[12].max:=  320;  p[12].teiler:=  2.025;  p[12].subtr:= 0.5 ;  p[12].flag:= TRUE;
      
      Loeschen(FALSE,Ch.bkColor);
      FOR bild:= 1 TO 12 DO
        Ch.SetForeColorNb(Ch.LightCyan);
        alpha:= offset;
        radius:= 155;
        FOR i:= 1 TO p[bild].max DO
          Ch.CalculatePoint(point,xM,yM,radius,alpha);
          x1:= point.x; y1:= point.y;
          IF p[bild].flag THEN
            Ch.SetForeColorNb(Ch.LightCyan);
            IF (i-1) MOD 5 = 0
              THEN Ch.SetForeColorNb(Ch.LightGreen)
            ELSIF i MOD 5 = 0 THEN
              Ch.SetForeColorNb(Ch.White)
            ELSIF (i+1) MOD 5 = 0 THEN
              Ch.SetForeColorNb(Ch.Yellow)
            ELSIF (i+2) MOD 5 = 0 THEN
              Ch.SetForeColorNb(Ch.Green)
            ELSE
              Ch.SetForeColorNb(Ch.Cyan)
            END
          ELSE
            Ch.SetForeColorNb(Ch.White)
          END;
          IF i MOD 2 = 0 THEN
            Ch.Line(x1,y1,x2,y2,Ch.DRAW);
            x1:= x2; y1:= y2
          ELSE  
            x2:= point.x; y2:= point.y 
          END;
          Ch.Delay_ms(2);
          alpha:= alpha + SHORT(Ch.Pi)/p[bild].teiler;
          radius:= radius - p[bild].subtr
        END;
        Loeschen(TRUE,Ch.bkColor)
      END
    END Polygone;


  PROCEDURE Abspann;
    BEGIN
      Ch.SetBackColorRec(Ch.bkColor);
      Ch.Bar(180,550,600,60,Ch.ERASE);
      Ch.SetForeColorNb(8);
      Ch.Box(210,445,570,100,Ch.DRAW);
      Berechne_und_zeichne(SHORT(Ch.Pi)*0.02+0.8555,155);
      Ch.SetForeColorNb(Ch.LightGreen);
      Ch.WriteStrXY(330,285,'Chamberlain-Soft');
      Ch.WriteStrXY(368,265,'J E N A');
      Ch.WriteStrXY(381,235,'2001');
      Ch.Delay_ms(dTime);
      Ch.Enter(660,45,Ch.Cyan,Ch.bkColor,FALSE,dTime)
    END Abspann;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)
 
 PROCEDURE ProgMain*;
   BEGIN
     Ch.Title(Ch.LightCyan,500,dTime,Ch.bkColor,
                     'Beispiele fr kleine Liniengraphiken',FALSE);
     Polygone;
     Abspann;
     Ch.InformationChS(Ch.bkColor,'2001',-384,-242);
     Ch.Close
   END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Ch.InitiateColorPlane(Ch.bkColor,0,0,32);   (* Malkasten ffnen und gro- *)
                                               (* es Fenster einstellen    *)
   Ch.HeadLine(message,year);                  (* Eintrag in die Bildleiste *)
   Ch.Delay_ms(500)
 END Linien.  

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)
