
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)          Dateiname: WHILE01.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Januar 2001 Version: V 2.0                  |
  |-------------------------------------------------------------------------|
  | Thema:    Wiederholungen: Schleife mit Eintrittsbedingung               |
  |                           (Schleife mit vorangestelltem Test,           |
  |                           die WHILE-Anweisung)                          |
  |-------------------------------------------------------------------------|
  | Anliegen: Das Programm demonstriert innerhalb der graphischen Darstel-  |
  |           lung die WHILE-Anweisung: SOLANGE Bedingung TUE ...           |
  |-------------------------------------------------------------------------|
  | Aufgabe:  Schreiben Sie ein Oberon-2-Programm, welches in einer Proze-  |
  |           dur oder einem Service-MODUL eine WHILE-Anweisung zum Zeich-  |
  |           nen eines Kegels oder verschachtelter Rechtecke enthlt.      |
  |           Speichern Sie dieses Programm unter dem Namen WILEUEB1.MOD    |
  |           in das Ihnen zugewiesene Verzeichnis!                         |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Programm ist fr den Grafikmodus 800 x 600 Pixel         |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |           Das Fortsetzen des Programms kann durch Bettigen der Enter-  |
  |           taste oder durch Mausklick auf das abschlieende < Enter >    |
  |           erfolgen.                                                     |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)

 MODULE WHILE01;
 
  IMPORT Ch:= ChSTools;
 
  CONST  dTime = 125;

         message   = 'ITERATION  (Schleifen)';
         year      = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)

 
 PROCEDURE Muster;
 (*-------------------------------------------------------------------------*
  | bernahme: RGB-Werte fr die Hintergrundfarbe (Wertparameter)            |
  | Leistung:  Positionierte farbige Ausgabe einer Liniengraphik unter       |
  |            Nutzung der Schleife mit Eintrittsbedingung.                  |
  *-------------------------------------------------------------------------*)

     VAR   alpha      : REAL;
           r, teiler,
           xOffset, 
           xM, yM,
           i, x, y    : INTEGER;
           farbe      : Ch.tColor;
           p          : Ch.tPoint;

     BEGIN
       alpha  :=   0;  r      :=  10; 
       teiler :=  32;  xOffset:=  48;
       xM     := 350;  yM     := 330;
       farbe.r:= 255;  farbe.g:= 200;
       farbe.b:=  60;
       
     (* -------------  Schleife mit Eintrittsbedingung  -------------- *)

       WHILE alpha < 2.06 * Ch.Pi DO  
         Ch.CalculatePoint(p,xM,yM,r,alpha);
         Ch.SetForeColorRec(farbe);
         Ch.Line(p.x-xOffset,p.y-xOffset,p.x,p.y,Ch.DRAW);
         Ch.Delay_ms(dTime DIV 10);
         DEC(farbe.r); 
         DEC(farbe.g); 
         farbe.b:= farbe.b + r MOD 2;
         INC(r);
         alpha:= alpha + SHORT(Ch.Pi / (3 * teiler))
       END; (* While *)
       
     (* -------------------------------------------------------------- *) 

       Ch.FlushKeyBuffer;
       Ch.Enter(660,45,Ch.Cyan,Ch.bkColor,FALSE,dTime*3)
     END Muster;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

 PROCEDURE ProgMain*();

   CONST text = 'Wiederholungen: Die WHILE-Anweisung';

   VAR farbe : Ch.tColor;

   BEGIN
     Ch.GetDot(10,10,farbe.r,farbe.g,farbe.b);
     IF farbe.r > 32 THEN
       Ch.Title(Ch.Black,490,dTime*5,Ch.bkColor,text,FALSE)
     ELSE
       Ch.Title(Ch.LightCyan,490,dTime*5,Ch.bkColor,text,FALSE)
     END;
     Ch.Delay_ms(dTime);
     Muster;
     Ch.Close                                         (* Malkasten schlieen *)
   END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
  (* Ch.InitiateColorPlane(Ch.bkColor,0,0,32); *)
   Ch.InitiateColorPlane(Ch.bkColor,255,255,220);
                                               (* Malkasten ffnen und gro- *)
                                               (* es Fenster einstellen    *)
   Ch.HeadLine(message,year);                  (* Eintrag in die Bildleiste *)
   Ch.Delay_ms(500)
 END WHILE01.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

