
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: SCHNECKE.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Februar 2001 Version: V 1.1                 |
  |-------------------------------------------------------------------------|
  | Thema:    Fortgeschrittene - Programmierung in OBERON-2 POW!            |
  |           Anwenden des User-Moduls LogoGraf zum Erstellen einfacher     |
  |           Grafiken unter Anwendung rekursiver Algorithmen.              |
  |-------------------------------------------------------------------------|
  | Leistung: Darstellen eines stilisierten Nautilushorns auf hellem und    |
  |           einer stilisierten Schnecke auf dunklem Hintergrund.          |
  |           Durch geringfgige nderungen im Quelltext, knnen andere     |
  |           Polygone (n-Ecke, Kreise) dargestellt werden.                 |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Programm ist fr den Grafikmodus 800 x 600 Pixel         |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)

 MODULE Schnecke;

  IMPORT L:= Logograf;

  CONST  dTime   = 25;

         message = 'REKURSION';
         year    = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Ueberschrift ( x, y : INTEGER; text : L.tStr75 );
   (*-----------------------------------------------------------------------*
    | bernahme: x- und y-Koordinate (x, y) fr die berschrift, die Vari-  |
    |            able text enthlt den Wortlaut                             |
    | Leistung:  Positionierte farbige Ausgabe der berschrift              |
    *-----------------------------------------------------------------------*)

    BEGIN
      L.SetPenColor(160,160,160);
      L.WriteStrXY(x,y,text)
    END Ueberschrift;


  PROCEDURE Polygon ( laenge, n : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Lnge einer Teilstrecke des Polygonumfangs (laenge) und    |
    |            Anzahl der Ecken (n)                                       |
    | Leistung:  In n Schritten, bei groen Kreisen sollten es 72 sein, bei |
    |            kleineren Kreisen 36 oder weniger, wird aus kleinen Teil-  |
    |            strecken ein n-Eck (n > 2, Polygon) oder ein Kreis zusam-  |
    |            mengesetzt.                                                |
    *-----------------------------------------------------------------------*)

    VAR i : INTEGER;
        w : REAL;

    BEGIN
      w:= 360/n;
      FOR i:= 1 TO n DO
        L.Forward(2*3.1415926*laenge/n);
        L.TurnRight(w)
      END;
    END Polygon;


  PROCEDURE Schnecke ( laenge : INTEGER; darkFlag : BOOLEAN );
    BEGIN
      IF laenge > 0 THEN                  (* Abbruchbedingung fr die Re-   *)
                                          (* kursion (den Selbstaufruf)     *)
        IF (laenge MOD 3 = 0) & darkFlag THEN
          L.SetPenColor(128,128,200)
        ELSIF ODD(laenge) THEN
          L.SetPenColor(169,169,0)
        ELSE
          L.SetPenColor(220,220,0)
        END;
        IF darkFlag THEN
          Polygon(laenge,4);
          L.Backward(10);
          L.TurnRight(8);
          Schnecke(laenge-2,darkFlag)     (* rekursiver Aufruf der Prozedur *)
                                          (* mit verndertem Parameter n    *)
        ELSE
          Polygon(laenge,36);
          L.TurnRight(10);
          Schnecke(laenge-5,darkFlag)     (* rekursiver Aufruf der Prozedur *)
                                          (* mit verndertem Parameter n    *)
        END
      END;
    END Schnecke;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      L.ClearScreen(255,255,232);        (* BS-Lschen, aktuelle Parameter: *)
      Ueberschrift(96,492,'N a u t i l u s h o r n');
                                         (* RGB-Werte der Hintergrundfarbe  *)
      L.Delay_ms(dTime*15);              (* 375 ms warten                   *)
      L.Init(300,310);                   (* Turtle an den Punkt P(320|310)  *)
      Schnecke(160,FALSE);               (* Liniengrafik darstellen         *)
      L.Enter(dTime);                    (* Eingabeaufforderung ausgeben    *)
                                         (* und Tastenbettigung auf der    *)
                                         (* Tastatur abwarten               *)
      L.ClearScreen(8,0,32);
      Ueberschrift(96,492,'Schnecke (symbolische)');
      L.Init(400,300);
      Schnecke(88,TRUE);
      L.Enter(dTime);
      L.Close
    END ProgMain;


 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   L.InitiateTurtleGraphic(L.screenCol,255,255,232);
                                         (* Malkasten ffnen und groes     *)
                                         (* Fenster einstellen              *)
   L.HeadLine(message,year);             (* Eintrag in die Bildleiste       *)
 END Schnecke.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)
