
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)           Dateiname: CASE02.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Februar 2001 Version: V 2.0                 |
  |-------------------------------------------------------------------------|
  | Thema:    Fallunterscheidung: Mehrfache Auswahl, die CASE-Anweisung     |
  |-------------------------------------------------------------------------|
  | Anliegen: Dieses Programm demonstriert die Anwendung der mehrfachen     |
  |           Auswahl (FALLWEISE selektor ...).                             |
  |           Statt Anweisungsblcken stehen Prozeduraufrufe in den Anwei-  |
  |           sungsteilen hinter den Marken (labels).                       |
  |-------------------------------------------------------------------------|
  | Aufgaben: Probieren Sie alle Wahlmglichkeiten.                         |
  |           Schreiben Sie ein Oberon-2-Programm, das die Prozeduren, die  |
  |           fr das Darstellen der verschiedene Figuren (Liniengrafiken)  |
  |           bentigt werden, in ein Service-Modul 'verbannt'.             |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)

 MODULE Case02;
 
  IMPORT Ch:= ChSTools, S:= Strings;
 
  CONST  dTime   = 75;

         message = 'SELEKTION  (Auswahl)';
         year    = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Key() : INTEGER;
   (*-----------------------------------------------------------------------*
    | Referenz: Funktionswert, mittels Tastatur eingegebener Wert           |
    | Leistung: Positionierte Ausgabe einer Zeichenkette, Einlesen eines    |
    |           mittels Tastatur eingegebenen Zeichens.                     |
    |           Auswertung: Wird die Enter- oder die Esc-Taste bettigt,    |
    |           wird die Variable aChar (Zeichenfolge) mit '1' belegt.      |
    |           Wird eine Ziffer eingegeben, die der Austrittsbedingung der |
    |           Schleife gengen, folgt die Konvertierung des Zeichens in   |
    |           einen INTEGER-Wert.                                         |
    *-----------------------------------------------------------------------*)

    VAR aChar    : Ch.tStr75;
        resCode  : CHAR;
        kennzahl : INTEGER;
       
    BEGIN
      Ch.SetForeColorNb(Ch.Yellow);
      Ch.GotoXY(209,70);
      Ch.WriteStr('Bitte eine Kennziffer (1..4) eingeben! Ziffer = ');
     
     (* ---  Schleife mit Austrittsbedingung  --- *)

      REPEAT
        Ch.Bar(593,70,601,56,Ch.ERASE);
        Ch.GotoXY(593,70);
        Ch.ReadStr(aChar,1,resCode);
        IF (aChar = '') & (resCode = Ch.ENTER) OR (resCode = Ch.ESC) THEN 
          aChar:= '1';
          Ch.WriteStr('1');
          Ch.Delay_ms(dTime)
        END;
        IF (aChar > '0') & (aChar < '5') THEN
          kennzahl:= SHORT(S.Val(aChar))
        END
      UNTIL (kennzahl > 0) & (kennzahl < 5);

     (* ----------------------------------------- *)

      RETURN kennzahl
    END Key;
 
 
  PROCEDURE Kennzahl () : INTEGER;
   (*-----------------------------------------------------------------------*
    | Referenz: Funktionswert, mittels Tastatur eingegebener Wert           |
    | Leistung: Positionierte Ausgabe einer Zeichenkette, die in Abhngig-  |
    |           keit der mittels Tastatur eingegebenen Ziffer (kennziffer)  |
    |           komplettiert und ausgegeben wird.                           |
    *-----------------------------------------------------------------------*)

    VAR zeichenkette : Ch.tStr75;
        ziffer       : ARRAY  4 OF CHAR;
        kennzahl     : INTEGER;

    BEGIN
      zeichenkette:= 'Sie haben das Bild   gewhlt.';
      ziffer[1]:= '1';
      ziffer[2]:= '2';
      ziffer[3]:= '3';
      kennzahl:= Key();
      Ch.Bar(188,56,601,70,Ch.ERASE);
      S.Delete(zeichenkette,20,1);

     (* ---  geschachtelte zweiseitige statt mehrseitiger Auswahl  --- *)

      IF kennzahl = 1 THEN S.InsertChar(ziffer[1],zeichenkette,20)
        ELSIF kennzahl = 2 THEN S.InsertChar(ziffer[2],zeichenkette,20)
          ELSE S.InsertChar(ziffer[3],zeichenkette,20)
      END;

     (* -------------------------------------------------------------- *)

      IF kennzahl # 4 THEN
        Ch.SetForeColorNb(Ch.Green);
        Ch.GotoXY(280,70); Ch.WriteStr(zeichenkette)
      END;
      RETURN kennzahl
    END Kennzahl;


  PROCEDURE Rosette;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe einer farbigen Rosette, die aus einem zusammenhn-  |
    |           genden Linienzug besteht.                                   |
    *-----------------------------------------------------------------------*)

    CONST xM = 390;  yM = 280;

    VAR alpha, i, r, w : INTEGER;
        VAR p          : Ch.tPoint;


    BEGIN
      w:= 0;
      r:= 160;
      Ch.Delay_ms(dTime);
      Ch.SetForeColorNb(Ch.LightRed);
      Ch.GotoXY(416,285);
      FOR i:= 1 TO 144 DO
        Ch.CalculatePoint(p,xM,yM,r,w);
        IF i = 73 THEN
          Ch.SetForeColorNb(Ch.Yellow);
        END;
        Ch.LineTo(p.x,p.y,Ch.DRAW);
                                (* Zeichnen eines geschlossenen Linienzuges *)
        Ch.Delay_ms(dTime DIV 8);
        w:= w + Ch.RoundLongReal(Ch.Pi*35);
        DEC(r)
      END
    END Rosette;


  PROCEDURE Polygonschar;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe von 36 farbigen Polygonen (Neunecken), deren Farbe  |
    |           zwischen Wei und hellem Rot alterniert.                    |
    *-----------------------------------------------------------------------*)

    CONST time = 25;
    VAR   i    : INTEGER;

    BEGIN
      Ch.Delay_ms(dTime);
      FOR i:= 1 TO 36 DO
        IF ODD(i) THEN
          Ch.SetForeColorNb(Ch.Yellow)
        ELSE
          Ch.SetForeColorNb(Ch.Cyan)
        END;
        Ch.Polygone(Ch.DRAW,9,220+6*i,135+4*i,5+4*i);
        Ch.Delay_ms(dTime DIV 3)
      END
    END Polygonschar;


  PROCEDURE Liniengrafik ( offset, r : REAL );
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe von zweimal sieben farbigen Dreiecken, deren Ecken  |
    |           auf der Peripherie eines Kreises angeordnet sind.           |
    *-----------------------------------------------------------------------*)

    CONST xOffset = 400;
          yOffset = 250;
          xM      = 390;
          yM      = 270;

    VAR   i, k, n,
          x, y, x1, 
          x2, y1, y2 : INTEGER;
          alpha      : REAL;
          p          : Ch.tPoint;

    BEGIN
      alpha:= offset;
      FOR k:= 1 TO 14 DO
        Ch.SetForeColorNb(k);
        Ch.CalculatePoint(p,xM,yM,r,alpha);
        x1:= p.x; y1:= p.y;
        FOR i:= 1 TO 3 DO
          alpha:= alpha + SHORT(Ch.Pi)/1.5;
          Ch.CalculatePoint(p,xM,yM,r,alpha);
          x2:= p.x; y2:= p.y;
          Ch.Line(x1,y1,x2,y2,Ch.DRAW);
          Ch.Delay(dTime * 4);
          x1:= x2; y1:= y2
        END;
        alpha:= alpha + 0.033 * SHORT(Ch.Pi)/0.02;
        Ch.Delay_ms(dTime DIV 3)
      END
    END Liniengrafik;


  PROCEDURE OhneGrafik;
    BEGIN
      Ch.SetForeColorNb(Ch.LightRed);
      Ch.GotoXY(217,250);
      Ch.WriteStr('Fr diese Kennzahl ist keine Grafik vorgesehen.');
      Ch.Enter(660,45,Ch.Cyan,Ch.bkColor,FALSE,dTime);
      Ch.Bar(209,250,593,236,Ch.ERASE)
    END OhneGrafik;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

 PROCEDURE ProgMain*;
   
   VAR kennzahl : INTEGER;

   BEGIN
     Ch.Title(Ch.LightCyan,490,dTime,Ch.bkColor,
              'Fallunterscheidung: Die mehrfache Auswahl mit ANSONSTEN-Zweig',
              FALSE);
     REPEAT
       kennzahl:= Kennzahl();
  
     (* ------  mehrfache Auswahl mit ANSONSTEN-Zweig -------- *)
  
       CASE kennzahl OF
         1: Rosette
       | 2: Polygonschar
       | 3: Liniengrafik(0.52,160)
       ELSE
         OhneGrafik
       END;
  
     (* ------------------------------------------------------ *)
  
       IF kennzahl # 4 THEN
         Ch.Enter(660,45,Ch.Cyan,Ch.bkColor,FALSE,dTime);
         Ch.Bar(280,70,512,54,Ch.ERASE)
       END
     UNTIL Ch.Repetition(10,240,50,dTime*5) = 'N';
     Ch.Close
   END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Ch.InitiateColorPlane(Ch.bkColor,0,0,32);   (* Malkasten ffnen und gro- *)
                                               (* es Fenster einstellen    *)
   Ch.HeadLine(message,year);                  (* Eintrag in die Bildleiste *)
   Ch.Delay_ms(500)
 END Case02.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

