
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)             Dateiname: IF01.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Februar 2001 Version: V 2.0                 |
  |-------------------------------------------------------------------------|
  | Thema:    Fallunterscheidung: Einfache Auswahl, die IF-Anweisung        |
  |-------------------------------------------------------------------------|
  | Anliegen: Dieses Programms zeigt die Anwendung der einfachen Auswahl.   |
  |           (WENN bedingung DANN tue)                                     |
  |-------------------------------------------------------------------------|
  | Aufgabe:  Treffen Sie nach dem Lesen Quelltextes der Prozedur           |
  |           'ZeichneRechtecke' eine Vorhersage zum Aussehen des von       |
  |           Ihnen erwarteten Bildes.                                      |
  |-------------------------------------------------------------------------|
  | Hinweise: Dieses Programm ist fr den Grafikmodus 800 x 600 Pixel      |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |           Das Beenden des Programms kann durch Bettigen der Enter-     |
  |           taste oder durch Mausklick auf das abschlieende < Enter >    |
  |           erfolgen.                                                     |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)
  
 MODULE If01;
 
  IMPORT Ch:= ChSTools;

  CONST  dTime     = 100;

         message   = 'SELEKTION  (Auswahl)';
         year      = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Beschriften;
   (*-----------------------------------------------------------------------*
    | Leistung: Positionierte farbige Ausgabe einer Textzeile (Zeichenkette)|
    *-----------------------------------------------------------------------*)

   BEGIN
     Ch.Delay_ms(dTime*3);
     Ch.SetForeColorNb(Ch.LightGray);
     Ch.GotoXY(100,60);
     Ch.WriteStr('Wenn die Laufvariable den Wert 21 erreicht, ');
     Ch.WriteStr('wechselt die Farbe.');
     Ch.Delay_ms(dTime*8)
   END Beschriften;


  PROCEDURE Hervorhebung;
    BEGIN
      Ch.SetForeColorNb(Ch.Yellow);
      Ch.GotoXY(348,60); Ch.WriteStr('21')
    END Hervorhebung;


  PROCEDURE ZeichneRechtecke;
   (*-----------------------------------------------------------------------*
    | bernahme: Hintergrundfarbe (Wertparameter, der DT Ch.tFarbe wird aus |
    |            dem MODUL ChSTools importiert)                             |
    | Leistung:  Ausgabe von 40 pinkfarbener Rechtecke am Bildschirm, deren |
    |            Kantenlnge sich nach einer bestimmten Vorschrift vergr-  |
    |            ert. Bevor das 21. Rechteck gezeichnet wird, wechselt die |
    |            Zeichenfarbe ihre Helligkeit. Zur Fallunterscheidung wird  |
    |            die Laufvariable der Zhlschleife genutzt.                 |
    *-----------------------------------------------------------------------*)

   VAR i : INTEGER;

   BEGIN
     Ch.SetForeColorNb(Ch.Brown);
     FOR i:= 1 TO 40 DO

   (* ---------  einfache Auswahl  --------- *)

       IF i = 21 THEN
         Hervorhebung;
         Ch.SetForeColorNb(Ch.Yellow);
         Ch.Delay_ms(dTime*5)
       END;

   (* -------------------------------------- *)
   
       Ch.Box(340-4*i,275-4*i,640-4*i,335+2*i,Ch.DRAW);
       Ch.Delay_ms(dTime)
     END; (* For *)
     Ch.Enter(660,45,Ch.Cyan,Ch.bkColor,FALSE,dTime)
   END ZeichneRechtecke;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

 PROCEDURE ProgMain*;
   BEGIN
     Ch.Title(Ch.LightCyan,490,dTime,Ch.bkColor,
                     'Fallunterscheidung: Die einfache Auswahl',FALSE);
     Beschriften;
     ZeichneRechtecke;
     Ch.Close                                         (* Malkasten schlieen *)
   END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Ch.InitiateColorPlane(Ch.bkColor,0,0,32);   (* Malkasten ffnen und gro- *)
                                               (* es Fenster einstellen    *)
   Ch.HeadLine(message,year);                  (* Eintrag in die Bildleiste *)
   Ch.Delay_ms(500)
 END If01.

 (* -----------   2001  Manfred Kmmerer, Chamberlain-Soft JENA  ----------*)

