
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)             Dateiname: IF02.MOD |
  |-------------------------------------------------------------------------|
  | Autor:    Manfred Kmmerer, Carl-Zeiss-Gymnasium JENA                   |
  |           Erstellungsdatum: Februar 2001 Version: V 2.0                 |
  |-------------------------------------------------------------------------|
  | Thema:    Fallunterscheidung: Zweifache Auswahl,                        |
  |                               die IF-Anweisung mit ELSE-Zweig           |
  |-------------------------------------------------------------------------|
  | Anliegen: Dieses Programm demonstriert die Anwendung der zweifachen     |
  |           Auswahl. (WENN bedingung DANN tue1 ANSONSTEN tue2)            |
  |-------------------------------------------------------------------------|
  | Aufgabe:  Schreiben Sie ein Oberon-2-Programm, dass unter Anwendung     |
  | |      |  e i n e r  Zhlschleife einen pfeilfrmigen 'Pallisadenzaun'  |
  | ||    ||  nach nebenstehenden Muster auf dem Bildschirm darstellt!      |
  | |||  |||  Der Endwert der Laufvariable der Zhlschleife ist gleich der  |
  | ||||||||  Anzahl der Pfhle des Zaunes. Nutzen Sie die Anweisungen      |
  | ||||||||  INC(x,n) und DEC(x,n). Die Pfhle sollen aus durchgezogenen   |
  | |||  |||  Linien bestehen. Speichern Sie das Programm unter dem Namen   |
  | ||    ||  IFUEBG01.MOD in das Ihnen zugewiesene Verzeichnis!            |
  |-------------------------------------------------------------------------|
  | Hinweise: Dieses Programm ist fr den Grafikmodus 800 x 600 Pixel      |
  |           konzipiert (Ausnutzung der gesamten Bildschirmflche).        |
  |           Die Koordinaten des sichtbaren Grafikbildschirms sind:        |
  |           linke untere Ecke P1(0|0), rechte obere Ecke P2(784|544).     |
  |           Das Beenden des Programms kann durch Bettigen der Enter-     |
  |           taste oder durch Mausklick auf das abschlieende < Enter >    |
  |           erfolgen.                                                     |
  |-------------------------------------------------------------------------|
  |            2001  Manfred Kmmerer, Chamberlain-Soft JENA               |
  *-------------------------------------------------------------------------*)

 MODULE If02;
 
  IMPORT Ch:= ChSTools;
 
  CONST  dTime     = 100;

         message   = 'SELEKTION  (Auswahl)';
         year      = '2001';


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Beschriften;
    BEGIN
      Ch.Delay_ms(dTime*5);
      Ch.SetForeColorNb(Ch.LightGray);
      Ch.GotoXY(85,90);
      Ch.WriteStr('Wenn die Laufvariable ungerade ist, wechselt die Farbe ');
      Ch.WriteStr('von Violett nach Grn.');
      Ch.Delay_ms(dTime*8)
    END Beschriften;


  PROCEDURE Hervorhebung ( flag : BOOLEAN );

    CONST wort1 = 'ungerade';
          wort2 = ' gerade ';

    BEGIN
      Ch.GotoXY(261,90);

   (* ----------  zweifache Auswahl  ----------- *)

      IF flag THEN
        Ch.SetForeColorNb(Ch.Yellow);
        Ch.WriteStr(wort2)
      ELSE
        Ch.SetForeColorNb(Ch.LightGray);
        Ch.WriteStr(wort1)
      END;

   (* ------------------------------------------ *)

    END Hervorhebung;


  PROCEDURE Kreise_zeichnen;

    VAR i : INTEGER;

    BEGIN
      FOR i:= 1 TO 32 DO

   (* -----------  zweifache Auswahl  ---------- *)

        IF ODD(i) THEN 
          Hervorhebung(TRUE);
          Ch.SetForeColorNb(Ch.LightGreen)
        ELSE 
          Hervorhebung(FALSE);
          Ch.SetForeColorNb(Ch.LightMagenta)
        END;

   (* ------------------------------------------ *)

        Ch.Circle(233+6*i,190+3*i,5+4*i);
        Ch.Delay_ms(dTime)
      END; (* For *)
      Ch.FlushKeyBuffer;
      Ch.Enter(660,45,Ch.Cyan,Ch.bkColor,FALSE,dTime)
    END Kreise_zeichnen;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

 PROCEDURE ProgMain*;
   BEGIN
     Ch.Title(Ch.LightCyan,490,dTime,Ch.bkColor,
                     'Fallunterscheidung: Die zweifache Auswahl',FALSE);
     Beschriften;
     Kreise_zeichnen;
     Ch.Close
   END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Ch.InitiateColorPlane(Ch.bkColor,0,0,32);   (* Malkasten ffnen und gro- *)
                                               (* es Fenster einstellen    *)
   Ch.HeadLine(message,year);                  (* Eintrag in die Bildleiste *)
   Ch.Delay_ms(500)
 END If02.

 (* -----------   2001 Manfred Kmmerer, Chamberlain-Soft JENA  -----------*)

