
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon (POW!-16)                   Dateiname: DREI.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    A b s t r a k t e r   D a t e n t y p   L i s t e             |
  |-------------------------------------------------------------------------|
  | Leistung: Das Modul importiert u. a. das Service-Modul ADTLISTE.        |
  |           Es wird eine leere Liste erzeugt, danach sollen INTEGER-Wer-  |
  |           te mittels Tastatur eingegeben werden. Diese werden nach auf- |
  |           steigenden Werten geordnet in die Liste eingefgt. Ein Hin-   |
  |           weis zum Abschluss der Eingabe wird am Bildschirm ausgegeben. |
  |           Monitorausgabe der Werte aller Listenelemente.                |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul als lauffhiges Grundgerst finden Sie unter:       |
  |            ...\adt\good\drei.mod                                        |
  *-------------------------------------------------------------------------*)

 MODULE Drei;

  IMPORT In, Out, ADTL:= Adtliste;

  VAR    a : ADTL.Liste;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Aufforderung;
    BEGIN
      Out.Ln; Out.Ln;
      Out.String('   Bitte etwa zehn einstellige INTEGER-Werte einzeln oder');
      Out.Ln;
      Out.String('   durch Leerzeichen getrennt (stream) eingeben und mit');
      Out.Ln;
      Out.String('   < Enter > abschlieen. Danach mittels Mausklick auf den');
      Out.Ln;
      Out.String('   End-Button die Ausgabe starten!');
      Out.Ln; Out.Ln
    END Aufforderung;


  PROCEDURE Eingabe;
   (*-----------------------------------------------------------------------*
    | Leistung: Erzeugen einer leeren Liste, ADTL.Erzeugen(), Aufnehmen der |
    |           grtmglichen INTEGER-Zahl, MAX(INTEGER), als erstes Ele-  |
    |           ment der Liste, Kopfelement. Ausgabe einer Mitteilung und   |
    |           einer Eingabeaufforderung. Einschalten des Bildschirmechos, |
    |           damit die Eingabewerte sichtbar bleiben. Einlesen des Werts |
    |           eines Elements. Abschalten des Bildschirmechos. Solange der |
    |           End-Button nicht bettigt wurde, wird folgendes wiederholt: |
    |           - stelle den beweglichen Listenzeiger auf das erste Element,|
    |             ADTL.GeheErstes(), hole den Eintrag, ADTL.HoleEintrag(),  |
    |           - solange der Wert der aktuellen Eingabe grer ist als der |
    |             Wert des geholten Listenelements oder ihm gleich ist, ge- |
    |             he zum nchsten Listenelement und hole den Eintrag,       |
    |           - ist das Ergebnis des Vergleichs falsch, fge den Wert der |
    |             aktuellen Eingabe an der Stelle in die Liste ein, an der  |
    |             sich der bewegliche Zeiger befindet, ADTL.EinfuegenEle-   |
    |             ment(),                                                   |
    |           - Ausgabe einer Eingabeaufforderung, Einschalten des Bild-  |
    |             schirmechos, Einlesen des Werts eines Elements, Abschal-  |
    |             ten des Bildschirmechos.                                  |
    |           Wurde der End-Button bettigt, wird zum letzten Element der |
    |           Liste gegangen und der Listeneintrag MAX(INTEGER) gelscht. |
    *-----------------------------------------------------------------------*)

    VAR x, daten : INTEGER;

    BEGIN
      ADTL.Erzeugen(a);
      ADTL.AnhaengenElement(a,MAX(INTEGER));
      Out.Ln;
      Out.String('   Die eingegebenen Werte lauten:'); Out.Ln;
      Out.Ln; Out.String('     ');
      In.Prompt('Eintrag (DT: INT)');
      In.Echo(TRUE);
      In.Int(x);
      Out.String('  ');
      In.Echo(FALSE);
      WHILE In.Done DO
        ADTL.GeheErstes(a);
        ADTL.HoleEintrag(a,daten);
        WHILE x >= daten DO
           ADTL.GeheNaechstes(a);
           ADTL.HoleEintrag(a,daten)
        END;
        ADTL.EinfuegenElement(a,x);
        In.Prompt('Eintrag (DT: INT)');             (* falls Einzeleingaben *)
        In.Echo(TRUE);
        In.Int(x);
        Out.String('  ');
        In.Echo(FALSE)
      END;
      Out.Ln;
      ADTL.GeheLetztes(a);
      ADTL.LoeschenElement(a)
    END Eingabe;


  PROCEDURE Ausgabe;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe einer Mitteilung. Der bewegliche Listenzeiger wird  |
    |           an den Listenanfang gesetzt, ADTL.GeheErstes(). Solange das |
    |           Listenende nicht erreicht ist, wird folgendes wiederholt:   |
    |             Wert eines Listenelements abholen, ADTL.HoleEintrag(),    |
    |             und ausgeben, beweglichen Listenzeiger auf das nchsten   |
    |             Listenelement weisen lassen, ADTL.GeheNaechstes().        |
    |           Ist das Listenende erreicht, wird der Wert des letzten Lis- |
    |           tenelements gelesen, ADTL.HoleEintrag(), und angezeigt.     |
    *-----------------------------------------------------------------------*)

    VAR daten: INTEGER;

    BEGIN
      Out.Ln;
      Out.String('   Die aufsteigend sortierten Werte lauten:'); Out.Ln;
      Out.Ln;
      Out.String('   ');
      ADTL.GeheErstes(a);
      WHILE ~ADTL.ListenEnde(a) DO
        ADTL.HoleEintrag(a,daten);
        Out.Int(daten,3);      
        ADTL.GeheNaechstes(a)
      END;
      ADTL.HoleEintrag(a, daten);
      Out.Int(daten,3); Out.Ln
    END Ausgabe;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Aufforderung;
      Eingabe;
      Ausgabe
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)
 
 BEGIN
   In.Open;
   Out.Open
 END Drei.

 (* ----------------------------------------------------------------------- *)

