
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon (POW!-16)                   Dateiname: EINS.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    A b s t r a k t e r   D a t e n t y p   L i s t e             |
  |-------------------------------------------------------------------------|
  | Leistung: Das Modul importiert u. a. das Servicemodul ADTListe.         |
  |           Es wird eine leere Liste erzeugt, zehn INTEGER-Werte in diese |
  |           eingetragen, danach wieder ausgelesen und am Bildschirm ge-   |
  |           folgt von der Anzahl der gelesenen Listenelemente ausgegeben. |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul als lauffhiges Grundgerst finden Sie unter:       |
  |            ...\adt\good\eins.mod                                        |
  *-------------------------------------------------------------------------*)

 MODULE Eins;

  IMPORT Out, ADTL:= Adtliste;

  VAR    a : ADTL.Liste;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Erlaeuterung;
    BEGIN
      Out.Ln; Out.Ln;
      Out.String('  Leistung:      Es wird eine leere Liste erzeugt. Danach werden zehn');
      Out.Ln;
      Out.String('                 INTEGER-Werte jeweils am aktuellen Listenende in die');
      Out.Ln;
      Out.String('                 Liste eingetragen, anschlieend aus dieser Liste ge-');
      Out.Ln;
      Out.String('                 lesen und am Bildschirm angezeigt.'); Out.Ln;
      Out.Ln; Out.Ln
    END Erlaeuterung;


  PROCEDURE ErzeugenListe_EinfuegenElemente;
   (*-----------------------------------------------------------------------*
    | Leistung: Erzeugen einer leeren Liste, Einfgen der Listenelemente    |
    |           durch Anhngen am jeweils aktuellen Listenende. Diese Ope-  |
    |           rationen werden durch die Prozeduren Erzeugen() und Anhaen- |
    |           genElement() des Servicemoduls ADTListe bernommen.         |
    *-----------------------------------------------------------------------*)

    VAR i : INTEGER;

    BEGIN
      ADTL.Erzeugen(a);
      FOR i:= 1 TO 10 DO
        ADTL.AnhaengenElement(a,i+10000)
      END;
      Out.String('  Listeninhalt: ');
      ADTL.GeheErstes(a)
    END ErzeugenListe_EinfuegenElemente;


  PROCEDURE LesenListe_AnzeigenElemente;
   (*-----------------------------------------------------------------------*
    | Leistung: Der Zhler wird initialisiert.                              |
    |           Solange das Listenende nicht erreicht ist, wird ein Listen- |
    |           eintrag gelesen, HoleEintrag(), ausgegeben und der beweg-   |
    |           liche Listenzeiger um eine Position weitergerckt, Gehe-    |
    |           Naechstes(). Ist das Listenende erreicht, wird das letzte   |
    |           Element gelesen und angezeigt. Anschlieend wird die Anzahl |
    |           gelesener Elemente ausgegeben.                              |
    | Hinweis:  An den qualifizierten Prozeduraufrufen ADTL.HoleEintrag()   |
    |           und ADTL.GeheNaechstes() ist zu erkennen, dass diese beiden |
    |           Prozeduren im Servicemoduls ADTListe definiert sind.        |
    *-----------------------------------------------------------------------*)

    VAR aus, zaehler : INTEGER;

    BEGIN
      zaehler:= 0;
      WHILE ~ADTL.ListenEnde(a) DO
        INC(zaehler);
        ADTL.HoleEintrag(a,aus);
        Out.Int(aus,6);
        ADTL.GeheNaechstes(a)
      END;
      INC(zaehler);
      ADTL.HoleEintrag(a,aus);
      Out.Int(aus,6);
      Out.Ln; Out.Ln;
      Out.String('  Anzahl:');
      Out.Int(zaehler,10); Out.Ln
    END LesenListe_AnzeigenElemente;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Erlaeuterung;
      ErzeugenListe_EinfuegenElemente;
      LesenListe_AnzeigenElemente
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Out.Open
 END Eins.

 (* ----------------------------------------------------------------------- *)

