
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)            Dateiname: FUENF.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Die Schleife mit vorangestelltem Test                         |
  |-------------------------------------------------------------------------|
  | Leistung: Errechnen der Potenz einer reellen Zahl                       |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst befindet sich in:       |
  |            ...\anwei\good\fuenf.mod                                     |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\anwei\txt\anweisu.txt und                         |
  |                   ...\anwei\doc\anweisu.doc                             |
  |-------------------------------------------------------------------------|
  |           Nherungsweise Berechnung der Zahl e: 1.0001 hoch 10000       |
  *-------------------------------------------------------------------------*)

 MODULE Fuenf;

  IMPORT In, Out, F:= Float, S:= Strings;

  TYPE   tZahlStr = ARRAY 26 OF CHAR;


 (* ---------------------  U N T E R P R O G R A M M  --------------------- *)


  PROCEDURE Wandeln ( zahl : REAL; nkSt : INTEGER; VAR zahlStr : tZahlStr );
   (*-----------------------------------------------------------------------*
    | bernahme: zu wandelnde (konvertierende) Zahl (DT: REAL) und Anzahl   |
    |            der Nachkommastellen (DT: INTEGER)                         |
    | Referenz:  gewandelte (konvertierte) Zahl als Zeichenkette            |
    |            (DT: tZahlStr = ARRAY 22 OF CHAR)                          |
    | Leistung:  Konvertieren einer reellen Zahl in eine Zeichenkette und   |
    |            Entfernen aller fhrenden Leerzeichen aus dieser Zeichen-  |
    |            kette. Betrgt die Anzahl der Nachkommastellen null, wird  |
    |            der Dezimalpunkt aus dem Ziffernstring gelscht.           |
    | Hinweis:   Syntax der Prozeduren: Float.StrF(), Strings.PosChar()     |
    |            und Strings.Delete(), rechten Mausklick nutzen!            |
    |            Erluterungen siehe ...\anwei\fine\eins.mod.               |
    *-----------------------------------------------------------------------*)

    BEGIN
      F.StrF(zahl,16,nkSt,zahlStr);
      WHILE S.PosChar(' ',zahlStr,1) = 1 DO
        S.Delete(zahlStr,1,1)
      END;
      IF nkSt = 0 THEN
        S.Delete(zahlStr,S.Length(zahlStr),1)
      END;
    END Wandeln;


  PROCEDURE Potenz;

    VAR exp, exponent,
        nkStBas, nkStErg       : INTEGER;
        b, basis, ergebnis     : REAL;
        basStr, ergStr, expStr : tZahlStr;

    BEGIN
      In.Prompt('Basis  (DT: REAL)');
      In.Real(basis);
      b:= basis;                               (* Kopie fr format. Ausgabe *)
      Out.Ln;
      Out.Real(basis,20); Out.String(' hoch ');
      In.Prompt('Exponent  (DT: INT)');
      In.Int(exponent);
      exp:= exponent;                          (* Kopie fr format. Ausgabe *)
      Out.Int(exponent,1);
      ergebnis:= 1.0;

      WHILE exponent # 0 DO
        IF ODD(exponent) THEN
          exponent:= exponent - 1;             (*  oder: DEC(exponent);     *)
          ergebnis:= ergebnis * basis
        ELSE
          exponent:= exponent DIV 2;
          basis:= basis * basis
        END
      END;

      Out.String(' = '); Out.Real(ergebnis,20); Out.Ln;
      Out.Ln;

    (* formatierte Ausgabe *)

      Out.Ln; Out.Ln;
      Out.String('    Formatierte Ausgabe:'); Out.Ln;
      Out.String('   '); Out.Ln;
      Out.Ln; Out.String('     Nachkommastellen: z. B.:  0, 1, 2,  ...');
      Out.Ln;
      In.Prompt('Basis:'); In.Int(nkStBas);
      In.Prompt('Ergebnis:'); In.Int(nkStErg);
      Out.Ln; Out.Ln; Out.String('     ');
      Wandeln(b,nkStBas,basStr); Out.String(basStr); Out.String(' hoch ');
      Wandeln(exp,0,expStr); Out.String(expStr);
      Wandeln(ergebnis,nkStErg,ergStr); Out.String(' = '); Out.String(ergStr)

    END Potenz;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Potenz
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;
   Out.Open
 END Fuenf.

 (* ----------------------------------------------------------------------- *)

