
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)            Dateiname: SECHS.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Die Schleife mit nachgestelltem Test                          |
  |-------------------------------------------------------------------------|
  | Leistung: Berechnen der dritten Wurzel (Kubikwurzel) einer reellen Zahl |
  |           Wurzelberechnung nach HERON VON ALEXANDRIA                    |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst befindet sich in:       |
  |            ...\anwei\good\sechs.mod                                     |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\anwei\txt\anweisu.txt und                         |
  |                   ...\anwei\doc\anweisu.doc                             |
  *-------------------------------------------------------------------------*)


 MODULE Sechs;

  IMPORT In, Out, F:= Float, S:= Strings;

  TYPE   tZahlStr = ARRAY 24 OF CHAR;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Ueberschrift;

    VAR i : INTEGER;

    BEGIN
      Out.Ln; Out.Ln;
      Out.String('   Kubikwurzelberechnung nach HERON VON ALEXANDRIA');
      Out.Ln;
      Out.String('  '); FOR i:= 1 TO 49 DO Out.Char('') END; Out.Ln;
      Out.String('                 Iterationsverfahren');
      Out.Ln; Out.Ln
    END Ueberschrift;


  PROCEDURE Wandeln ( zahl : REAL; VAR zahlStr : tZahlStr );
   (*-----------------------------------------------------------------------*
    | bernahme: zu wandelnde (konvertierende) Zahl (DT: REAL)              |
    | Referenz:  gewandelte (konvertierte) Zahl als Zeichenkette            |
    |            (DT: tZahlStr = ARRAY 22 OF CHAR)                          |
    | Leistung:  Konvertieren einer reellen Zahl in eine Zeichenkette und   |
    |            Entfernen aller fhrenden Leerzeichen aus dieser Zeichen-  |
    |            kette.                                                     |
    | Hinweis:   Syntax der Prozeduren: Float.StrF(), Strings.PosChar()     |
    |            und Strings.Delete(), rechten Mausklick nutzen!            |
    |            Erluterungen siehe ...\anwei\fine\eins.mod.               |
    *-----------------------------------------------------------------------*)

    BEGIN
      F.StrF(zahl,16,3,zahlStr);
      WHILE S.PosChar(' ',zahlStr,1) = 1 DO
        S.Delete(zahlStr,1,1)
      END
    END Wandeln;


  PROCEDURE Kubikwurzel;

    CONST epsilon = 1.0E-8;

    VAR zahl, xAlt, xNeu : REAL;
        zahlStr          : tZahlStr;

    BEGIN
      In.Prompt('Wert  ( DT: REAL )');
      In.Real(zahl);
      xNeu:= 1.0;
      
      REPEAT
        xAlt:= xNeu;
        xNeu:= (2 * xAlt + zahl / (xAlt * xAlt)) / 3
      UNTIL ABS(xAlt - xNeu) < epsilon * ABS(xNeu);
      
      Out.Ln;
      Out.String('     Die Kubikwurzel von ');
      Wandeln(zahl,zahlStr); Out.String(zahlStr);
      Out.String(' ist ');
      Wandeln(xNeu,zahlStr); Out.String(zahlStr);
      Out.Char('.'); Out.Ln
    END Kubikwurzel;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Ueberschrift;
      Kubikwurzel;

      (* Formatierung einfgen *)

    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Out.Open
 END Sechs.

 (* ----------------------------------------------------------------------- *)

