
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)            Dateiname: SECHS.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Die Schleife mit nachgestelltem Test                          |
  |-------------------------------------------------------------------------|
  | Leistung: Berechnen der dritten Wurzel (Kubikwurzel) einer reellen Zahl |
  |           Wurzelberechnung nach HERON VON ALEXANDRIA                    |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise eingefgt werden.                   |
  |           Siehe ...\anwei\fine\sechs.mod                                |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\anwei\txt\anweisu.txt und                         |
  |                   ...\anwei\doc\anweisu.doc                             |
  *-------------------------------------------------------------------------*)

 MODULE Sechs;

  IMPORT In, Out;

  PROCEDURE Wurzel;

    CONST epsilon = 1.0E-8;

    VAR z, xAlt, xNeu : REAL;

    BEGIN
      In.Real(z);
      Out.Ln;
      Out.String('   Die Kubikwurzel von '); Out.Real(z,8);
      xNeu:= 1.0;
      
      REPEAT
        xAlt:= xNeu;
        xNeu:= (2 * xAlt + z / (xAlt * xAlt)) / 3
      UNTIL ABS(xAlt - xNeu) < epsilon * ABS(xNeu);
      
      Out.String(' ist '); Out.Real(xNeu,10); Out.Char('.'); Out.Ln
    END Wurzel;


  PROCEDURE ProgMain*();
    BEGIN
      Wurzel
    END ProgMain;

 BEGIN
   Out.Open
 END Sechs.

