
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)            Dateiname: NAMEN.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    D a t u m  (Namen der Wochentage und Monate)                  |
  |-------------------------------------------------------------------------|
  | Leistung: Ermitteln und Ausgeben der Wochentags- und Monatsnamen.       |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst, das eine 'Lcke' im    |
  |           Quelltext enthlt, befindet sich in:                          |
  |            ...\datum1\good\namen.mod                                    |
  |-------------------------------------------------------------------------|
  | Aufgabenstellung: ...\datum1\txt\datum.txt und                          |
  |                   ...\datum1\doc\datum.doc                              |
  *-------------------------------------------------------------------------*)

 MODULE Namen;

  IMPORT In, Out;


 (* --------------------  U N T E R P R O G R A M M E --------------------- *)


  PROCEDURE Ueberschrift;

    VAR i : INTEGER;

    BEGIN
      Out.Ln; Out.Ln;
      Out.String('   Wochentags- und Monatsnamenbestimmung'); Out.Ln;
      Out.String('  '); FOR i:= 1 TO 39 DO Out.Char('') END; Out.Ln;
      Out.Ln;
      Out.String('     0 = Sonntag,  1 = Montag,  ...'); Out.Ln;
      Out.Ln
    END Ueberschrift;


  PROCEDURE Wochentagsname;
   (*-----------------------------------------------------------------------*
    | Leistung: Einlesen der Wochentagsnummer (tagesnummer {0..6}).         |
    |           Ermitteln des Wochentagsnamens (mehrseitige Auswahl). Da    |
    |           die Gltigkeit der Wochentagsnummer nicht sofort nach der   |
    |           Eingabe berprft wird,  m u s s  der Fallunterscheidung    |
    |           ein ELSE-Zweig nachgestellt werden. Vermeiden der Fehler-   |
    |           meldung: CASE trap (no ELSE includet) at line ..., nach     |
    |           Eingabe einer ungltigen Wochentagsnummer.                  |
    |           Ausgabe der Wochentagsnummer und des Wochentagsnamens am BS.|
    *-----------------------------------------------------------------------*)

    VAR tagesnummer: INTEGER;

    BEGIN
      REPEAT
        In.Prompt('Wochentagsnr.');
        In.Int(tagesnummer);
        Out.Ln;
        Out.String('     Wochentagsnummer  ='); Out.Int(tagesnummer,3);
        Out.Ln;
        Out.String('     Wochentagsname    =  ');
        CASE tagesnummer OF
           0: Out.String('Sonntag')
         | 1: Out.String('Montag')
         | 2: Out.String('Dienstag')
         | 3: Out.String('Mittwoch')
         | 4: Out.String('Donnerstag')
         | 5: Out.String('Freitag')
         | 6: Out.String('Samstag')
        ELSE
          Out.String(' Fehlerhafte Tagesnummer!'); Out.Ln
        END
      UNTIL (tagesnummer >= 0) & (tagesnummer < 7);
      Out.Ln
    END Wochentagsname;


  PROCEDURE Monatsname;
   (*-----------------------------------------------------------------------*
    | Leistung: Einlesen der Monatsnummer (monatsnummer {1..12}).           |
    |           Ermitteln des Monatsnamens (mehrseitige Auswahl). Da die    |
    |           Gltigkeit der Monatsnummer sofort nach der Eingabe ber-   |
    |           prft wird, erhlt die Fallunterscheidung keinen ELSE-Zweig.|
    |           Ausgabe der Monatsnummer und des Monatsnamens am Bildschirm.|
    *-----------------------------------------------------------------------*)

    VAR monatsnummer: INTEGER;

    BEGIN
      REPEAT
        In.Prompt('Monatsnummer');
        In.Int(monatsnummer)
      UNTIL (monatsnummer > 0) & (monatsnummer < 13);
      Out.Ln;
      Out.String('     Monatsnummer      = '); Out.Int(monatsnummer,2);
      Out.Ln;
      Out.String('     Monatsname        = '); Out.Char(' ');
      CASE monatsnummer OF
         1: Out.String('Januar')
       | 2: Out.String('Februar')
       | 3: Out.String('Mrz')
       | 4: Out.String('April')
       | 5: Out.String('Mai')
       | 6: Out.String('Juni')
       | 7: Out.String('Juli')
       | 8: Out.String('August')
       | 9: Out.String('September')
       |10: Out.String('Oktober')
       |11: Out.String('November')
       |12: Out.String('Dezember')
      END;
      Out.Ln
    END Monatsname;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)


  PROCEDURE ProgMain*();
    BEGIN
      Ueberschrift;
      Wochentagsname;
      Monatsname
    END ProgMain;


 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;
   Out.Open
 END Namen.

 (* ----------------------------------------------------------------------- *)

