 
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: RECHNUNG.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    D a t u m  (Wochentagsnamen ermitteln)                        |
  |-------------------------------------------------------------------------|
  | Leistung: Ermitteln des Wochentagsnamens eines 'beliebigen' Datums.     |
  |           Mit Hilfe der Kalenderformel nach JACOBSTHAL kann fr ein ge- |
  |           gebenes Datum (Jahr, Monat, Tag) der dazugehrige Wochentags- |
  |           name ermittelt werden.                                        |
  |           Es drfen nur korrekte Kalenderdaten eingegeben werden, da    |
  |           k e i n e  Prfung der Existenz vorgenommen wird.             |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise eingefgt werden.                   |
  |           Siehe ...\datum1\fine\rechnung.mod                            |
  |-------------------------------------------------------------------------|
  | Aufgabenstellung: ...\datum1\txt\datum.txt u. ...\datum1\doc\datum.doc  |
  | Erluterungstext: ...\datum1\txt\rechnung.txt und                       |
  |                   ...\datum1\doc\rechnung.doc                           |
  *-------------------------------------------------------------------------*)

 MODULE Rechnung;

  IMPORT In, Out;

  PROCEDURE Wochentag;

    VAR c, d, j, jahr, 
        k, monat, tag  : INTEGER;
        schaltjahr     : BOOLEAN;

    BEGIN
      In.Int(jahr); In.Int(monat); In.Int(tag);
      Out.Ln; Out.Int(jahr,5); Out.Int(monat,3); Out.Int(tag,3);
      Out.String(' : ');
    
      c:= jahr DIV 100;
      j:= jahr MOD 100;
      
      IF j = 0 THEN
        schaltjahr:= c MOD 4 = 0
      ELSE
        schaltjahr:= j MOD 4 = 0 
      END;

      CASE monat OF
          1: IF schaltjahr THEN k:= 5 ELSE k:= 6 END 
       |  2: IF schaltjahr THEN k:= 1 ELSE k:= 2 END
       |  3: k := 2
       |  4: k := 5
       |  5: k := 0
       |  6: k := 3
       |  7: k := 5
       |  8: k := 1
       |  9: k := 4
       | 10: k := 6
       | 11: k := 2
       | 12: k := 4
      END;
    
      d:= tag + k + j + j DIV 4 - 2 * (c MOD 4);
    
      CASE d MOD 7 OF
         0: Out.String('Sonntag')
       | 1: Out.String('Montag')
       | 2: Out.String('Dienstag')
       | 3: Out.String('Mittwoch')
       | 4: Out.String('Donnerstag')
       | 5: Out.String('Freitag')
       | 6: Out.String('Samstag')
      END;

      Out.Ln
    END Wochentag;


  PROCEDURE ProgMain*();
    BEGIN
      Wochentag
    END ProgMain;


 BEGIN
   In.Open;
   Out.Open
 END Rechnung.
 
