
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: EUKLDEMO.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Einstieg in die Programmierung mit OBERON                     |
  |-------------------------------------------------------------------------|
  | Leistung: Berechnen und Ausgeben des grten gemeinsamen Teilers        |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst befindet sich in:       |
  |            ...\einstieg\good\euklid.mod                                 |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\einstieg\txt\beispiel.txt und                     |
  |                   ...\einstieg\doc\beispiel.doc                         |
  *-------------------------------------------------------------------------*)

 MODULE EuklDemo;

  IMPORT In, Out, W:= Window;

  VAR dummy : BOOLEAN;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Ueberschrift;
    BEGIN
      Out.Ln; Out.Ln;
      Out.String('     Der grte gemeinsame Teiler'); Out.Ln;
      Out.String('    '); Out.Ln
             (* '' = <Alt> + < 0 1 6 8 > auf dem Nummernblock der Tastatur *)
    END Ueberschrift;


  PROCEDURE EinlesenUndAnleitung ( VAR x, y : LONGINT );

    VAR zeichen : CHAR;
        spalte,
        zeile   : INTEGER;

    BEGIN
      In.Prompt('Ohne Eingabe!');
      Out.Ln;
      Out.String('   A N L E I T U N G :'); Out.Ln; Out.Ln;
      Out.String("   - Aktivieren Sie das Men 'Pane',"); Out.Ln;
      Out.String("   - klicken Sie auf die Option 'read input from file...',");
      Out.Ln;
      Out.String("   - whlen Sie den Dateipfad '...\einstieg\demo und"); Out.Ln;
      Out.String("   - klicken Sie doppelt auf den Dateinamen 'beispiel.txt'!");
      Out.Ln; Out.Ln; Out.Ln;
      
      In.LongInt(x);
      In.LongInt(y);
      
      FOR zeile:= 1 TO 13 DO
        spalte:= 0;
        REPEAT
          INC(spalte); 
          In.Char(zeichen);
          IF zeichen # CHR(13) THEN Out.Char(zeichen) END;
        UNTIL zeichen = CHR(13)
      END;
      Out.Ln
    END EinlesenUndAnleitung;


  PROCEDURE ggT ( x, y : LONGINT );

    VAR rest : LONGINT;                (* Die Variable rest vom Typ LONGINT *)
                                       (* ist in der Prozedur ggT lokal.    *)
    BEGIN
      Out.Ln;
      Out.String('        1. Zahl =');        (*   E i n g a b e             *)
      Out.Int(x,5);
      Out.Ln; Out.Ln;
      Out.String('        2. Zahl =');
      Out.Int(y,5);
      WHILE y > 0 DO                         (*   V e r a r b e i t u n g   *)
        rest:= x MOD y;
        x:= y;
        y:= rest
      END;
      Out.Ln; Out.Ln;
      Out.String('           ggt  =');
      Out.Int(x,5);                          (*   A u s g a b e             *)
      Out.Ln; Out.Ln
    END ggT;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();

    VAR x, y : LONGINT;

    BEGIN
      EinlesenUndAnleitung(x,y);
      Ueberschrift;
      ggT(x,y)
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   dummy:= W.ShowWindow(W.GetActiveWindow(),3);
                                           (* grtmgliches Fenster ffnen *)
   In.Open;
   Out.Open
 END EuklDemo.

 (*-------------------------------------------------------------------------*)
