
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: MAXIMUMK.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Einstieg in die Programmierung mit OBERON                     |
  |-------------------------------------------------------------------------|
  | Leistung: Suche und Ausgabe des Maximums in einer vom Nutzer abhngi-   |
  |           gen Anzahl eingelesener ganzer Zahlen. Bei mehrfachem Auftre- |
  |           ten des Maximums werden die Positionen seines Auftretens im   |
  |           Eingabestream am Bildschirm angezeigt.                        |
  |-------------------------------------------------------------------------|
  | Achtung!  Eingaben mit <Enter> abschlieen. Nach der letzten Eingabe    |
  |           den End-Button bettigen.                                     |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst befindet sich in:       |
  |            ...\einstieg\good\maximumk.mod                               |
  *-------------------------------------------------------------------------*)

 MODULE MaximumK;                   (* Maximumsuche kommentiert             *)

  IMPORT In, Out, S:= Strings;

  VAR zahl, maximum, n : INTEGER;   (* globale Variablen in dem Modul       *)


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Erlaeuterungen;

    VAR i : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('  Bitte ganze Zahlen im Intervall -32768 .. 32767 eingeben!');
      Out.Ln; Out.Ln;
      Out.String('  Nach Eingabe der letzten Zahl End-Button bettigen.');
      Out.Ln; Out.Ln;
      Out.String('    O D E R');
      Out.Ln; Out.Ln;
      Out.String('    Men:   Pane                     (Mausklick)'); Out.Ln;
      Out.String('    Option: read input from file...  (Mausklick)'); Out.Ln;
      Out.String('    Pfad:   ...\einstieg\fine        (Doppelklick)'); Out.Ln;
      Out.String('    Datei:  daten.txt ffnen         (Doppelklick)'); Out.Ln;
      Out.Ln; Out.Char(' ');
      FOR i:= 1 TO 56 DO Out.Char('') END; Out.Ln;
           (* '' = <Alt> + <0><1><7><5> auf dem Nummernblock der Tastatur *)
    END Erlaeuterungen;


  PROCEDURE AusgebenUndAnzahl;
   (*-----------------------------------------------------------------------*
    | Leistung: Einlesen einer Anzahl ganzer Zahlen (Eingabestream)         |
    |           Ausgabe der Anzahl eingelesenen Zahlen.                     |
    *-----------------------------------------------------------------------*)

    VAR ordinal, text : ARRAY 16 OF CHAR;

    BEGIN
      Out.String('  Zahlen =');
      n:= 1;
      In.Prompt('1. ganze Zahl');   (* Textausgabe in der Kopfzeile         *)
      In.Int(zahl);
      Out.Int(zahl,6);

      WHILE In.Done DO
        INC(n);
        S.Str(n,ordinal);           (* Ganze Zahl in Zeichenkette wandeln   *)
        text:= '. ganze Zahl';
        S.Insert(ordinal,text,0);   (* Text in eine Zeichenkette einfgen   *)
        In.Prompt(text);
        In.Int(zahl);               (* Die Zahlen werden zum ersten Mal ein *)
                                    (* gelesen!                             *)
        Out.Int(zahl,6);
        IF n MOD 10 = 0 THEN        (* Zeilenumbruch nach zehn Zahlen       *)
          Out.Ln;
          Out.String('          ')
        END;
      END;
      
      Out.Ln; Out.Ln;
      Out.String('  Anzahl Zahlen: '); Out.Int(n,6); Out.Ln; Out.Ln
    END AusgebenUndAnzahl;

    
  PROCEDURE Maximum;
   (*-----------------------------------------------------------------------*
    | Leistung: Suche des Maximums im Eingabestream, Ausgabe am Bildschirm. |
    *-----------------------------------------------------------------------*)

    VAR i : INTEGER;

    BEGIN
      maximum:= MIN(INTEGER);       (* Dies ist die kleinste INTEGER-Zahl   *)
                                    (* in diesem Oberon-System. Mit ihr     *)
                                    (* wird das Maximum initialisiert.      *)
                                     
      In.Open;                      (* Eingabestream erneut bereitstellen   *)
                                    (* Zahlen zum zweiten Mal einlesen      *)
      FOR i:= 1 TO n DO
        In.Int(zahl);  
        IF zahl > maximum THEN maximum:= zahl END
      END;
      
      Out.String('  Maximum:       '); Out.Int(maximum,6); Out.Ln
    END Maximum;


  PROCEDURE MaxPositionen;
   (*-----------------------------------------------------------------------*
    | Leistung: Durchsuchen des Eingabestreams nach dem Maximum, Position   |
    |           bzw. Positionen des Auftretens am Bildschirm ausgeben.      |
    *-----------------------------------------------------------------------*)

    VAR i: INTEGER;

    BEGIN
      In.Open;                      (* Eingabestream erneut bereitstellen   *)
      Out.Ln;
      Out.String('  Position(en) des Maximums: ');
                                    
      FOR i:= 1 TO n DO             (* Die Zahlen werden zum dritten Mal    *)
        In.Int(zahl);               (* eingelesen!                          *)
        IF zahl = maximum THEN Out.Int(i,6) END
      END;
      
      Out.Ln
    END MaxPositionen;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Erlaeuterungen;
      AusgebenUndAnzahl;
      Maximum;
      MaxPositionen
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)
 
  BEGIN
    In.Open;                        (* Initialisieren des In-Moduls         *)
    Out.Open                        (* Initialisieren des Out-Moduls        *)
  END MaximumK.

 (* ----------------------------------------------------------------------- *)

