
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)          Dateiname: HAMMING.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Thringer Abiturprfung Grundfach Informatik 1999,            |
  |           Aufgabe 1.3 (Zentralabitur)                                   |
  |-------------------------------------------------------------------------|
  | Leistung: Fr einen Code wird der kleinste auftretende Abstand seiner   |
  |           Codewrter ermittelt. Diese Zahl heit Hamming-Abstand.       |
  |           Beispiel:  Die Codewrter  00110                              |
  |                      und             10111                              |
  |                      besitzen den Abstand 2.                            |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise eingefgt werden.                   |
  |           Siehe ...\hammining\fine\hamming.mod                          |
  |-------------------------------------------------------------------------|
  | Aufgabenstellung: ...\hammining\txt\hamminga.txt                        |
  |                   ...\hammining\doc\hamminga.doc                        |
  | Lsungsentwurf:   ...\hammining\txt\hammingb.txt                        |
  |                   ...\hammining\doc\hammingb.doc                        |
  | Eingabehinweise:  ...\hammining\doc\hammtool.txt                        |
  |                   ...\hammining\doc\hammtool.doc                        |
  *-------------------------------------------------------------------------*)

 MODULE Hamming;

  IMPORT In, Out;

  TYPE CODEWORT = ARRAY  21 OF CHAR;   (* maximale Lnge der Codewrter: 20 *)
       CODE     = ARRAY 100 OF CODEWORT;    (* max. Anzahl Codewrtern: 100 *)

  VAR  code     : CODE;
       anzahl, 
       laenge   : INTEGER;


  PROCEDURE AnzahlEinlesen;
    BEGIN
      Out.Ln;
      Out.String('  Anzahl einzulesender Codewrter (maximal 20)'); Out.Ln;
      In.Prompt('Anzahl');
      In.Int(anzahl)
    END AnzahlEinlesen;


  PROCEDURE LaengeEinlesen;
    BEGIN
      Out.Ln;
      Out.String('  Lnge der einzulesenden Codewrter (maximal 100)');
      Out.Ln;
      In.Prompt('Lnge');
      In.Int(laenge)
    END LaengeEinlesen;


  PROCEDURE CodeEinlesen;

    VAR k: INTEGER;

    BEGIN
      Out.Ln;
      Out.String('  Codewrter eingeben!'); Out.Ln;
      FOR k:= 0 TO anzahl-1 DO
        In.Prompt('Codewort');
        In.String(code[k]) END;
      Out.Ln; Out.String('  Alle Codewrter eingelesen'); Out.Ln
    END CodeEinlesen;


  PROCEDURE Abstand ( r, s : CODEWORT ) : INTEGER;

    VAR abstand, i: INTEGER;

    BEGIN
      abstand:= 0;
      FOR i:= 0 TO laenge-1 DO
        IF r[i] # s[i] THEN INC(abstand) END
      END;
      RETURN abstand
    END Abstand;


  PROCEDURE HammingAbstand() : INTEGER;

    VAR m, n, a, minimum : INTEGER;

    BEGIN
      minimum:= laenge;
      FOR m:= 0 TO anzahl-2 DO
        FOR n:= m+1 TO anzahl-1 DO
          a:= Abstand(code[m],code[n]);
          IF a < minimum THEN minimum:= a END
        END
      END;
      RETURN minimum
    END HammingAbstand;


  PROCEDURE AbstandBerechnen;
    BEGIN
      Out.Ln; 
      Out.String('  Hamming-Abstand: '); Out.Int(HammingAbstand(),3);
      Out.Ln
    END AbstandBerechnen;


  PROCEDURE ProgMain*();

    VAR

    BEGIN
      AnzahlEinlesen;
      LaengeEinlesen;
      CodeEinlesen;
      AbstandBerechnen
    END ProgMain;


 BEGIN
   In.Open;
   Out.Open
 END Hamming.

