
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: TURTDEMO.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Anwendung der Kommandos aus dem Service-Modul: Turtle-Grafik  |
  |-------------------------------------------------------------------------|
  | Leistung: Zeichnen der Liniengrafik 'Das Haus vom Nikolaus' unter       |
  |           Verwendung der Turtle-Grafik-Kommandos.                       |
  *-------------------------------------------------------------------------*)

 MODULE TurtDemo;

  IMPORT C:= ColorPlane, In, Out, T:= Turtle, W:= Windows;

  CONST  dTime = 500;

  VAR    dummy : INTEGER;


 (* --------------------  U N T E R P R O G R A M M E --------------------- *)


  PROCEDURE Delay_ms ( msec : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Eine bestimmte Zeit warten.                                 |
    *-----------------------------------------------------------------------*)

    VAR startzeit, zielzeit : LONGINT;

    BEGIN
      startzeit:= W.GetTickCount(); 
      REPEAT
        zielzeit:= W.GetTickCount()
      UNTIL zielzeit > startzeit + msec 
    END Delay_ms;


  PROCEDURE Erlaeuterungen;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe von Erluterungen und Beispieldaten.                |
    *-----------------------------------------------------------------------*)
    BEGIN
      Out.Ln;
      Out.String('    Folgende Menpunkte abarbeiten:');
      Out.String('            O D E R       Eingabe der Beispieldaten:');
      Out.Ln; Out.Ln;
      Out.String('    Men:   Pane                     (Mausklick)');
      Out.String('             300  50   0 150 225 212 135 150 225'); Out.Ln;
      Out.String('    Option: read input from file...  (Mausklick)');
      Out.String('             106 270 106 315 150 225 212 135 150'); Out.Ln;
      Out.String('    Pfad:   ...\kreuzung\demo        (Doppelklick)');
      Out.String('             0'); Out.Ln;
      Out.String('    Datei:  turtdemo.txt ffnen      (Doppelklick)'); Out.Ln
    END Erlaeuterungen;


  PROCEDURE Ueberschrift;
    BEGIN
      C.GotoXY(64,290);
      C.WriteStr('Das Haus vom Nikolaus');
      C.Line(60,272,236,272,C.DRAW);
      Delay_ms(dTime)
    END Ueberschrift;


  PROCEDURE Init;
   (*-----------------------------------------------------------------------*
    | Leistung: Einlesen der Koordinaten fr den Startpunkt der Linien-     |
    |           grafik.                                                     |
    *-----------------------------------------------------------------------*)

    VAR x, y: INTEGER;

    BEGIN
      In.Prompt('x-Koordinate'); In.Int(x);
      In.Prompt('y-Koordinate'); In.Int(y);
      T.BildNeu(x,y)
    END Init;


  PROCEDURE Ausrichten;
   (*-----------------------------------------------------------------------*
    | Leistung: Einlesen der Zeichenrichtung.                               |
    *-----------------------------------------------------------------------*)

    VAR richtung : INTEGER;

    BEGIN
      In.Prompt('Richtung'); In.Int(richtung);
      T.Aufkurs(richtung)
    END Ausrichten;


  PROCEDURE Drehen;
   (*-----------------------------------------------------------------------*
    | Leistung: Einlesen der Drehrichtung (Winkel) der Turtle.              |
    *-----------------------------------------------------------------------*)

    VAR winkel : INTEGER;

    BEGIN
      In.Prompt('Winkel'); In.Int(winkel);
      T.Rechts(winkel)
    END Drehen;


  PROCEDURE Gehen;
   (*-----------------------------------------------------------------------*
    | Leistung: Einlesen der zu zeichnenden Strecke (Einheit: Pixel).       |
    |           Pixel (engl. pixel) ist die Abkrzung fr die englischen    |
    |           Wrter picture element.                                     |
    *-----------------------------------------------------------------------*)

    VAR schritte: INTEGER;

    BEGIN
      In.Prompt('Lnge in Pixeln');In.Int(schritte);
      T.Vorwaerts(schritte)
    END Gehen;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();

    VAR i : INTEGER;

    BEGIN
      Erlaeuterungen;
      Init;
      Ueberschrift;
      Ausrichten;
      FOR i:= 1 TO 8 DO
        Gehen;
        Drehen;
        Delay_ms(dTime)
      END
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

  BEGIN
    dummy:= W.ShowWindow(W.GetActiveWindow(),3);
    In.Open;
    Out.Open
  END TurtDemo.

 (* ----------------------------------------------------------------------- *)

