
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: HILBERTV.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    HILBERT-Kurven, David HILBERT (1891)                          |
  |           Vorwrtsdeklarationen von Prozeduern                          |
  |-------------------------------------------------------------------------|
  | Leistung: Ausgeben der Aktionen zum Zeichnen der Hilbert-Kurve einer    |
  |           bestimmten Ordnung.                                           |
  |           Das Modul enthlt Vorwrtsdeklarationen von Prozeduern        |
  |           (Erweiterung der Sichtbarkeitsregel)                          |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst befindet sich in:       |
  |           ...\hilbert\good\hilbertv.mod                                 |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\hilbert\txt\hilbert.txt                           |
  |                   ...\hilbert\doc\hilbert.doc                           |
  | Eingabehinweise:  ...\hilbert\doc\hilbtool.txt                          |
  | (Turtle/Hilbert)  ...\hilbert\doc\hilbtool.doc                          |
  *-------------------------------------------------------------------------*)

 MODULE HilbertV;

   IMPORT In, Out;

 (* --------------------  U N T E R P R O G R A M M E --------------------- *)


  PROCEDURE ^B ( i : INTEGER );     (* Vorwrtsdeklarationen der Prozeduern *)
  PROCEDURE ^C ( i : INTEGER );     (* B, C, D. Damit erfolgt eine Erweite- *)
  PROCEDURE ^D ( i : INTEGER );     (* rung der Sichtbarkeitsregel          *)


  PROCEDURE A ( i : INTEGER );
    BEGIN
      IF i > 0 THEN
        D(i - 1); Out.Char('W');    (* ('W') West bedeutet: Zeichne eine    *)
                                    (*       Strecke der Lnge h von der    *)
                                    (*       aktuellen Position nach links. *)
        A(i - 1); Out.Char('S');    (* ('S') Sd bedeutet: Zeichne eine     *)
                                    (*       Strecke der Lnge h von der    *)
                                    (*       aktuellen Position nach unten. *)
        A(i - 1); Out.Char('O');    (* ('O') Ost bedeutet: Zeichne eine     *)
                                    (*       Strecke der Lnge h von der    *)
                                    (*       aktuellen Position nach rechts.*)

        B(i - 1)
      END
    END A;


  PROCEDURE B ( i : INTEGER );
    BEGIN
      IF i > 0 THEN
        C(i - 1); Out.Char('N');    (* ('N') Nord bedeutet: Zeichne eine    *)
                                    (*       Strecke der Lnge h von der    *)
                                    (*       aktuellen Position nach oben.  *)
        B(i - 1); Out.Char('O');
        B(i - 1); Out.Char('S');
        A(i - 1)
      END
    END B;


  PROCEDURE C ( i : INTEGER );
    BEGIN
      IF i > 0 THEN
        B(i - 1); Out.Char('O');
        C(i - 1); Out.Char('N');
        C(i - 1); Out.Char('W');
        D(i - 1)
      END
    END C;


  PROCEDURE D ( i : INTEGER );
    BEGIN
      IF i > 0 THEN
        A(i - 1); Out.Char('S');
        D(i - 1); Out.Char('W');
        D(i - 1); Out.Char('N');
        C(i - 1)
      END
    END D;


  PROCEDURE Zeichne;

    VAR ordnung: INTEGER;

    BEGIN
      In.Prompt('Ordnung ( 0 .. 3 )');
      In.Int(ordnung);    
      Out.Ln; Out.Char(' ');
      A(ordnung)
    END Zeichne;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Zeichne
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;
   Out.Open
 END HilbertV.

 (* ----------------------------------------------------------------------- *)

