
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: HILBERTV.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    HILBERT-Kurven, David HILBERT (1891)                          |
  |           Vorwrtsdeklarationen von Prozeduern                          |
  |-------------------------------------------------------------------------|
  | Leistung: Ausgeben der Aktionen zum Zeichnen der Hilbert-Kurve einer    |
  |           bestimmten Ordnung.                                           |
  |           Das Modul enthlt Vorwrtsdeklarationen von Prozeduern        |
  |           (Erweiterung der Sichtbarkeitsregel)                          |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise eingefgt werden.                   |
  |           Siehe ...\hilbert\fine\hilbertv.mod                           |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\hilbert\txt\hilbert.txt                           |
  |                   ...\hilbert\doc\hilbert.doc                           |
  | Eingabehinweise:  ...\hilbert\doc\hilbtool.txt                          |
  | (Turtle/Hilbert)  ...\hilbert\doc\hilbtool.doc                          |
  *-------------------------------------------------------------------------*)

 MODULE HilbertV;

   IMPORT In, Out;


  PROCEDURE ^B ( i : INTEGER );     (* Vorwrtsdeklarationen der Prozeduern *)
  PROCEDURE ^C ( i : INTEGER );     (* B, C, D. Damit erfolgt eine Erweite- *)
  PROCEDURE ^D ( i : INTEGER );     (* rung der Sichtbarkeitsregel          *)


  PROCEDURE A ( i : INTEGER );
    BEGIN
      IF i > 0 THEN
        D(i - 1); Out.Char('W');
        A(i - 1); Out.Char('S');
        A(i - 1); Out.Char('E');
        B(i - 1)
      END
    END A;


  PROCEDURE B ( i : INTEGER );
    BEGIN
      IF i > 0 THEN
        C(i - 1); Out.Char('N');
        B(i - 1); Out.Char('E');
        B(i - 1); Out.Char('S');
        A(i - 1)
      END
    END B;


  PROCEDURE C ( i : INTEGER );
    BEGIN
      IF i > 0 THEN
        B(i - 1); Out.Char('E');
        C(i - 1); Out.Char('N');
        C(i - 1); Out.Char('W');
        D(i - 1)
      END
    END C;


  PROCEDURE D ( i : INTEGER );
    BEGIN
      IF i > 0 THEN
        A(i - 1); Out.Char('S');
        D(i - 1); Out.Char('W');
        D(i - 1); Out.Char('N');
        C(i - 1)
      END
    END D;


  PROCEDURE Zeichne;

    VAR ordnung: INTEGER;

    BEGIN
      In.Prompt('Ordung ( 0..3 )');
      In.Int(ordnung);    
      Out.Ln; Out.Char(' ');
      A(ordnung)
    END Zeichne;


  PROCEDURE ProgMain*();
    BEGIN
      Zeichne
    END ProgMain;

 BEGIN
   In.Open;
   Out.Open
 END HilbertV.

