
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: KREUZUNG.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Thringer Abiturprfung Grundfach Informatik 1998,            |
  |           Aufgabe 1.4  (Zentralabitur)                                  |
  |-------------------------------------------------------------------------|
  | Leistung: Ermitteln der Stunde(n) des geringsten und grten Verkehrs-  |
  |           aufkommens an einer Straenkreuzung.                          |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul als lauffhiges Grundgerst befindet sich in:       |
  |           ...\kreuzung\good\kreuzung.mod                                |
  |-------------------------------------------------------------------------|
  | Aufgabenstellung: ...\kreuzung\txt\kruezuna.txt                         |
  |                   ...\kreuzung\doc\kreuzuna.doc                         |
  | Lsungsentwurf:   ...\kreuzung\txt\kreuzung.txt                         |
  |                   ...\kreuzung\doc\kreuzung.doc                         |
  | Eingabehinweise:  ...\kreuzung\doc\krztool.txt                          |
  |                   ...\kreuzung\doc\krztool.doc                          |
  |-------------------------------------------------------------------------|
  | Zustzliche Dateien mit Verkehrsaufkommen (24 Stunden):                 |
  |                   ...\kreuzung\txt\kruezun1.txt                         |
  |                   ...\kreuzung\txt\kruezun2.txt                         |
  |                   ...\kreuzung\txt\kruezun3.txt                         |
  *-------------------------------------------------------------------------*)

 MODULE Kreuzung;

  IMPORT In, Out, S:= Strings;


 (* --------------------  U N T E R P R O G R A M M E --------------------- *)


  PROCEDURE Erlaeuterungen;

    VAR i : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('    Men:   Pane                     (Mausklick)'); Out.Ln;
      Out.String('    Option: read input from file...  (Mausklick)'); Out.Ln;
      Out.String('    Pfad:   ...\kreuzung\fine        (Doppelklick)'); Out.Ln;
      Out.String('    Datei:  kreuzung.txt ffnen      (Doppelklick)'); Out.Ln;
      Out.Ln; Out.Char(' ');
      FOR i:= 1 TO 56 DO Out.Char('') END;
            (* '' = <Alt> + <0><1><6><8> auf dem Nummernblock der Tastatur *)
      Out.Ln
    END Erlaeuterungen;


  PROCEDURE SummeUndDurchschnitt;

   (*-----------------------------------------------------------------------*
    | Leistung: Einlesen der stndlichen Verkehrsdichte von 1 Uhr bis 24    |
    |           Uhr. Berechnen und Ausgabe der Summe der Fahrzeuge, die     |
    |           diese Kreuzung innerhalb der Beobachtungszeit befahren ha-  |
    |           ben, und des arithmetischen Mittels.                        |
    *-----------------------------------------------------------------------*)

    CONST stunde   = '. Stunde';

    VAR   summe, 
          wert, k  : INTEGER;
          zahl     : ARRAY  3 OF CHAR;
          message  : ARRAY 24 OF CHAR;

    BEGIN
      summe:= 0;
      In.Open;
      FOR k:= 1 TO 24 DO
        message:= 'Anzahl ';
        S.Str(k,zahl); S.Append(message,zahl); S.Append(message,stunde);
        In.Prompt(message);
        In.Int(wert);
        summe:= summe + wert
      END;
      Out.Ln; Out.String('  Summe        = '); Out.Int(summe,6); Out.Ln;
      Out.Ln; Out.String('  Durchschnitt = '); Out.Real(summe / 24,6);
      Out.Ln
    END SummeUndDurchschnitt;


  PROCEDURE Positionieren;

    VAR i : INTEGER;

    BEGIN
      Out.Ln;
      FOR i:= 1 TO 50 DO Out.Char(' ') END
    END Positionieren;


  PROCEDURE Minimum;
   (*-----------------------------------------------------------------------*
    | Leistung: Ermitteln der Stunden minimaler Belastung der Kreuzung und  |
    |           tabellarische Ausgabe der Stundennummer(n).                 |
    *-----------------------------------------------------------------------*)

    VAR i, k, min, wert : INTEGER;

    BEGIN
      min:= MAX(INTEGER);                    (* Initialisieren des Minimums *)
      In.Open;                               (* Datenstream erneut einlesen *)
      FOR k:= 1 TO 24 DO
        In.Int(wert);
        IF wert < min THEN min:= wert END    (* Aktualisieren des Minimums  *)
      END;
      Out.Ln;
      Out.String('  Stunde(n) mit dem geringsten Verkehrsaufkommen =');
      i:= 0;
      In.Open;                               (* Datenstream erneut einlesen *)
      FOR k:= 1 TO 24 DO
        In.Int(wert);
          IF wert = min THEN                 (* Vergleich und Ausgabe       *)
          INC (i);
          Out.Int(k,4);
          IF i MOD 6 = 0 THEN Positionieren END
        END;
      END;
      Out.Ln
    END Minimum;


  PROCEDURE Maximum;
   (*-----------------------------------------------------------------------*
    | Leistung: Ermitteln der Stunden maximaler Belastung der Kreuzung und  |
    |           tabellarische Ausgabe der Stundennummer(n).                 |
    *-----------------------------------------------------------------------*)

    VAR i, k, max, wert : INTEGER;

    BEGIN
      max:= MIN(INTEGER);
      In.Open;
      FOR k:= 1 TO 24 DO
        In.Int(wert);
        IF wert > max THEN max:= wert END
      END;
      Out.Ln;
      Out.String('  Stunde(n) mit dem grten Verkehrsaufkommen    =');
      i:= 0;
      In.Open;                               (* Datenstream erneut einlesen *)
      FOR k := 1 TO 24 DO
        In.Int(wert);
        IF wert = max THEN
          INC(i);
          Out.Int(k,4);
          IF i MOD 6 = 0 THEN Positionieren END
        END
      END;
      Out.Ln
    END Maximum;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Erlaeuterungen;
      SummeUndDurchschnitt;
      Minimum;
      Maximum
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   Out.Open
 END Kreuzung.

 (* ----------------------------------------------------------------------- *)

