
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 BIT)        Datei-Name: PERMUTAT.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    P e r m u t a t i o n                                         |
  |-------------------------------------------------------------------------|
  | Leistung: Permutation von vier Zeichen (DT: CHAR)                       |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise eingefgt werden.                   |
  |           Siehe ...\ostern\fine\ostern.mod                              |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul als lauffhiges Grundgerst befindet sich in:       |
  |            ...\perm\good\permutat.mod                                   |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\perm\txt\permutat.txt und                         |
  |                   ...\perm\doc\permutat.doc                             |
  *-------------------------------------------------------------------------*)

 MODULE Permutat;

  IMPORT In, Out, W:= Window;

  CONST  max      = 4;

  TYPE   tReihung = ARRAY max+1 OF CHAR;

  VAR    dummy    : BOOLEAN;
         anzahl   : LONGINT;
         a        : tReihung;


 (* --------------------  U N T E R P R O G R A M M E --------------------- *)


  PROCEDURE Ueberschrift;
    BEGIN
      Out.Ln; Out.Ln;
      Out.String('    P E R M U T A T I O N'); Out.Ln;
      Out.String('   '); Out.Ln;
            (* '' = <Alt> + <0><1><6><8> auf dem Nummernblock der Tastatur *)
    END Ueberschrift;


  PROCEDURE LoesungAusgeben;
   (*-----------------------------------------------------------------------*
    | Leistung: Ausgabe aller Lsungen in Tabellenform.                     |
    *-----------------------------------------------------------------------*)

    VAR i: INTEGER;

    BEGIN 
      INC(anzahl);
      Out.String('          ');
      FOR i:= 0 TO max-1 DO
        Out.Char(' '); Out.Char(a[i])
      END;
      Out.Ln
    END LoesungAusgeben;


  PROCEDURE Tauschen ( VAR x, y : CHAR );
   (*-----------------------------------------------------------------------*
    | Referenz: Zu tauschende/getauschte Buchstaben                         |
    | Leistung: Tauschen zweier Daten (DT: CHAR) unter Zuhilfenahme eiens   |
    |           Hilfsspeicherplatzes h (DT: CHAR).                          |
    *-----------------------------------------------------------------------*)

    VAR h: CHAR;

    BEGIN
      h:= x;
      x:= y;
      y:= h
    END Tauschen;


  PROCEDURE Perm ( n : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Anzahl zu permutierender Zeichen                           |
    | Leistung:  Abarbeiten des rekursiven Algorithmus zum Ermitteln aller  |
    |            Premutationen. Die Abbruchbedingung lautet n = 0. Ist die- |
    |            se Bedingung nach einigen rekursiven Aufrufen Perm(n-1)    |
    |            erfllt, wird das UP LoesungAusgeben aufgerufen.           |
    *-----------------------------------------------------------------------*)

    VAR k : INTEGER;

    BEGIN 
      IF n = 0 THEN
        LoesungAusgeben
      ELSE
        FOR k:= n TO 0 BY -1 DO
          Tauschen(a[k],a[n]);
          Perm(n-1);                                   (* rekursiver Aufruf *)
          Tauschen(a[k],a[n])
        END
      END
    END Perm;


  PROCEDURE Einlesen;
   (*-----------------------------------------------------------------------*
    | Leistung: Vier Zeichen (DT: CHAR) einlesen. Falls es sich um Klein-   |
    |           buchstaben handelt, werden sie in Grobuchstaben gewandelt. |
    |           Leerzeichen werden nicht in die Reihung aufgenommen.        |
    |           Kontrollausgabe am Bildschirm, da der Eingabestream nach    |
    |           dem Bettigen der Enter-Taste nicht mehr zu lesen ist.      |
    *-----------------------------------------------------------------------*)

    VAR i       : INTEGER;
        zeichen : CHAR;

    BEGIN
      In.Prompt('vier Buchstaben:');
      i:= 0;
      REPEAT
        In.Char(zeichen);
        WHILE zeichen = ' ' DO
          In.Char(zeichen)
        END;
        a[i]:= CAP(zeichen);
        INC(i)
      UNTIL i = max;
      Out.Ln; Out.String('    eingelesen: ');
      FOR i:= 0 TO max-1 DO
        Out.Char(' '); Out.Char(a[i])
      END;
      Out.Ln; Out.Ln
    END Einlesen;


  PROCEDURE Loesen;
   (*-----------------------------------------------------------------------*
    | Leistung: Permutationszhler (anzahl, DT : LONGINT) auf null setzen.  |
    |           UP Perm(utationen) aufrufen. Dabei erfolgt eine Parameter-  |
    |           bergabe. Ausgabe der Anzahl der Permutationen.             |
    *-----------------------------------------------------------------------*)

    BEGIN
      anzahl:= 0;
      Perm(max-1);                                         (* erster Aufruf *)
      Out.Ln;
      Out.String('    '); Out.Int(anzahl,1); Out.String(' Permutationen');
      Out.Ln
    END Loesen;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Ueberschrift;
      Einlesen;
      Loesen
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;
   Out.Open;
   dummy:= W.ShowWindow(W.GetActiveWindow(),3)
 END Permutat.

 (* ----------------------------------------------------------------------- *)

