
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: AUSWAEHL.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   durch Auswhlen - 1. Variante             |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren von INTEGER-Zahlen, die in einer Textdatei abgelegt |
  |           sind.                                                         |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul als lauffhiges Grundgerst finden Sie unter:       |
  |            ...\sort1\good\auswaehl.mod                                  |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort1\txt\auswaeh1.txt und                        |
  |                   ...\sort1\doc\auswaeh1.doc                            |
  *-------------------------------------------------------------------------*)

 MODULE Auswaehl;

  IMPORT In, Out;

  CONST  max = 5;

  VAR    a : ARRAY max+1 OF INTEGER;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Ueberschrift;
    BEGIN
      Out.Ln; Out.Ln;
      Out.String('    S O R T I E R E N   durch Auswhlen'); Out.Ln;
      Out.String('   '); Out.Ln
             (* '' = <Alt> + < 0 1 6 8 > auf dem Nummernblock der Tastatur *)
    END Ueberschrift;


  PROCEDURE Anleitung;

    VAR zeichen : CHAR;
        spalte,
        zeile   : INTEGER;

    BEGIN
      In.Prompt('Ohne Eingabe!');
      Out.Ln;
      Out.String('   A N L E I T U N G :'); Out.Ln; Out.Ln;
      Out.String("   - Aktivieren Sie das Men 'Pane',"); Out.Ln;
      Out.String("   - klicken Sie auf die Option 'read input from file...',");
      Out.Ln;
      Out.String("   - whlen Sie den Dateipfad '...\SORT1\FINE und"); Out.Ln;
      Out.String("   - klicken Sie doppelt auf den Dateinamen 'ZAHLEN.TXT'!");
      Out.Ln; Out.Ln; Out.Ln
    END Anleitung;


  PROCEDURE ElementeAusgeben;

    VAR index : INTEGER;

    BEGIN
      FOR index:= 1 TO max DO
        Out.Int(a[index],6)
      END;
      Out.Ln
    END ElementeAusgeben;


  PROCEDURE Einlesen;
   (*-----------------------------------------------------------------------*
    | Leistung: Einlesen der INTEGER-Werte aus einer Textdatei mittels der  |
    |           Option 'read input from file...' aus dem Men 'Pane'        |
    *-----------------------------------------------------------------------*)

    VAR zahl, index : INTEGER;

    BEGIN
      index:= 0;
      FOR index:= 1 TO max DO
        In.Int(zahl);
        a[index]:= zahl
      END;
      Out.String('   Zu sortierende Elemente a[1] bis a['); Out.Int(max,1);  
      Out.String(']: ');
      ElementeAusgeben
    END Einlesen;


  PROCEDURE Sortieren;
   (*-----------------------------------------------------------------------*
    | Leistung: Sortieren durch Auswhlen.                                  |
    |           Die ausfhrliche Beschreibung des Algorithmus' findet man   |
    |           unter  ...\sort1\doc\auswaeh1.doc (WORD-Version)            |
    |           oder   ...\sort1\txt\auswaeh1.txt (Text-Version)            |
    *-----------------------------------------------------------------------*)

    VAR r, s, t, x : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('   Das Sortieren beginnt.'); Out.Ln;
      FOR r:= 1 TO max-1 DO
         t:= r;
         x:= a[r];
         FOR s:= r+1 TO max DO
            IF a[s] < x THEN
               t:= s;
               x:= a[s]
            END
         END;
         a[t]:= a[r];
         a[r]:= x
      END;
      Out.String('   Der Sortiervorgang ist beendet.'); Out.Ln
    END Sortieren;


  PROCEDURE Ausgeben;
    BEGIN
      Out.Ln;
      Out.String('   Die Elemente in sortierter Reihenfolge:');
      ElementeAusgeben
    END Ausgeben;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Ueberschrift;
      Anleitung;
      Einlesen;
      Sortieren;
      Ausgeben
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;
   Out.Open
 END Auswaehl.

 (*-------------------------------------------------------------------------*)

