
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: AUSWAEHS.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   durch Auswhlen - 3. Variante             |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren von Strecken, die auf einer Geraden liegen, auf-    |
  |           steigend nach der Koordinate ihres Anfangspunkts.             |
  |           Ist die Koordinate des Anfangspunkts mehrer Strecken gleich,  |
  |           werden die Lngen der Strecken beim Sortieren nicht beachtet. |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul als lauffhiges Grundgerst finden Sie unter:       |
  |            ...\sort1\good\auswaehs.mod                                  |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort1\txt\auswaeh3.txt und                        |
  |                   ...\sort1\doc\auswaeh3.doc                            |
  *-------------------------------------------------------------------------*)

 MODULE AuswaehS;

  IMPORT In, Out, S:= Strings, W:= Window;

  CONST  max = 8;

  TYPE   tDatensatz = RECORD
                        anf, end: INTEGER 
                                     (* Anfangs- und Endpunkt einer Strecke *)
                      END;

  VAR    sort, usort : ARRAY max +1 OF tDatensatz;
         

 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Ueberschrift;
    BEGIN
      Out.Ln;
      Out.String('   S O R T I E R E N   durch Auswhlen'); Out.Ln;
      Out.String('  '); Out.Ln
             (* '' = <Alt> + < 0 1 6 8 > auf dem Nummernblock der Tastatur *)
    END Ueberschrift;


  PROCEDURE Anleitung;
    BEGIN
      In.Prompt('Ohne Eingabe!');
      Out.Ln;
      Out.String('  A N L E I T U N G :'); Out.Ln;
      Out.String('  '); Out.Ln;
             (* '' = <Alt> + < 0 1 7 5 > auf dem Nummernblock der Tastatur *)
      Out.String("  - Aktivieren Sie das Men 'Pane',"); Out.Ln;
      Out.String("  - klicken Sie auf die Option 'read input from file...',");
      Out.Ln;
      Out.String("  - whlen Sie den Dateipfad '...\SORT1\FINE' und"); Out.Ln;
      Out.String("  - klicken Sie doppelt auf den Dateinamen 'STRECKEN.TXT'!");
      Out.Ln; Out.Ln
    END Anleitung;


  PROCEDURE EinlesenStrecke ( VAR t : tDatensatz );
   (*-----------------------------------------------------------------------*
    | Leistung: Einlesen des Anfangs- und des Endpunkts einer Strecken      |
    |           (DT: INTEGER) aus einer Textdatei.                          |
    *-----------------------------------------------------------------------*)

    BEGIN
      In.Int(t.anf);                (* die ersten beiden Eintrge aus der   *)
      In.Int(t.end);                (* Textdatei (Eingabestream) lesen.     *)
    END EinlesenStrecke;


  PROCEDURE Einlesen;
   (*-----------------------------------------------------------------------*
    | Leistung: mittels der Option 'read input from file...' aus dem Men   |
    |           'Pane'.                                                     |
    *-----------------------------------------------------------------------*)

    VAR n       : INTEGER;
        strecke : tDatensatz;

    BEGIN
      n:= 0;
      EinlesenStrecke(strecke);     (* ein Datenpaar aus der Datei lesen    *)
      WHILE In.Done DO              (* Solange das Dateiende nicht erreicht *)
        INC(n);                     (* wurde, n inkrementieren, a[n] die    *)
        usort[n]:= strecke;         (* Werte der RECORD-Variable strecke    *)
        EinlesenStrecke(strecke);   (* zuweisen und ein Datenpaar aus der   *)
      END;                          (* Datei lesen.                         *)
      Out.Ln;
      Out.String('   Zu sortierende Strecken: a[1] bis a[');
      Out.Int(max,1); Out.Char(']'); Out.Ln; Out.Ln
    END Einlesen;


  PROCEDURE Sortieren;
   (*-----------------------------------------------------------------------*
    | Leistung: Sortieren durch Auswhlen.                                  |
    |           Die ausfhrliche Beschreibung des Algorithmus' findet man   |
    |           unter  ...\sort1\doc\auswaeh1.doc (WORD-Version)            |
    |           oder   ...\sort1\txt\auswaeh1.txt (Text-Version)            |
    *-----------------------------------------------------------------------*)

    VAR r, s, t : INTEGER;
        x       : tDatensatz;

    BEGIN
      Out.String('     Das Sortieren beginnt.'); Out.Ln;
      FOR r:= 1 TO max -1 DO
         t:= r;
         x:= sort[r];
         FOR s:= r+1 TO max DO
            IF sort[s].anf < x.anf THEN
               t:= s;
               x:= sort[s]
            END
         END;
         sort[t]:= sort[r];
         sort[r]:= x
      END;
      Out.String('     Das Sortieren ist beendet.'); Out.Ln; Out.Ln
    END Sortieren;


  PROCEDURE AusgebenStrecke ( t : tDatensatz; n, stz1, stz2 : INTEGER; 
                                                           ordFlag : BOOLEAN);
   (*-----------------------------------------------------------------------*
    | bernahme: Datensatz, der den Anfangs- und Endpunkt einer Strecke be- |
    |            inhaltet, die beiden Stellenzahlen fr die formatierte IN- |
    |            TEGER-Ausgabe und eine boolesche Variable, deren Wert be-  |
    |            stimmt, ob eine Ordnungszahl ausgegeben wird (TRUE = ja).  |
    | Leistung:  Ausgabe einer Ordnungszahl gefolgt von dem Wort 'Strecke'  |
    |            und deren Werte des Anfangs- und Endpunkts.                |
    *-----------------------------------------------------------------------*)

    VAR ordStrecke : ARRAY 18 OF CHAR;

    BEGIN
      IF ordFlag THEN
        ordStrecke:= '';
        S.Str(n,ordStrecke);
        S.Insert('     ',ordStrecke,0);
        S.Append(ordStrecke,'. Strecke:');
        Out.String(ordStrecke)
      END;
      Out.Int(t.anf,stz1);  
      Out.Int(t.end,stz2)
    END AusgebenStrecke;


  PROCEDURE Ausgeben;
   (*-----------------------------------------------------------------------*
    | Leistung: Aufziehen des Fensters auf die volle Bilschirmgre und     |
    |           Ausgabe der unsortierten und sortierten Streckendaten.      |
    *-----------------------------------------------------------------------*)

    VAR k     : INTEGER;
        dummy : BOOLEAN;

    BEGIN
      dummy:= W.ShowWindow(W.GetActiveWindow(),3);
      Out.String('   Strecken in unsortierter und sortierter Reihenfolge:');
      Out.Ln; Out.Ln;
      FOR k:= 1 TO max DO
        AusgebenStrecke(usort[k],k,6,6,TRUE);
        AusgebenStrecke(sort[k],k,8,6,FALSE);
        Out.Ln
      END
    END Ausgeben;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Ueberschrift;
      Anleitung;
      Einlesen;
      sort:= usort;
      Sortieren;
      Ausgeben
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;
   Out.Open
 END AuswaehS.

 (* ----------------------------------------------------------------------- *)
