
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: AUSWAEHV.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   durch Auswhlen - 4. Variante             |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren einer unstrukturierten Punktwolke (aufsteigend).    |
  |           Der Sortiervorgang wird durch wiederholtes Setzen und Lschen |
  |           der Punkte im Grafikfenster (ColorPlane) veranschaulicht.     |
  |-------------------------------------------------------------------------|
  | Hinweis:  Grafikmodus 800 x 600 Pixel, Farbauflsung mindestens 15 Bit |
  |           Siehe:                                                        |
  |            ...\ALL\DOC\GRAFIK.DOC  o d e r  ...\ALL\TXT\GRAFIK.TXT      |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul als lauffhiges Grundgerst finden Sie unter:       |
  |            ...\sort1\good\auswaehv.mod                                  |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort1\txt\auswaeh4.txt und                        |
  |                   ...\sort1\doc\auswaeh4.doc                            |
  *-------------------------------------------------------------------------*)

 MODULE AuswaehV;

  IMPORT C:= ColorPlane, P:= Process, R:= RandomNu, W:= Window;

  CONST  dTime  =    5;
         h       = 400;
         n       = 400;
         xOffset = 180;
         yOffset =  50;

  VAR    a       : ARRAY 1000 OF INTEGER;
         dummy   : BOOLEAN;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Zufallszahl() : INTEGER;
    BEGIN
      RETURN SHORT(ENTIER(R.Uniform() * h))
    END Zufallszahl;


  PROCEDURE FlushKeyBuffer;
   (*-----------------------------------------------------------------------*
    | Leistung: Lschen des Tastaturpuffers                                 |
    *-----------------------------------------------------------------------*)

    VAR Dummy : CHAR;
 
    BEGIN
      WHILE C.KeyPressed() DO Dummy:= C.ReadKey() END
    END FlushKeyBuffer;


  PROCEDURE Delay_ms ( msec : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Eine bestimmte Zeit warten.                                 |
    *-----------------------------------------------------------------------*)

    VAR startzeit, zielzeit : LONGINT;

    BEGIN
      startzeit:= W.GetTickCount(); 
      REPEAT
        zielzeit:= W.GetTickCount()
      UNTIL zielzeit > startzeit + msec 
    END Delay_ms;


  PROCEDURE Ueberschrift;
    BEGIN
      C.SetForeColor(0,136,136);
      C.GotoXY(xOffset+60,495); C.WriteStr('S O R T I E R E N   durch Auswhlen');
      C.Line(xOffset+50,478,xOffset+h-50,478,C.DRAW)
    END Ueberschrift;


  PROCEDURE Eroeffnen;

    VAR k : INTEGER;

    BEGIN
      Ueberschrift;
      Delay_ms(dTime*15);
      C.SetBackColor(255,255,220);
      C.Bar(xOffset-1,yOffset-1,xOffset+h+1,yOffset+h+1,C.ERASE);
      C.SetBackColor(255,255,255);
      C.SetForeColor(0,0,0);
      C.Box(xOffset-2,yOffset-2,xOffset+h+2,yOffset+h+2,C.DRAW);
      FOR k:= 1 TO n DO
        a[k]:= Zufallszahl();
        C.Dot(k+xOffset,a[k]+yOffset,C.DRAW)
      END;
      Delay_ms(dTime*50)
    END Eroeffnen;


  PROCEDURE Sortieren;
   (*-----------------------------------------------------------------------*
    | Leistung: Sortieren durch Auswhlen.                                  |
    |           Die ausfhrliche Beschreibung des Algorithmus' findet man   |
    |           unter  ...\sort1\doc\auswaeh1.doc (WORD-Version)            |
    |           oder   ...\sort1\txt\auswaeh1.txt (Text-Version)            |
    *-----------------------------------------------------------------------*)

    VAR r, s, t, x : INTEGER;

    BEGIN
      P.Yield;                                       (* keine Multitasking  *)
      FOR r:= 1 TO n-1 DO
         t:= r;
         x:= a[r];
         FOR s:= r+1 TO n DO
           IF a[s] < x THEN
             t:= s;
             x:= a[s]
           END
         END;
         Delay_ms(dTime);
         C.Dot(t+xOffset,a[t]+yOffset,C.ERASE);      (* Punkt lschen       *)
         C.Dot(r+xOffset,a[r]+yOffset,C.ERASE);      (* Punkt lschen       *)
         a[t]:= a[r];
         a[r]:= x;
         C.Dot(t+xOffset,a[t]+yOffset,C.DRAW);       (* Punkt setzen        *)
         C.Dot(r+xOffset,a[r]+yOffset,C.DRAW)        (* Punkt setzen        *)
       END
    END Sortieren;


  PROCEDURE Enter;
    BEGIN
      Delay_ms(dTime*25);
      C.GotoXY(650,32); C.WriteStr('< ENTER >');
      FlushKeyBuffer;
      REPEAT UNTIL C.KeyPressed()
    END Enter;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      R.Randomize;  (* Zufallszahlengenerator mit neuem Wert initialisieren *)
      Eroeffnen;
      Sortieren;
      Enter
    END ProgMain;

 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

 BEGIN
   C.Open;
   dummy:= W.ShowWindow(W.GetActiveWindow(),3)   (* maximales Grafikfenster *)
 END AuswaehV.

 (* ----------------------------------------------------------------------- *)

