
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: AUSWAEHO.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   durch Auswhlen - 6. Variante             |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren von n Zahlen durch Auswhlen.                       |
  |           Zum Ermitteln des Zeitverhaltens des Algorithmus bei wachsen- |
  |           der Anzahl n werden entweder die Anzahl der Vergleiche oder   |
  |           die der Bewegungen ermittelt.                                 |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise und ggf. Beispiele fr gltige Ein- |
  |           gaben eingefgt werden.                                       |
  |           Siehe ...\sort1\fine\auswaeho.mod                             |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort1\txt\auswaeh6.txt und                        |
  |                   ...\sort1\doc\auswaeh6.doc                            |
  *-------------------------------------------------------------------------*)

 MODULE AuswaehO;

  IMPORT In, Out, S:= Strings;

  CONST  max = 1000;

  VAR    a   : ARRAY max+1 OF INTEGER;


  PROCEDURE Art ( VAR art : INTEGER );
    BEGIN
      Out.Ln;
      Out.String('   Arten:'); Out.Ln;
      Out.String('     (1) Vergleiche'); Out.Ln;
      Out.String('     (2) Bewegungen'); Out.Ln;
      Out.String('   anzeigen'); Out.Ln; Out.Ln;
      Out.String('   Eingabe mit < Enter > abschlieen.'); Out.Ln;
      REPEAT
        In.Prompt('Art   ( 1 oder 2 )');
        In.Int(art)
      UNTIL (art = 1) OR (art = 2)
    END Art;


  PROCEDURE Einlesen ( VAR n : INTEGER );

    VAR string  : ARRAY 45  OF CHAR;
        zahlStr : ARRAY 10  OF CHAR;
        art, i  : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('   Anzahl der zu sortierenden Zahlen =');
      REPEAT
        In.Prompt('Anzahl   ( 5 .. 10 )');
        In.Int(n)
      UNTIL (n > 4) & (n < 11);
      Out.Int(n,3); Out.Ln; Out.Ln;
      Out.String('   Die Zahlen werden in'); Out.Ln;
      Out.String('     (1) aufsteigender'); Out.Ln;
      Out.String('     (2) zuflliger oder'); Out.Ln;
      Out.String('     (3) absteigender'); Out.Ln;
      Out.String('   Reihenfolge eingegeben'); Out.Ln; Out.Ln;      
      S.Str(n,string);
      S.Insert('  Gegeben: ',string,1);
      S.Insert(' Zahlen (',string,S.Length(string)+1);
      REPEAT
        In.Prompt('Art   ( 1 .. 3 )');
        In.Int(art)
      UNTIL (art > 0) & (art < 4);
      IF art = 1 THEN
        S.Append(string,'aufsteigend sortiert)')
      ELSIF art = 2 THEN
        S.Append(string,'zufllig verteilt)')
      ELSE
        S.Append(string,'absteigend sortiert)')
      END;
      Out.Ln; Out.String(string); Out.Ln; Out.Ln;
      FOR i:= 1 TO n DO
        S.Str(i,zahlStr);
        S.Append(zahlStr,'. Zahl');
        In.Prompt(zahlStr);
        In.Int(a[i]);
        Out.Int(a[i],5)
      END;
      Out.Ln;
    END Einlesen;


  PROCEDURE Sortieren ( art, n : INTEGER; VAR z : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Sortieren durch Auswhlen.                                  |
    |           Die ausfhrliche Beschreibung des Algorithmus' findet man   |
    |           unter  ...\sort1\doc\auswaeh1.doc (WORD-Version)            |
    |           oder   ...\sort1\txt\auswaeh1.txt (Text-Version)            |
    *-----------------------------------------------------------------------*)

    VAR r, s, t, x : INTEGER;      
        vergleiche,
        bewegungen    : LONGINT;

    BEGIN
      Out.Ln;
      IF art = 1 THEN
        Out.String('  Ausgabe der Vergleiche'); Out.Ln;
        vergleiche:= 0
      ELSE
        Out.String('  Ausgabe der Bewegungen'); Out.Ln;
        bewegungen:= 0
      END;
      Out.Ln;
      Out.String('    ');
      z:= 6;                                 (* Hilfsvariable: Zeilenzhler *)
      FOR r:= 1 TO n-1 DO
        t:= r;
        x:= a[r];  
        IF art = 2 THEN
          Out.Char('*');
          INC(bewegungen)
        END;
        FOR s:= r+1 TO n DO
          IF art = 1 THEN
            Out.Char('*');
            INC(vergleiche)
          END;
          IF a[s] < x THEN
            t:= s;
            x:= a[s];  
            IF art = 2 THEN
              Out.Char('*');
              INC(bewegungen)
            END
          END
        END;
        a[t]:= a[r];
        a[r]:= x;  
        IF art = 2 THEN
          Out.String('**');
          INC(bewegungen,2)
        END;
        Out.Ln; Out.String('    ');                        (* Zeilenwechsel *)
        INC(z)                                             (* Zeilenzhler  *)
      END;
      Out.Ln; INC(z);
      IF art = 1 THEN
        Out.Int(vergleiche,5); Out.String(' Vergleiche')
      ELSE
        Out.Int(bewegungen,5); Out.String(' Bewegungen')
      END;
      Out.Ln; Out.Ln;
      INC(z,7)                                             (* Zeilenzhler  *)
    END Sortieren;


  PROCEDURE Ausgeben ( n, z : INTEGER );

    VAR k: INTEGER;

    BEGIN
      Out.String('   Elemente in sortierter Reihenfolge:'); Out.Ln; Out.Ln;
      FOR k:= 1 TO n DO
        Out.Int(a[k],5)
      END;
      WHILE z < 25 DO
        Out.Ln; INC(z)                                   (* Zeilenzhler    *)
      END;                                               (* Bildschirm o.k. *)
    END Ausgeben;


  PROCEDURE ProgMain*();

    VAR art, n, z : INTEGER;

    BEGIN
      Art(art);
      Einlesen(n);
      Sortieren(art,n,z);
      Ausgeben(n,z)
    END ProgMain;


 BEGIN
   In.Open;
   Out.Open
 END AuswaehO.

