
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: AUSWAEHV.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   durch Auswhlen - 4. Variante             |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren einer unstrukturierten Punktwolke (aufsteigend).    |
  |           Der Sortiervorgang wird durch wiederholtes Setzen und Lschen |
  |           der Punkte im Grafikfenster (ColorPlane) veranschaulicht.     |
  |-------------------------------------------------------------------------|
  | Hinweise: Grafikmodus 800 x 600 Pixel                                  |
  |           Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Siehe ...\sort1\fine\auswaehv.mod                             |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort1\txt\auswaeh4.txt und                        |
  |                   ...\sort1\doc\auswaeh4.doc                            |
  *-------------------------------------------------------------------------*)

 MODULE AuswaehV;

  IMPORT C:= ColorPlane, Ran:= RandomNu, W:= Window;

  CONST  n     = 400;
         h     = 400;
         delay =  50;            (* darf bis MAX(LONGINT) vergrert werden *)

  VAR    a     : ARRAY 1000 OF INTEGER;
         dummy : BOOLEAN;


  PROCEDURE Zufallszahl() : INTEGER;
    BEGIN
      RETURN SHORT(ENTIER(Ran.Uniform() * h))
    END Zufallszahl;


  PROCEDURE Delay;

    VAR g, w : LONGINT;

    BEGIN
      w:= 0;
      FOR g:= 0 TO 1000 * delay DO INC(w) END
    END Delay;

  
  PROCEDURE Start;
   (*-----------------------------------------------------------------------*
    | Leistung: Sortieren durch Auswhlen.                                  |
    |           Die ausfhrliche Beschreibung des Algorithmus' findet man   |
    |           unter  ...\sort1\doc\auswaeh1.doc (WORD-Version)            |
    |           oder   ...\sort1\txt\auswaeh1.txt (Text-Version)            |
    *-----------------------------------------------------------------------*)

    VAR r, s, t, x, k : INTEGER;

    BEGIN
      FOR k:= 1 TO n DO
        a[k]:= Zufallszahl();
        C.Dot(k,a[k],C.draw)
      END;
      FOR r:= 1 TO n-1 DO
         t:= r;
         x:= a[r];
         FOR s:= r+1 TO n DO
           IF a[s] < x THEN
             t:= s;
             x:= a[s]
           END
         END;
         Delay;
         C.Dot(t,a[t],C.erase); C.Dot(r,a[r],C.erase);
         a[t]:= a[r];
         a[r]:= x;
         C.Dot(t,a[t],C.draw); C.Dot(r,a[r],C.draw)
       END
    END Start;


  PROCEDURE Enter;
    BEGIN
      Delay;
      C.GotoXY(650,32); C.WriteStr('< ENTER >');
      REPEAT UNTIL C.KeyPressed()
    END Enter;


  PROCEDURE ProgMain*();
    BEGIN
      Start;
      Enter
    END ProgMain;


 BEGIN
   C.Open;
   dummy:= W.ShowWindow(W.GetActiveWindow(),3)   (* maximales Grafikfenster *)
 END AuswaehV.

