
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: AUSWAEHZ.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   durch Auswhlen - 5. Variante             |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren von INTEGER-Zahlen mit bestimmten Eigenschaften:    |
  |            - die Zahlen sind bereits aufsteigend sortiert               |
  |            - es handelt sich um Zufallszahlen                           |
  |            - die Zahlen sind absteigend (also "falsch herum") sortiert  |
  |            - Messen der zum Sortieren bentigten Zeit                   |
  |            - Speichern der Messdaten auf einem externen Speichermedium  |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Siehe ...\sort1\fine\auswaehz.mod                             |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort1\txt\auswaeh5.txt und                        |
  |                   ...\sort1\doc\auswaeh5.doc                            |
  *-------------------------------------------------------------------------*)

 MODULE AuswaehZ;

  IMPORT In, Out, Ran:= RandomNu, Zeit;

  CONST  max = 25000;

  TYPE   tStr = ARRAY 51 OF CHAR;

  VAR    a : ARRAY max+1 OF INTEGER;


  PROCEDURE Arbeit ( n : INTEGER );
    BEGIN
      Out.Ln;
      Out.String('  Das System sortiert '); Out.Int(n,1);
      Out.String(' Zahlen.'); Out.Ln; Out.Ln
    END Arbeit;


  PROCEDURE AusgabeArtStrg;

    VAR artStr : ARRAY 4 OF tStr;
        i      : INTEGER;

    BEGIN
      artStr[0]:= 'aufsteigend sortierte Zahlen';
      artStr[1]:= 'Zufallszahlen';
      artStr[2]:= 'absteigend, also "falsch herum", sortierte Zahlen';
      artStr[3]:= 'alle drei Arten nacheinander';
      Out.Ln;
      FOR i:= 0 TO 3 DO
        Out.Int(i+1,5); Out.String('. Art: '); Out.String(artStr[i]); Out.Ln
      END;
      Out.Ln
    END AusgabeArtStrg;


  PROCEDURE Art ( VAR art : INTEGER );
    BEGIN
      REPEAT
        In.Prompt('Art ( 1..4 )');
        In.Int(art)
      UNTIL art IN {1..4}
    END Art;


  PROCEDURE Anzahl ( VAR n : INTEGER );
    BEGIN
      In.Prompt(' Anzahl ( DT: INT )');
      In.Int(n)
    END Anzahl;


  PROCEDURE Zufallszahl() : INTEGER;
    BEGIN
      RETURN SHORT(ENTIER(Ran.Uniform() * 10000))
    END Zufallszahl;


  PROCEDURE Sortieren ( art, n : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Sortieren durch Auswhlen.                                  |
    |           Die ausfhrliche Beschreibung des Algorithmus' findet man   |
    |           unter  ...\sort1\doc\auswaeh1.doc (WORD-Version)            |
    |           oder   ...\sort1\txt\auswaeh1.txt (Text-Version)            |
    *-----------------------------------------------------------------------*)

    VAR k, r, s, t, x : INTEGER;
    
    BEGIN
      CASE art OF
         1: FOR k:= 1 TO n DO
               a[k]:= k
             END
      | 2: FOR k:= 1 TO n DO
               a[k]:= Zufallszahl()
             END;
      | 3: FOR k:= 1 TO n DO
              a[k]:= -k
            END
      END;
      Zeit.Start;
      FOR r:= 1 TO n-1 DO
         t:= r;
         x:= a[r];
         FOR s:= r+1 TO n DO
            IF a[s] < x THEN
               t:= s;
               x:= a[s]
            END
         END;
         a[t]:= a[r];
         a[r]:= x
      END;
      Zeit.Stopp;
      Out.Int(art,8); Out.Ln;
      Out.Int(n,8); Out.Ln;
      Out.Int(Zeit.differenz,8); Out.Ln   (* Zeitdifferenz in Millisekunden *)
    END Sortieren;


  PROCEDURE ProgMain*();

    VAR art, i, n : INTEGER;

    BEGIN
      AusgabeArtStrg;
      Art(art);
      Anzahl(n);
      Arbeit(n);
      IF art = 4 THEN
        FOR i:= 1 TO 3 DO              (* alle drei Ausgangskonfigurationen *)
          Sortieren(i,n)
        END
      ELSE
        Sortieren(art,n)
      END
    END ProgMain;


 BEGIN
   In.Open;
   Out.Open
 END AuswaehZ.
