
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: QUICKSO2.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   (Teile und Herrsche)  2. Variante         |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren von INTEGER-Zahlen (Quicksort) mit grafischer       |
  |           Veranschaulichung des Sortiervorgangs                         |
  |-------------------------------------------------------------------------|
  | Hinweis:  Grafikmodus 800 x 600 Pixel, Farbauflsung mindestens 15 Bit |
  |           Siehe:                                                        |
  |            ...\GRDLAGEN\ALLGEM\DOC\GRAFIK.DOC  o d e r                  |
  |            ...\GRDLAGEN\ALLGEM\TXT\GRAFIK.TXT                           |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul als lauffhiges Grundgerst finden Sie unter:       |
  |            ...\sort2\good\quickso2.mod                                  |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort2\txt\quickso2.txt und                        |
  |                   ...\sort2\doc\quickso2.doc                            |
  *-------------------------------------------------------------------------*)

 MODULE Quickso2;

  IMPORT C:= ColorPlane, P:= Process, R:= RandomNu, W:= Window;

  CONST  dTime   =   5;
         h       = 400;
         n       = 400;
         xOffset = 180;
         yOffset =  50;

  VAR    a       : ARRAY 1000 OF INTEGER;
         dummy   : BOOLEAN;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Zufallszahl() : INTEGER;
    BEGIN
      RETURN SHORT(ENTIER(R.Uniform() * h))
    END Zufallszahl;


  PROCEDURE FlushKeyBuffer;
   (*-----------------------------------------------------------------------*
    | Leistung: Lschen des Tastaturpuffers                                 |
    *-----------------------------------------------------------------------*)

    VAR Dummy : CHAR;
 
    BEGIN
      WHILE C.KeyPressed() DO Dummy:= C.ReadKey() END
    END FlushKeyBuffer;


  PROCEDURE Delay_ms ( msec : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Eine bestimmte Zeit warten.                                 |
    *-----------------------------------------------------------------------*)

    VAR startzeit, zielzeit : LONGINT;

    BEGIN
      startzeit:= W.GetTickCount(); 
      REPEAT
        zielzeit:= W.GetTickCount()
      UNTIL zielzeit > startzeit + msec 
    END Delay_ms;


  PROCEDURE Ueberschrift;
    BEGIN
      C.SetForeColor(0,136,136);
      C.GotoXY(xOffset-20,495);
      C.WriteStr('S O R T I E R E N   nach dem Prinzip TEILE UND HERRSCHE');
      C.Line(xOffset-26,478,xOffset+h+24,478,C.DRAW)
    END Ueberschrift;


  PROCEDURE Eroeffnen;

    VAR k : INTEGER;

    BEGIN
      Ueberschrift;
      Delay_ms(dTime*5);
      C.SetBackColor(255,255,220);
      C.Bar(xOffset-1,yOffset-1,xOffset+h+1,yOffset+h+1,C.ERASE);
      C.SetBackColor(255,255,255);
      C.SetForeColor(0,0,0);
      C.Box(xOffset-2,yOffset-2,xOffset+h+2,yOffset+h+2,C.DRAW);
      Delay_ms(dTime*15)
    END Eroeffnen;


  PROCEDURE Start;

    VAR k : INTEGER;

    PROCEDURE Sort ( l, r : INTEGER );
     (*---------------------------------------------------------------------*
      | Leistung: Sortieren durch Auswhlen.                                |
      |           Die ausfhrliche Beschreibung des Algorithmus' findet man |
      |           unter  ...\sort2\doc\quicksor.doc (WORD-Version)          |
      |           oder   ...\sort2\txt\quicksor.txt (Text-Version)          |
      *---------------------------------------------------------------------*)

      VAR i, j, x, w : INTEGER;

      BEGIN
        i:= l; j:= r;
        x:= a[(l + r) DIV 2];
        REPEAT
          WHILE a[i] < x DO INC(i) END;
          WHILE x < a[j] DO DEC(j) END;
          IF i <= j THEN
            Delay_ms(dTime);
            C.Dot(i+xOffset,a[i]+yOffset,C.ERASE);   (* Punkt lschen       *)
            C.Dot(j+xOffset,a[j]+yOffset,C.ERASE);   (* Punkt lschen       *)
            w:= a[i];
            a[i]:= a[j];
            a[j]:= w;
            C.Dot(i+xOffset,a[i]+yOffset,C.DRAW);    (* Punkt setzen        *)
            C.Dot(j+xOffset,a[j]+yOffset,C.DRAW);    (* Punkt setzen        *)
            INC(i);
            DEC(j)
          END
        UNTIL i > j;
        IF l < j THEN Sort(l,j) END;
        IF i < r THEN Sort(i,r) END
      END Sort;

    BEGIN  (* Sort *)
      FOR k:= 1 TO n DO
        a[k]:= Zufallszahl();
        C.Dot(k+xOffset,a[k]+yOffset,C.DRAW)         (* Punkt setzen        *)
      END;
      P.Yield;                                       (* keine Multitasking  *)
      Sort(1,n)
    END Start;


  PROCEDURE Enter;
    BEGIN
      Delay_ms(dTime*15);
      C.GotoXY(650,32); C.WriteStr('< ENTER >');
      FlushKeyBuffer;
      REPEAT UNTIL C.KeyPressed()
    END Enter;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Ueberschrift;
      Eroeffnen;
      R.Randomize;  (* Zufallszahlengenerator mit neuem Wert initialisieren *)
      Start;
      Enter
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   C.Open;
   dummy:= W.ShowWindow(W.GetActiveWindow(),3)   (* maximales Grafikfenster *)
 END Quickso2.

 (* ----------------------------------------------------------------------- *)

