
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: TEXTSTAT.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Textstatistik (Wort- und Buchstabenanzahl eines Textes)       |
  |-------------------------------------------------------------------------|
  | Leistung: Das Programm ermitteln, aus wie vielen Wrtern ein Text be-   |
  |           steht und wie hufig die 26 Buchstaben in dem Text vorkommen. |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul als lauffhiges Grundgerst finden Sie unter:       |
  |            ...\textsta\good\textsta.mod                                 |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\textsta\txt\textstat.txt und                      |
  |                   ...\textsta\doc\textstat.doc                          |
  *-------------------------------------------------------------------------*)

 MODULE TextStat;

  IMPORT C:= ColorPlane, F:= File, P:=  Process, S:= Strings, W:= Window;

  CONST  fPfad     = 'DEMO1.TXT';
  
         delayTime =  100;     (* 2 ist der Wert fr eine CPU i80486 66 MHz *)
                               (* Bitte an Ihren Prozessor anpassen!        *)
         maxAnzahl = 1441;
         bc_red    =    8;
         bc_green  =   16;
         bc_blue   =   48;
         br        =  480;
         chrAnz    =   60;               (* Anzahl Zeichen pro Ausgabezeile *)
         chrBreite =    8;
         xOffset   =   36;
         yOffset   =  530;
         zeiHoehe  =   20;

  TYPE   tZahlStr  = ARRAY  6 OF CHAR;
         tAlphabet = ARRAY 27 OF INTEGER;
         tStr30    = ARRAY 31 OF CHAR;
         tReihung  = ARRAY maxAnzahl+1 OF INTEGER;

         tArt      = RECORD
                       eigen, trenn, dTfaktor : INTEGER
                     END;

  VAR    dummy     : BOOLEAN;
         zeichen   : tStr30;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE FlushKeybuffer;
   (*-----------------------------------------------------------------------*
    | Leistung: Lschen des Tastaturpuffers                                 |
    *-----------------------------------------------------------------------*)

    VAR Dummy : CHAR;
 
    BEGIN
      WHILE C.KeyPressed() DO Dummy:= C.ReadKey() END
    END FlushKeybuffer;


  PROCEDURE Delay ( dTfaktor : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Eine bestimmte Zeit warten.                                 |
    *-----------------------------------------------------------------------*)

    VAR blue, green, red : INTEGER;
        i, endwert       : LONGINT;

   BEGIN
     endwert:= delayTime * dTfaktor;
     FOR i:= 1 TO endwert DO C.GetDot(0,0,red,green,blue) END 
   END Delay;


  PROCEDURE Delay_ms ( delayTime : LONGINT );
   (*-----------------------------------------------------------------------*
    | Leistung: Eine definierte Zeit warten.                                |
    *-----------------------------------------------------------------------*)

    VAR endwert, tick : LONGINT;

   BEGIN
     tick:= W.GetTickCount();
     endwert:= tick + delayTime;
     REPEAT UNTIL endwert < W.GetTickCount()
   END Delay_ms;


  PROCEDURE Enter ( x, y : INTEGER );
   (*-----------------------------------------------------------------------|
    | bernahme: x-und y-Koordinate fr die Position des Zeichenkette,      |
    | Leistung:  Ausgabe einer Zeichenkette, Lschen des Tastaturpuffers,   |
    |            Warten auf eine Tastatureingabe (Enter- oder Escape-Taste) |
    |            und Lschen der Zeichenkette.                              |
    |            Die Wartezeit sorgt fr einen ruhigeren Programmlauf.      |
    |-----------------------------------------------------------------------*)

   VAR  ChTaste : CHAR;
     
   BEGIN
     Delay_ms(delayTime*5);
     C.SetBackColor(bc_red,bc_green,bc_blue);
     C.SetForeColor(32,160,160);
     C.GotoXY(x,y); C.WriteStr('< ENTER >');
     FlushKeybuffer;
     REPEAT
        ChTaste:= C.ReadKey()
     UNTIL (ChTaste = CHR(13)) OR (ChTaste = CHR(27));
     C.Bar(x,y-14,x+72,y,C.erase)
   END Enter;


 PROCEDURE WriteStrXY ( x, y : INTEGER; string : tStr30 );
   (*-----------------------------------------------------------------------*
    | Leistung: Positionierte Ausgebe einer Zeichenkette im Grafikmodus,    |
    |           x = Pixelspalte; x = 0 entspricht der linken Begrenzung des |
    |                                  aktuellen Grafikfensters             |
    |           y = Pixelzeile;  y = 0 entspricht der unteren Begrenzung    |
    |                                  des aktuellen Grafikfensters         |
    *-----------------------------------------------------------------------*)

    BEGIN
      C.GotoXY(x,y); C.WriteStr(string)
    END WriteStrXY;


  PROCEDURE Wiederholung() : BOOLEAN;
   (*-----------------------------------------------------------------------*
    | Referenz: Funktionswert TRUE, falls eine Wiederholung gewnscht wird, |
    |           d.h. es wurde eine beliebige Taste auer <N> bettigt,      |
    |           sonst FALSE.                                                |
    | Leistung: Ausgabe einer Information, Warten auf eine Tastenbettigung |
    |           (Tastatur), Wandeln des Zeichens in einen Grobuchstaben,   |
    |           falls ein Kleinbuchstabe eingegeben wurde und Asuwerten der |
    |           Eingabe (boolescher Wert).                                  |
    *-----------------------------------------------------------------------*)

    VAR ch : CHAR;
      
    BEGIN
      Delay_ms(delayTime*5);
      C.SetBackColor(bc_red,bc_green,bc_blue);
      C.SetForeColor(32,160,160);
      WriteStrXY(575,50,'Wiederholung (J/N) J');
      FlushKeybuffer;
      ch:= C.ReadKey();
      ch:= S.UpCaseChar(ch);
      C.Bar(575,50,735,34,C.ERASE);
      RETURN ~(ch = 'N') 
    END Wiederholung;


  PROCEDURE AusgabefensterLoeschen;
   (*-----------------------------------------------------------------------*
    | Leistung: Lschen des Inhalts des Ausgabefensters.                    |
    *-----------------------------------------------------------------------*)

    BEGIN
      C.SetBackColor(0,0,0);
      C.Bar(xOffset-2,yOffset-br-18,xOffset+br+2,yOffset-15,C.ERASE)
    END AusgabefensterLoeschen;


  PROCEDURE Ausgabefenster;
   (*-----------------------------------------------------------------------*
    | Leistung: Einen Rahmen zeichnen und das UP AusgabefensterLschen auf  |
    |           rufen.                                                      |
    *-----------------------------------------------------------------------*)

    BEGIN
      C.SetForeColor(0,192,192);
      C.Box(xOffset-5,yOffset-br-21,xOffset+br+5,yOffset-12,C.DRAW);
      AusgabefensterLoeschen
    END Ausgabefenster;


  PROCEDURE Ueberschrift;
    BEGIN
      Ausgabefenster;
      C.SetBackColor(bc_red,bc_green,bc_blue);
      C.SetForeColor(32,208,208);
      WriteStrXY(574,495,'T E X T A N A L Y S E');
      C.Line(564,476,752,476,C.DRAW);
      C.Line(564,475,752,475,C.DRAW);
      Delay(delayTime*2)
    END Ueberschrift;


  PROCEDURE Textausgabe ( a : tReihung; anzahl : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Originaltext zeichenweise in einer Reihung (a) abgelegt.   |
    |            Anzahl aller im Text enthaltenen Zeichen.                  |
    | Leistung:  Zhlen der Textabstze, formatierte Textausgabe und Aus-   |
    |            gabe der Anzahl der Abstze im groen Fenster.             |
    *-----------------------------------------------------------------------*)

   CONST xTextoffset = 14;  yTextoffset = 10;

    VAR  absAnzahl,i, k,
         spalte, zeile   : INTEGER; 
         zahlStr         : tZahlStr;

    BEGIN
      spalte:= xOffset;
      zeile:=  yOffset;
      C.SetBackColor(0,0,0);
      C.SetForeColor(32,160,160);
      absAnzahl:= 0;
      i:= 0; k:= 0;
      WHILE i < anzahl-1 DO
        INC(i); INC(k);
        IF k MOD chrAnz = 1 THEN
          DEC(zeile,zeiHoehe);
          spalte:= xOffset
        END;
        IF (a[i] = 13) & (a[i+1] = 10) THEN 
          DEC(zeile,zeiHoehe);
          spalte:= xOffset;
          INC(absAnzahl);
          INC(i);
          k:= 1
        ELSE
          zeichen:= '';
          S.AppendChar(zeichen,CHR(a[i]));
          WriteStrXY(spalte+xTextoffset,zeile-yTextoffset,zeichen);
          INC(spalte,chrBreite)
        END
      END; (* while *)
      C.SetBackColor(bc_red,bc_green,bc_blue);
      C.SetForeColor(120,208,160);
      WriteStrXY(576,330,'Anzahl Abstze = ');
      S.Str(absAnzahl,zahlStr); C.WriteStr(zahlStr)
    END Textausgabe;


  PROCEDURE Wortanzahl ( a : tReihung; anzahl : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Text, der zeichenweise der Reihung a zugewiesen wurde, Ge- |
    |            samtzahl der Zeichen des Textes (anzahl)                   |
    | Leistung:  Die Komponenten der Reihung werden zeichenweise getestet.  |
    |            Ist ein Zeichen der Menge der Klein- oder Grobuchstaben   |
    |            zuordenbar, wird es gezhlt (chrAnzahl).                   |
    |            Die boolesche Variable imWort wird mit dem Wert FALSE ini- |
    |            tialisiert. Im Schleifenkrper der Zhlschleife wird durch |
    |            geschickte Abfrage (IF ... THEN ... ELSIF ... END) ermit-  |
    |            telt, ob ein Zeichen zu einem Wort gehrt oder ein Trenn-  |
    |            zeichen ist. Die Wrter werden gezhlt.                    |
    |            Die Anzahl der gefundenen Wrter und die Gesamtzahl der    |
    |            Zeichen werden am Bildschirm angezeigt.                    |
    *-----------------------------------------------------------------------*)


    VAR inWort,
        buchstabe  : BOOLEAN;
        zeichen    : CHAR;
        i,
        chrAnzahl,
        wortAnzahl : INTEGER;
        zahlStr    : tZahlStr;

    BEGIN
      C.SetBackColor(bc_red,bc_green,bc_blue);
      C.SetForeColor(120,208,160);
      inWort:= FALSE;
      chrAnzahl:= 0; wortAnzahl:= 0;
      FOR i:= 1 TO anzahl-1 DO
        zeichen:= CHR(a[i]);
        buchstabe:= ('A' <= CAP(zeichen)) & (CAP(zeichen) <= 'Z');
        IF buchstabe THEN INC(chrAnzahl) END;
        IF inWort & ~buchstabe THEN
          inWort:= FALSE
        ELSIF ~inWort & buchstabe THEN
          inWort:= TRUE;
          INC(wortAnzahl)
        END
      END;
      C.SetForeColor(120,208,160);
      WriteStrXY(576,310,'Anzahl Wrter  = ');
      S.Str(wortAnzahl,zahlStr); C.WriteStr(zahlStr);
      Enter(650,40)
    END Wortanzahl;


  PROCEDURE TextEinlesenAusgeben ( VAR a : tReihung; VAR anzahl : INTEGER );
   (*-----------------------------------------------------------------------*
    | Referenz:  Text, der zeichenweise der Reihung a zugewiesen wurde, Ge- |
    |            samtzahl der Zeichen des Textes (anzahl)                   |
    | Leistung:  Lesen der Inhalte der ersten beiden Zeilen der Textdatei   |
    |            von einem externen Datentrger und Ausgabe des Inhalts am  |
    |            Bildschirm. Dann wird der Rest der Textdatei zeichenweise  |
    |            gelesen und die Ordinalzahl des Zeichens (ASCII) je einer  |
    |            Komponenten der Reihung a zugewiesen.                      |
    *-----------------------------------------------------------------------*)


    CONST x1 = 560;  x2 = 576;

    VAR   row         : tStr30; zahlStr : tStr30;
          key         : CHAR;
          fHandle     : F.Handle;
          i, resCode  : INTEGER;

    BEGIN
      C.SetBackColor(bc_red,bc_green,bc_blue);
      C.SetForeColor(0,160,160);
      WriteStrXY(x1,430,'Ausgabe:');
      IF F.Exist(fPfad) THEN
        F.Open(fPfad,FALSE,F.DENYNONE,F.READONLY,fHandle,resCode);
        FOR i:= 1 TO 2 DO
          F.ReadLn(fHandle,row,resCode);
          C.SetForeColor(120,208,160);
          WriteStrXY(x2,410-i*20,row)
        END;
        i:= 1;
        WHILE (~F.AtEnd(fHandle)) & (i < maxAnzahl) DO
          F.ReadChar(fHandle,key,resCode);
          a[i]:= ORD(key);
          INC(i)
        END;
        anzahl:= i;
        F.Close(fHandle);
        Textausgabe(a,anzahl)
      ELSE
        C.SetForeColor(255,127,0);
        WriteStrXY(x1+16,400,'Fehler beim Lesen');
        WriteStrXY(x1+16,380,'der Textatei!');
        Enter(650,40)
      END
    END TextEinlesenAusgeben;

                  
  PROCEDURE Sortieren ( VAR a : tReihung; anzahl : INTEGER; art : tArt );

    PROCEDURE Quicksort ( l, r : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Sortieren der Werte der Komponenten der Reihung nach auf-   |
    |           steigender Gre mittels Qicksort (Teile und Herrsche).     |
    | Hinweis:  Beschreibung des Algorithmus siehe:                         |
    |             ...\SORT2\TXT\QUICKSOR.TXT und ...\QUICKS1.TXT            |
    |            oder bei Nutzung von MS-WORD (o..) unter                  |
    |             ...\SORT2\DOC\QUICKSOR.DOC und ...\QUICKS1.DOC            |
    |           Die Originalwerte der Komponenten der Reihung werden als    |
    |           violette Pixel angezeigt. Die beiden Pixel, die an einer    |
    |           Tauschaktion beteiligt sind werden gelscht (mit Hinter-    |
    |           grundfarbe berschrieben) und an ihrer jeweils neuen Posi-  |
    |           tion als gelbes Pixel ausgegeben.                           |
    *-----------------------------------------------------------------------*)

      VAR i, j, x, w : INTEGER;

      BEGIN
        i:= l;
        j:= r;
        x:= a[(l+r) DIV 2];
        P.Yield;                                     (* keine Multitasking  *)
        REPEAT
          WHILE a[i] < x DO INC(i) END;
          WHILE x < a[j] DO DEC(j) END;
          IF i <= j THEN
            Delay(art.dTfaktor);
            w:= a[i];
            a[i]:= a[j];
            a[j]:= w;
            Delay(art.dTfaktor);
            zeichen:= '';
            S.AppendChar(zeichen,CHR(a[i]));
            WriteStrXY(xOffset+((i-1) MOD chrAnz)*chrBreite,
                       yOffset-(((i-1) DIV chrAnz)+2)*zeiHoehe,zeichen);
            zeichen:= '';
            S.AppendChar(zeichen,CHR(a[j]));
            WriteStrXY(xOffset+((j-1) MOD chrAnz)*chrBreite,
                       yOffset-(((j-1) DIV chrAnz)+2)*zeiHoehe,zeichen);
            INC(i);
            DEC(j)
          END
        UNTIL i > j;
        IF l < j THEN Quicksort(l,j) END;
        IF i < r THEN Quicksort(i,r) END
      END Quicksort;

    BEGIN  (* Start *)
      C.SetBackColor(bc_red,bc_green,bc_blue);
      C.SetForeColor(255,127,0);
      WriteStrXY(576,260,'Sortiervorgang luft!');
      C.SetBackColor(0,0,0);
      C.SetForeColor(255,255,127);
      Quicksort(1,anzahl);
      C.SetBackColor(bc_red,bc_green,bc_blue);
      C.Bar(576,260,744,244,C.ERASE);
      Enter(650,40)
    END Sortieren;


  PROCEDURE Strichgruppen ( alphabet : tAlphabet; i : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Reihung alphabet, deren Komponenten die Hufigkeit des     |
    |            Vorhandenseins der Buchstaben des deutschen Alphabets im   |
    |            analysierten Text in alphabetisch aufsteigender Ordnung    |
    |            enthlt. Die Variable i hlt den Index der aktuellen Kom-  |
    |            ponente.                                                   |
    | Leistung:  Die Hufigkeit des Vorhandenseins eines Buchstabens wird   |
    |            durch Anzeige von Fnfer-Strichgruppen und Einzelstrichen  |
    |            symbolisiert. Jedes Fnfer-Strichgruppenpaar wird farbig   |
    |            abgesetzt, so dass der Eindruck von Zehner-Strichgruppen   |
    |            entsteht.                                                  |
    *-----------------------------------------------------------------------*)
    
    VAR colorFlag : BOOLEAN;
        einer,
        fuenfer,
        x, x1, y  : INTEGER;

    PROCEDURE DarstellenFuenfergruppe;

      VAR i, k : INTEGER;

      BEGIN
        x1:= x;
        FOR i:= 1 TO fuenfer DO
          INC(x1,28);
          IF ODD(i) THEN
            colorFlag:= TRUE;
            C.SetForeColor(255,128,0)
          ELSE
            colorFlag:= FALSE;
            C.SetForeColor(0,220,196)
          END;
          FOR k:= 1 TO 5 DO
            C.Line(x1+k*4,y,x1+k*4-3,y-13,C.DRAW)
          END;
          C.Line(x1-1,y-6,x1+21,y-6,C.DRAW)
        END;
      END DarstellenFuenfergruppe;

    PROCEDURE DarstellenEiner;

      VAR i : INTEGER;

      BEGIN
        INC(x1,24);
        IF colorFlag THEN
          C.SetForeColor(0,220,196)
        ELSE
          C.SetForeColor(255,128,0)
        END;
        FOR i:= 1 TO einer DO
          INC(x1,2);
          C.Line(x1+i*2,y,x1+i*2-3,y-13,C.DRAW)
        END
      END DarstellenEiner;


    BEGIN  (* Strichgruppen *)
      x:= 120; y:= 522 - i*18;
      C.SetForeColor(223,223,127);
      IF alphabet[i] # 0 THEN
        fuenfer:= alphabet[i] DIV 5;
        einer:= alphabet[i] MOD 5;
        DarstellenFuenfergruppe;
        DarstellenEiner
      END
    END Strichgruppen;


  PROCEDURE InitialisierenAlphabet ( VAR alphabet : tAlphabet );
   (*-----------------------------------------------------------------------*
    | Referenz: Reihung alphabet, deren Komponenten die Hufigkeit des Vor- |
    |           handenseins der Buchstaben des deutschen Alphabets im zu    |
    |           analysierenden Text in alphabetisch aufsteigender Ordnung   |
    |           enthalten werden.                                           |
    | Leistung: Initialisieren aller Komponenten mit dem Wert 0.            |
    *-----------------------------------------------------------------------*)

    VAR i : INTEGER;

    BEGIN
      FOR i:= 1 TO 26 DO alphabet[i]:= 0 END;    
    END InitialisierenAlphabet;


  PROCEDURE AnzahlBuchstaben ( a : tReihung; anzahl : INTEGER );
   (*-----------------------------------------------------------------------*
    | bernahme: Text, der zeichenweise der Reihung a zugewiesen wurde, Ge- |
    |            samtzahl der Zeichen des Textes (anzahl)                   |
    | Leistung:  Ermitteln der Buchstabenhufigkeit innerhalb des zu ana-   |
    |            lysierenden Textes.                                        |
    *-----------------------------------------------------------------------*)

    VAR key      : ARRAY  2 OF CHAR;
        alphabet : tAlphabet;
        zeichen  : CHAR;
        einzel,
        fuenfer,
        i, x1,
        x2, y    : INTEGER;
        zahlStr  : tZahlStr;

    BEGIN
      x1:= 70; x2:= 108; y:= 522;
      InitialisierenAlphabet(alphabet);
      FOR i:= 1 TO anzahl DO
        IF a[i] > 91 THEN a[i]:= a[i] - 32 END;
        IF (65 <= a[i]) & (a[i] <= 91) THEN
          INC(alphabet[a[i]-64])
        END
      END;
      FOR i:= 1 TO 26 DO
        key:= '';
        S.AppendChar(key,CHR(i+64));
        C.SetForeColor(223,223,127);
        C.GotoXY(x1,y-i*18); C.WriteStr(key);
        C.WriteStr(' ='); 
        S.Str(alphabet[i],zahlStr);
        C.GotoXY(x2,y-i*18); C.WriteStr(zahlStr); C.WriteStr(' ');
        Strichgruppen(alphabet,i);
      END
    END AnzahlBuchstaben;


  PROCEDURE Analyse ( a : tReihung; anzahl : INTEGER; art : tArt );
    BEGIN
      Wortanzahl(a,anzahl);
      AusgabefensterLoeschen;
      Sortieren(a,anzahl,art);
      C.SetBackColor(0,0,0);
      AusgabefensterLoeschen;
      AnzahlBuchstaben(a,anzahl);
      Enter(650,40)
    END Analyse;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)


  PROCEDURE ProgMain*();

    VAR a          : tReihung;
        anzahl, i  : INTEGER;
        art        : tArt;

    BEGIN
      Ueberschrift;
      art.eigen:= 1;
      art.trenn:= 2;
      art.dTfaktor:= 1;
      i:= 0;
      INC(i);
      IF i > 1 THEN Ausgabefenster END;
      TextEinlesenAusgeben(a,anzahl);
      IF anzahl > 0 THEN
        Analyse(a,anzahl,art)
      END
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   C.Open;
   dummy:= W.ShowWindow(W.GetActiveWindow(),3);
   C.SetBackColor(bc_red,bc_green,bc_blue);
   C.Bar(5,0,850,650,C.ERASE);
   C.SetForeColor(200,200,200);
   C.Bar(1,0,3,650,C.DRAW);
   C.SetForeColor(63,63,63);
   C.Line(4,0,4,650,C.DRAW)
 END TextStat.

 (*-------------------------------------------------------------------------*)

