
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: TEXTSTAT.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Textstatistik (Wort- und Buchstabenanzahl eines Textes)       |
  |-------------------------------------------------------------------------|
  | Leistung: Das Programm ermitteln, aus wie vielen Wrtern ein Text be-   |
  |           steht und wie hufig die 26 Buchstaben in dem Text vorkommen. |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Siehe ...\textsta\fine\textsta.mod                            |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\textsta\txt\textstat.txt und                      |
  |                   ...\textsta\doc\textstat.doc                          |
  *-------------------------------------------------------------------------*)

 MODULE Textstatistik;

  IMPORT In, Out;


  PROCEDURE Anleitung;

    VAR key : CHAR;

    BEGIN
      In.Prompt('Ohne Eingabe!');
      Out.Ln;
      Out.String('  A N L E I T U N G :'); Out.Ln;
      Out.String('  '); Out.Ln;
             (* '' = <Alt> + < 0 1 7 5 > auf dem Nummernblock der Tastatur *)
      Out.String("  - Aktivieren Sie das Men 'Pane',"); Out.Ln;
      Out.String("  - klicken Sie auf die Option 'read input from file...',");
      Out.Ln;
      Out.String("  - whlen Sie den Dateipfad '...\TEXTSTA\GOOD' und"); Out.Ln;
      Out.String("  - klicken Sie doppelt auf den Dateinamen 'DEMOTXT1.TXT'!");
      Out.Ln; Out.Ln;
      Out.String('  O D E R :'); Out.Ln;
      Out.Ln;
      Out.String('  Falls Sie einen Text eingeben wollen, geben Sie ein');
      Out.Ln;
      Out.String('  Leerzeichen ein und bettigen einmal die ENTER-Taste.');
      In.Char(key);
      Out.Ln; Out.Ln;
      Out.String('  Geben Sie den Text ein, bettigen die ENTER-Taste');
      Out.Ln;
      Out.String('  und anschlieend den End-Button.');
      Out.Ln
    END Anleitung;


  PROCEDURE Wortanzahl;

    VAR anzahl    : LONGINT; 
        zeichen   : CHAR;
        inWort,
        buchstabe : BOOLEAN;

    BEGIN
      inWort:= FALSE;
      anzahl:= 0;
      In.Prompt('Zeichenkette');
      In.Char(zeichen);
      WHILE In.Done DO 
        buchstabe:= ('A' <= CAP(zeichen)) & (CAP(zeichen) <= 'Z');
        IF inWort & ~buchstabe THEN
          inWort:= FALSE
        ELSIF ~inWort & buchstabe THEN
          inWort:= TRUE;
          INC(anzahl)
        END;
        In.Char(zeichen)
      END;
      Out.Ln; Out.String('  Anzahl Wrter: '); Out.Int(anzahl,5); Out.Ln
    END Wortanzahl;


  PROCEDURE Buchstaben;

    VAR a       : ARRAY 26 OF LONGINT;
        zeichen : CHAR;
        k       : INTEGER;

    BEGIN
      FOR k:= 0 TO 25 DO a[k]:= 0 END;
      In.Open;
      In.Char(zeichen);
      WHILE In.Done DO
        zeichen:= CAP(zeichen);
        IF ('A' <= zeichen) & (zeichen <= 'Z') THEN
          INC(a[ORD(zeichen) - 65])
        END;
        In.Char(zeichen)
      END;
      Out.Ln; 
      FOR k:= 0 TO 25 DO
        (**) IF a[k] # 0 THEN (**)
          Out.String('   ');
          Out.Char(CHR(k + 65));  
          Out.String(' ('); Out.Int(a[k],2);  
          Out.String(')') 
        (**) END (**);
        IF (k + 1) MOD 6 = 0 THEN Out.Ln END
      END;
      Out.Ln
    END Buchstaben;


  PROCEDURE ProgMain*();
    BEGIN
      Anleitung;
      Wortanzahl;
      Buchstaben
    END ProgMain;


 BEGIN
   In.Open;
   Out.Open
 END Textstatistik.

