
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)          Dateiname: ZIFFERN.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Z A H L E N R A T E N                                         |
  |           Thringer Abiturprfung Grundfach Informatik 1997,            |
  |           Aufgabe 1.4 (Zentralabitur)                                   |
  |-------------------------------------------------------------------------|
  | Leistung: Ein Mensch und ein Computer spielen Ziffernraten.             |
  |           Der Computer whlt eine zufllige Folge von vier Ziffern aus. |
  |           Die vom Menschen eingegebene Zahlenfolge wird mit der vom     |
  |           Computer gewhlten Zahlenfolge verglichen und die Anzahl der  |
  |           Treffer ermittelt und angezeigt.                              |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul als lauffhiges Grundgerst finden Sie unter:       |
  |            ...\ziffern\good\ziffern.mod                                 |
  |-------------------------------------------------------------------------|
  | Aufgabenstellung: ...\ziffern\txt\zifferna.txt und                      |
  |                   ...\ziffern\doc\zifferna.doc                          |
  | Lsungsentwurf:   ...\ziffern\txt\ziffernb.txt und                      |
  |                   ...\ziffern\doc\ziffernb.doc                          |
  *-------------------------------------------------------------------------*)

 MODULE Ziffern;

  IMPORT In, Out, R:= RandomNu;

  VAR a, b, c, d : INTEGER;

 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Ueberschrift;
    BEGIN
      Out.Ln; Out.Ln;
      Out.String('    Z A H L E N R A T E N'); Out.Ln;
      Out.String('   '); Out.Ln; Out.Ln
             (* '' = <Alt> + < 0 1 6 8 > auf dem Nummernblock der Tastatur *)
    END Ueberschrift;


  PROCEDURE Zufallszahl() : INTEGER;
   (*-----------------------------------------------------------------------*
    | Referenz: Diese Funktionsprozedur liefert eine ganzzahlige Zufalls-   |
    |           zahl aus dem Intervall von 0 bis 9.                         |
    | Hinweis:  Fr die vom Modul RandomNumbers bereitgestellte Zufalls-    |
    |           zahl z gilt: 0 < z < 1.                                     |
    |           ENTIER(10 * z) liefert eine LONGINT-Zufalls zahl aus dem    |
    |           Intervall von 0 bis 9. Mit der Standardfunktion SHORT wird  |
    |           LONGINT in INTEGER berfhrt.                               |
    *-----------------------------------------------------------------------*)

    BEGIN
      RETURN SHORT(ENTIER(10 * R.Uniform()))
    END Zufallszahl;


  PROCEDURE Erzeugen;
   (*-----------------------------------------------------------------------*
    | Diese Prozedur fhrt den 1. Schritt der Lsung aus.                   | 
    *-----------------------------------------------------------------------*)

    BEGIN
      a:= Zufallszahl();
      b:= Zufallszahl();
      c:= Zufallszahl();
      d:= Zufallszahl();
      Out.String('   Der Computer hat vier Zahlen erzeugt.'); Out.Ln
    END Erzeugen;


  PROCEDURE Bewerten;
   (*-----------------------------------------------------------------------*
    | Diese Prozedur fhrt den 2. und 3. Schritt der Lsung aus.            | 
    *-----------------------------------------------------------------------*)

    VAR e, f, g, h, anzahl: INTEGER;

    BEGIN
      Out.Ln;
      Out.String('   Bitte vier einstellige Zahlen eingeben!'); Out.Ln;
      In.Prompt('1. Zahl'); In.Int(e);
      In.Prompt('2. Zahl'); In.Int(f);
      In.Prompt('3. Zahl'); In.Int(g);
      In.Prompt('4. Zahl'); In.Int(h);
      Out.Ln;
      Out.String('   Computer:');
      Out.Int(a,3); Out.Int(b,3);
      Out.Int(c,3); Out.Int(d,3);
      Out.Ln; Out.Ln;
      Out.String('   Mensch:');
      Out.Int(e,5); Out.Int(f,3);
      Out.Int(g,3); Out.Int(h,3);
      Out.Ln; Out.Ln;
      anzahl := 0;
      IF a = e THEN INC(anzahl) END;
      IF b = f THEN INC(anzahl) END;
      IF c = g THEN INC(anzahl) END;
      IF d = h THEN INC(anzahl) END;
      Out.Int(anzahl,15);
      Out.String(' Treffer'); Out.Ln
    END Bewerten;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();
    BEGIN
      Ueberschrift;
      R.Randomize;
      Erzeugen;
      Bewerten
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;
   Out.Open
 END Ziffern.

 (*-------------------------------------------------------------------------*)
