
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)          Dateiname: ZIFFERN.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Z A H L E N R A T E N                                         |
  |           Thringer Abiturprfung Grundfach Informatik 1997,            |
  |           Aufgabe 1.4 (Zentralabitur)                                   |
  |-------------------------------------------------------------------------|
  | Leistung: Ein Mensch und ein Computer spielen Ziffernraten.             |
  |           Der Computer whlt eine zufllige Folge von vier Ziffern aus. |
  |           Die vom Menschen eingegebene Zahlenfolge wird mit der vom     |
  |           Computer gewhlten Zahlenfolge verglichen und die Anzahl der  |
  |           Treffer ermittelt und angezeigt.                              |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise eingefgt werden.                   |
  |           Siehe: ...\ziffern\fine\ziffern.mod                           |
  |-------------------------------------------------------------------------|
  | Aufgabenstellung: ...\ziffern\txt\zifferna.txt und                      |
  |                   ...\ziffern\doc\zifferna.doc                          |
  | Lsungsentwurf:   ...\ziffern\txt\ziffernb.txt und                      |
  |                   ...\ziffern\doc\ziffernb.doc                          |
  *-------------------------------------------------------------------------*)

 MODULE Ziffern;

  IMPORT In, Out, Ran:= RandomNu;

  VAR a, b, c, d : INTEGER;


  PROCEDURE Zufallszahl() : INTEGER;
    (* Diese Funktionsprozedur liefert eine ganzzahlige  *)
    (* Zufallszahl aus dem Intervall von 0 bis 9.        *)

    BEGIN
      RETURN SHORT(ENTIER(10 * Ran.Uniform()))
      (* Fr die vom Modul RandomNumbers bereitgestellte *)
      (* Zufallszahl z gilt: 0 < z < 1.                  *)
      (* ENTIER(10 * z) liefert eine LONGINT-Zufallszahl *)
      (* aus dem Intervall von 0 bis 9.                  *)
      (* Mit der Standardfunktion SHORT wird LONGINT in  *)
      (* INTEGER berfhrt.                              *)
    END Zufallszahl;


  PROCEDURE Erzeugen;
   (* Diese Prozedur fhrt den 1. Schritt aus.           *)
    BEGIN
      a:= Zufallszahl();
      b:= Zufallszahl();
      c:= Zufallszahl();
      d:= Zufallszahl();
      Out.Ln;
      Out.String('   Zahlen erzeugt.'); Out.Ln
    END Erzeugen;


  PROCEDURE Bewerten;
   (* Diese Prozedur fhrt den 2. und 3. Schritt aus.    *)
    VAR e, f, g, h, anzahl: INTEGER;

    BEGIN
      Out.Ln;
      Out.String('   Vier einstellige Zahlen eingeben!'); Out.Ln;
      In.Int(e);
      In.Int(f);
      In.Int(g);
      In.Int(h);
      Out.Ln;
      Out.Int(e,5); Out.Int(f,3); Out.Int(g,3); Out.Int(h,3); Out.Ln;
      Out.Ln;
      anzahl:= 0;
      IF a = e THEN INC(anzahl) END;
      IF b = f THEN INC(anzahl) END;
      IF c = g THEN INC(anzahl) END;
      IF d = h THEN INC(anzahl) END;
      Out.Int(anzahl,5);
      Out.String(' Treffer')
    END Bewerten;


  PROCEDURE ProgMain*();
    BEGIN
      Erzeugen;
      Bewerten
    END ProgMain;

 BEGIN
   In.Open;
   Out.Open
 END Ziffern.

