
 MODULE BspSound;

  IMPORT D:= Display, F:= File, S:= Strings, Sp:= Speaker, SYSTEM;

  CONST  n         = 46;
         fPfad     = 'F:\POW\EXERCISE\POW16\SPEAKER\WIN31_98\POWSOUND\C_DUR.DAT';

  TYPE   tFrequStr = ARRAY 5 OF CHAR;
         tFrequTab = ARRAY n+1 OF INTEGER;


 (* --------------------  U N T E R P R O G R A M M E  --------------------- *)


  PROCEDURE RoundReal ( x : REAL ) : INTEGER;
    BEGIN
      RETURN SYSTEM.VAL(INTEGER,x+0.5)
    END RoundReal;


  PROCEDURE Frequenzen_berechnen ( VAR FrequTab : tFrequTab );
            (* speichert alle Halbtne von a bis a *)
    VAR i        : INTEGER;
        Frequenz : REAL;

    BEGIN
      Frequenz:= 262;                             (* Ausgangsfrequenz auf a (=220 Hz) setzen *)
      FOR i:= 0 TO n DO
        FrequTab[i]:= RoundReal(Frequenz); (* aktuelle Frequenz runden und in FreqTab speichern *)
        Frequenz:= Frequenz * Sp.HF         (* mit Speaker.HF multiplizieren (ergibt nchsten Halbton) *)
      END;
    END Frequenzen_berechnen;


  PROCEDURE Datei_schreiben ( VAR FrequTab : tFrequTab );
   (*------------------------------------------------------------------------*
    | bergabe: Vollstndige Kartei (als Kopie (Wertparameter)), Anzahl der  |
    |           zu speichernden Datenstze                                   |
    | Leistung: Blockweise Schreiben (SIZE(tPerson);) aller Inhalte der Da-  |
    |           tenstze der Kartei auf einen externen Datentrger           |
    *------------------------------------------------------------------------*)

    VAR fhandle     : F.Handle;
        i, resCode  : INTEGER;
        FrequStrg   : tFrequStr;

    BEGIN
      IF F.Exist(fPfad) THEN
        F.Delete(fPfad,resCode)
      END;
      F.Open(fPfad,TRUE,F.DENYNONE,F.WRITEONLY,fhandle,resCode);
      FOR i:= 0 TO n DO
        S.Str(FrequTab[i],FrequStrg);
        F.WriteLn(fhandle,FrequStrg,resCode)
      END;
      F.Close(fhandle)
    END Datei_schreiben;


  PROCEDURE Reihung_loeschen ( VAR FrequTab : tFrequTab );

    VAR i : INTEGER;

    BEGIN
      FOR i:= 0 TO n DO
        FrequTab[i]:= 0
      END
    END Reihung_loeschen;


  PROCEDURE Datei_lesen ( VAR FrequTab : tFrequTab; VAR AnzDatensaetze :INTEGER );
   (*------------------------------------------------------------------------*
    | bergabe: Leere Kartei, Variable fr die Anzahl der zu lesenden Daten- |
    |           stze (Adresse (Referenzpameter))                            |
    | Leistung: Blockweise Lesenen (SIZE(tPerson);) aller Inhalte der Daten- |
    |           stze von einem externen Datentrger, Ablage in PKartei      |
    *------------------------------------------------------------------------*)

    VAR fhandle     : F.Handle;
        i, resCode  : INTEGER;
        FrequStrg   : tFrequStr;

    BEGIN
      IF F.Exist(fPfad) THEN
        i:= -1;
        F.Open(fPfad,FALSE,F.DENYNONE,F.READONLY,fhandle,resCode);
        WHILE ~F.AtEnd(fhandle) DO
          INC(i);
          F.ReadLn(fhandle,FrequStrg,resCode);
          FrequTab[i]:= SHORT(S.Val(FrequStrg))
        END;
        AnzDatensaetze:= i;
        F.Close(fhandle)
      END
    END Datei_lesen;


  PROCEDURE Toene_ausgeben ( FrequTab : tFrequTab; Anzahl : INTEGER );

    VAR i : INTEGER;

    BEGIN
      IF Sp.IsPlaying() THEN                (* Prfen, ob der Lautsprecher gerade eingeschaltet ist *)
        D.WriteStr('Der Lautsprecher wird gerade von einem anderen Programm verwendet.')
      ELSE
        FOR i:= 0 TO Anzahl DO
          D.WriteLn;
          Sp.Sound(FrequTab[i]);             (* Speaker einschalten und den Ton aus der Tabelle ausgeben *)
          D.WriteInt(FrequTab[i],5);
          Sp.Delay(250)                     (* 50 ms warten *)
        END;
        Sp.NoSound                          (* Speaker ausschalten *)
      END;
    END Toene_ausgeben;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)


  PROCEDURE ProgMain*();

    VAR Frequenztabelle    : tFrequTab;
        Anzahl_Datensaetze : INTEGER;

    BEGIN
     (* Frequenzen_berechnen(Frequenztabelle);
      Datei_schreiben(Frequenztabelle);
      Reihung_loeschen(Frequenztabelle); *)
      Datei_lesen(Frequenztabelle,Anzahl_Datensaetze);
      Toene_ausgeben(Frequenztabelle,Anzahl_Datensaetze);
      REPEAT UNTIL D.KeyPressed()
    END ProgMain;

 END BspSound.
