
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon (POW!-16)                   Dateiname: ZWEI.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    A b s t r a k t e r   D a t e n t y p   L i s t e             |
  |-------------------------------------------------------------------------|
  | Leistung: - Das Modul importiert u. a. das Service-Modul ADTLISTE.      |
  |             Es wird ein Stapel (Keller, stack) erzeugt.                 |
  |             (Stapel 1 oder Stapel 2)                                    |
  |           - Auf einem Stapel wird ein INTEGER-Wert abgelegt.            |
  |             Existiert dieser Stapel noch nicht, wird er erzeugt.        |
  |           - Ein Element wird vom Stapel 1 oder Stapel 2 abgeholt.       |
  |             Wird auf einen leeren Stapel zugegriffen, erfolgt eine      |
  |             entsprechende Meldung.                                      |
  |           - Ein Stapel wird inspiziert und ein Text ausgegeben.         |
  |             (Mitteilung, dass der Stapel leer/nicht leer ist)           |
  |-------------------------------------------------------------------------|
  | Hinweise: Es werden global deklarierte Variablen verwendet, weil sie    |
  |           in allen Unterprogrammen bentigt werden.                     |
  |           Das Modul ist lauffhig. Es sollte kommentiert werden.        |
  |           Siehe: ...\adt\mod\zweivari.mod                               |
  *-------------------------------------------------------------------------*)

 MODULE zwei;

  IMPORT In, Out, ADTL:= Adtliste;

  VAR eins, zwei       : ADTL.Liste;
      stapel1, stapel2 : BOOLEAN;


  PROCEDURE Ok ( nummer : INTEGER ) : BOOLEAN;
    BEGIN
      RETURN (nummer = 1) OR (nummer = 2)
    END Ok;


  PROCEDURE Fehler;
    BEGIN
      Out.String('  Fehlerhafte Eingabe!'); Out.Ln; Out.Ln
    END Fehler;


  PROCEDURE ErzeugenStapel;

    VAR nummer, daten : INTEGER;

    BEGIN
      stapel1:= FALSE;
      stapel2:= FALSE;
      Out.Ln;
      Out.String('  Erzeugen eines leeren Stapels.'); Out.Ln;
      In.Prompt('Stapel 1 oder 2');
      In.Int(nummer);
      CASE nummer OF
         1: ADTL.Erzeugen(eins);
            stapel1:= TRUE
       | 2: ADTL.Erzeugen(zwei);
            stapel2:= TRUE
       ELSE Fehler
      END;
      IF Ok(nummer) THEN
        Out.String('  Es wurde ein leerer Stapel ('); Out.Int(nummer,1);
        Out.String(') erzeugt.'); Out.Ln; Out.Ln
      END
    END ErzeugenStapel;


  PROCEDURE StapelnElement;

    VAR nummer, daten : INTEGER;

    BEGIN
      Out.String('  Einlesen eines INTEGER-Werts.');
      In.Prompt('Wert (INTEGER)');
      In.Int(daten);
      Out.String(' (erfolgreich)'); Out.Ln;
      Out.String('  In welchem der beiden Stapel soll der Wert');
      Out.String(' abgelegt werden?'); Out.Ln;
      In.Prompt('Stapel 1 oder 2');
      In.Int(nummer);
      IF (nummer = 1) & ~stapel1 OR (nummer = 2) & ~stapel2 THEN
        Out.String('  Da der Stapel nicht existierte, wurde er erzeugt.');
        Out.Ln
      END;
      CASE nummer OF
         1: ADTL.EinfuegenElement(eins,daten)
       | 2: ADTL.EinfuegenElement(zwei,daten)
       ELSE Fehler
      END;
      IF Ok(nummer) THEN
        Out.String('  Es wurde ein Element ('); Out.Int(daten,1);
        Out.String(') im Stapel (');  Out.Int(nummer,1);
        Out.String(') abgelegt.'); Out.Ln; Out.Ln
      END
    END StapelnElement;


  PROCEDURE EntstapelnElement;

    CONST str1 = '  Der Stapel ist leer!';
          str2 = '  Vom Stapel geholte Zahl: ';

    VAR   nummer, daten : INTEGER;

    BEGIN
      Out.String('  Ein Element aus einem Stapel entnehmen.'); Out.Ln;
      In.Prompt('Stapel 1 oder 2');
      In.Int(nummer);
      CASE nummer OF
         1: IF ADTL.ListeLeer(eins) THEN
              Out.String(str1); Out.Ln;
              Out.Ln
            ELSE
              ADTL.HoleEintrag(eins,daten);
              Out.String(str2);
              Out.Int(daten,6); Out.Ln;
              Out.Ln;
              ADTL.LoeschenElement(eins)
            END
       | 2: IF ADTL.ListeLeer(zwei) THEN
              Out.String(str1); Out.Ln;
              Out.Ln
            ELSE
              ADTL.HoleEintrag(zwei,daten);
              Out.String(str2);
              Out.Int(daten,6); Out.Ln;
              Out.Ln;
              ADTL.LoeschenElement(zwei)
            END
        ELSE Fehler
      END
    END EntstapelnElement;


  PROCEDURE StapelLeer;

    VAR nummer : INTEGER;
        leer   : BOOLEAN;

    BEGIN
      Out.String('  Einen Stapel inspizieren.'); Out.Ln;
      In.Prompt('Stapel 1 oder 2');
      In.Int(nummer);
      CASE nummer OF 
         1: leer:= ADTL.ListeLeer(eins)
       | 2: leer:= ADTL.ListeLeer(zwei)
        ELSE Fehler
      END;
      IF Ok(nummer) THEN
        IF leer THEN
          Out.String('  Der Stapel ist leer.'); Out.Ln;
          Out.Ln
        ELSE
          Out.String('  Der Stapel ist nicht leer.'); Out.Ln;
          Out.Ln
        END
      END
    END StapelLeer;


  PROCEDURE ProgMain*();
    BEGIN
      ErzeugenStapel;
      StapelnElement;
      EntstapelnElement;
      StapelLeer
    END ProgMain;


 BEGIN
   In.Open;
   Out.Open             (* kann entfallen  *)
 END zwei.

