
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)          Dateiname: EINSGUT.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    W e r t z u w e i s u n g e n                                 |
  |-------------------------------------------------------------------------|
  | Importe:  Das Modul Eins importiert die von POW! bereitgestellten       |
  |           Module In und Out (Oakwood Guidelines). Damit werden Proze-   |
  |           duren fr Ein- und Ausgabeanweisungen bereitgestellt.         |
  |-------------------------------------------------------------------------|
  | Leistung: bernahme zweier ganzer Zahlen (Datentyp INTEGER), die vom    |
  |           Anwender mittels Tastatur eingegeben werden mssen.           |
  |           Tauschen der beiden Zahlen und Ausgabe des Ergebnises am BS.  |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\anwei\txt\anweisu.txt und                         |
  |                   ...\anwei\doc\anweisu.doc                             |
  *-------------------------------------------------------------------------*)

 MODULE EinsGut;                 (* Modulkopf allgemein: MODULE bezeichner; *)

  IMPORT In, Out;                (* Importliste (Standardmodule In und Out) *)


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Aufgabe;                (* Prozedurkopf: PROCEDURE bezeichner;  *)
                                    (*               parameterlose Prozedur *)
    BEGIN
      Out.Ln;
      Out.String('   Aufgabe'); Out.Ln;
      Out.String('  ');  Out.Ln;
      Out.String('  Zwei vom Anwender eingegebene ganze Zahlen sollen');
      Out.String(' getauscht werden.'); Out.Ln;
      Out.Ln
    END Aufgabe;


  PROCEDURE Einlesen ( VAR a, b : INTEGER );
                  (* Prozedurkopf: PROCEDURE bezeichner ( Parameterliste ); *)
                  (*               Parameterliste enthlt Referenzparameter *)
   (*-----------------------------------------------------------------------*
    | Referenz: Variablen a und b (Referenz- oder Variablenparameter)       |
    |           Von der jeweiligen (Speicherplatz-)Adresse der beiden Vari- |
    |           ablen wird je eine Kopie angefertigt.                       |
    | Leistung: Durch Anweisungstexte untersttztes Einlesen zweier ganzer  |
    |           Zahlen, die vom Anwender eingegeben werden.                 |
    |           Der mittels Tastatur eingegebene erste ganzzahlige Wert     |
    |           wird der ersten Variable und der zweite der zweiten Varia-  |
    |           ble zugewiesen.                                             |
    *-----------------------------------------------------------------------*)

    BEGIN                             (* Anfang des Rumpfs der Prozedur,    *)
                                      (* auch Blockoder Anweisungsteil ge-  *)
                                      (* nannt.                             *)
      Out.Ln;                         (* Ausgabe einer Leerzeile            *)
      Out.String('   Zahl 1 = ');     (* Ausgabe einer Zeichenkette         *)
      In.Prompt('Zahl 1  (INTEGER)'); (* prompter, engl. Souffleur          *)
      In.Int(a);                      (* Einlesen eines INTEGER-Werts       *)
      Out.Int(a,5); Out.Ln;           (* formatierte Ausgabe eines INTEGER- *)
                                      (* Werts und eines Zeilenumbruchs     *)
      Out.String('   Zahl 2 = ');
      In.Prompt('Zahl 2  (INTEGER)');
      In.Int(b);
      Out.Int(b,5); Out.Ln            (* Das Semikolon (Strichpunkt) vor    *)
                                      (* einem END kann weggelassen werden. *)
    END Einlesen;                     (* Ende des Rumpfs der Prozedur       *)


  PROCEDURE Tauschen ( VAR a, b : INTEGER );
                  (* Prozedurkopf: PROCEDURE bezeichner ( Parameterliste ); *)
                  (*               Parameterliste enthlt Referenzparameter *)
   (*-----------------------------------------------------------------------*
    | Referenz: Variablen a und b (Referenz- oder Variablenparameter)       |
    | Leistung: Tauschen der Werte der beiden Variablen unter Zuhilfenahme  |
    |           einer Hilfsvariable (hilf).                                 |
    | Hinweis:  Die Hilfsvariable muss vom gleichen Datentyp sein.          |
    *-----------------------------------------------------------------------*)

    VAR hilf : INTEGER;               (* Deklaration einer lokalen Variable *)
                                      (* Gltigkeitsbereich: diese Prozedur *)

    BEGIN
      hilf:= a;                       (* drei Wertzuweisungen (Tauschen)    *)
      a:= b;
      b:= hilf;
      Out.Ln;
      Out.String('  Die Zahlenwerte der beiden Variablen wurden getauscht.');
      Out.Ln
    END Tauschen;


  PROCEDURE Ausgeben ( a, b : INTEGER );
                  (* Prozedurkopf: PROCEDURE bezeichner ( Parameterliste ); *)
                  (*                  Parameterliste enthlt Wertparametern *)
   (*-----------------------------------------------------------------------*
    | bernahme: Wert der Variablen a und b (Wertparameter)                 |
    |            Vom jeweiligen Wert der beiden Variablen wird je eine      |
    |            Kopie angefertigt.                                         |
    | Leistung:  Ausgabe der beiden getauscheten ganzen Zahlen.             |
    |            Den beiden Ausgaben wird jeweils ein Erluterungstext vo-  |
    |            rangestellt.                                               |
    *-----------------------------------------------------------------------*)

    BEGIN
      Out.Ln;
      Out.String('   Zahl 1 = '); Out.Int(a,5); Out.Ln;
      Out.String('   Zahl 2 = '); Out.Int(b,5); Out.Ln
    END Ausgeben;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();              (* Das POW!-"Hauptprogramm"           *)

    VAR a, b : INTEGER;               (* Deklaration lokaler Variablen      *)

    BEGIN
      Aufgabe;                        (* Prozeduraufruf ohne Parameter      *)
      Einlesen(a,b);   (* E *)        (* Prozeduraufruf mit Parametern      *)
      Tauschen(a,b);   (* V *)
      Ausgeben(a,b)    (* A *)
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;                   (* Die Initialisierung des In- und Out-Moduls *)
   Out.Open                   (* kann weggelassen werden!                   *)
 END EinsGut.

 (* ----------------------------------------------------------------------- *)

