
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: EINSVARI.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Wertzuweisungen, If-Anweisung und Repeat-Anweisung            |
  |-------------------------------------------------------------------------|
  | Leistung: bernahme zweier ganzer Zahlen (Datentyp INTEGER), die vom    |
  |           Anwender mittels Tastatur eingegeben werden mssen.           |
  |           Tauschen der beiden Zahlen und Ausgabe des Ergebnises am BS.  |
  |           Durch Bettigen der J-Taste knnen das Tauschen und die Aus-  |
  |           gabe des Ergebnises beliebig wiederholt werden.               |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul ist eine Ergnzung zum Modul eins.mod, das sich     |
  |           im gleichen Pfad befindet.                                    |
  |           Es sollte erst nach der Behandlung der If-Anweisungen und der |
  |           Repeat-Anweisungen genutzt werden.                            |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\anwei\txt\anweisu.txt und                         |
  |                   ...\anwei\doc\anweisu.doc                             |
  *-------------------------------------------------------------------------*)

 MODULE EinsVari;

  IMPORT In, Out;


 (* --------------------  U N T E R P R O G R A M M E  -------------------- *)


  PROCEDURE Aufgabe;                (* Prozedurkopf: PROCEDURE bezeichner;  *)
                                    (*               parameterlose Prozedur *)
    BEGIN
      Out.Ln;
      Out.String('  Aufgabe'); Out.Ln;
      Out.String(' ');  Out.Ln;
      Out.String(' Zwei vom Anwender eingegebene ganze Zahlen');
      Out.String(' sollen mehrmals getauscht werden.'); Out.Ln;
      Out.Ln
    END Aufgabe;


  PROCEDURE Einlesen ( VAR a, b : INTEGER ); (* Prozedur mit Parameterliste *)
                                             (* a, b sind Referen- oder     *)
                                             (*      Variablenparameter     *)
    BEGIN
      Out.String('  eingelesen:'); Out.Ln; Out.Ln;
      Out.String('    a =');
      In.Prompt('Zahl 1  (INTEGER)');
      In.Int(a);
      Out.Int(a,6); Out.Ln;
      Out.String('    b =');
      In.Prompt('Zahl 2  (INTEGER)');
      In.Int(b);
      Out.Int(b,6); Out.Ln
    END Einlesen;


  PROCEDURE Tauschen ( VAR a, b : INTEGER );
   (*-----------------------------------------------------------------------*
    | Referenz: Variablen a und b                                           |
    | Leistung: Tauschen der Werte der beiden Variablen unter Zuhilfenahme  |
    |           einer Hilfsvariable (hilf).                                 |
    | Hinweis:  Die Hilfsvariable muss vom gleichen Datentyp sein.          |
    *-----------------------------------------------------------------------*)

    VAR hilf : INTEGER;

    BEGIN
      hilf:= a;
      a:= b;
      b:= hilf
    END Tauschen;


  PROCEDURE Ausgeben ( a, b : INTEGER );     (* Prozedur mit Parameterliste *)
                                             (* a, b sind Wertparameter     *)
    BEGIN
      Out.Ln;
      Out.String('  getauscht:'); Out.Ln;
      Out.Ln;
      Out.String('    a ='); Out.Int(a,6); Out.Ln;
      Out.String('    b ='); Out.Int(b,6); Out.Ln
    END Ausgeben;


  PROCEDURE Wiederholung () : BOOLEAN;   (* parameterlose Funktionsprozedur *)

    VAR schluessel : CHAR;

    BEGIN
      In.Prompt('Wiederholung (j/n)');
      In.Char(schluessel);
      IF CAP(schluessel) = 'N' THEN (* CAP(char) = wandelt einen Klein- in  *)
                                    (*             einen Grobuchstaben     *)
        RETURN FALSE                (* Dem Bezeichner der Funktionsprozedur *)
                                    (* wird ein Wert zugewiesen und danach  *)
                                    (* das Unterprogramm sofort verlassen.  *)
      ELSE
        RETURN TRUE                 (* dito                                 *)
      END
    END Wiederholung;


 (* ---------------------  H A U P T P R O G R A M M  --------------------- *)

  PROCEDURE ProgMain*();

    VAR a, b : INTEGER;

    BEGIN
      Aufgabe;
      Einlesen(a,b);
      REPEAT
        Tauschen(a,b);
        Ausgeben(a,b)
      UNTIL ~Wiederholung()
    END ProgMain;

 (* -------------------  I N I T I A L I S I E R U N G  ------------------- *)

 BEGIN
   In.Open;                   (* Die Initialisierung des In- und Out-Moduls *)
   Out.Open                   (* kann weggelassen werden!                   *)
 END EinsVari.

 (* ----------------------------------------------------------------------- *)

