
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)            Dateiname: SECHS.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Die Schleife mit nachgestelltem Test                          |
  |-------------------------------------------------------------------------|
  | Leistung: Berechnen der dritten Wurzel (Kubikwurzel) einer reellen Zahl |
  |           Wurzelberechnung nach HERON VON ALEXANDRIA                    |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise eingefgt werden.                   |
  |           Die Eingabe und das Ergebnis (reellen Zahl) knnen formatiert |
  |           werden. Dazu mssen das Modul Float importiert und die darin  |
  |           enthaltene Anweisung StrF(...) mit den entsprechenden Parame- |
  |           tern in den Quelltext der Prozedur Wurzel eingefgt werden.   |
  |           Die lokale Variablendeklaration erhlt zwei neue Variablen,   |
  |           z.B. zStrg und ergStrg, beide vom DT: ARRAY 26 OF CHAR, die   |
  |           die Eingabe und das konvertierte Ergebnis als Zeichenkette    |
  |           aufnehmen knnen. Die Zeichenketten werden statt der unforma- |
  |           tierten rellen Zahlen in den Antwortsatz integriert und am    |
  |           Bildschirm ausgegeben.                                        |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\anwei\txt\anweisu.txt und                         |
  |                   ...\anwei\doc\anweisu.doc                             |
  *-------------------------------------------------------------------------*)

 MODULE Sechs;

  IMPORT In, Out;

  PROCEDURE Wurzel;

    CONST epsilon = 1.0E-8;

    VAR z, xAlt, xNeu : REAL;

    BEGIN
      Out.Ln;
      Out.String('   Die Kubikwurzel von ');
      In.Prompt('z  (REAL)');
      In.Real(z);
      Out.Real(z,8);
      xNeu:= 1.0;

    (* ---  Repeat-Anweisung  --------------------------------------------- *)

      REPEAT
        xAlt:= xNeu;
        xNeu:= (2 * xAlt + z / (xAlt * xAlt)) / 3
      UNTIL ABS(xAlt - xNeu) < epsilon * ABS(xNeu);

    (* -------------------------------------------------------------------- *)

      Out.String(' ist '); Out.Real(xNeu,10); Out.Char('.'); Out.Ln
    END Wurzel;


  PROCEDURE ProgMain*();
    BEGIN
      Wurzel
    END ProgMain;

 BEGIN
   Out.Open
 END Sechs.

