
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: EINDATUM.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    D a t u m   (Import des Servicemoduls DatumOperationen)       |
  |-------------------------------------------------------------------------|
  | Leistung: Demonstrieren einiger Operationen des Moduls DatumOperationen |
  |           unter Anwendung des aus diesem Modul importierten Datentyps   |
  |           tDatum.                                                       |
  |           Alle Daten mssen zwischen 1583 und 3000 (gregorianisher Ka-  |
  |           lender) liegen.                                               |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Kommentare eingefgt werden.                       |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\datum2\txt\datum.txt und ...\datum2\doc\datum.doc |
  *-------------------------------------------------------------------------*)

 MODULE EinDatum;

  IMPORT In, Out, Op:= DatumOperationen;


  PROCEDURE Ausgeben ( datum : Op.tDatum );
    BEGIN
      Out.Int(datum.jahr,7); Out.Int(datum.monat,3); Out.Int(datum.tag,3);
      Out.Ln
    END Ausgeben;


  PROCEDURE Einlesen ( VAR datum : Op.tDatum );
    BEGIN
      In.Prompt('Jahreszahl');
      In.Int(datum.jahr);
      In.Prompt('Monatsnummer');
      In.Int(datum.monat);
      In.Prompt('Tagesnummer');
      In.Int(datum.tag);
      Out.Ln;
      Ausgeben(datum)
    END Einlesen;


  PROCEDURE Korrekt ( datum: Op.tDatum ) : BOOLEAN;
    BEGIN
      IF Op.Existenz(datum) THEN
        Out.String('   Der Tag existiert.'); Out.Ln;
        RETURN TRUE
      ELSE
        Out.String('   Der Tag existiert nicht.'); Out.Ln;
        RETURN FALSE
      END
    END Korrekt;


  PROCEDURE Wochentagsname ( datum : Op.tDatum );

    VAR wochentagsname : Op.tName;

    BEGIN
      Out.String('   Der Tag ist ein ');
      Op.Wochentagsname(Op.Wochentag(datum),wochentagsname);
      Out.String(wochentagsname); Out.Char('.'); Out.Ln    
    END Wochentagsname;


  PROCEDURE Vorgaenger ( datum: Op.tDatum );
    BEGIN
      Op.Vorgaenger(datum);
      Ausgeben(datum)
    END Vorgaenger;


  PROCEDURE Nachfolger ( datum: Op.tDatum );
    BEGIN
      Op.Nachfolger(datum);
      Ausgeben(datum)
    END Nachfolger;


  PROCEDURE ProgMain*();

      VAR datum : Op.tDatum;

    BEGIN
      Einlesen(datum);
      IF Korrekt(datum) THEN
        Wochentagsname(datum);
        Vorgaenger(datum);
        Nachfolger(datum)
      END
    END ProgMain;


  BEGIN
    In.Open;
    Out.Open
  END EinDatum.
