
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: MAXIMUMK.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    Einstieg in die Programmierung mit OBERON                     |
  |-------------------------------------------------------------------------|
  | Leistung: Suche und Ausgabe des Maximums in einer vom Nutzer abhngi-   |
  |           gen Anzahl eingelesener ganzer Zahlen. Bei mehrfachem Auftre- |
  |           ten des Maximums werden die Positionen seines Auftretens im   |
  |           Eingabestream am Bildschirm angezeigt.                        |
  |-------------------------------------------------------------------------|
  | Achtung!  Jede Eingaben durch Bettigen der Enter-Taste abschlieen.    |
  |           ODER: Alle gewnschten Zahlen nacheinander, durch Leerzeichen |
  |           getrennt, eingeben und anschlieend die Enter-Taste bettigen |
  |           (Eingabestrom, engl.: inputstream).                           |
  |           Nach der letzten Eingabe den End-Button bettigen (linke MT). |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise eingefgt werden.                   |
  *-------------------------------------------------------------------------*)

 MODULE MaximumK;                     (* Maximumsuche kommentiert           *)

  IMPORT In, Out;

    VAR zahl, maximum, n : INTEGER;


  PROCEDURE Erlaeuterungen;
    BEGIN
      Out.Ln;
      Out.String('  Bitte ganze Zahlen im Intervall -32768 .. 32767 eingeben!');
      Out.Ln; Out.Ln;
      Out.String('  Eingabe mit <Enter> abschlieen.');
      Out.Ln; Out.Ln;
      Out.String('  Nach Eingabe der letzten Zahl End-Button bettigen.');
      Out.Ln; Out.Ln
    END Erlaeuterungen;


  PROCEDURE Anzahl;
    BEGIN
      n:= 0;
      In.Int(zahl);
      WHILE In.Done DO
        INC(n);
        In.Int(zahl)                  (* Die Zahlen werden zum ersten Mal   *)
                                      (* eingelesen!                        *)
      END;
      Out.Ln;
      Out.String('  Anzahl Zahlen ='); Out.Int(n,4); Out.Ln
    END Anzahl;
    

  PROCEDURE Max;

    VAR i: INTEGER;

    BEGIN
      In.Open;                        (* Eingabestream erneut bereitstellen *)
      maximum:= MIN(INTEGER);         (* Das ist die kleinste INTEGER-Zahl  *)
                                      (* in diesem Oberon-System. Mit ihr   *)
                                      (* wird das Maximum initialisiert.    *) 
      FOR i:= 1 TO n DO
        In.Int(zahl);                 (* Die Zahlen werden zum zweiten Mal  *)
                                      (* eingelesen!                        *)  
        IF zahl > maximum THEN maximum:= zahl END
      END;
      Out.String('  Maximum ='); Out.Int(maximum,10); Out.Ln
    END Max;


  PROCEDURE Pos;

    VAR i: INTEGER;

    BEGIN
      In.Open;                        (* Eingabestream wieder bereitstellen *)
      Out.Ln;
      Out.String('  Position(en) des Maximums:');
      FOR i:= 1 TO n DO  
        In.Int(zahl);                 (* Die Zahlen werden zum dritten Mal  *)
                                      (* eingelesen!                        *)
        IF zahl = maximum THEN Out.Int(i,4) END
      END;
      Out.Ln
    END Pos;


  PROCEDURE ProgMain*();
    BEGIN
      Erlaeuterungen;
      Anzahl;
      Max;
      Pos
    END ProgMain;

 BEGIN
   In.Open;
   Out.Open
 END MaximumK.
    
