
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)          Dateiname: HILBERT.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    HILBERT-Kurven, David HILBERT (1891)                          |
  |-------------------------------------------------------------------------|
  | Leistung: Darstellen hilbertscher Kurven 3. - 5. Ordnungen.             |
  |           Das Modul enthlt Vorwrtsdeklarationen von Prozeduern        |
  |           (Erweiterung der Sichtbarkeitsregel)                          |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise eingefgt werden.                   |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\hilbert\txt\hilbert.txt                           |
  |                   ...\hilbert\doc\hilbert.doc                           |
  | Eingabehinweise:  ...\hilbert\doc\hilbtool.txt                          |
  | (Turtle/Hilbert)  ...\hilbert\doc\hilbtool.doc                          |
  *-------------------------------------------------------------------------*)

 MODULE Hilbert;

  IMPORT In, Out, T:= Turtle;

  VAR    h: INTEGER;


  PROCEDURE Ost;    (* Diese Prozedur zeichnet eine Strecke der Lnge h von *)
                    (* der aktuellen Position nach rechts.                  *)
    BEGIN 
      T.Aufkurs(0);
      T.Vorwaerts(h)
    END Ost;


  PROCEDURE Nord;   (* Diese Prozedur zeichnet eine Strecke der Lnge h von *)
                    (* der aktuellen Position nach oben.                    *)
    BEGIN 
      T.Aufkurs(90);
      T.Vorwaerts(h)
    END Nord;


  PROCEDURE West;   (* Diese Prozedur zeichnet eine Strecke der Lnge h von *)
                    (* der aktuellen Position nach links.                   *)
    BEGIN 
      T.Aufkurs(180);
      T.Vorwaerts(h)
    END West;


  PROCEDURE Sued;   (* Diese Prozedur zeichnet eine Strecke der Lnge h von *)
                    (* der aktuellen Position nach unten.                   *)
    BEGIN 
      T.Aufkurs(270);
      T.Vorwaerts(h)
    END Sued;


  PROCEDURE ^B ( i : INTEGER );     (* Vorwrtsdeklarationen der Prozeduern *)
  PROCEDURE ^C ( i : INTEGER );     (* B, C, D. Damit erfolgt eine Erweite- *)
  PROCEDURE ^D ( i : INTEGER );     (* rung der Sichtbarkeitsregel          *)


  PROCEDURE A ( i : INTEGER );
    BEGIN
      IF i > 0 THEN
        D(i - 1); West;
        A(i - 1); Sued;
        A(i - 1); Ost;
        B(i - 1)
      END
    END A;


  PROCEDURE B ( i : INTEGER );
    BEGIN
      IF i > 0 THEN
        C(i - 1); Nord;
        B(i - 1); Ost;
        B(i - 1); Sued;
        A(i - 1)
      END
    END B;


  PROCEDURE C ( i : INTEGER );
    BEGIN
      IF i > 0 THEN
        B(i - 1); Ost;
        C(i - 1); Nord;
        C(i - 1); West;
        D(i - 1)
      END
    END C;

  PROCEDURE D ( i : INTEGER );
    BEGIN
      IF i > 0 THEN
        A(i - 1); Sued;
        D(i - 1); West;
        D(i - 1); Nord;
        C(i - 1)
      END
    END D;


  PROCEDURE Zeichne;

    VAR ordnung, x0, y0: INTEGER;

    BEGIN
      In.Prompt('Ordnung');
      In.Int(ordnung);
      In.Prompt('x-Koordinate');
      In.Int(x0);
      In.Prompt('y-Koordinate');
      In.Int(y0);
      In.Prompt('Linienlnge');
      In.Int(h);
      T.BildNeu(x0,y0); 
      A(ordnung)
    END Zeichne;


  PROCEDURE AusgabeBeispieldaten;
    BEGIN
      Out.Ln;
      Out.String('                Beispiel 1   Beispiel 2   Beispiel 3');
      Out.Ln;
      Out.String('   Ordnung:          3            4            5'); Out.Ln;
      Out.String('   x-Koordinate:   460          460          460'); Out.Ln;
      Out.String('   y-Koordinate:   600          600          600'); Out.Ln;
      Out.String('   Linienlnge:     20           10            5'); Out.Ln
    END AusgabeBeispieldaten;


  PROCEDURE ProgMain*();
    BEGIN
      AusgabeBeispieldaten;
      Zeichne
    END ProgMain;

 END Hilbert.

