
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: AUSWAEHD.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   durch Auswhlen - 2. Variante             |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren von Kalenderdaten, die in einer Textdatei abgelegt  |
  |           sind oder mittels Tastatur eingegeben werden.                 |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise und ggf. Beispiele fr gltige Ein- |
  |           gaben eingefgt werden.                                       |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort1\txt\auswaeh2.txt ...\sort1\doc\auswaeh2.doc |
  *-------------------------------------------------------------------------*)

 MODULE AuswaehD;

  IMPORT In, Out, D:= DatumOpe;

  CONST  max = 3;                    (* es darf auch eine grere Zahl sein *)

  TYPE   tString    = ARRAY 26 OF CHAR;

         tDatensatz = RECORD
                        dat : D.tDatum;
                        txt : tString
                      END;

  VAR    a : ARRAY max+1 OF tDatensatz; 


  PROCEDURE EinlesenDatum ( VAR datum : D.tDatum );
    BEGIN
      In.Prompt('Datum ( jjjj mm tt ):');
      In.Int(datum.jahr);  
      In.Int(datum.monat); 
      In.Int(datum.tag)
    END EinlesenDatum;


  PROCEDURE EinlesenText ( VAR text : tString );
    BEGIN
      In.Prompt('String[25]:');                         (* Text bis 25 Char *)
      In.String(text)
    END EinlesenText;


  PROCEDURE Einlesen;

    VAR index : INTEGER;
        datum : D.tDatum;
        text  : tString;

    BEGIN
      Out.Ln;
      Out.String('  '); Out.String('Bitte '); Out.Int(max,1);
      Out.String(' Kalenderdaten mit jeweils einem Ereignis eingeben!');
      Out.Ln; Out.Ln;
      Out.String('  EINGABEVARIANTEN:'); Out.Ln; Out.Ln;
      Out.String('  - das Datum und das Ereignisse werden nacheinander'); Out.Ln;
      Out.String('    in der gleichen Eingabezeile eingegeben'); Out.Ln;
      Out.String('  - es wird erst das Kalenderdatum und danach das'); Out.Ln;
      Out.String('    Ereignis eingegeben'); Out.Ln;
      Out.Ln;
      Out.String('  Jede Eingabe wird mit < Enter > abgeschlossen.'); Out.Ln;
      FOR index:= 1 TO max DO
        EinlesenDatum(datum);
        EinlesenText(text);
        a[index].dat:= datum;
        a[index].txt:= text
      END;
      Out.Ln;
      Out.String('  Zu sortierende Elemente: a[1] bis a['); Out.Int(max,1);
     Out.Char(']'); Out.Ln; Out.Ln
    END Einlesen;


  PROCEDURE Sortieren;
   (*-----------------------------------------------------------------------*
    | Leistung: Sortieren durch Auswhlen.                                  |
    |           Die ausfhrliche Beschreibung des Algorithmus findet man    |
    |           unter  ...\sort1\doc\auswaeh1.doc (WORD-Version)            |
    |           oder   ...\sort1\txt\auswaeh1.txt (Text-Version)            |
    *-----------------------------------------------------------------------*)

    VAR r, s, t : INTEGER;
        x       : tDatensatz;

    BEGIN
      Out.String('  Das Sortieren beginnt.'); Out.Ln;
      FOR r:= 1 TO max-1 DO
         t:= r;
         x:= a[r];
         FOR s:= r+1 TO max DO
            IF D.LiegtVor(a[s].dat,x.dat) THEN
               t:= s;
               x:= a[s]
            END
         END;
         a[t]:= a[r];
         a[r]:= x
      END;
      Out.String('  Das Sortieren ist beendet.'); Out.Ln; Out.Ln
    END Sortieren;


  PROCEDURE AusgebenDatum ( datum : D.tDatum );
    BEGIN
      Out.String('   ');
      Out.Int(datum.jahr,5);  
      Out.Int(datum.monat,3); 
      Out.Int(datum.tag,3)
    END AusgebenDatum;


  PROCEDURE AusgebenEreignis ( txt : tString );
    BEGIN
      Out.String('  '); Out.String(txt)    
    END AusgebenEreignis;


  PROCEDURE Ausgeben;

    VAR k : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('  Elemente in sortierter Reihenfolge:'); Out.Ln;
      Out.Ln;
      FOR k := 1 TO max DO
        AusgebenDatum(a[k].dat);
        AusgebenEreignis(a[k].txt); Out.Ln
      END
    END Ausgeben;


  PROCEDURE ProgMain*();
    BEGIN
      Einlesen;
      Sortieren;
      Ausgeben
    END ProgMain;


 BEGIN
   In.Open;
   Out.Open
 END AuswaehD.
