
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: AUSWAEHL.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   durch Auswhlen - 1. Variante             |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren von INTEGER-Zahlen, die vom Anwender eingegeben     |
  |           werden.                                                       |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort1\txt\auswaeh1.txt ...\sort1\doc\auswaeh1.doc |
  *-------------------------------------------------------------------------*)

 MODULE Auswaehl;

  IMPORT In, Out;

  CONST  max = 5;

  VAR    a : ARRAY max+1 OF INTEGER;


  PROCEDURE Anleitung;
    BEGIN
      Out.Ln;
      Out.String('  Bitte fnf INTEGER-Zahlen eingeben und mit <ENTER> ');
      Out.String('abschlieen!  '); Out.Ln;
      Out.String('  Trennzeichen ist das Leerzeichen.'); Out.Ln; Out.Ln;
      Out.String('  Beispiel:  24 46 18 11 40'); Out.Ln; Out.Ln; Out.Ln
    END Anleitung;


  PROCEDURE ElementeAusgeben;

    VAR index : INTEGER;

    BEGIN
      FOR index:= 1 TO max DO
        Out.Int(a[index],6)
      END;
      Out.Ln
    END ElementeAusgeben;


  PROCEDURE Einlesen;

    VAR zahl, index : INTEGER;

    BEGIN
      FOR index:= 1 TO max DO
        In.Int(zahl);
        a[index]:= zahl
      END;
      Out.String('  Zu sortierende Elemente a[1] bis a['); Out.Int(max,1);  
      Out.String(']: ');
      ElementeAusgeben
    END Einlesen;


  PROCEDURE Sortieren;
   (*-----------------------------------------------------------------------*
    | Leistung: Sortieren durch Auswhlen.                                  |
    |           Die ausfhrliche Beschreibung des Algorithmus findet man    |
    |           unter  ...\sort1\doc\auswaeh1.doc (WORD-Version)            |
    |           oder   ...\sort1\txt\auswaeh1.txt (Text-Version)            |
    *-----------------------------------------------------------------------*)

    VAR r, s, t, x : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('  Das Sortieren beginnt.'); Out.Ln;
      FOR r:= 1 TO max-1 DO
         t:= r;
         x:= a[r];
         FOR s:= r+1 TO max DO
            IF a[s] < x THEN
               t:= s;
               x:= a[s]
            END
         END;
         a[t]:= a[r];
         a[r]:= x
      END;
      Out.String('  Der Sortiervorgang ist beendet.'); Out.Ln
    END Sortieren;


  PROCEDURE Ausgeben;
    BEGIN
      Out.Ln;
      Out.String('  Die Elemente in sortierter Reihenfolge:');
      ElementeAusgeben
    END Ausgeben;


  PROCEDURE ProgMain*();
    BEGIN
      Anleitung;
      Einlesen;
      Sortieren;
      Ausgeben
    END ProgMain;


 BEGIN
   In.Open;
   Out.Open
 END Auswaehl.

