
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: AUSWAEHS.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   durch Auswhlen - 3. Variante             |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren von Strecken, die auf einer Geraden liegen, auf-    |
  |           steigend nach der Koordinate ihres Anfangspunkts.             |
  |           Ist die Koordinate des Anfangspunkts mehrer Strecken gleich,  |
  |           werden die Lngen der Strecken beim Sortieren nicht beachtet. |
  |-------------------------------------------------------------------------|
  | Hinweis:  Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort1\txt\auswaeh3.txt ...\sort1\doc\auswaeh3.doc |
  *-------------------------------------------------------------------------*)

 MODULE AuswaehS;

  IMPORT In, Out, S:= Strings;

  CONST  max = 7;

  TYPE   tDatensatz = RECORD
                        anf, end: INTEGER 
                                     (* Anfangs- und Endpunkt einer Strecke *)
                      END;

  VAR    a : ARRAY max +1 OF tDatensatz;


  PROCEDURE Hinweis;
    BEGIN
      Out.Ln;
      Out.String('   Alle Eingaben mssen INTEGER-Werte sein!'); Out.Ln;
      Out.Ln
    END Hinweis;


  PROCEDURE EinlesenStrecke ( n : INTEGER; VAR t : tDatensatz );

    VAR promptStr : ARRAY 16 OF CHAR;

    BEGIN
      promptStr:= '';
      S.Str(n,promptStr);
      S.Append(promptStr,'. Anfangspunkt');
      In.Prompt(promptStr);
      In.Int(t.anf);
      S.Delete(promptStr,4,12);
      S.Append(promptStr,'Endpunkt');
      In.Prompt(promptStr);
      In.Int(t.end)
    END EinlesenStrecke;


  PROCEDURE Einlesen;

    VAR i       : INTEGER;
        strecke : tDatensatz;

    BEGIN
      Out.Ln;
      Out.String('   Beispiele: ');
      Out.String('(17, 560)  (3,  20)  (123,8023)  ( 200, 660)'); Out.Ln;
      Out.String('              (40, 100)  (1,1480)  (421, 520)  (1899,  21)');
      Out.Ln;
      FOR i:= 1 TO max DO
        EinlesenStrecke(i,strecke);
        a[i]:= strecke
      END;
      Out.Ln;
      Out.String('   Zu sortierende Strecken: a[1] bis a[');
      Out.Int(max,1); Out.Char(']'); Out.Ln; Out.Ln
    END Einlesen;


  PROCEDURE Sortieren;
   (*-----------------------------------------------------------------------*
    | Leistung: Sortieren durch Auswhlen.                                  |
    |           Die ausfhrliche Beschreibung des Algorithmus findet man    |
    |           unter  ...\sort1\doc\auswaeh1.doc (WORD-Version)            |
    |           oder   ...\sort1\txt\auswaeh1.txt (Text-Version)            |
    *-----------------------------------------------------------------------*)

    VAR r, s, t : INTEGER;
        x       : tDatensatz;

    BEGIN
      Out.String('     Das Sortieren beginnt.'); Out.Ln;
      FOR r:= 1 TO max -1 DO
         t:= r;
         x:= a[r];
         FOR s:= r+1 TO max DO
            IF a[s].anf < x.anf THEN
               t:= s;
               x:= a[s]
            END
         END;
         a[t]:= a[r];
         a[r]:= x
      END;
      Out.String('     Das Sortieren ist beendet.'); Out.Ln; Out.Ln
    END Sortieren;


  PROCEDURE AusgebenStrecke ( t : tDatensatz );
    BEGIN
      Out.Int(t.anf,9);  
      Out.Int(t.end,6)
    END AusgebenStrecke;


  PROCEDURE Ausgeben;

    VAR k : INTEGER;

    BEGIN
      Out.String('   Elemente in sortierter Reihenfolge:'); Out.Ln; Out.Ln;
      FOR k:= 1 TO max DO
        AusgebenStrecke(a[k]); Out.Ln
      END
    END Ausgeben;


  PROCEDURE ProgMain*();
    BEGIN
      Hinweis;
      Einlesen;
      Sortieren;
      Ausgeben
    END ProgMain;


 BEGIN
   In.Open;
   Out.Open
 END AuswaehS.

