
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: QUICKSO1.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   (Teile und Herrsche)  1. Variante         |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren von INTEGER-Zahlen (Quicksort)                      |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Es sollten Bedienhinweise eingefgt werden.                   |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort2\txt\quickso1.txt ...\sort2\doc\quickso1.doc |
  *-------------------------------------------------------------------------*)

 MODULE Quickso1;

  IMPORT In, Out;

  VAR    a : ARRAY 50 OF INTEGER;
         n : INTEGER;


  PROCEDURE Anleitung;

    VAR zeichen : CHAR;
        spalte,
        zeile   : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('   A N L E I T U N G :'); Out.Ln; Out.Ln;
      Out.String('     Geben Sie etwa 10 ganze Zahlen (DT: INTEGER) ein,');
      Out.Ln;
      Out.String('     das Leerzeichen ist das Trennzeichen. Beenden Sie');
      Out.Ln;
      Out.String('     die Eingabe mit dem Bettigen der ENTER-Taste und');
      Out.Ln;
      Out.String('     einem Mausklick (linke MT) auf den End-Button!');
      Out.Ln; Out.Ln
    END Anleitung;


  PROCEDURE Einlesen;

    VAR i, index, zahl : INTEGER;

    BEGIN
      index:= 0;
      In.Int(zahl);
      WHILE In.Done DO
        INC(index);
        a[index]:= zahl;
        In.Int(zahl)
      END;
      n:= index;
      Out.Ln;
      Out.String('   Zu sortierende Elemente: a[1] bis a[');
      Out.Int(n,1); Out.String(']:'); Out.Ln; Out.Ln;
      Out.Char(' ');
      FOR i:= 1 TO n DO
        Out.Int(a[i],6)
      END;
      Out.Ln
    END Einlesen;


  PROCEDURE Sortieren;
   (*-----------------------------------------------------------------------*
    | Leistung: Sortieren durch Auswhlen.                                  |
    |           Die ausfhrliche Beschreibung des Algorithmus findet man    |
    |           unter  ...\sort2\doc\quicksor.doc (WORD-Version)            |
    |           oder   ...\sort2\txt\quicksor.txt (Text-Version)            |
    *-----------------------------------------------------------------------*)

    PROCEDURE Sort ( l, r : INTEGER );

      VAR i, j, x, w : INTEGER;

      BEGIN
        i:= l;
        j:= r;
        x:= a[(l+r) DIV 2];
        REPEAT
          WHILE a[i] < x DO INC(i) END;
          WHILE x < a[j] DO DEC(j) END;
          IF i <= j THEN
            w:= a[i];
            a[i]:= a[j];
            a[j] := w;
            INC(i);  DEC(j)
          END
        UNTIL i > j;
        IF l < j THEN Sort(l,j) END;
        IF i < r THEN Sort(i,r) END
      END Sort;

    BEGIN
      Out.Ln;
      Out.String('     Das Sortieren beginnt.'); Out.Ln;
      Sort(1, n);
      Out.String('     Das Sortieren ist beendet.'); Out.Ln
    END Sortieren;


  PROCEDURE Ausgeben;

    VAR k : INTEGER;

    BEGIN
      Out.Ln;
      Out.String('   Elemente in sortierter Reihenfolge:'); Out.Ln; Out.Ln;
      Out.Char(' ');
      FOR k:= 1 TO n DO
        Out.Int(a[k],6)
      END;
      Out.Ln
    END Ausgeben;


  PROCEDURE ProgMain*();
    BEGIN
      Anleitung;
      Einlesen;
      Sortieren;
      Ausgeben
    END ProgMain;


 BEGIN
   In.Open;
   Out.Open
 END Quickso1.

