
 (*-------------------------------------------------------------------------*
  | Programmieren in Oberon-2 POW! (16 Bit)         Dateiname: QUICKSO2.MOD |
  |-------------------------------------------------------------------------|
  | Thema:    S O R T I E R E N   (Teile und Herrsche)  2. Variante         |
  |-------------------------------------------------------------------------|
  | Leistung: Sortieren von INTEGER-Zahlen (Quicksort) mit grafischer       |
  |           Veranschaulichung des Sortiervorgangs                         |
  |-------------------------------------------------------------------------|
  | Hinweise: Das Modul ist lauffhig, stellt aber nur ein Grundgerst dar. |
  |           Die grafische Ausgabe sollte verbessert werden.               |
  |-------------------------------------------------------------------------|
  | Erluterungstext: ...\sort2\txt\quickso2.txt ...\sort2\doc\quickso2.doc |
  *-------------------------------------------------------------------------*)


 MODULE Quickso2;

  IMPORT In, Out, C:= ColorPlane, P:= Process, Ran:= RandomNu, W:= Window;

  CONST  n = 400;
         h = 400;

  VAR    a     : ARRAY 1000 OF INTEGER;
         dTime : INTEGER;
         dummy : BOOLEAN;


  PROCEDURE Zufallszahl(): INTEGER;
    BEGIN
      RETURN SHORT(ENTIER(Ran.Uniform() * h))
    END Zufallszahl;


  PROCEDURE Delay_ms ( msec : INTEGER );
   (*-----------------------------------------------------------------------*
    | Leistung: Eine bestimmte Zeit warten.                                 |
    *-----------------------------------------------------------------------*)

    VAR startzeit, zielzeit : LONGINT;

    BEGIN
      startzeit:= W.GetTickCount(); 
      REPEAT
        zielzeit:= W.GetTickCount()
      UNTIL zielzeit > startzeit + msec 
    END Delay_ms;


  PROCEDURE Start;

    VAR k : INTEGER;

    PROCEDURE Sort ( l, r : INTEGER );
     (*---------------------------------------------------------------------*
      | Leistung: Sortieren durch Auswhlen.                                |
      |           Die ausfhrliche Beschreibung des Algorithmus findet man  |
      |           unter  ...\sort2\doc\quicksor.doc (WORD-Version)          |
      |           oder   ...\sort2\txt\quicksor.txt (Text-Version)          |
      *---------------------------------------------------------------------*)

      VAR i, j, x, w : INTEGER;

      BEGIN
        i:= l; j:= r;
        x:= a[(l + r) DIV 2];
        REPEAT
          WHILE a[i] < x DO INC(i) END;
          WHILE x < a[j] DO DEC(j) END;
          IF i <= j THEN
            Delay_ms(dTime);
            C.Dot(i,a[i],C.ERASE);
            C.Dot(j,a[j],C.ERASE);
            w:= a[i];
            a[i]:= a[j];
            a[j]:= w;
            C.Dot(i,a[i],C.DRAW);
            C.Dot(j,a[j],C.DRAW);
            INC(i);
            DEC(j)
          END
        UNTIL i > j;
        IF l < j THEN Sort(l,j) END;
        IF i < r THEN Sort(i,r) END
      END Sort;

    BEGIN  (* Sort *)
      Out.Ln; Out.String('   ');
      Out.String('Die Verzgerung ist vom Prozessortakt abhngig.');
      Out.Ln; Out.String('   ');
      Out.String('Bitte mit kleinen ganzzahligen Werten beginnen.');
      Out.Ln; Out.Ln; Out.String('     ');
      Out.String('(Beispiel: 5 fr eine 1000 MHz-Maschine)');
      In.Prompt('Verzgerungsfaktor');
      In.Int(dTime);
      FOR k:= 1 TO n DO
        a[k]:= Zufallszahl();
        C.Dot(k,a[k],C.DRAW)
      END;
      P.Yield;                                       (* keine Multitasking  *)
      Sort(1,n)
    END Start;


  PROCEDURE ProgMain*();
    BEGIN
      Start
    END ProgMain;


 BEGIN
   C.Open;
   In.Open;
   Out.Open;
   dummy:= W.ShowWindow(W.GetActiveWindow(),3)
 END Quickso2.

